Type: Package
Package: rhdf5
Title: R Interface to HDF5
Version: 2.56.0
Authors@R: c(
    person("Bernd", "Fischer", role = "aut"),
    person("Mike", "Smith", role = "aut",
           comment = c(ORCID = "0000-0002-7800-3848", "Maintainer from 2017 to 2025")),
    person("Gregoire", "Pau", role = "aut"),
    person("Martin", "Morgan", role = "ctb"),
    person("Daniel", "van Twisk", role = "ctb"),
    person("Hugo", "Gruson", , "hugo.gruson@embl.de", role = "cre",
           comment = c(ORCID = "0000-0002-4094-1476")),
    person("German Network for Bioinformatics Infrastructure - de.NBI", role = "fnd")
  )
Description: This package provides an interface between HDF5 and R.
    HDF5's main features are the ability to store and access very large
    and/or complex datasets and a wide variety of metadata on mass storage
    (disk) through a completely portable file format. The rhdf5 package is
    thus suited for the exchange of large and/or complex datasets between
    R and other software package, and for letting R applications work on
    datasets that are larger than the available RAM.
License: Artistic-2.0
URL: https://huber-group-embl.github.io/rhdf5/,
        https://github.com/Huber-group-EMBL/rhdf5
BugReports: https://github.com/Huber-group-EMBL/rhdf5/issues
Depends: methods, R (>= 4.0.0)
Imports: rhdf5filters (>= 1.15.5), Rhdf5lib (>= 1.33.3)
Suggests: bench, BiocParallel, BiocStyle, bit64, curl, dplyr, ggplot2,
        knitr, rmarkdown, testthat, withr
LinkingTo: Rhdf5lib
VignetteBuilder: knitr
biocViews: Infrastructure, DataImport
Encoding: UTF-8
LazyLoad: true
Roxygen: list(markdown = TRUE)
RoxygenNote: 7.3.3
SystemRequirements: GNU make
git_url: https://git.bioconductor.org/packages/rhdf5
git_branch: RELEASE_3_23
git_last_commit: cef3c44
git_last_commit_date: 2026-04-28
Repository: Bioconductor 3.23
Date/Publication: 2026-04-28
NeedsCompilation: yes
Packaged: 2026-04-29 00:17:05 UTC; biocbuild
Author: Bernd Fischer [aut],
  Mike Smith [aut] (ORCID: <https://orcid.org/0000-0002-7800-3848>,
    Maintainer from 2017 to 2025),
  Gregoire Pau [aut],
  Martin Morgan [ctb],
  Daniel van Twisk [ctb],
  Hugo Gruson [cre] (ORCID: <https://orcid.org/0000-0002-4094-1476>),
  German Network for Bioinformatics Infrastructure - de.NBI [fnd]
Maintainer: Hugo Gruson <hugo.gruson@embl.de>

# rhdf5

<img align = "right" src="https://raw.githubusercontent.com/Bioconductor/BiocStickers/master/rhdf5/rhdf5.png" height="200">

This R/Bioconductor package provides an interface between HDF5 and R. HDF5's main features are the ability to store and access very large and/or complex datasets and a wide variety of metadata on mass storage (disk) through a completely portable file format. The rhdf5 package is thus suited for the exchange of large and/or complex datasets between R and other software package, and for letting R applications work on datasets that are larger than the available RAM.

## Current Status

| GitHub Actions | Bioconductor Build Sysytem | Test Coverage |
| ------------- |-------------| ----- |
| [![Package Checks](https://github.com/grimbough/rhdf5/actions/workflows/main.yml/badge.svg)](https://github.com/grimbough/rhdf5/actions/workflows/main.yml) | [![BioC Status](https://bioconductor.org/shields/build/devel/bioc/rhdf5.svg)](http://bioconductor.org/checkResults/devel/bioc-LATEST/rhdf5/) | [![Codecov](http://img.shields.io/codecov/c/github/grimbough/rhdf5.svg)](https://codecov.io/gh/grimbough/rhdf5) |

## Contact

For bug reports, please register an [issue](https://github.com/grimbough/rhdf5/issues) here on Github. For usage queries please post a question on the [Bioconductor Support Forum](https://support.bioconductor.org/p/new/post/?tag_val=rhdf5).


## Funding 

Funding for continued development and maintenance of this package has been provided by the German Network for Bioinformatics Infrastructure & the Chan Zuckerberg Initiative.

|    |    |
|:---|---:|
|<a href="http://www.denbi.de"><img src="https://tess.elixir-europe.org/system/content_providers/images/000/000/063/original/deNBI_Logo_rgb.jpg" width="400" align="left"></a>|<img src="https://image4.owler.com/logo/chan-zuckerberg-initiative_owler_20160616_114930_original.png" width="257" align="right">|

# Description

This folder contains the script used to produce the example HDF5 files  found
in the inst/testfiles/ folder.  These are created using the 
reference implementation of the anndata library found in 
[anndata](https://github.com/scverse/anndata).

# Generating the data

## Using Docker

If you do not have a version of python and zarr readily available, you can
alternatively use the Dockerfile provided to generate the data.  The following
command will build a container called `zarr_tester`.

```
docker build -t anndata-nullable .   
```

To generate the data you then use the command below.  This will produce the
example files in the folder `/tmp/zarr` on your local filesystem.  Modify that
path in the call to `docker run` if it is not appropriate for your system.

```
mkdir /tmp/anndata-nullable
docker run --rm --name anndata-nullable --user ${UID}:${UID} \
  -v /tmp/anndata-nullable:/data \
  anndata-nullable
```

The rhdf5 package will contain a complete installation of the HDF5 C library.
No further downloads from HDF5 are necessary. 

###############################
Only for bioconductor-administrator:

To prepare the R-package rhdf5, call the bash script download.sh from the base
directory rhdf5.

download.sh will download all necessary files from www.hdfgroup.org/HDF5.
configure scripts and Makefiles will be updated as needed for the HDF5 package using
the R-script replacestr.R. 
The HDF5 source package will be light-weighted.








download from 




sed 's/-install_name \$rpath\$soname/\$soname/g' hdf5-1.8.7/configure > tmp.txt


change

in file configure.in:
AC_CONFIG_FILES

in file configure:
ac_config_files

in file configure:
change all appearances of
"-install_name \$rpath\$soname"
to
"-install_name \$soname"

in file configure:
change
  library_names_spec='${libname}${release}${major}$shared_ext ${libname}$shared_ext'
  soname_spec='${libname}${release}${major}$shared_ext'
to
  library_names_spec='${libname}${release}$shared_ext ${libname}$shared_ext'
  soname_spec='${libname}${release}$shared_ext'

in file configure:
change 
  shrext = ".so" for all shrext that contain a ".dylib"

in file Makefile.in:
DIST_SUBDIRS
und SUBDIRS

in file src/Makefile.in and src/Makefile.ac and src/Makefile:
change PACKAGE = hdf5ForBioC
change lib_LTLIBRARIES = libhdf5ForBioC.la
change target libhdf5.la to libhdf5ForBioC.la.

# The rhdf5 package will contain a complete installation of the HDF5 C library.
# No further downloads from HDF5 are necessary. 
# This file contains code for bioconductor administrators.

replacestr <- function(file, pat1, pat2, newtext) {
  L = readLines(file)
  I = grep(pat1,L,fixed=TRUE)
  n=0
  while(length(I) > 0) {
    n=n+1
    I = I[1]
    J=I+grep(pat2,L[I:length(L)],fixed=TRUE)[1]-1
    cat("\n#######################\nIn file ",file," REPLACE\n")
    cat("lines ",I," to ",J,"\n")
    cat(paste(L[I:J],collapse="\n"))
    cat("\nWITH\n",newtext,"\n")
    L = c(L[1:(I-1)],newtext,L[(J+1):(length(L))])
    offset = (I+length(newtext))
    I = grep(pat1,L[offset:length(L)],fixed=TRUE)
    if (length(I) > 0) {
      I = I + offset - 1
    }
  }
  writeLines(L, file)
  invisible(n)
}

sed <- function(file, replace, with) {
  L = readLines(file)
  K = sub(replace, with, L, fixed=TRUE)
  I <- which(L != K)
  n <- 0
  for (i in I) {
    n <- n + 1
    cat("\n#######################\nIn file",file, "REPLACE line",i,"\n")
    cat(L[i],"\n")
    cat("WITH\n")
    cat(K[i],"\n")
  }
  writeLines(K, file)
  invisible(n)
}

n = rep(0,12)
n[1] = replacestr("configure.in", "AC_CONFIG_FILES", "])", c("AC_CONFIG_FILES([src/libhdf5.settings"," src/Makefile])"))
n[2] = replacestr("configure", "ac_config_files=\"", "ac_config_files=\"", "ac_config_files=\"$ac_config_files src/libhdf5.settings Makefile src/Makefile\"")
n[3] = sed("configure", "-install_name \\$rpath/\\$soname", "-install_name \\$soname")
n[4] = sed("configure", "library_names_spec='${libname}${release}${major}$shared_ext", "library_names_spec='${libname}${release}$shared_ext")
n[5] = sed("configure", "soname_spec='${libname}${release}${major}$shared_ext'", "soname_spec='${libname}${release}$shared_ext'")
n[6] = replacestr("configure", "test .$module", "test .$module", "  shrext_cmds='.so'")
n[7] = replacestr("Makefile.in", "SUBDIRS = src test $(TESTPARALLEL_DIR) tools", "perform", "SUBDIRS = src")
n[8] = replacestr("Makefile.in", "DIST_SUBDIRS = src test testpar", "examples", "DIST_SUBDIRS = src")
n[9] = replacestr("src/Makefile.in", "lib_LTLIBRARIES = libhdf5.la", "lib_LTLIBRARIES = libhdf5.la", "lib_LTLIBRARIES = libhdf5ForBioC.la")
n[10] = replacestr("src/Makefile.am", "lib_LTLIBRARIES=libhdf5.la", "lib_LTLIBRARIES=libhdf5.la", "lib_LTLIBRARIES = libhdf5ForBioC.la")
n[11] = sed("src/Makefile.in", "libhdf5.la:", "libhdf5ForBioC.la:")
n[12] = sed("configure", "$H5_CFLAGS $", "$H5_CFLAGS -w $")

N <- c(1,1,8,3,3,3,1,1,1,1,1,3)

M = data.frame(replacement = n,intended = N, correct=n==N)
row.names(M) = c("AC_CONFIG_FILES","as_config_files", "install_name", "library_names_spec", "soname_spec", "dylib", "SUBDIRS", "DIST_SUBDIRS", "LTLIBRARIES_1", "LTLIBRARIES_2", "libhdf5.la:", "-Wconversion")

cat("Summary of replacements\n")
print(M)

#' Open an object in an HDF5 file
#' 
#' @param h5loc An object of class [H5IdComponent-class]
#' @param name Path to the object to be opened.  This should be relative to
#' `h5loc` rather than the file.
#' 
#' @return An object of class [H5IdComponent-class] if the open operation was
#' successful. `FALSE` otherwise.
#' 
#' @examples
#' 
#' # create an hdf5 file and write something
#' h5createFile("ex_H5O.h5")
#' h5createGroup("ex_H5O.h5","foo")
#' B = array(seq(0.1,2.0,by=0.1),dim=c(5,2,2))
#' h5write(B, "ex_H5O.h5","foo/B")
#' 
#' # reopen file and dataset and get object info
#' fid <- H5Fopen("ex_H5O.h5")
#' oid = H5Oopen(fid, "foo")
#' H5Oget_num_attrs(oid)
#' H5Oclose(oid)
#' H5Fclose(fid)
#' 
#' @seealso [H5Oclose()]
#' 
#' @export
H5Oopen <- function( h5loc, name ) {
  h5checktype(h5loc, "loc")
  if (length(name)!=1 || !is.character(name)) stop("'name' must be a character string of length 1")
  oid <- .Call("_H5Oopen", h5loc@ID, name, PACKAGE='rhdf5')
  if (oid > 0) {
    h5object = new("H5IdComponent", ID = oid, native = h5loc@native)
  } else {
    message("HDF5: unable to open object")
    h5object = FALSE
  }
  invisible(h5object)
}

#' Close an HDF5 object
#' 
#' @param h5obj An object of class [H5IdComponent-class] representing an open
#' HDF5 object.
#' 
#' @seealso [H5Oopen()]
#' 
#' @export
H5Oclose <- function( h5obj ) {
  h5checktype(h5obj, "object")
  invisible(.Call("_H5Oclose", h5obj@ID, PACKAGE='rhdf5'))
}

#' Copies an HDF5 object
#' 
#' @param h5loc An object of class [H5IdComponent-class] representing an open
#' HDF5 object where the source obiect should be copied from.
#' @param name Character vector of length 1, giving the name of the source object
#' to be copied.
#' @param h5loc_dest An object of class [H5IdComponent-class] representing an open
#' HDF5 object where the new copy should be created.
#' @param name_dest Character vector of length 1, giving the name of the new object
#' to be created.
#' @param obj_cpy_pl,lcpl [H5IdComponent-class] objects representing object copy and link creation property lists
#' respectively.  If left as `NULL` the default values for these will be used.
#' 
#' @examples 
#' 
#' ## Create a temporary copy of an example file check the contents
#' example_file <- system.file("testfiles", "h5ex_t_array.h5", package="rhdf5")
#' file.copy(example_file, tempdir())
#' h5_file <- file.path(tempdir(), "h5ex_t_array.h5")
#' h5ls(h5_file)
#' 
#' ## open the example file and create a new, empty, file
#' fid1 <- H5Fopen( h5_file )
#' h5_file2 <- tempfile(fileext = ".h5")
#' fid2 <- H5Fcreate( h5_file2 )
#' 
#' ## We can copy a dataset inside the same file
#' H5Ocopy(h5loc = fid1, name = "DS1", h5loc_dest = fid1, name_dest = "DS2")
#' ## Or to a different file
#' H5Ocopy(h5loc = fid1, name = "DS1", h5loc_dest = fid2, name_dest = "DS1_copy")
#' 
#' ## if we want to create a new group hierarchy we can use a link creation property list
#' lcpl <- H5Pcreate("H5P_LINK_CREATE")
#' H5Pset_create_intermediate_group( lcpl, create_groups = TRUE )
#' H5Ocopy(h5loc = fid1, name = "DS1", h5loc_dest = fid2, name_dest = "/foo/baa/DS1_nested", lcpl = lcpl)
#' 
#' ## tidy up
#' H5Pclose(lcpl)
#' H5Fclose(fid1)
#' H5Fclose(fid2)
#' 
#' ## Check we now have groups DS1 and DS2 in the original file
#' h5ls( h5_file )
#' ## Check we have a copy of DS1 at the root and nests in the new file
#' h5ls( h5_file2 )
#' 
#' @export
H5Ocopy <- function( h5loc, name, h5loc_dest, name_dest, obj_cpy_pl = NULL, lcpl = NULL ) {
  h5checktype(h5loc, "loc")
  h5checktype(h5loc_dest, "loc")
  
  ## if not provided a creation property list, use the one from the source    
  if(is.null(lcpl)) {
    lcpl <- H5Pcreate("H5P_LINK_CREATE")
    on.exit(H5Pclose(lcpl), add = TRUE)
  } else {
    lcpl <- h5checktypeAndPLC(lcpl, "H5P_LINK_CREATE", allowNULL = FALSE)
  }
  
  ## use default access property list if not given
  if(is.null(obj_cpy_pl)) {
    obj_cpy_pl <- H5Pcreate("H5P_OBJECT_COPY")
    on.exit(H5Pclose(obj_cpy_pl), add = TRUE)
  } else {
    lapl <- h5checktypeAndPLC(lapl, "H5P_OBJECT_COPY", allowNULL = FALSE) 
  }
  
  res <- invisible(.Call("_H5Ocopy", h5loc@ID, name, h5loc_dest@ID, name_dest, obj_cpy_pl@ID, lcpl@ID, PACKAGE='rhdf5'))
  
  if(res < 0) {
    stop("Object copying failed")
  } else {
    return(invisible(TRUE))
  }
}

#' Create a hard link to an object in an HDF5 file
#' 
#' @param h5obj An object of class [H5IdComponent-class] representing the object to be linked to.
#' @param h5loc An object of class [H5IdComponent-class] representing the location at which the 
#' object is to be linked.  Can represent a file, group, dataset, datatype or attribute.
#' @param newLinkName Character string giving the name of the new link.  This should be relative to
#' `h5loc`.
#' @param lcpl,lapl [H5IdComponent-class] objects representing link creation and link access property lists
#' respectively.  If left as `NULL` the default values for these will be used.
#' 
#' @seealso [H5Gcreate_anon]
#' 
#' @examples 
#' ## Create a temporary copy of an example file, and open it
#' example_file <- system.file("testfiles", "h5ex_t_array.h5", package="rhdf5")
#' file.copy(example_file, tempdir())
#' h5_file <- file.path(tempdir(), "h5ex_t_array.h5")
#' fid <- H5Fopen( h5_file )
#' 
#' ## create a new group without a location in the file
#' gid <- H5Gcreate_anon(fid)
#' 
#' ## create link to newly create group
#' ## relative to the file identifier
#' H5Olink(h5obj = gid, h5loc = fid, newLinkName = "foo")
#' 
#' ## tidy up
#' H5Gclose(gid)
#' H5Fclose(fid)
#' 
#' ## Check we now have a "/foo" group
#' h5ls( h5_file )
#' 
#' @export
H5Olink <- function( h5obj, h5loc, newLinkName, lcpl = NULL, lapl = NULL ) {
  h5checktype(h5obj, "object")
  h5checktype(h5loc, "loc")
  
  lcpl <- h5checktypeAndPLC(lcpl, "H5P_LINK_CREATE", allowNULL = TRUE)
  lapl <- h5checktypeAndPLC(lapl, "H5P_LINK_ACCESS", allowNULL = TRUE)
  
  res <- .Call("_H5Olink", h5obj@ID, h5loc@ID, newLinkName, lcpl@ID, lapl@ID, PACKAGE='rhdf5')
  
  if(res < 0) {
    stop("Link creation failed")
  } else {
    return(invisible(TRUE))
  }
}

#' Test and set file locking for HDF5
#'
#' HDF5 uses file locking by default.  On some file systems this is not
#' available, and the HDF5 library will throw an error if the user attempts to
#' create or access a file located on such a file system.  These functions help
#' identify if file locking is available without throwing an error, and allow
#' the locking to be disabled for the duration of the R session if needed.
#'
#' `h5testFileLocking` will create a temporary file and then attempt to
#' apply a file lock using the appropriate function within the HDF5 library.
#' The success or failure of the locking is then recorded and the temporary
#' file removed.  Even relatively low level functions such as
#' [H5Fcreate()] will fail inelegantly if file locking fails.
#'
#' `h5disableFileLocking` will set the environment variable
#' `HDF5_USE_FILE_LOCKING=FALSE`, which is the recommended was to disable
#' this behaviour if file locking is not supported.  This will only persist
#' within the current R session.  You can set the environment variable outside
#' of R if this is a more general issue on your system.
#'
#' `h5enableFileLocking` will unset the `HDF5_USE_FILE_LOCKING`
#' environment variable.
#'
#' More discussion of HDF5's use of file locking can be found online e.g.
#' <https://forum.hdfgroup.org/t/hdf5-1-10-0-and-flock/3761/4> or
#' <https://forum.hdfgroup.org/t/hdf5-files-on-nfs/3985/5>
#'
#' @aliases h5testFileLocking h5enableFileLocking h5disableFileLocking
#' @param location The name of a directory or file to test.  If an existing
#' directory is provided a temporary file will be created in this folder.  If
#' non-existent location is provided a file with the name will be created,
#' tested for file locking, and then removed.  Providing an existing file will
#' result in an error.
#' @returns `h5testFileLocking` returns `TRUE` if a file can be
#' successfully locked at the specified location, or `FALSE` otherwise.
#'
#' `h5disableFileLocking` and `h5enableFileLocking` set are called
#' for the side effect of setting or unsetting the environment variable
#' `HDF5_USE_FILE_LOCKING` and do not return anything.
#'
#' @author Mike Smith
#' @keywords IO file
#' @examples
#'
#' ## either a file name or directory can be tested
#' file <- tempfile()
#' dir <- tempdir()
#'
#' h5testFileLocking(dir)
#' h5testFileLocking(file)
#'
#' ## we can check for file locking, and disable if needed
#' if (!h5testFileLocking(dir)) {
#'   h5disableFileLocking()
#' }
#'
#' @name h5_FileLocking
#' @importFrom utils file_test
#' @export h5testFileLocking
h5testFileLocking <- function(location) {
  if (missing(location)) {
    stop("You must provide a location to test.")
  }

  ## stop if existing file passed
  if (file_test("-f", location)) {
    stop(
      "Testing file locking will remove ",
      location,
      "\nPlease provide a directory or the name of a temporary file to be created."
    )
  }

  ## passed an existing directory
  if (file_test("-d", location)) {
    file <- tempfile(tmpdir = location)
  } else {
    ## location doesn't exist, we will create it
    file <- location
  }

  lock_status <- .Call("_h5fileLock", file, PACKAGE = "rhdf5")

  file.remove(file)

  return(lock_status >= 0)
}

#' @rdname h5_FileLocking
#' @export
h5disableFileLocking <- function() {
  Sys.setenv(HDF5_USE_FILE_LOCKING = "FALSE") # nolint: undesirable_function_linter.
}

#' @rdname h5_FileLocking
#' @export
h5enableFileLocking <- function() {
  Sys.unsetenv("HDF5_USE_FILE_LOCKING")
}

library(rhdf5)

############################################################
context("Testing file locking")
############################################################

test_that("File or directory can be passed", {
  file <- tempfile()
  dir <- tempdir()
  expect_silent(h5testFileLocking(file)) %>%
    expect_is('logical')
  expect_silent(h5testFileLocking(dir)) %>%
    expect_is('logical')
  
  ## Temporary file removed
  expect_false(file.exists(file))
})

test_that("Error when using existing file", {
  
  tf <- tempfile()
  file.create(tf)
  expect_error(h5testFileLocking(location = tf),
               "Testing file locking will remove")
  
})

test_that("Error when missing argument", {
  expect_error(h5testFileLocking(),
               "You must provide a location to test")
})


############################################################
context("Setting file locking")
############################################################

## record the current state of this, we'll set again at the end
curr <- Sys.getenv("HDF5_USE_FILE_LOCKING")

test_that("Disabling sets value", {
  h5disableFileLocking()
  expect_equal(Sys.getenv("HDF5_USE_FILE_LOCKING"), "FALSE")
})

test_that("Enabling removes value", {
  h5enableFileLocking()
  expect_equal(Sys.getenv("HDF5_USE_FILE_LOCKING"), "")
})

## set original value for environment variable
Sys.setenv(HDF5_USE_FILE_LOCKING = curr)

#' Retrieve the name of an object from a given identifier
#' 
#' @param h5obj An object of class [H5IdComponent-class].  Can represent a 
#' file, group, dataset or attribute.
#' 
#' @export
H5Iget_name <- function( h5obj ) {
  h5checktype(h5obj, "object")
  name <- .Call("_H5Iget_name", h5obj@ID, PACKAGE='rhdf5')
  name
}

#' Find the type of an object
#' 
#' Possible types returned by the function are:
#' * `H5I_FILE`
#' * `H5I_GROUP`
#' * `H5I_DATATYPE`
#' * `H5I_DATASPACE`
#' * `H5I_DATASET`
#' * `H5I_ATTR`
#' 
#' @return Returns a character vector of length 1 containing the HDF5 type
#' for the supplied identifier.
#' 
#' @param h5identifier Object of class [H5IdComponent-class].
#' 
#' @examples 
#' h5file <- system.file("testfiles", "h5ex_t_array.h5", package="rhdf5")
#' fid <- H5Fopen(h5file)
#' gid <- H5Gopen(fid, "/")
#' 
#' ## identify the HDF5 types for these identifiers
#' H5Iget_type(fid)
#' H5Iget_type(gid)
#' 
#' ## tidy up
#' H5Gclose(gid)
#' H5Fclose(fid)
#' 
#' @export
H5Iget_type <- function( h5identifier ) {
  stopifnot( is( h5identifier, "H5IdComponent" ) )
  tid <- .Call("_H5Iget_type", h5identifier@ID, PACKAGE='rhdf5')
  h5const2String("H5I_TYPE",tid)
}

#' Determine whether an identifier is valid
#' 
#' An identifier is no longer valid after it has been closed.
#' 
#' @param h5identifier Object of class [H5IdComponent-class].
#' 
#' @return A logical of length 1.  `TRUE` is the identifier is valid,
#' `FALSE` if not.
#' 
#' @examples
#' 
#' h5file <- system.file("testfiles", "h5ex_t_array.h5", package="rhdf5")
#' fid <- H5Fopen(h5file)
#' 
#' ## test whether the identifer to the opened file is valid
#' H5Iis_valid(fid)
#' 
#' ## the file ID is no longer valid after it has been closed
#' H5Fclose(fid)
#' H5Iis_valid(fid)
#' 
#' @export
H5Iis_valid<- function( h5identifier ) {
  stopifnot( is( h5identifier, "H5IdComponent" ) )
  tid <- .Call("_H5Iis_valid", h5identifier@ID, PACKAGE='rhdf5')
  tid
}

library(rhdf5)

############################################################
context("H5I methods")
############################################################

h5File <- withr::local_tempfile(pattern = "H5_methods", fileext = ".h5")

fid <- H5Fcreate(name = h5File)
gid <- H5Gcreate(fid, name = "foo")
sid <- H5Screate_simple(dims = c(5, 5))
did <- H5Dcreate(
  h5loc = fid,
  name = "baa",
  dtype_id = "H5T_NATIVE_UINT32",
  h5space = sid
)

test_that("getting names", {
  expect_match(H5Iget_name(fid), "/")
  expect_match(H5Iget_name(gid), "/foo")
  expect_match(H5Iget_name(did), "/baa")

  expect_error(
    H5Iget_name(sid),
    "The provided H5Identifier is not an object identifier"
  )
  expect_error(H5Iget_name("test"), "Argument not of class H5IdComponent")
})

test_that("getting types", {
  expect_match(as.character(H5Iget_type(fid)), "H5I_FILE")
  expect_match(as.character(H5Iget_type(gid)), "H5I_GROUP")
  expect_match(as.character(H5Iget_type(did)), "H5I_DATASET")
  expect_match(as.character(H5Iget_type(sid)), "H5I_DATASPACE")

  expect_error(H5Iget_type("test"))
})

test_that("getting types", {
  expect_true(H5Iis_valid(fid))
  expect_true(H5Iis_valid(did))
  expect_true(H5Iis_valid(gid))
  expect_true(H5Iis_valid(sid))
})

H5Sclose(sid)

test_that("getting types from closed or invalid objects", {
  ## try with a closed object
  expect_false(H5Iis_valid(sid))

  expect_error(H5Iis_valid("test"))
  expect_error(H5Iis_valid(1L))
})

H5Dclose(did)
H5Gclose(gid)
H5Fclose(fid)

#' Create an HDF5 file
#' 
#' @param name The name of the HDF5 file to create.
#' @param flags See \code{h5const("H5F_ACC")} for possible arguments.
#' @param fcpl,fapl Object object of class [H5IdComponent-class].  This should 
#' representing a file creation property list and a file access property list
#' respectively. See [H5Pcreate()] or  [H5Pcopy()] to create objects of this 
#' kind.  Leaving as `NULL` will use the default HDF5 settings which are often
#' sufficient.
#' @param native An object of class \code{logical}. If `TRUE`, array-like 
#' objects are treated as stored in HDF5 row-major rather than R column-major 
#' orientation. Using \code{native = TRUE} increases HDF5 file portability 
#' between programming languages. A file written with \code{native = TRUE} 
#' should also be read with \code{native = TRUE}.
#' 
#' @export
H5Fcreate <- function( name, flags = h5default("H5F_ACC"), fcpl = NULL, fapl = NULL, native = FALSE) {

    if (length(name)!=1 || !is.character(name)) 
        stop("'name' must be a character string of length 1")
    name <- normalizePath(name, mustWork = FALSE)
    if(.Platform$OS.type == "windows") {
      name <- enc2utf8(name)
    }
    
    flags <- h5checkConstants( "H5F_ACC", flags )
    fcpl = h5checktypeAndPLC(fcpl, "H5P_FILE_CREATE", allowNULL = TRUE)
    if (is.null(fapl)) {
        ## create a new property list, and make sure it is closed
        fapl = H5Pcreate("H5P_FILE_ACCESS")
        on.exit(H5Pclose(fapl))
        H5Pset_libver_bounds(fapl, libver_low = "H5F_LIBVER_EARLIEST", libver_high = "H5F_LIBVER_LATEST")
    }
    fapl = h5checktypeAndPLC(fapl, "H5P_FILE_ACCESS", allowNULL = TRUE)
    fid <- .Call("_H5Fcreate", name, flags, fcpl@ID, fapl@ID, PACKAGE='rhdf5')
    if (fid > 0) {
        h5file = new("H5IdComponent", ID = fid, native = native)
    } else {
        message("HDF5: unable to create file")
        h5file = FALSE
    }
    invisible(h5file)
}

#' Open an existing HDF5 file
#' 
#' @details Possible values for the `flags` argument are `H5F_ACC_RDWR` and `H5F_ACC_RDONLY`.  
#' Note that HDF5's "Single Write Multiple Reader (SWMR) mode is not currently supported via
#' **rhdf5**.
#' 
#' @param name The name (or path) of the HDF5 file to be opened.
#' @param flags Character string defining the access mode for opening the file.
#' @param fapl [H5IdComponent-class] object representing a file access property list.
#' Leaving this argument as `NULL` will use the default HDF5 properties.
#' @param native An object of class \code{logical}. If `TRUE`, array-like 
#' objects are treated as stored in HDF5 row-major rather than R column-major 
#' orientation. Using `native = TRUE` increases HDF5 file portability 
#' between programming languages. A file written with `native = TRUE`
#' should also be opened for reading with `native = TRUE`.
#' 
#' @export
H5Fopen <- function( name, flags = h5default("H5F_ACC_RD"), fapl = NULL, native = FALSE ) {
  
  if (length(name)!=1 || !is.character(name)) {
    stop("'name' must be a character string of length 1")
  }
  if(!grepl("^http[s]?://", x = name)) {
    name <- normalizePath(name, mustWork = FALSE)
  }
  flags <- h5checkConstants( "H5F_ACC_RD", flags )
  
  if (is.null(fapl)) {
    ## create a new file access property list
    fapl <- H5Pcreate("H5P_FILE_ACCESS")
    on.exit(H5Pclose(fapl))
  } else {
    fapl <- h5checktypeAndPLC(fapl, "H5P_FILE_ACCESS", allowNULL = FALSE)
  }
  
  fid <- .Call("_H5Fopen", name, flags, fapl@ID, PACKAGE='rhdf5')
  if (fid > 0) {
    h5file = new("H5IdComponent", ID = fid, native = native)
  } else {
    message("HDF5: unable to open file")
    h5file = FALSE
  }
  invisible(h5file)
}

#' Close access to an HDF5 file
#' 
#' @param h5file [H5IdComponent-class] representing an HDF5 file ID.  Typically
#' created via [H5Fcreate()] or [H5Fopen()].
#' 
#' @export
H5Fclose <- function( h5file ) {
  h5checktype(h5file, "file")
  invisible(.Call("_H5Fclose", h5file@ID, PACKAGE='rhdf5'))
}

#' Flush all buffers associated with a file to disk
#'
#' @param h5file [H5IdComponent-class] representing any object associated with
#'   the file to be flushed.
#' @param scope Specifies whether the scope of the flushing action is global
#'   (flushes the entire virtual file) or local (flushes only the specified
#'   file). Valid values are `H5F_SCOPE_GLOBAL` and `H5F_SCOPE_LOCAL`.
#'
#' @export
H5Fflush <- function( h5file, scope = h5default("H5F_SCOPE") ) {
  h5checktype(h5file, "file")
  scope <- h5checkConstants( "H5F_SCOPE", scope )
  invisible(.Call("_H5Fflush", h5file@ID, scope, PACKAGE='rhdf5'))
}

#' Determine whether a file is in the HDF5 format
#' 
#' `H5Fis_hdf5()` determines whether a file is in the HDF5 format.
#' 
#' @param name Character vector of length 1, giving the path to the file to
#' be checked.
#' @param showWarnings If the file doesn't exist an warning is generated.
#' Setting this argument to `FALSE` will suppress the warning.
#' 
#' @return Returns `TRUE`, if the file is an HDF5 file, or `FALSE` otherwise. 
#' In the case the file doesn't exist, `NA` is returned
#' 
#' @export
H5Fis_hdf5 <- function( name, showWarnings=TRUE ) {

    if (length(name)!=1 || !is.character(name)) 
        stop("'name' must be a character string of length 1")
    name <- normalizePath(name, mustWork = FALSE)
    res <- NA
    if (file.exists(name)) {
        res = .Call("_H5Fis_hdf5", name, PACKAGE = 'rhdf5')
    } else {
        if (showWarnings) {
            warning("File does not exist.")
        }
    }
    res
}

#' Find the size of an open HDF5 file
#' 
#' `H5Fget_filesize()` returns the size in bytes of the HDF5 file specified by
#' `h5file`.
#' 
#' @param h5file [H5IdComponent-class] representing an HDF5 file ID.  Typically
#' created via [H5Fcreate()] or [H5Fopen()].
#' 
#' @export
H5Fget_filesize <- function( h5file ) {
  h5checktype(h5file, "file")
  .Call("_H5Fget_filesize", h5file@ID, PACKAGE = 'rhdf5')
}

#' Get property lists associated with an HDF5 file
#' 
#' @param h5file An object of class [H5IdComponent-class] representing a H5
#' file identifier.  Typically produced by [H5Fopen()] or [H5Fcreate()].
#' 
#' @name H5Fget_plist


#' @rdname H5Fget_plist
#' @export
H5Fget_create_plist <- function( h5file ) {
  h5checktype(h5file, "file")
  pid <- .Call("_H5Fget_create_plist", h5file@ID, PACKAGE='rhdf5')
  if (pid > 0) {
    h5plist = new("H5IdComponent", ID = pid, native = h5file@native)
  } else {
    message("HDF5: unable to create property list")
    h5plist = FALSE
  }
  invisible(h5plist)
}

#' @rdname H5Fget_plist
#' @export
H5Fget_access_plist <- function( h5file ) {
  h5checktype(h5file, "file")
  pid <- .Call("_H5Fget_access_plist", h5file@ID, PACKAGE='rhdf5')
  if (pid > 0) {
    h5plist = new("H5IdComponent", ID = pid, native = h5file@native)
  } else {
    message("HDF5: unable to create property list")
    h5plist = FALSE
  }
  invisible(h5plist)
}

#' Retrieve the name of the file to which an object belongs
#' 
#' @param h5obj An object of class [H5IdComponent-class].  Despite this being
#' an H5F function, it works equally well on H5 file, group, dataset and 
#' attribute datatypes.
#' 
#' @examples 
#' 
#' ## use an example file and show its location
#' h5file <- system.file("testfiles", "h5ex_t_array.h5", package = "rhdf5")
#' h5file
#' 
#' ## open a file handle and confirm we can identify the file it points to
#' fid <- H5Fopen(h5file)
#' H5Fget_name(fid)
#' 
#' ## H5Fget_name() can be applied to group and dataset handles too
#' gid <- H5Gopen(fid, name = "/")
#' did <- H5Dopen(fid, name = "DS1")
#' H5Fget_name(gid)
#' H5Fget_name(did)
#' 
#' ## tidy up
#' H5Dclose(did)
#' H5Gclose(gid)
#' H5Fclose(fid)
#' 
#' @export
H5Fget_name <- function( h5obj ) {
  h5checktype(h5obj, "object")
  .Call("_H5Fget_name", h5obj@ID, PACKAGE='rhdf5')
}

## Collection of tests that have been written with the expectation that they
## work or produce useful error messages, but at the moment are not handled
## in a graceful fashion.  Updating the the package code to get these to pass
## is not a priority, but will improve the user experience IMHO

############################################################
context("h5write")
############################################################

D <- 1:20
h5createFile(h5File)
h5createDataset(file = h5File, dataset = "foo", dims = c(2, length(D)))

expect_message(
  h5write(obj = D, file = h5File, name = "foo"),
  "dimensions of 'obj' and the 'foo' dataset are different"
)

############################################################
context("h5set_extent")
############################################################

h5File <- withr::local_tempfile(pattern = "ex_set_extent_", fileext = ".h5")
D <- 1:20
h5createFile(h5File)
h5createDataset(
  file = h5File,
  dataset = "foo",
  dims = c(1, length(D)),
  maxdims = c(2, length(D))
)
h5write(obj = D, file = h5File, name = "foo")

## you can't pass a dataset ID to this function, you always get the
## "file open" warning, but you can't close it before reading.
test_that("Work with dataset identifier", {
  fid <- H5Fopen(h5File)
  did <- H5Dopen(fid, name = "foo")
  H5Fclose(fid)

  expect_identical(
    h5set_extent(file = h5File, dataset = did, dims = c(1, length(D))),
    0
  )

  H5Dclose(did)
})

library(rhdf5)

############################################################
context("h5delete")
############################################################

A <- 1:7
## output file name
h5File <- withr::local_tempfile(pattern = "ex_delete", fileext = ".h5")
h5write(obj = A, file = h5File, name = "A")

test_that("Error if file doesn't exist", {
  expect_error(
    h5delete(file = "foo", name = "baa"),
    regexp = "Cannot open file"
  )
})

test_that("Error if link doesn't exist", {
  expect_error(
    h5delete(file = h5File, name = "baa"),
    regexp = "Specified link doesn't exist"
  )
})

test_that("Deletion works for vector", {
  expect_true("A" %in% h5ls(h5File)$name)
  expect_silent(h5delete(file = h5File, name = "A"))
  expect_false("A" %in% h5ls(h5File)$name)
})

## add several datatypes including a list with subgroups
fid <- H5Fopen(h5File)
expect_silent(h5writeDataset(
  obj = matrix(1:10, ncol = 2),
  h5loc = fid,
  name = "matrix"
))
expect_silent(h5writeDataset(
  obj = list(a = 1:4, b = letters[10:15]),
  h5loc = fid,
  name = "list"
))
expect_silent(h5writeDataset(
  obj = data.frame("col_A" = 1:10, "col_B" = letters[1:10]),
  h5loc = fid,
  name = "data.frame"
))
H5Fclose(fid)

## record the file size
original_filesize <- file.size(h5File)

test_that("Deletion is selective", {
  expect_true("data.frame" %in% h5ls(h5File)$name)
  expect_silent(h5delete(file = h5File, name = "data.frame"))
  ## 'data.frame' has been removed
  expect_false("data.frame" %in% h5ls(h5File)$name)
  ## 'list' is still present
  expect_true("list" %in% h5ls(h5File)$name)
})

test_that("Deletion removes subgroups", {
  expect_silent(h5delete(file = h5File, name = "list"))
  expect_false("a" %in% h5ls(h5File)$name)
})

test_that("Deletion reduces filesize", {
  expect_lt(file.size(h5File), original_filesize)
})

########################
## Attribute deletion ##
########################

h5write(obj = A, file = h5File, name = "A")

test_that("Attributes can be deleted", {
  expect_true(h5deleteAttribute(h5File, name = "A", attribute = "rhdf5-NA.OK"))
  expect_length(h5readAttributes(h5File, name = "A"), n = 0)
})

test_that("Attribute deletion error handling works", {
  expect_false(h5deleteAttribute(h5File, name = "B", attribute = "test")) %>%
    expect_message(regexp = "Object 'B' not found in")
  expect_false(h5deleteAttribute(h5File, name = "A", attribute = "test")) %>%
    expect_message(regexp = "Attribute 'test' not found")
})

test_that("Verbosity of HDF5 error messages can be adjusted", {
  expect_silent(h5errorHandling("suppress"))
  expect_message(H5Fopen("foo.h5"), "^HDF5")

  expect_silent(h5errorHandling("normal"))
  expect_error(
    H5Fopen("foo.h5"),
    "HDF5. File accessibility. Unable to open file."
  )

  expect_silent(h5errorHandling("verbose"))
  expect_error(H5Fopen("foo.h5"), "libhdf5\n    error #000:")
})

library(rhdf5)

############################################################
context("h5write")
############################################################

A <- 1:7
## output file name
h5File <- withr::local_tempfile(pattern = "ex_save", fileext = ".h5")

test_that("Error if file doesn't exist", {
  expect_error(h5write(
    obj = A,
    file = h5File,
    name = "A",
    createnewfile = FALSE
  ))
})

test_that("Writing works", {
  ## writing to a file name
  expect_silent(h5write(obj = A, file = h5File, name = "A"))
  expect_identical(as.integer(h5read(file = h5File, name = "A")), A)

  fid <- H5Fopen(name = h5File)
  ## writing to a group
  gid <- H5Gcreate(h5loc = fid, name = "test_group")
  expect_silent(h5write(matrix(1:20, ncol = 10), file = gid, name = "foo"))
  H5Gclose(gid)

  H5Fclose(fid)
})


test_that("Attributes are written too", {
  B <- runif(n = 10)
  attr(B, "scale") <- "centimeters"
  h5write(obj = B, file = h5File, name = "B", write.attributes = TRUE)
  ## note that attributes aren't retrieved here
  expect_equivalent(as.numeric(h5read(file = h5File, name = "B")), B)
  # expect_equal( h5read(file = h5File, name = "B", read.attributes = TRUE), B )
  expect_true("scale" %in% names(h5readAttributes(file = h5File, name = "B")))
})

test_that("Write by index and hyperslab works.", {
  h5createDataset(file = h5File, dataset = "D", dims = c(10, 9))

  ## Test index works
  h5write(1:4, file = h5File, name = "D", index = list(2:3, c(3, 6)))
  res <- h5read(file = h5File, name = "D", index = list(2:3, c(3, 6)))
  expect_equal(res, matrix(1:4, nrow = 2, ncol = 2))

  ## Test hyperslabs without stride and block arguments work
  h5write(
    matrix(1:12, nrow = 4, ncol = 3),
    file = h5File,
    name = "D",
    start = c(2, 2),
    stride = NULL,
    count = c(4, 3),
    block = NULL
  )
  expect_equal(
    h5read(h5File, "D")[2:5, 2:4],
    matrix(1:12, nrow = 4, ncol = 3)
  )
  res <- h5read(
    file = h5File,
    name = "D",
    start = c(2, 2),
    stride = NULL,
    count = c(4, 3),
    block = NULL
  )
  expect_equal(res, matrix(1:12, nrow = 4, ncol = 3))

  ## Test hyperslabs with all arguments work
  h5write(
    matrix(1:48, nrow = 6, ncol = 8),
    file = h5File,
    name = "D",
    start = c(1, 1),
    stride = c(4, 5),
    count = c(2, 2),
    block = c(3, 4)
  )
  expect_equal(
    h5read(h5File, "D")[c(1:3, 5:7), c(1:4, 6:9)],
    matrix(1:48, nrow = 6, ncol = 8)
  )
  res <- h5read(
    file = h5File,
    name = "D",
    start = c(1, 1),
    stride = c(4, 5),
    count = c(2, 2),
    block = c(3, 4)
  )
  expect_equal(res, matrix(1:48, nrow = 6, ncol = 8))
})

############################################################
context("h5writeDataset")
############################################################

## output file name
h5File <- withr::local_tempfile(pattern = "ex_writeDataset_", fileext = ".h5")

test_that("Writing to file handle", {
  fid <- H5Fcreate(name = h5File)
  expect_silent(h5writeDataset(
    obj = matrix(1:10, ncol = 2),
    h5loc = fid,
    name = "matrix"
  ))
  expect_silent(h5writeDataset(obj = integer(1), h5loc = fid, name = "integer"))
  expect_silent(h5writeDataset(obj = numeric(1), h5loc = fid, name = "numeric"))
  expect_silent(h5writeDataset(obj = "foobaa", h5loc = fid, name = "character"))
  expect_silent(h5writeDataset(obj = logical(1), h5loc = fid, name = "logical"))
  expect_silent(h5writeDataset(
    obj = list(a = 1:4, b = letters[10:15]),
    h5loc = fid,
    name = "list"
  ))
  expect_silent(h5writeDataset(
    obj = data.frame("col_A" = 1:10, "col_B" = letters[1:10]),
    h5loc = fid,
    name = "data.frame"
  ))
  expect_silent(h5writeDataset(
    obj = data.frame("col_A" = 1:10, "col_B" = letters[1:10]),
    h5loc = fid,
    name = "data.frame2",
    DataFrameAsCompound = FALSE
  ))
  expect_silent(h5writeDataset(
    obj = complex(length.out = 10, real = 1:10, imaginary = 10:1),
    h5loc = fid,
    name = "complex"
  ))
  H5Fclose(fid)
})


############################################################
context("h5write with data.frames")
############################################################

h5f1 <- withr::local_tempfile(fileext = ".h5")
h5f2 <- withr::local_tempfile(fileext = ".h5")

h5createFile(h5f1)
h5createFile(h5f2)

## we use file size as a proxy for chunk size
## larger chunks should compress better in this example
test_that("Changing chunk size works", {
  expect_silent(h5write(
    data.frame("A" = rep(1:100), "B" = 201:300),
    h5f1,
    "dset",
    level = 7,
    chunk = 1L
  ))
  expect_silent(h5write(
    data.frame("A" = rep(1:100), "B" = 201:300),
    h5f2,
    "dset",
    level = 7,
    chunk = 100L
  ))
  expect_true(file.size(h5f2) < file.size(h5f1))
})

## only run this test on 64bit OS with space to allocate more than 4GB RAM
test_that("Very large data.frames are limited to chunk size < 4GB", {
  skip_if_not(.Platform$r_arch != "i386")

  counts_1 <- tryCatch(rep(0, 500000000), error = function(e) NULL)
  skip_if(is.null(counts_1), "Not enough memory to run this test")

  d1 <- data.frame(counts_1, counts_1, counts_1, counts_1)

  fid <- H5Fcreate(name = h5File)
  expect_silent(
    did <- .Call(
      "_h5createDataFrame",
      d1,
      fid@ID,
      "test",
      7L,
      nrow(d1),
      PACKAGE = "rhdf5"
    )
  )
  expect_gt(as.numeric(did), 0)
  expect_identical(.Call("_H5Dclose", did, PACKAGE = "rhdf5"), 0L)
  H5Fclose(fid)
})


test_that("We can write a data.frame with multiple factor columns", {
  if (file.exists(h5f1)) {
    file.remove(h5f1)
  }

  Z <- data.frame(
    X = sample(LETTERS, 20000, replace = TRUE),
    Y = sample(LETTERS, 20000, replace = TRUE),
    stringsAsFactors = FALSE
  )

  expect_silent(h5write(
    Z,
    file = h5f1,
    name = "data",
    DataFrameAsCompound = FALSE
  ))
  expect_equivalent(h5read(file = h5f1, name = "data/X"), as.character(Z$X))
  expect_equivalent(h5read(file = h5f1, name = "data/Y"), as.character(Z$Y))
})

test_that("We can write a data.frame with many data types", {
  if (file.exists(h5f1)) {
    file.remove(h5f1)
  }

  Z <- data.frame(
    "col_A" = 1:10,
    "col_B" = letters[1:10],
    "col_C" = as.raw(1:10),
    "col_D" = as.integer(1:10)
  )

  expect_silent(h5write(
    Z,
    file = h5f1,
    name = "data",
    DataFrameAsCompound = TRUE
  ))
  Z2 <- h5read(file = h5f1, name = "data")
  expect_identical(dim(Z), dim(Z2))
  ##  this test is a bit weird, testthat doesn't consider RAW and as.array(RAW) equivalent
  for (i in seq_along(Z)) {
    expect_equivalent(as.array(Z[[i]]), Z2[[i]])
  }
})


############################################################
context("Writing a datset subset")
############################################################

## output file name
h5File <- withr::local_tempfile(pattern = "ex_writeDataset_", fileext = ".h5")

test_that("Overwriting a subset", {
  fid <- H5Fcreate(name = h5File)
  expect_silent(h5writeDataset(
    obj = matrix(1:40, ncol = 4),
    h5loc = fid,
    name = "matrix"
  ))
  expect_silent(h5writeDataset(
    obj = rep(0, 20),
    h5loc = fid,
    name = "matrix",
    index = list(NULL, 2:3)
  ))
  H5Fclose(fid)

  expect_is(mat <- h5read(h5File, name = "matrix"), "matrix")
  expect_true(all(mat[, 2] == 0))
})

library(rhdf5)

############################################################
context("Print methods")
############################################################

h5File <- withr::local_tempfile(pattern = "H5_methods", fileext = ".h5")

test_that("Printing various object types", {
  ## file
  expect_silent(fid <- H5Fcreate(name = h5File))
  expect_output(print(fid), regexp = "HDF5 FILE")

  ## group
  expect_silent(gid <- H5Gcreate(fid, name = "foo"))
  expect_output(print(gid), regexp = "HDF5 GROUP")
  expect_silent(H5Gclose(gid))

  ## dataspace
  expect_silent(sid <- H5Screate_simple(dims = c(5, 5)))
  expect_output(print(sid), regexp = "HDF5 DATASPACE")

  ## dataset
  expect_silent(
    did <- H5Dcreate(
      h5loc = fid,
      name = "baa",
      dtype_id = "H5T_NATIVE_UINT32",
      h5space = sid
    )
  )
  expect_output(print(did), regexp = "HDF5 DATASET")

  ## datatype
  expect_silent(tid <- H5Tcopy("H5T_NATIVE_INT32"))
  expect_output(print(tid), regexp = "[0-9]{8}")

  ## attribute
  expect_silent(
    aid <- H5Acreate(did, name = "bang", dtype_id = tid, h5space = sid)
  )
  expect_output(print(aid), regexp = "HDF5 ATTR")

  ## close everything
  expect_silent(H5Aclose(aid))
  expect_silent(H5Sclose(sid))
  expect_silent(H5Dclose(did))
  expect_silent(H5Fclose(fid))
})

############################################################
context("Subsetting methods")
############################################################

h5File <- withr::local_tempfile(pattern = "H5_methods", fileext = ".h5")

test_that("Subsetting datasets", {
  A <- matrix(data = 1:200, nrow = 10)
  h5save(A, file = h5File)

  expect_silent(fid <- H5Fopen(name = h5File))
  expect_silent(did <- H5Dopen(h5loc = fid, name = "A"))

  expect_silent(col1 <- did[, 1])
  expect_is(col1, "integer")

  expect_silent(col15 <- did[, 1:5])
  expect_is(col15, "matrix")
  expect_identical(dim(col15), c(10L, 5L))

  # https://github.com/Huber-group-EMBL/rhdf5/issues/69
  myidx <- 1:5
  expect_no_condition(col15_fromvar <- did[, myidx])
  expect_identical(col15, col15_fromvar)

  expect_identical(did[], A)

  # https://github.com/Huber-group-EMBL/rhdf5/issues/68
  expect_no_condition(nodrop <- did[1, 1:5, drop = FALSE])
  expect_shape(nodrop, dim = c(1L, 5L))

  expect_silent(H5Dclose(did))

  expect_error(did[], regexp = "Bad HDF5 ID")
  expect_error(
    fid[, 3],
    regexp = "The provided H5Identifier is not a dataset identifier"
  )

  expect_silent(H5Fclose(fid))
})

test_that("Subsetting assignment", {
  expect_silent(fid <- H5Fopen(name = h5File))
  expect_silent(did <- H5Dopen(h5loc = fid, name = "A"))

  ## assign new values
  expect_silent(did[10, ] <- did[10, ] + 1000)
  expect_silent(did[, 1] <- 1001:1010)
  expect_silent(did[1:3, 5:7] <- rep(0, 9))
  # https://github.com/Huber-group-EMBL/rhdf5/issues/69
  ind <- 2
  expect_silent(did[ind, ind] <- 12L)
  ## in native R the 0 would be repeated to fill the space
  # expect_silent( did[1:3,5:7] <- 0 )

  ## close dataset and check the values are permanent
  expect_silent(H5Dclose(did))
  expect_silent(did <- H5Dopen(h5loc = fid, name = "A"))
  expect_identical(did[, 1], 1001:1010)
  expect_identical(did[10, ], seq(10L, 200L, 10L) + 1000L)
  expect_identical(did[1:3, 5:7], matrix(0L, ncol = 3, nrow = 3))
  expect_identical(did[2, 2], 12L)
  expect_silent(H5Dclose(did))

  expect_error(did[, 1] <- 10:1, regexp = "Bad HDF5 ID")
  expect_error(
    fid[, 3] <- 10,
    regexp = "The provided H5Identifier is not a dataset identifier"
  )

  expect_silent(H5Fclose(fid))
})

library(rhdf5)

############################################################
context("h5ls")
############################################################

A <- 1:7
B <- 1:18
D <- seq(0, 1, by = 0.1)
## output file name
h5File <- withr::local_tempfile(pattern = "ex_h5ls_", fileext = ".h5")

# create file with group heirachy
h5createFile(h5File)
h5createGroup(file = h5File, group = "foo")
h5createDataset(
  file = h5File,
  dataset = "foo/A",
  dims = c(1, length(A)),
  maxdims = c(2, 50)
)
h5write(obj = A, file = h5File, name = "foo/A")
h5createDataset(file = h5File, dataset = "foo/B", dims = c(1, length(B)))
h5write(obj = B, file = h5File, name = "foo/B")
h5createDataset(file = h5File, dataset = "baa", dims = c(1, length(D)))
h5write(obj = D, file = h5File, name = "baa")

test_that("Default arguments", {
  ls_output <- h5ls(file = h5File)
  expect_is(ls_output, "data.frame")
  expect_identical(ls_output$name, c("baa", "foo", "A", "B"))
  expect_identical(dim(ls_output), c(4L, 5L))
})

test_that("Expanded information", {
  ls_output <- h5ls(file = h5File, all = TRUE)
  expect_identical(dim(ls_output), c(4L, 12L))
})

test_that("h5ls reads dimensions correctly", {
  ls_output <- h5ls(file = h5File, all = TRUE)
  expect_identical(ls_output[3, "dim"], "1 x 7")
  expect_identical(ls_output[3, "maxdim"], "2 x 50")
})

test_that("Changing recursion depth", {
  expect_silent(ls_output <- h5ls(file = h5File, recursive = FALSE))
  expect_identical(dim(ls_output), c(2L, 5L))
  expect_identical(ls_output$name, c("baa", "foo"))

  expect_identical(h5ls(h5File, recursive = 1), ls_output)
  expect_identical(h5ls(h5File, recursive = -1), h5ls(h5File))

  expect_error(h5ls(h5File, recursive = 0))
  expect_warning(
    h5ls(h5File, recursive = 1:3),
    regexp = "'recursive' must be of length 1"
  )
  expect_error(h5ls(h5File, recursive = "TRUE"))
})

test_that("Changing traversal order", {
  expect_identical(
    h5ls(h5File, order = "H5_ITER_DEC")$name,
    c("foo", "B", "A", "baa")
  )
  expect_identical(
    h5ls(h5File, order = "H5_ITER_INC")$name,
    c("baa", "foo", "A", "B")
  )
})

test_that("Passing H5Identifier does not close it", {
  fid <- H5Fopen(h5File)
  expect_is(h5ls(file = fid), class = "data.frame")
  expect_silent(H5Fclose(fid))
})


test_that("h5ls warns if identical groups are detected", {
  createFileWithCopiedGroup <- function(h5file) {
    h5createFile(h5file)
    h5createGroup(h5file, group = "/group1")
    h5createDataset(h5file, dataset = "/dset1", dims = list(50))
    h5write(1:50, h5file, name = "/group1/dset1")
    fid <- H5Fopen(h5file)
    H5Lcopy(fid, "/group1", fid, "/group2")
    H5Fclose(fid)
  }

  h5file <- withr::local_tempfile()
  createFileWithCopiedGroup(h5file)
  expect_warning(h5ls(h5file), regexp = "Identical objects found")
})

test_that("h5ls doesn't report false positives with external links to groups", {
  f1 <- withr::local_tempfile()
  f2 <- withr::local_tempfile()
  h5createFile(f1)
  h5createFile(f2)
  h5createGroup(f1, group = "/test/")
  h5createGroup(f2, group = "/test/")
  h5write(1:10, file = f1, name = "/test/A")
  h5write(1:10, file = f2, name = "/test/B")

  f3 <- withr::local_tempfile()
  fid <- H5Fcreate(name = f3)
  H5Lcreate_external(
    link_loc = fid,
    link_name = "A",
    target_file_name = f2,
    target_obj_name = "/test/"
  )
  H5Lcreate_external(
    link_loc = fid,
    link_name = "B",
    target_file_name = f3,
    target_obj_name = "/test/"
  )
  H5Fclose(fid)

  expect_silent(h5ls(f1, recursive = 1))
})

library(rhdf5)

h5File <- withr::local_tempfile(pattern = "H5Close_", fileext = ".h5")
h5createFile(h5File)
h5write(1:10, file = h5File, name = "DS1")

test_that("Object handles can be closed", {
  ## open file and create orphan group
  fid <- H5Fopen(h5File)
  gid <- H5Gcreate_anon(fid)
  did <- H5Dopen(fid, name = "DS1")

  expect_length(h5validObjects(), 3)

  ## close only the dataset
  expect_silent(h5closeAll(did))
  expect_length(h5validObjects(), 2)

  ## close the file and group ids
  expect_silent(h5closeAll(gid, fid))
  expect_length(h5validObjects(), 0)
})

library(rhdf5)

############################################################
context("H5Fcreate")
############################################################

test_that("Invalid file names", {
  expect_error(
    H5Fcreate(name = 1),
    regexp = "must be a character string of length 1"
  )
  expect_error(
    H5Fcreate(name = c("F1", "F2")),
    regexp = "must be a character string of length 1"
  )
})

h5File <- withr::local_tempfile(pattern = "H5F_", fileext = ".h5")

test_that("Default arguments", {
  expect_silent(fid <- H5Fcreate(name = h5File))
  expect_is(fid, "H5IdComponent")
  H5Fclose(fid)
})

## this should really be an error
# test_that("Fail if file already open", {
#    fid <- H5Fopen(name = h5File)
#    expect_message( fid2 <- H5Fcreate(name = h5File),
#                  regexp = "unable to create file")
#    H5Fclose(fid)
# })

test_that("Non-ASCII filename", {
  for (name in c("éxample", "år")) {
    tmp_dir <- file.path(tempdir(), name)
    dir.create(tmp_dir, showWarnings = FALSE)
    ## this gives a UTF-8 encoded file path on windows
    h5File <- normalizePath(
      withr::local_tempfile(pattern = "H5F", fileext = ".h5", tmpdir = tmp_dir),
      mustWork = FALSE
    )

    fid <- H5Fcreate(h5File)
    expect_true(file.exists(h5File))
    H5Fclose(fid)
  }
})

############################################################
context("H5Fis_hdf5")
############################################################

h5File <- withr::local_tempfile(pattern = "H5F_", fileext = ".h5")


test_that("Invalid file names", {
  expect_error(
    H5Fis_hdf5(name = 1),
    regexp = "must be a character string of length 1"
  )
  expect_error(
    H5Fis_hdf5(name = c("F1", "F2")),
    regexp = "must be a character string of length 1"
  )
})

test_that("Missing file", {
  expect_warning(
    res <- H5Fis_hdf5(name = "/foo/baa.h5"),
    regexp = "File does not exist."
  )
  expect_identical(res, NA)
})

test_that("Check if HDF5", {
  ## create a new HDF5 file
  if (file.exists(h5File)) {
    file.remove(h5File)
  }
  expect_silent(fid <- H5Fcreate(name = h5File))
  H5Fclose(fid)
  ## write a non HDF5 file
  txtFile <- withr::local_tempfile(fileext = "txt")
  writeLines(text = "foo\nbaa", con = txtFile)

  expect_true(H5Fis_hdf5(name = h5File))
  expect_false(H5Fis_hdf5(name = txtFile))
})

############################################################
context("H5F Misc")
############################################################

fid <- H5Fopen(name = h5File)

test_that("H5Fflush doesn't error", {
  expect_silent(H5Fflush(h5file = fid))
})

test_that("H5Fget_name", {
  expect_true(grepl(x = H5Fget_name(h5obj = fid), pattern = basename(h5File)))
})

test_that("H5Fget_filesize", {
  expect_is(H5Fget_filesize(h5file = fid), "numeric") %>%
    expect_lt(1000) %>%
    expect_gt(0)
})

H5Fclose(fid)

############################################################
context("H5F intent")
############################################################

fid <- H5Fopen(name = h5File, flags = "H5F_ACC_RDONLY")
test_that("H5Fget_intent reports read only", {
  expect_identical(H5Fget_intent(h5file = fid), "H5F_ACC_RDONLY")
})
H5Fclose(fid)

fid <- H5Fopen(name = h5File, flags = "H5F_ACC_RDWR")
test_that("H5Fget_intent reports read only", {
  expect_identical(H5Fget_intent(h5file = fid), "H5F_ACC_RDWR")
})
H5Fclose(fid)

############################################################
context("H5F plists")
############################################################

test_that("Property list getters", {
  expect_silent(fid <- H5Fopen(name = h5File))

  expect_silent(create_plist <- H5Fget_create_plist(fid)) %>%
    expect_is("H5IdComponent")
  expect_output(show(create_plist), "HDF5 GENPROP_LST")
  expect_silent(H5Pclose(create_plist))

  expect_silent(access_plist <- H5Fget_access_plist(fid)) %>%
    expect_is("H5IdComponent")
  expect_output(show(access_plist), "HDF5 GENPROP_LST")
  expect_silent(H5Pclose(access_plist))

  expect_silent(H5Fclose(fid))
})

library(rhdf5)

Dim = 10000000
Data = 1:10000000L
Data2 = 1:10000000L

chunksize = 10L^(0:6)
level = c(0, 3, 6, 9)

nchunks = length(chunksize)
WT = matrix(-1, nrow = nchunks, ncol = 4)
RT = matrix(-1, nrow = nchunks, ncol = 4)
S = matrix(-1, nrow = nchunks, ncol = 4)

for (i in 1:nchunks) {
  for (j in 1:4) {
    h5createFile("test.h5")
    h5createDataset(
      "test.h5",
      "A",
      dims = Dim,
      storage.mode = "integer",
      chunk = chunksize[i],
      level = level[j]
    )

    t1 = Sys.time()
    for (k in 1:100) {
      h5write(
        Data[1:10000 + (k - 1) * 10000],
        "test.h5",
        "A",
        index = list(1:10000 + (k - 1) * 10000)
      )
    }
    t2 = Sys.time()
    dt1 = as.double(t2 - t1)
    WT[i, j] = dt1

    t1 = Sys.time()
    for (k in 1:100) {
      Data2[1:10000 + (k - 1) * 10000] = h5read(
        "test.h5",
        "A",
        index = list(1:10000 + (k - 1) * 10000)
      )
    }
    t2 = Sys.time()
    dt2 = as.double(t2 - t1)
    RT[i, j] = dt2

    s = file.info("test.h5")$size
    S[i, j] = s
    file.remove("test.h5")

    cat(
      "i = ",
      i,
      "; j = ",
      j,
      "; t1 = ",
      dt1,
      "; t1 = ",
      dt2,
      " size=",
      s,
      "\n"
    )
  }
}

pdf(file = "chunksize.pdf")
par(mfrow = c(3, 1))
ylim = range(c(WT))
col = rainbow(4)
plot(
  NA,
  xlim = c(1, nchunks),
  ylim = ylim,
  xlab = "chunksize",
  ylab = "time (sec)",
  main = "writing time",
  xaxt = "n"
)
axis(1, 1:nchunks, chunksize)
chunk.x <- t(replicate(4, jitter(1:nchunks, factor = 0.5)))
for (i in 1:4) {
  lines(chunk.x[i, ], WT[, i], col = col[i], pch = 20, lwd = 3, type = "b")
}
legend(
  "topright",
  sprintf("level = %d", c(0, 3, 6, 9)),
  fill = col,
  inset = 0.01
)

ylim = range(c(RT))
plot(
  NA,
  xlim = c(1, nchunks),
  ylim = ylim,
  xlab = "chunksize",
  ylab = "time (sec)",
  main = "reading time",
  xaxt = "n"
)
axis(1, 1:nchunks, chunksize)
for (i in 1:4) {
  lines(chunk.x[i, ], RT[, i], col = col[i], pch = 20, lwd = 3, type = "b")
}
legend(
  "topright",
  sprintf("level = %d", c(0, 3, 6, 9)),
  fill = col,
  inset = 0.01
)

ylim = range(c(log10(S)))
plot(
  NA,
  xlim = c(1, nchunks),
  ylim = ylim,
  xlab = "chunksize",
  ylab = "byte [log10]",
  main = "file size",
  xaxt = "n"
)
axis(1, 1:nchunks, chunksize)
for (i in 1:4) {
  lines(
    chunk.x[i, ],
    log10(S[, i]),
    col = col[i],
    pch = 20,
    lwd = 3,
    type = "b"
  )
}
legend(
  "topright",
  sprintf("level = %d", c(0, 3, 6, 9)),
  fill = col,
  inset = 0.01
)
dev.off()

#' Create a new dataspace of a specified type
#'
#' @param type The type of dataspace to create. See `h5const("H5S")` for
#'   possible types.
#' @param native An object of class `logical`. If `TRUE`, array-like
#'   objects are treated as stored in HDF5 row-major rather than R column-major
#'   orientation. Using `native = TRUE` increases HDF5 file portability between
#'   programming languages. A file written with `native = TRUE` should also be
#'   read with `native = TRUE`.
#'
#' @return Returns an object of class [H5IdComponent-class] representing a
#'   dataspace.
#'
#' @seealso [H5Screate_simple]
#'
#' @export
H5Screate <- function( type = h5default("H5S"), native = FALSE ) {
  type <- h5checkConstants( "H5S", type )
  sid <- .Call("_H5Screate", type, PACKAGE='rhdf5')
  if (sid > 0) {
    h5space = new("H5IdComponent", ID = sid, native = native)
  } else {
    message("HDF5: unable to create data space")
    h5space = FALSE
  }
  invisible(h5space)
}


#' Create a simple dataspace
#'
#' @param dims An integer vector defining the initial dimensions of the dataspace.
#' The length of `dims` determines the rank of the dataspace.
#' @param maxdims An integer vector with the same length length as `dims`.  Specifies the 
#' upper limit on the size of the dataspace dimensions.  Only needs to be specified
#' if this is different from the values given to `dims`.
#' @param native An object of class `logical`. If `TRUE`, array-like
#'   objects are treated as stored in HDF5 row-major rather than R column-major
#'   orientation. Using `native = TRUE` increases HDF5 file portability between
#'   programming languages. A file written with `native = TRUE` should also be
#'   read with `native = TRUE`.
#'
#' @return Returns an object of class [H5IdComponent-class] representing a
#'   dataspace.
#'
#' @seealso [H5Screate]
#'
#' @export
H5Screate_simple <- function( dims, maxdims, native = FALSE ) {
  if (missing(maxdims)) {
    maxdims = dims
  }
  dims <- as.numeric(dims)
  maxdims <- as.numeric(maxdims)
  if (!native) {
    dims <- rev(dims)
    maxdims <- rev(maxdims)
  }
  sid <- .Call("_H5Screate_simple", dims, maxdims, PACKAGE='rhdf5')
  if (sid > 0) {
    h5space = new("H5IdComponent", ID = sid, native = native)
  } else {
    message("HDF5: unable to create simple data space")
    h5space = FALSE
  }
  invisible(h5space)
}

#' Close and release a dataspace
#' 
#' @param h5space Object of class [H5IdComponent-class] representing the 
#' dataspace to be closed.
#' 
#' @seealso [H5Screate()]
#' 
#' @export
H5Sclose <- function( h5space ) {
  h5checktype(h5space, "dataspace")
  invisible(.Call("_H5Sclose", h5space@ID, PACKAGE='rhdf5'))
}

#' Create a copy of a dataspace
#' 
#' `H5S_copy()` creates an exact copy of a given dataspace.
#' 
#' @param h5space Object of class [H5IdComponent-class] representing the 
#' dataspace to be copied.
#' 
#' @return If the copying is successful returns an object of class 
#' [H5IdComponent-class] representing the new dataspace.  Otherwise returns
#' `FALSE`.
#' 
#' @export
H5Scopy <- function( h5space ) {
  h5checktype(h5space, "dataspace")
  sid <- .Call("_H5Scopy", h5space@ID, PACKAGE='rhdf5')
  if (sid > 0) {
    h5spacenew = new("H5IdComponent", ID = sid, native = h5space@native)
  } else {
    message("HDF5: unable to copy data space")
    h5spacenew = FALSE
  }
  invisible(h5spacenew)
}



#' Determine whether a dataspace is a simple dataspace
#' 
#' In HDF5 a dataspace is considered "simple" if it represents a regular
#' N-dimensional array of points.
#' Currently (HDF 1.10.7) all dataspaces are simple.  Support for complex
#' dataspaces is planned for future HDF versions.
#' 
#' @param h5space [H5IdComponent-class] object representing a dataspace.
#' 
#' @export
H5Sis_simple<- function( h5space ) {
  h5checktype(h5space, "dataspace")
  as.logical(.Call("_H5Sis_simple", h5space@ID, PACKAGE='rhdf5'))
}

#' Find the size of a dataspace
#' 
#' @param h5space [H5IdComponent-class] object representing a dataspace.
#' 
#' @export
H5Sget_simple_extent_dims <- function( h5space ) {
  h5checktype(h5space, "dataspace")
  res <- .Call("_H5Sget_simple_extent_dims", h5space@ID, PACKAGE='rhdf5')
  if (length(res) > 2 && !h5space@native) {
    res$size <- rev(res$size)
    res$maxsize <- rev(res$maxsize)
  }
  res
}

#' Set the size of a dataspace
#' 
#' @param h5space [H5IdComponent-class] object representing a dataspace.
#' @param dims Dimension of the dataspace. This argument is similar to the dim
#' attribute of an array. When viewing the HDF5 dataset with an C-program 
#' (e.g. HDFView), the dimensions appear in inverted order, because the 
#' fastest changing dimension in R is the first one, and in C its the last 
#' one.
#' @param maxdims Maximum extension of the dimension of the dataset in the 
#' file. If not provided, it is set to `dims`.
#' 
#' @export
H5Sset_extent_simple <- function( h5space, dims, maxdims) {
  h5checktype(h5space, "dataspace")
  if (missing(maxdims)) {
    maxdims = dims
  }
  dims <- as.numeric(dims)
  maxdims <- as.numeric(maxdims)
  if (!h5space@native){
      dims <- rev(dims)
      maxdims <- rev(maxdims)
  }
  res <- .Call("_H5Sset_extent_simple", h5space@ID, dims, maxdims, PACKAGE='rhdf5')
  invisible(res)
}

#' Find the number of elements in a dataspace selection
#' 
#' @param h5space [H5IdComponent-class] object representing a dataspace.
#' 
#' @export
H5Sget_select_npoints <- function( h5space ) {
  h5checktype(h5space, "dataspace")
  res <- .Call('_H5Sget_select_npoints', h5space@ID, PACKAGE = "rhdf5")
  return(res)
}

#' Set the selection region of a dataspace to include all elements
#' 
#' @param h5space [H5IdComponent-class] object representing a dataspace.
#' 
#' @export
H5Sselect_all <- function(h5space) {
  h5checktype(h5space, "dataspace")
  res <- .Call("_H5Sselect_all", h5space@ID, PACKAGE='rhdf5')
  invisible(res)
}

#' Set the selection region of a dataspace to include no elements
#' 
#' @param h5space [H5IdComponent-class] object representing a dataspace.
#' 
#' @export
H5Sselect_none <- function(h5space) {
  h5checktype(h5space, "dataspace")
  res <- .Call("_H5Sselect_none", h5space@ID, PACKAGE='rhdf5')
  invisible(res)
}

#' Check that a selection is valid
#' 
#' @param h5space [H5IdComponent-class] object representing a dataspace.
#' 
#' @export
H5Sselect_valid <- function(h5space) {
  h5checktype(h5space, "dataspace")
  res <- .Call("_H5Sselect_valid", h5space@ID, PACKAGE='rhdf5')
  invisible(res)
}


H5Sselect_elements <- function( h5space, op = h5default("H5S_SELECT"), index) {
  
  op <- h5checkConstants( "H5S_SELECT", op )
  
  dims <- H5Sget_simple_extent_dims( h5space )
  
  if(length(index) != dims$rank) {
    stop("Index must be the same length as the rank of the dataspace.")
  }
  
  if(h5space@native) {
    coords <- expand.grid(index)
  } else {
    coords <- rev(expand.grid(index))
  }
  
  coords <- as.integer(t(coords))
  numElements <- as.integer(length(coords) / dims$rank)
  
  res <- .Call("_H5Sselect_elements", h5space@ID, op, numElements, coords, PACKAGE='rhdf5')
  if(res < 0) { 
    stop("Error selecting elements")
  }
  
  size <- H5Sget_select_npoints(h5space)
  return(size)
}

#' Perform operation between an existing selection and an another 
#' hyperslab definition.
#' 
#' Combines a hyperslab selection specified by `start`, `stride`, `count` and 
#' `block` arguments with the current selection for the dataspace 
#' represented by `h5space`.
#' 
#' @details `H5Sselect_hyperslab` is similar to, but subtly different from, 
#' [H5Scombine_hyperslab()].  The former modifies the selection of the 
#' dataspace provided in the `h5space` argument, while the later returns a
#' new dataspace with the combined selection.
#' 
#' @param h5space [H5IdComponent-class] object representing a dataspace.
#' @param op Character string defined the operation used to join the two 
#' dataspaces.  See `h5const("H5S_SELECT")` for the list of available options.
#' @param start,stride,count,block Integer vectors, each with length equal
#' to the rank of the dataspace.  These parameters define the new hyperslab
#' to select.
#' 
#' @examples 
#' 
#' ## create a 1 dimensional dataspace
#' sid_1 <- H5Screate_simple(dims = 20)
#' 
#' ## select a single block of 5 points in sid_1
#' ## this is equivalent to [11:16] in R syntax
#' H5Sselect_hyperslab(sid_1, start = 11, stride = 1, 
#'                     block = 5, count = 1)
#'                     
#' ## confirm we have selected 5 in our original dataspace
#' H5Sget_select_npoints(sid_1)
#' 
#' ## combine the existing selection with a new
#' ## selection consisting of 2 blocks each of 1 point
#' ## equivalent to [c(3,5)] in R syntax
#' H5Sselect_hyperslab(sid_1, op = "H5S_SELECT_OR",
#'                      start = 3, stride = 2, 
#'                      block = 1, count = 2)
#' 
#' ## The dataspace now has 7 points selected
#' H5Sget_select_npoints(sid_1)
#' 
#' ## tidy up
#' H5Sclose(sid_1)
#' 
#' @export
H5Sselect_hyperslab <- function( h5space, op = h5default("H5S_SELECT"), 
                                 start=NULL, stride=NULL, count=NULL, block=NULL ) {
  h5checktype(h5space, "dataspace")
  op <- h5checkConstants( "H5S_SELECT", op )

  dims <- H5Sget_simple_extent_dims( h5space )
  R <- dims$rank
  if (is.null(start)) {
    start <- rep(1, R)
  } else {
    if (length(start) != R) {
      stop(sprintf("start must either be NULL or have length %d (rank of dataspace)",R))
    }
  }
  if (is.null(stride)) {
    stride <- rep(1, R)
  } else {
    if (length(stride) != R) {
      stop(sprintf("stride must either be NULL or have length %d (rank of dataspace)",R))
    }
  }
  if (is.null(count)) {
    count <- dims$size
  } else {
    if (length(count) != R) {
      stop(sprintf("count must either be NULL or have length %d (rank of dataspace)",R))
    }
  }
  if (is.null(block)) {
    block <- rep(1, R)
  } else {
    if (length(block) != R) {
      stop(sprintf("block must either be NULL or have length %d (rank of dataspace)",R))
    }
  }

  count <- as.numeric(count)
  block <- as.numeric(block)
  stride <- as.numeric(stride)
  size <- count * block
  start <- start - 1
  if (!h5space@native) {
    start <- rev(start)
    stride <- rev(stride)
    count <- rev(count)
    block <- rev(block)
  }

  res <- .Call("_H5Sselect_hyperslab", h5space@ID, op, start, stride, count, block, PACKAGE='rhdf5')
  if(res < 0) { stop("Error selecting hyperslab") }
  invisible(size)
}

#' Perform operation between an existing selection and an another 
#' hyperslab definition.
#' 
#' Combines a hyperslab selection specified by `start`, `stride`, `count` and 
#' `block` arguments with the current selection for the dataspace 
#' represented by `h5space`.
#' 
#' @param h5space [H5IdComponent-class] object representing a dataspace.
#' @param op Character string defined the operation used to join the two 
#' dataspaces.  See `h5const("H5S_SELECT")` for the list of available options.
#' @param start,stride,count,block Integer vectors, each with length equal
#' to the rank of the dataspace.  These parameters define the new hyperslab
#' to select.
#'  
#' @returns An [H5IdComponent-class] object representing a new dataspace 
#' with the generated selection.
#' 
#' @examples 
#' 
#' ## create a 1 dimensional dataspace
#' sid_1 <- H5Screate_simple(dims = 20)
#' 
#' ## select a single block of 5 points in sid_1
#' ## this is equivalent to [11:16] in R syntax
#' H5Sselect_hyperslab(sid_1, start = 11, stride = 1, 
#'                     block = 5, count = 1)#
#' 
#' ## combine the existing selection with a new
#' ## selection consisting of 2 blocks each of 1 point
#' ## equivalent to [c(3,5)] in R syntax
#' sid_2 <- H5Scombine_hyperslab(sid_1, op = "H5S_SELECT_OR",
#'                               start = 3, stride = 2, 
#'                               block = 1, count = 2)
#' 
#' ## confirm we have selected 5 in our original dataspace
#' ## and 7 points in the newly created dataspace
#' H5Sget_select_npoints(sid_1)
#' H5Sget_select_npoints(sid_2)
#' 
#' ## tidy up
#' H5Sclose(sid_1)
#' H5Sclose(sid_2)
#' 
#' @seealso [H5Scombine_select()], [H5Sselect_hyperslab()]
#' 
#' @export
H5Scombine_hyperslab <- function( h5space, op = h5default("H5S_SELECT"), 
                                  start=NULL, stride=NULL, count=NULL, block=NULL ) {
  
  h5checktype(h5space, "dataspace")
  op <- h5checkConstants( "H5S_SELECT", op )
  
  dims <- H5Sget_simple_extent_dims( h5space )
  R <- dims$rank
  if (is.null(start)) {
    start <- rep(1, R)
  } else {
    if (length(start) != R) {
      stop(sprintf("start must either be NULL or have length %d (rank of dataspace)",R))
    }
  }
  if (is.null(stride)) {
    stride <- rep(1, R)
  } else {
    if (length(stride) != R) {
      stop(sprintf("stride must either be NULL or have length %d (rank of dataspace)",R))
    }
  }
  if (is.null(count)) {
    count <- dims$size
  } else {
    if (length(count) != R) {
      stop(sprintf("count must either be NULL or have length %d (rank of dataspace)",R))
    }
  }
  if (is.null(block)) {
    block <- rep(1, R)
  } else {
    if (length(block) != R) {
      stop(sprintf("block must either be NULL or have length %d (rank of dataspace)",R))
    }
  }
  
  count <- as.numeric(count)
  block <- as.numeric(block)
  stride <- as.numeric(stride)
  size <- count * block
  start <- start - 1
  if (!h5space@native) {
    start <- rev(start)
    stride <- rev(stride)
    count <- rev(count)
    block <- rev(block)
  }
  
  sid <- .Call("_H5Scombine_hyperslab", h5space@ID, op, start, stride, count, block, PACKAGE='rhdf5')
  if (sid > 0) {
    h5spacenew = new("H5IdComponent", ID = sid, native = h5space@native)
  } else {
    message("HDF5: error combining hyperslabs")
    h5spacenew = FALSE
  }
  
  invisible(h5spacenew)
  
}

#' Combine two selections
#' 
#' @param h5space1,h5space2 [H5IdComponent-class] objects representing a dataspaces.
#' @param op Character string defined the operation used to join the two 
#' dataspaces.  See `h5const("H5S_SELECT")` for the list of available options.
#' 
#' @return Returns an [H5IdComponent-class] object representing a new dataspace.
#' The new dataspace will have the same extent as `h5space1` with the 
#' hyperslab selection being the result of combining the selections of 
#' `h5space1` and `h5space2`.
#' 
#' @examples 
#' 
#' ## create two 1 dimensional dataspaces
#' ## of different sizes
#' sid_1 <- H5Screate_simple(dims = 20)
#' sid_2 <- H5Screate_simple(dims = 10)
#' 
#' ## select a single block of 5 points in sid_1
#' ## this is equivalent to [11:16] in R syntax
#' H5Sselect_hyperslab(sid_1, start = 11, stride = 1, 
#'                     block = 5, count = 1)
#' 
#' ## select 2 blocks of 1 point from sid_2
#' ## equivalent to [c(3,5)] in R syntax
#' H5Sselect_hyperslab(sid_2, start = 3, stride = 2, 
#'                     block = 1, count = 2)
#' 
#' ## confirm we have select 5 and 2 points resepectively
#' H5Sget_select_npoints(sid_1)
#' H5Sget_select_npoints(sid_2)
#' 
#' ## combine the two dataset selections keeping points that
#' ## are in one or both of the selections
#' sid_3 <- H5Scombine_select(sid_1, "H5S_SELECT_OR", sid_2)
#' 
#' ## extent of the new dataset is the same as sid_1
#' sid_3
#' ## confirm the selection contains 7 points
#' H5Sget_select_npoints(sid_3)
#' 
#' ## tidy up
#' H5Sclose(sid_1)
#' H5Sclose(sid_2)
#' H5Sclose(sid_3)
#' 
#' @seealso [H5Scombine_hyperslab()]
#' 
#' @export
H5Scombine_select <- function( h5space1, op = h5default("H5S_SELECT"), h5space2 ) {
  h5checktype(h5space1, "dataspace")
  h5checktype(h5space2, "dataspace")
  op <- h5checkConstants( "H5S_SELECT", op )
  
  sid <- .Call("_H5Scombine_select", h5space1@ID, op, h5space2@ID)
  
  if (sid > 0) {
    h5spacenew = new("H5IdComponent", ID = sid, native = h5space1@native)
  } else {
    message("HDF5: unable to copy data space")
    h5spacenew = FALSE
  }
  invisible(h5spacenew)
  
}

#' Retrieve value for `H5S_UNLIMITED` constant
#' 
#' The value for `H5S_UNLIMITED` can be provided to the `maxdims` argument of [H5Screate_simple] 
#' to indicate that the maximum size of the corresponding dimension is unlimited.
#' 
#' @seealso [H5Screate_simple]
#' 
#' @export
H5Sunlimited <- function()  {
  as.integer(h5checkConstants("H5S_UNLIMITED", "H5S_UNLIMITED"))
}

library(rhdf5)

############################################################
context("H5Screate")
############################################################

test_that("Dataspace creation & closure", {
  expect_silent(sid <- H5Screate())
  expect_is(sid, "H5IdComponent")
  expect_silent(H5Sclose(sid))

  expect_silent(sid <- H5Screate(type = "H5S_SIMPLE"))
  expect_is(sid, "H5IdComponent")
  expect_silent(H5Sclose(sid))

  expect_silent(sid <- H5Screate(type = "H5S_NULL"))
  expect_is(sid, "H5IdComponent")
  expect_silent(H5Sclose(sid))

  expect_null(h5errorHandling(type = "suppress"))
  expect_message(sid <- H5Screate(type = "FOO"))
  expect_false(sid)
})

############################################################
context("H5Scopy")
############################################################

test_that("Dataspace copying", {
  sid <- H5Screate()
  expect_silent(sid2 <- H5Scopy(sid))
  expect_false(identical(sid, sid2))
  expect_silent(H5Sclose(sid))
  expect_silent(H5Sclose(sid2))
})

test_that("Dataspace copy fails on bad input", {
  expect_error(sid <- H5Scopy("foo"))
})

############################################################
context("H5S simple")
############################################################

test_that("We can create a simple dataspace", {
  expect_silent(sid <- H5Screate_simple(dims = c(10, 2)))
  expect_is(sid, "H5IdComponent")
  expect_true(H5Sis_simple(sid))

  expect_is(dspace_dims <- H5Sget_simple_extent_dims(sid), "list")
  expect_named(dspace_dims, c("rank", "size", "maxsize"))
  expect_identical(dspace_dims$size, dspace_dims$maxsize)
  expect_identical(dspace_dims$rank, 2L)

  ## if maxdims isn't supplied, it just matches dims
  expect_silent(H5Sset_extent_simple(sid, dims = c(1, 1, 1)))
  dspace_dims <- H5Sget_simple_extent_dims(sid)
  expect_identical(dspace_dims$size, dspace_dims$maxsize)

  expect_silent(H5Sset_extent_simple(
    sid,
    dims = c(1, 2, 3),
    maxdims = c(10, 20, 30)
  ))
  expect_is(dspace_dims <- H5Sget_simple_extent_dims(sid), "list")
  expect_false(identical(dspace_dims$size, dspace_dims$maxsize))
  expect_identical(dspace_dims$rank, 3L)

  expect_silent(H5Sclose(sid))
})

test_that("We can create a dataspace with unlimited or non 32-bit integer dims", {
  expect_silent(sid <- H5Screate_simple(dims = c(10, 2), maxdims = c(10, 3e9)))
  dspace_dims <- H5Sget_simple_extent_dims(sid)
  expect_is(dspace_dims$maxsize, "numeric")
  expect_identical(dspace_dims$maxsize, c(10, 3e9))

  expect_silent(H5Sset_extent_simple(
    sid,
    dims = c(1, 2),
    maxdims = c(10, H5Sunlimited())
  ))
  dspace_dims <- H5Sget_simple_extent_dims(sid)
  expect_is(dspace_dims$maxsize, "integer")
  expect_identical(dspace_dims$maxsize, c(10L, -1L))

  expect_silent(H5Sclose(sid))
})

############################################################
context("H5S Select Hyperslab")
############################################################

test_that("Selecting hyperslabs", {
  expect_silent(sid <- H5Screate_simple(dims = c(10, 20)))

  expect_silent(H5Sselect_hyperslab(sid))

  ## errors when not providing enough dimensions
  expect_error(H5Sselect_hyperslab(sid, start = 2))
  expect_error(H5Sselect_hyperslab(sid, stride = 2))
  expect_error(H5Sselect_hyperslab(sid, count = 2))
  expect_error(H5Sselect_hyperslab(sid, block = 2))

  expect_silent(H5Sclose(sid))

  ## error in incorrect input
  expect_error(H5Sselect_hyperslab("foo"))
})

############################################################
context("H5S Select Index")
############################################################

test_that("Selecting using an index", {
  expect_silent(sid <- H5Screate_simple(dims = c(10, 20, 30)))

  expect_silent(size <- H5Sselect_index(sid, index = list(1:5, 1:5, 11:15)))
  expect_identical(size, c(5, 5, 5))

  expect_silent(size <- H5Sselect_index(sid, index = list(NULL, NULL, NULL)))
  expect_identical(size, c(10, 20, 30))

  ## errors when not providing enough dimensions or incorrect dimensions
  expect_error(
    H5Sselect_index(sid, index = list(10)),
    regexp = "length of list index not equal to h5space dimensional extension"
  )
  expect_error(
    H5Sselect_index(sid, index = list(1:5, 1:5, 0:5)),
    regexp = "negative indices and 0 not supported"
  )
  expect_error(
    H5Sselect_index(sid, index = list(1:15, 1:5, 1:5)),
    regexp = "index exceeds HDF5-array dimension"
  )

  expect_silent(H5Sclose(sid))
})

test_that("Other selection functions", {
  dims <- c(10, 20, 30)
  expect_silent(sid <- H5Screate_simple(dims = dims))

  expect_silent(H5Sselect_all(sid))
  expect_identical(H5Sget_select_npoints(sid), prod(dims))

  expect_silent(H5Sselect_none(sid))
  expect_identical(H5Sget_select_npoints(sid), 0)

  expect_silent(H5Sclose(sid))
})

test_that("Combining selections", {
  sid_1 <- H5Screate_simple(dims = 20)
  sid_2 <- H5Screate_simple(dims = 10)

  ## select a single block of 5 points in sid_1
  ## this is equivalent to [11:16] in R syntax
  H5Sselect_hyperslab(sid_1, start = 11, stride = 1, block = 5, count = 1)

  ## select 2 blocks of 1 point from sid_2
  ## equivalent to [c(3,5)] in R syntax
  H5Sselect_hyperslab(sid_2, start = 3, stride = 2, block = 1, count = 2)

  ## confirm we have select 5 and 2 points resepectively
  expect_identical(H5Sget_select_npoints(sid_1), 5)
  expect_identical(H5Sget_select_npoints(sid_2), 2)

  ## combine the two dataset selections keeping points that
  ## are in one or both of the selections
  sid_3 <- H5Scombine_select(sid_1, "H5S_SELECT_OR", sid_2)

  ## extent of the new dataset is the same as sid_1
  sid_3
  ## confirm the selection contains 7 points
  expect_identical(H5Sget_select_npoints(sid_3), 7)

  ## tidy up
  H5Sclose(sid_1)
  H5Sclose(sid_2)
  H5Sclose(sid_3)
})

library(rhdf5)

############################################################
context("h5ls supports native functionality")
############################################################

h5File <- withr::local_tempfile(fileext = ".h5")

h5createFile(file = h5File)

test_that("h5ls supports native", {
  h5createGroup(file = h5File, group = "test")
  m0 <- matrix(1:12, 3, 4)

  h5write(m0, file = h5File, name = "test/native", native = TRUE)
  h5write(m0, file = h5File, name = "test/nonnative", native = FALSE)

  xx <- h5ls(h5File)
  object <- subset(xx, group == "/test" & name == "nonnative", "dim")[[1]]
  expect_identical(object, "3 x 4")
  object <- subset(xx, group == "/test" & name == "native", "dim")[[1]]
  expect_identical(object, "4 x 3")

  xx <- h5ls(h5File, native = TRUE)
  object <- subset(xx, group == "/test" & name == "nonnative", "dim")[[1]]
  expect_identical(object, "4 x 3")
  object <- subset(xx, group == "/test" & name == "native", "dim")[[1]]
  expect_identical(object, "3 x 4")

  m0 <- array(1:24, c(2, 3, 4))
  h5write(m0, file = h5File, name = "test/native-array", native = TRUE)
  h5write(m0, file = h5File, name = "test/nonnative-array", native = FALSE)

  xx <- h5ls(h5File)
  object <-
    subset(xx, group == "/test" & name == "nonnative-array", "dim")[[1]]
  expect_identical(object, "2 x 3 x 4")
  object <-
    subset(xx, group == "/test" & name == "native-array", "dim")[[1]]
  expect_identical(object, "4 x 3 x 2")

  xx <- h5ls(h5File, native = TRUE)
  object <-
    subset(xx, group == "/test" & name == "nonnative-array", "dim")[[1]]
  expect_identical(object, "4 x 3 x 2")
  object <-
    subset(xx, group == "/test" & name == "native-array", "dim")[[1]]
  expect_identical(object, "2 x 3 x 4")
})

############################################################
context("h5read/h5write supports native functionality")
############################################################

test_that("h5read/write supports native", {
  h5createGroup(file = h5File, group = "test")

  ## matrix
  do_matrix <- function(values, nrow, ncol, val) {
    m0 <- matrix(values, nrow, ncol)

    h5write(
      m0,
      file = h5File,
      name = paste0("test/nonnative", val),
      native = FALSE
    )
    m1 <- h5read(
      file = h5File,
      name = paste0("test/nonnative", val),
      native = TRUE
    )
    expect_equivalent(m0, t(m1))
    m2 <- h5read(
      file = h5File,
      name = paste0("test/nonnative", val),
      native = FALSE
    )
    expect_equivalent(m0, m2)

    h5write(m0, file = h5File, name = paste0("test/native", val), native = TRUE)
    m1 <- h5read(
      file = h5File,
      name = paste0("test/native", val),
      native = FALSE
    )
    expect_equivalent(m0, t(m1))
    m2 <- h5read(
      file = h5File,
      name = paste0("test/native", val),
      native = TRUE
    )
    expect_equivalent(m0, m2)
  }
  do_matrix(1:12, 3, 4, "A")
  do_matrix(as.numeric(1:12), 3, 4, "B")
  do_matrix(sample(c(TRUE, FALSE), 12, replace = TRUE), 3, 4, "C")
  do_matrix(LETTERS[1:12], 3, 4, "D")

  ## 3D-array
  do_array <- function(values, dim, val) {
    m0 <- array(values, dim)

    h5write(
      m0,
      file = h5File,
      name = paste0("test/nonnative-array", val),
      native = FALSE
    )
    m1 <- h5read(
      file = h5File,
      name = paste0("test/nonnative-array", val),
      native = TRUE
    )
    expect_equivalent(m0, aperm(m1))
    m2 <- h5read(
      file = h5File,
      name = paste0("test/nonnative-array", val),
      native = FALSE
    )
    expect_equivalent(m0, m2)

    h5write(
      m0,
      file = h5File,
      name = paste0("test/native-array", val),
      native = TRUE
    )
    m1 <- h5read(
      file = h5File,
      name = paste0("test/native-array", val),
      native = FALSE
    )
    expect_equivalent(m0, aperm(m1))
    m2 <- h5read(
      file = h5File,
      name = paste0("test/native-array", val),
      native = TRUE
    )
    expect_equivalent(m0, m2)
  }

  do_array(1:12, c(2, 3, 4), "A")
  do_array(as.numeric(1:12), c(2, 3, 4), "B")
  do_array(sample(c(TRUE, FALSE), 12, replace = TRUE), c(2, 3, 4), "C")
  do_array(LETTERS[1:12], c(2, 3, 4), "D")
})

test_that("h5read/h5write supports index and hyperslab", {
  h5createDataset(file = h5File, dataset = "D", dims = c(10, 9), native = TRUE)

  ## Test index works
  h5write(
    1:4,
    file = h5File,
    name = "D",
    index = list(2:3, c(3, 6)),
    native = TRUE
  )
  res <- h5read(
    file = h5File,
    name = "D",
    index = list(2:3, c(3, 6)),
    native = TRUE
  )
  expect_equal(res, matrix(1:4, nrow = 2, ncol = 2))

  ## Test hyperslabs without stride and block arguments work
  h5write(
    matrix(1:12, nrow = 4, ncol = 3),
    file = h5File,
    name = "D",
    start = c(2, 2),
    stride = NULL,
    count = c(4, 3),
    block = NULL,
    native = TRUE
  )
  expect_equal(
    h5read(h5File, "D", native = TRUE)[2:5, 2:4],
    matrix(1:12, nrow = 4, ncol = 3)
  )
  res <- h5read(
    file = h5File,
    name = "D",
    start = c(2, 2),
    stride = NULL,
    count = c(4, 3),
    block = NULL,
    native = TRUE
  )
  expect_equal(res, matrix(1:12, nrow = 4, ncol = 3))

  ## Test hyperslabs with all arguments work
  h5write(
    matrix(1:48, nrow = 6, ncol = 8),
    file = h5File,
    name = "D",
    start = c(1, 1),
    stride = c(4, 5),
    count = c(2, 2),
    block = c(3, 4),
    native = TRUE
  )
  expect_equal(
    h5read(h5File, "D", native = TRUE)[c(1:3, 5:7), c(1:4, 6:9)],
    matrix(1:48, nrow = 6, ncol = 8)
  )
  res <- h5read(
    file = h5File,
    name = "D",
    start = c(1, 1),
    stride = c(4, 5),
    count = c(2, 2),
    block = c(3, 4),
    native = TRUE
  )
  expect_equal(res, matrix(1:48, nrow = 6, ncol = 8))
})

test_that("h5read native non-R hdf5 files", {
  enum <- system.file("testfiles", "h5ex_t_enum.h5", package = "rhdf5")
  arr <- system.file("testfiles", "h5ex_t_array.h5", package = "rhdf5")
  compound <- system.file("testfiles", "h5ex_t_cmpd.h5", package = "rhdf5")

  # Test enums type
  m1 <- h5read(file = enum, name = "/DS1", native = TRUE)
  m2 <- h5read(file = enum, name = "/DS1", native = FALSE)
  expect_equivalent(m1, t(m2))

  # Test arrays type
  m1 <- h5read(file = arr, name = "/DS1", native = TRUE)
  m2 <- h5read(file = arr, name = "/DS1", native = FALSE)
  expect_equivalent(m1, aperm(m2))

  # Test compound type (currently native provides no different functionality)
  m1 <- h5read(file = compound, name = "/DS1", native = TRUE)
  m2 <- h5read(file = compound, name = "/DS1", native = FALSE)
  expect_equivalent(m1, m2)
})

############################################################
context("H5Sselect_hyperslab supports native functionality")
############################################################

test_that("Selecting hyperslabs", {
  expect_silent(sid <- H5Screate_simple(dims = c(10, 20), native = TRUE))

  expect_silent(H5Sselect_hyperslab(sid))

  expect_silent(H5Sclose(sid))
})

############################################################
context("H5Sselect_index supports native functionality")
############################################################

test_that("Selecting using an index", {
  expect_silent(sid <- H5Screate_simple(dims = c(10, 20, 30)))

  expect_silent(size <- H5Sselect_index(sid, index = list(1:5, 1:5, 11:15)))
  expect_identical(size, c(5, 5, 5))

  expect_silent(size <- H5Sselect_index(sid, index = list(NULL, NULL, NULL)))
  expect_identical(size, c(10, 20, 30))

  ## errors when not providing enough dimensions or incorrect dimensions
  expect_error(
    H5Sselect_index(sid, index = list(10)),
    regexp = "length of list index not equal to h5space dimensional extension"
  )
  expect_error(
    H5Sselect_index(sid, index = list(1:5, 1:5, 0:5)),
    regexp = "negative indices and 0 not supported"
  )
  expect_error(
    H5Sselect_index(sid, index = list(1:15, 1:5, 1:5)),
    regexp = "index exceeds HDF5-array dimension"
  )

  expect_silent(H5Sclose(sid))
})

############################################################
context("H5F supports native functionality")
############################################################

test_that("H5F native functionality", {
  for (native in c(FALSE, TRUE)) {
    h5createGroup(file = h5File, group = "H5Ftest")

    A <- matrix(1:10, nrow = 5, ncol = 2)
    h5write(A, h5File, paste0("H5Ftest/A", native), native = native)

    h5f <- H5Fopen(h5File, native = native)
    h5d <- h5f & paste0("/H5Ftest/A", native)

    expect_equivalent(h5d[,], A)
    expect_equivalent(h5d[1, ], A[1, ])

    h5d[, 1] <- 11:15
    expect_equivalent(h5d[, 1], 11:15)

    H5Oclose(h5d)

    B <- matrix(11:20, nrow = 5, ncol = 2)
    h5writeDataset(B, h5f, paste0("H5Ftest/A", native))

    H5Fclose(h5f)

    expect_equivalent(
      h5read(h5File, paste0("H5Ftest/A", native), native = native),
      B
    )
  }
})

.onLoad <- function(libname, pkgname) {
  h5constants <<- H5loadConstants() # nolint: undesirable_operator_linter.
  h5errorHandling()

  if (requireNamespace("rhdf5filters")) {
    plugin_path <- rhdf5filters::hdf5_plugin_path()
    H5PLprepend(plugin_path)
  }
}

#' Create a new HDF5 group and link it to a location in a file
#'
#' `H5Gcreate` is used to a new group and link it into a file.
#'
#' @param h5loc An object of class [H5IdComponent-class]
#' @param name Name of the new group to be created.
#'
#' @export
H5Gcreate <- function(h5loc, name) {
  h5checktype(h5loc, "loc")
  if (length(name) != 1 || !is.character(name)) {
    stop("'name' must be a character string of length 1")
  }
  gid <- .Call("_H5Gcreate", h5loc@ID, name, PACKAGE = "rhdf5")
  if (gid > 0) {
    h5group <- new("H5IdComponent", ID = gid, native = h5loc@native)
  } else {
    message("HDF5: unable to create group")
    h5group <- FALSE
  }
  invisible(h5group)
}

#' Create a new HDF5 group without linking it into a file
#'
#' @param h5loc An object of class [H5IdComponent-class] specifying the file in
#' which the new group is to be created.
#'
#' @returns `H5Gcreate_anon` returns an object of class [H5IdComponent-class]
#' representing the newly created group.  However at this point is is still
#' anonymous, and must be linked into the file structure via [H5Olink()].
#' If this is not done, the group will be deleted from the file when it
#' is closed.
#'
#' @seealso [H5Gcreate()], [H5Olink()]
#' @export
H5Gcreate_anon <- function(h5loc) {
  h5checktype(h5loc, "loc")
  gid <- .Call("_H5Gcreate_anon", h5loc@ID, PACKAGE = "rhdf5")
  if (gid > 0) {
    h5group <- new("H5IdComponent", ID = gid, native = h5loc@native)
  } else {
    message("HDF5: unable to create group")
    h5group <- FALSE
  }
  invisible(h5group)
}

#' Open a specified group
#'
#' @param h5loc An object of class [H5IdComponent-class] representing a H5
#' file or group that contains the group to be opened.
#' @param name Name of the group to open.
#'
#' @returns An object of class [H5IdComponent-class] representing the opened
#' group.  When access to the group is no longer needed this should be released
#' with [H5Gclose()] to prevent resource leakage.
#'
#' @seealso [H5Gclose()]
#'
#' @export
H5Gopen <- function(h5loc, name) {
  h5checktype(h5loc, "loc")
  if (length(name) != 1 || !is.character(name)) {
    stop("'name' must be a character string of length 1")
  }
  gid <- .Call("_H5Gopen", h5loc@ID, name, PACKAGE = "rhdf5")
  if (gid > 0) {
    h5group <- new("H5IdComponent", ID = gid, native = h5loc@native)
  } else {
    message("HDF5: unable to open group")
    h5group <- FALSE
  }
  invisible(h5group)
}

#' Close a specified group
#'
#' @param h5group An object of class [H5IdComponent-class] representing a H5
#' group.  Typically created via [H5Gopen()] or [H5Gcreate()].
#'
#' @export
H5Gclose <- function(h5group) {
  h5checktype(h5group, "group")
  invisible(.Call("_H5Gclose", h5group@ID, PACKAGE = "rhdf5"))
}

#' Retrieve information about a group
#'
#' @param h5loc An object of class [H5IdComponent-class] representing a H5
#' group.
#' @param group_name An additional group name specifying the group for which
#' information is sought. It is interpreted relative to `h5loc`.
#' @param n Position in the index of the group for which information is
#' retrieved.
#' @param index_type See `h5const("H5_INDEX")` for possible arguments.
#' @param order See `h5const("H5_ITER")` for possible arguments.
#'
#' @returns A list with group information
#'
#' @examples
#' h5file <- system.file("testfiles", "multiple_dtypes.h5", package = "rhdf5")
#' fid <- H5Fopen(h5file)
#' gid <- H5Gopen(fid, "/foo")
#' gid
#' H5Gget_info(gid)
#' H5Gclose(gid)
#'
#' ## the "get_info_by" functions take the H5 object that contains the
#' ## group(s) of interest.  We can retrieve information by index or by name
#' H5Gget_info_by_idx(fid, 3)
#' H5Gget_info_by_name(fid, "/foo")
#'
#' H5Fclose(fid)
#'
#' @name H5Gget_info
NULL

#' @rdname H5Gget_info
#' @export
H5Gget_info <- function(h5loc) {
  h5checktype(h5loc, "loc")
  .Call("_H5Gget_info", h5loc@ID, PACKAGE = "rhdf5")
}

#' @rdname H5Gget_info
#' @export
H5Gget_info_by_name <- function(h5loc, group_name) {
  h5checktype(h5loc, "loc")
  if (length(group_name) != 1 || !is.character(group_name)) {
    stop("'group_name' must be a character string of length 1")
  }
  .Call("_H5Gget_info_by_name", h5loc@ID, group_name, PACKAGE = "rhdf5")
}

#' @rdname H5Gget_info
#' @export
H5Gget_info_by_idx <- function(
  h5loc,
  n,
  group_name = ".",
  index_type = h5default("H5_INDEX"),
  order = h5default("H5_ITER")
) {
  h5checktype(h5loc, "loc")
  if (length(n) != 1) {
    stop("'n' must be an integer of length 1")
  }
  n <- as.integer(n) - 1L # we will use R style numbering beginning with 1
  if (n < 0) {
    stop("'n' must be larger than 1")
  }
  if (length(group_name) != 1 || !is.character(group_name)) {
    stop("'group_name' must be a character string of length 1")
  }
  index_type <- h5checkConstants("H5_INDEX", index_type)
  order <- h5checkConstants("H5_ITER", order)
  .Call(
    "_H5Gget_info_by_idx",
    h5loc@ID,
    group_name,
    index_type,
    order,
    n,
    PACKAGE = "rhdf5"
  )
}

library(rhdf5)

## output file name
h5File <- withr::local_tempfile(pattern = "ex_save", fileext = ".h5")

############################################################
context("H5Gcreate")
############################################################

test_that("Group creation & closure", {
  expect_silent(fid <- H5Fcreate(name = h5File))
  ## writing to a group
  expect_silent(gid <- H5Gcreate(h5loc = fid, name = "test_group"))
  expect_silent(h5write(matrix(1:20, ncol = 10), file = gid, name = "foo"))

  expect_silent(H5Gclose(gid))
  expect_silent(H5Fclose(fid))
})

############################################################
context("H5G info")
############################################################

test_that("Group creation & closure", {
  expect_silent(fid <- H5Fopen(name = h5File))
  ## writing to a group
  expect_silent(gid <- H5Gopen(h5loc = fid, name = "test_group"))
  expect_silent(info <- H5Gget_info(gid))
  expect_is(info, "list")
  expect_named(info, c("storage_type", "nlink", "max_corder", "mounted"))

  expect_silent(H5Gclose(gid))
  ## we can use the name rather than the group_id
  expect_silent(info2 <- H5Gget_info_by_name(fid, "test_group"))
  expect_identical(info, info2)

  ## also by index
  expect_silent(info3 <- H5Gget_info_by_idx(fid, n = 1))
  expect_identical(info, info3)

  ## some input errors are caught
  expect_error(
    H5Gget_info_by_idx(fid, n = 1:10),
    regexp = "integer of length 1"
  )
  expect_error(H5Gget_info_by_idx(fid, n = 0), regexp = "larger than 1")
  expect_error(
    H5Gget_info_by_idx(fid, n = 1, group_name = NULL),
    regexp = "character string of length 1"
  )

  H5Fclose(fid)
})

test_that("Group creation & closure", {
  fid <- H5Fopen(name = h5File)
  ## writing to a group
  expect_silent(gid <- H5Gopen(h5loc = fid, name = "test_group"))
  expect_silent(info <- H5Gget_info(gid))
  expect_is(info, "list")
  expect_named(info, c("storage_type", "nlink", "max_corder", "mounted"))

  expect_silent(H5Gclose(gid))
  ## we can use the name rather than the group_id
  expect_silent(info2 <- H5Gget_info_by_name(fid, "test_group"))
  expect_identical(info, info2)

  ## also by index
  expect_silent(info3 <- H5Gget_info_by_idx(fid, n = 1))
  expect_identical(info, info3)

  expect_silent(H5Fclose(fid))
})

h5checktype <- function(
  h5id,
  type,
  fctname = deparse(match.call()[1]),
  allow.character = FALSE
) {
  if (!is(h5id, "H5IdComponent")) {
    if (allow.character) {
      stop(
        "Error in ",
        fctname,
        ". Argument neither of class H5IdComponent nor a character.",
        call. = FALSE
      )
    } else {
      stop(
        "Error in ",
        fctname,
        ". Argument not of class H5IdComponent.",
        call. = FALSE
      )
    }
  }
  isvalid <- H5Iis_valid(h5id)
  if (!isvalid) {
    stop("Error in ", fctname, ". H5Identifier not valid.", call. = FALSE)
  }
  truetype <- H5Iget_type(h5id)
  switch(
    type,
    file = {
      if (truetype != "H5I_FILE") {
        stop(
          "Error in ",
          fctname,
          ". The provided H5Identifier is not a file identifier.",
          call. = FALSE
        )
      }
      0
    },
    group = {
      if (truetype != "H5I_GROUP") {
        stop(
          "Error in ",
          fctname,
          ". The provided H5Identifier is not a group identifier.",
          call. = FALSE
        )
      }
      0
    },
    loc = {
      if (!truetype %in% c("H5I_FILE", "H5I_GROUP")) {
        stop(
          "Error in ",
          fctname,
          ". The provided H5Identifier is not a location identifier.",
          call. = FALSE
        )
      }
      0
    },
    dataset = {
      if (truetype != "H5I_DATASET") {
        stop(
          "Error in ",
          fctname,
          ". The provided H5Identifier is not a dataset identifier.",
          call. = FALSE
        )
      }
      0
    },
    object = {
      if (!truetype %in% c("H5I_FILE", "H5I_GROUP", "H5I_DATASET")) {
        stop(
          "Error in ",
          fctname,
          ". The provided H5Identifier is not an object identifier.",
          call. = FALSE
        )
      }
      0
    },
    dataspace = {
      if (truetype != "H5I_DATASPACE") {
        stop(
          "Error in ",
          fctname,
          ". The provided H5Identifier is not a dataspace identifier.",
          call. = FALSE
        )
      }
      0
    },
    attribute = {
      if (truetype != "H5I_ATTR") {
        stop(
          "Error in ",
          fctname,
          ". The provided H5Identifier is not an attribute identifier.",
          call. = FALSE
        )
      }
      0
    },
    type = {
      if (truetype != "H5I_DATATYPE") {
        stop(
          "Error in ",
          fctname,
          ". The provided H5Identifier is not a type identifier.",
          call. = FALSE
        )
      }
      0
    },
    plist = {
      if (truetype != "H5I_GENPROP_LST") {
        stop(
          "Error in ",
          fctname,
          ". The provided H5Identifier is not a property list.",
          call. = FALSE
        )
      }
      0
    },
    plistclass = {
      if (truetype != "H5I_GENPROP_CLS") {
        stop(
          "Error in ",
          fctname,
          ". The provided H5Identifier is not a property list class.",
          call. = FALSE
        )
      }
      0
    },
    {
      stop("argument for type unknown")
    }
  )
  return(invisible(NULL))
}

h5checktypeOrNULL <- function(h5id, type, fctname = deparse(match.call()[1])) {
  if (!is.null(h5id)) {
    h5checktype(h5id, type, fctname = fctname)
  }
  invisible(NULL)
}

h5FileIsOpen <- function(filename) {
  filename <- normalizePath(filename, mustWork = FALSE)
  L <- h5validObjects()
  isobject <- vapply(
    L,
    function(x) {
      H5Iget_type(x) %in% c("H5I_FILE", "H5I_GROUP", "H5I_DATASET")
    },
    logical(1)
  )
  isopen <- any(vapply(
    L[isobject],
    function(x) {
      H5Fget_name(x) == filename
    },
    logical(1)
  ))
  isopen
}

h5checktypeOrOpenLoc <- function(
  file,
  fctname = deparse(match.call()[1]),
  createnewfile = FALSE,
  readonly = FALSE,
  fapl = NULL,
  native
) {
  res <- list()
  if (is.character(file)) {
    file <- normalizePath(file, mustWork = FALSE)
    if (file.exists(file)) {
      if (h5FileIsOpen(file)) {
        warning(
          "An open HDF5 file handle exists. ",
          "If the file has changed on disk meanwhile, the function may not work properly. ",
          "Run 'h5closeAll()' to close all open HDF5 object handles."
        )
      }

      flags <- ifelse(readonly, "H5F_ACC_RDONLY", "H5F_ACC_RDWR")
      h5loc <- H5Fopen(file, flags = flags, fapl = fapl, native = native)

      if (!is(h5loc, "H5IdComponent")) {
        stop(
          "Error in ",
          fctname,
          ". File '",
          file,
          "' is not a valid HDF5 file."
        )
      }
      res$H5Identifier <- h5loc
      res$closeit <- TRUE
    } else {
      if (!createnewfile) {
        stop(
          "Error in ",
          fctname,
          ". Cannot open file. File '",
          file,
          "' does not exist."
        )
      }
      h5loc <- H5Fcreate(file, native = native)
      if (!is(h5loc, "H5IdComponent")) {
        stop("Error in ", fctname, ". Cannot create file.")
      }
      res$H5Identifier <- h5loc
      res$closeit <- TRUE
    }
  } else {
    ## We have passed an H5IdComponent, so it should not be closed after
    h5checktype(file, "loc", fctname = fctname, allow.character = TRUE)
    res$H5Identifier <- file
    res$closeit <- FALSE
  }
  invisible(res)
}

h5checktypeOrOpenLocS3 <- function(
  file,
  fctname = deparse(match.call()[1]),
  createnewfile = FALSE,
  readonly = FALSE,
  fapl = NULL,
  native
) {
  res <- list()
  if (is.character(file)) {
    flags <- ifelse(readonly, "H5F_ACC_RDONLY", "H5F_ACC_RDWR")
    h5loc <- H5Fopen(file, flags = flags, fapl = fapl, native = native)

    if (!is(h5loc, "H5IdComponent")) {
      stop(
        "Error in ",
        fctname,
        ". File '",
        file,
        "' is not a valid HDF5 file."
      )
    }
    res$H5Identifier <- h5loc
    res$closeit <- TRUE
  } else {
    ## We have passed an H5IdComponent, so it should not be closed after
    h5checktype(file, "loc", fctname = fctname, allow.character = TRUE)
    res$H5Identifier <- file
    res$closeit <- FALSE
  }
  invisible(res)
}

h5closeitLoc <- function(file, fctname = deparse(match.call()[1])) {
  res <- TRUE
  if (file$closeit) {
    if (H5Iis_valid(file$H5Identifier)) {
      res <- H5Fclose(file$H5Identifier)
    } else {
      res <- FALSE
    }
  } else {
    res <- FALSE
  }
  invisible(res)
}

h5checktypeOrOpenObj <- function(
  obj,
  file,
  fctname = deparse(match.call()[1]),
  native
) {
  res <- list()
  if (is.character(obj)) {
    if (missing(file)) {
      stop(
        "Error in ",
        fctname,
        ". If the object is specified by name, then you have to specify the file."
      )
    }
    loc <- h5checktypeOrOpenLoc(file, fctname = fctname, native = native)

    if (!H5Lexists(loc$H5Identifier, obj)) {
      stop("Error in ", fctname, ". Object '", obj, "' not found in file.")
    }
    h5obj <- H5Oopen(loc$H5Identifier, obj)
    if (!is(h5obj, "H5IdComponent")) {
      stop("Error in ", fctname, ". Cannot open object.")
    }
    res$H5Identifier <- h5obj
    res$closeit <- TRUE
    h5closeitLoc(loc)
  } else {
    h5checktype(obj, "object", fctname = fctname, allow.character = TRUE)
    res$H5Identifier <- obj
    res$closeit <- FALSE
  }
  invisible(res)
}

h5closeitObj <- function(obj, fctname = deparse(match.call()[1])) {
  res <- TRUE
  if (obj$closeit) {
    if (H5Iis_valid(obj$H5Identifier)) {
      res <- H5Oclose(obj$H5Identifier)
    } else {
      res <- FALSE
    }
  } else {
    res <- FALSE
  }
  invisible(res)
}

h5checktypeAndPLC <- function(
  h5id,
  plc,
  allowNULL = FALSE,
  fctname = deparse(match.call()[1])
) {
  if (is.null(h5id)) {
    if (!allowNULL) {
      stop("Error in ", fctname, ". Property list is null", call. = FALSE)
    }
    h5id <- new("H5IdComponent", ID = character(0), native = logical(0))
  } else {
    if (!is(h5id, "H5IdComponent")) {
      stop(
        "Error in ",
        fctname,
        ". Argument not of class H5IdComponent.",
        call. = FALSE
      )
    }
    isvalid <- H5Iis_valid(h5id)
    if (!isvalid) {
      stop("Error in ", fctname, ". H5Identifier not valid.", call. = FALSE)
    }
    truetype <- H5Iget_type(h5id)
    if (truetype != "H5I_GENPROP_LST") {
      stop(
        "Error in ",
        fctname,
        ". The provided H5Identifier is not a property list.",
        call. = FALSE
      )
    }
    h5plc <- H5Pget_class(h5id)
    if (!plc %in% names(h5constants[["H5P"]])) {
      stop("plist class '", plc, "' unknown")
    }
    if (
      !.Call(
        "_H5Pequal",
        h5plc@ID,
        h5constants[["H5P"]][plc],
        PACKAGE = "rhdf5"
      )
    ) {
      stop("property list is not of class '", plc, "'")
    }
    H5Pclose_class(h5plc)
  }
  return(invisible(h5id))
}

#' Additional functions for finding details of dataset chunking.
#'
#' @details These functions do not map directly to the HDF5 C API but follow the same style and are
#' included as potentially useful additions.
#'
#' * `H5Dis_chunked` tests whether a dataset is chunked.
#' * `H5Dchunk_dims` will return the dimensions of the dataset chunks.
#'
#' @param h5dataset Object of class [H5IdComponent-class] representing an open HDF5
#' dataset.
#'
#' @returns
#' * `H5Dchunk_dims`: If the supplied dataset is chunked returns a vector, with length
#' equal to the rank of the dataset, containing the size of the dataset
#' dimensions.  Returns `NULL` if the given dataset is not chunked.
#' * `H5Dis_chunked`: returns `TRUE` if a dataset is chunked and `FALSE` otherwise.
#'
#' @author Mike Smith
#'
#' @name H5D_extras
NULL

#' @rdname H5D_extras
#' @export
H5Dchunk_dims <- function(h5dataset) {
  h5checktype(h5dataset, "dataset")

  pid <- H5Dget_create_plist(h5dataset)
  on.exit(H5Pclose(pid), add = TRUE)

  if (H5Pget_layout(pid) != "H5D_CHUNKED") {
    return(NULL)
  } else {
    return(rev(H5Pget_chunk(pid)))
  }
}

#' @rdname H5D_extras
#' @export
H5Dis_chunked <- function(h5dataset) {
  h5checktype(h5dataset, "dataset")

  pid <- H5Dget_create_plist(h5dataset)
  on.exit(H5Pclose(pid), add = TRUE)

  return(H5Pget_layout(pid) == "H5D_CHUNKED")
}

# This helper function allows us to distinguish between:
# - an argument being omitted entirely. This is the expectation when wanting to
#   rely on the default value
# - a missing value being passed down from a higher-level function call
fix_missing <- function(x, default) {
  if (missing(x)) {
    warning(
      sprintf(
        'To rely on the `%s` argument default, you should omit omit it or explicitly set it to its default value (`"%s"`).',
        deparse(substitute(x)),
        default
      ),
      " Passing a missing value  will be disallowed in the next release cycle.",
      call. = FALSE
    )
    x <- "int"
  }
  return(x)
}

#' Create HDF5 file
#' 
#' R function to create an empty HDF5 file.
#' 
#' Creates an empty HDF5 file.
#' 
#' @param file The filename of the HDF5 file.
#' 
#' @return Returns (invisibly) `TRUE` is file was created successfully and `FALSE` otherwise.
#' 
#' @author Bernd Fischer
#' @seealso [h5createGroup()], [h5createDataset()],
#' [h5read()], [h5write()], \link{rhdf5}
#' @examples
#' 
#' h5createFile("ex_createFile.h5")
#' 
#' # create groups
#' h5createGroup("ex_createFile.h5","foo")
#' h5createGroup("ex_createFile.h5","foo/foobaa")
#' 
#' h5ls("ex_createFile.h5")
#' 
#' @name h5_createFile
#' @export h5createFile
h5createFile <- function(file) {

    res <- FALSE
    if (is.character(file)) {
        file = normalizePath(file,mustWork = FALSE)
        if (file.exists(file)) {
            message("file '", file, "' already exists.")
        } else {
            h5loc <- H5Fcreate(file)
            if (is(h5loc, "H5IdComponent")) {
                H5Fclose(h5loc)
                res <- TRUE
            }
        }
    } else {
        stop("file has to be a valid filename.")
    }
    
    invisible(res)
}


#' Create HDF5 group
#' 
#' Creates a group within an HDF5 file.
#' 
#' Creates a new group within an HDF5 file.
#' 
#' @param file The filename (character) of the file in which the dataset will
#' be located. For advanced programmers it is possible to provide an object of
#' class [H5IdComponent-class] representing a H5 location identifier
#' (file or group). See [H5Fcreate()], [H5Fopen()],
#' [H5Gcreate()], [H5Gopen()] to create an object of this
#' kind.
#' @param group The name of the new group. The name can contain a hierarchy of
#' groupnames, e.g. `"/group1/group2/newgroup"`, but the function will fail if the
#' top level groups do not exists.
#' 
#' @return Returns TRUE is group was created successfully and FALSE otherwise.
#' @author Bernd Fischer
#' @seealso [h5createFile()], [h5createDataset()],
#' [h5read()], [h5write()]
#' @examples
#' 
#' h5createFile("ex_createGroup.h5")
#' 
#' # create groups
#' h5createGroup("ex_createGroup.h5","foo")
#' h5createGroup("ex_createGroup.h5","foo/foobaa")
#' 
#' h5ls("ex_createGroup.h5")
#' 
#' @name h5_createGroup
#' @export h5createGroup
h5createGroup <- function(file, group) {
    loc = h5checktypeOrOpenLoc(file, native = FALSE)
    on.exit(h5closeitLoc(loc))
    
    res <- FALSE
    if (is.character(group)) {
        if (H5Lexists(loc$H5Identifier,group)) {
            message("Can not create group. Object with name '", group, "' already exists.")
        } else {
            gid <- H5Gcreate(loc$H5Identifier, group)
            if (is(gid, "H5IdComponent")) {
                H5Gclose(gid)
                res <- TRUE
            }
        }
    }
    
    invisible(res)
}

.setDataType <- function(H5type, storage.mode, size, encoding) {
  
  if (is.null(H5type)) {
    if (is.character(storage.mode)) {
      tid <- switch(storage.mode[1],
                    double = h5constants$H5T["H5T_IEEE_F64LE"],
                    integer = h5constants$H5T["H5T_STD_I32LE"],
                    integer64 = h5constants$H5T["H5T_STD_I64LE"],
                    logical = h5constants$H5T["H5T_STD_I8LE"],
                    raw = h5constants$H5T["H5T_STD_U8LE"],
                    character = {
                      tid <- H5Tcopy("H5T_C_S1")
                      H5Tset_strpad(tid, strpad = "NULLPAD")
                      H5Tset_size(tid, size)
                      H5Tset_cset(tid, encoding)
                      tid
                    },
                    { stop("datatype ",storage.mode, " not yet implemented.\n", 
                           "Try 'logical', 'double', 'integer', 'integer64' or 'character'.") } )
    } else {
      stop("Can not create dataset. 'storage.mode' has to be a character.")
    }
  } else {
    tid <- h5checkConstants("H5T", H5type)
  }
  if (is.na(tid)) {
    stop("Can not create dataset. H5type unknown. Check h5const('H5T') for valid types.")
  }
  return(tid)
}

.createDCPL <- function(chunk, dims, level, fillValue, dtype, filter, shuffle = FALSE) {
  
  dcpl <- H5Pcreate("H5P_DATASET_CREATE"); 
  if (length(chunk) > 0) {

    if (!is.null(H5Tget_size(dtype))) { 
        chunk_size <- H5Tget_size(dtype) * prod(chunk)
        if(chunk_size > 2^32-1) {
          root_dim <- floor(((2^32-1) / H5Tget_size(dtype))^(1/length(chunk)))
          chunk[ chunk > root_dim ] = root_dim
          message("Current chunk settings will exceed HDF5's 4GB limit.\n", 
                  "Automatically adjusting them to: ", paste(chunk, collapse = " x "),
                  "\nYou may wish to set these to more appropriate values using the 'chunk' argument.")
        }
    }

    if ((prod(dims) > 1000000L) & (all(dims == chunk))) {
      message("You created a large dataset with compression and chunking.\n",
              "The chunk size is equal to the dataset dimensions.\n", 
              "If you want to read subsets of the dataset, you should test",
              "smaller chunk sizes to improve read times.")
    }
    H5Pset_fill_time( dcpl, "H5D_FILL_TIME_ALLOC" )
    H5Pset_chunk( dcpl, chunk)
    
    ## set the selected compression filter
    filter <- toupper(filter)
    if(!filter %in% c("GZIP", "ZLIB", "DEFLATE", 
                      "SZIP",
                      "BZIP2",
                      "BLOSC_BLOSCLZ", "BLOSC_LZ4", "BLOSC_LZ4HC", "BLOSC_SNAPPY", "BLOSC_ZLIB", "BLOSC_ZSTD",
                      "LZF",
                      "NONE")) {
      warning("Filter not found, using default: ZLIB")
      filter <- "ZLIB"
    }
    
    ## only use this shuffle if not using blosc filter
    if(shuffle && !grepl("BLOSC", x = filter)) {
      H5Pset_shuffle(dcpl)
    }
    
    ## set the appropriate filter
    if (filter %in% c("GZIP", "ZLIB", "DEFLATE")) { 
      H5Pset_deflate( dcpl, level = level) 
    } else if(filter == "SZIP") {
      H5Pset_szip(dcpl, 1L, 32L)
    } else if(filter == "BZIP2") {
      H5Pset_bzip2( dcpl, level = level )
    } else if (grepl(pattern = "BLOSC", x = filter)) {
      method <- which(c("BLOSC_BLOSCLZ", "BLOSC_LZ4", "BLOSC_LZ4HC", "BLOSC_SNAPPY", "BLOSC_ZLIB", "BLOSC_ZSTD") == filter)
      H5Pset_blosc(dcpl, method = method, h5tid = dtype, level = level, shuffle = shuffle )
    } else if(filter == "LZF") {
      H5Pset_lzf( dcpl, h5tid = dtype )
    }
    
  }
  
  if(!missing(fillValue)) {
    H5Pset_fill_value(dcpl, fillValue)
  }
  
  ## turn off time stamp
  H5Pset_obj_track_times(dcpl, FALSE)
  
  return(dcpl)
}

.checkArgs_createDataset <- function(dims, maxdims, chunk) {
  
  if (any(is.na(dims)) | any(is.na(maxdims))) {
    stop("Can not create dataset. 'dims' and 'maxdims' must be numeric.")
  } 
  if (any(dims < 0)) {
    stop('All elements of "dims" must be non-negative.')
  }
  if (length(maxdims) != length(dims)) {
    stop('"maxdims" has to have the same rank as "dims".')
  } 
  if (any(maxdims != dims) & is.null(chunk)) {
    stop('If "maxdims" is different from "dims", chunking is required.')
  }
  if (any(maxdims != H5Sunlimited() & maxdims < dims)) {
    stop('All non-extensible elements of "maxdims" must be equal or larger than "dims".')
  }
  
  chunk_vs_maxdims <- ((chunk > maxdims) & (maxdims != H5Sunlimited()))
  if(any(chunk_vs_maxdims)) {
    chunk[ which(chunk_vs_maxdims) ]  <- dims[ which(chunk_vs_maxdims) ]
    warning("One or more chunk dimensions exceeded the maximum for the dataset.\n",
            "These have been automatically set to the maximum.\n",
            "The new chunk dimensions are: ", paste0("c(", paste(chunk, collapse = ","), ")"),
            call. = FALSE)
  }
  
  return(chunk)
}

#' Create HDF5 dataset
#'
#' R function to create an HDF5 dataset and defining its dimensionality and
#' compression behaviour.
#'
#' Creates a new dataset in an existing HDF5 file. The function will fail if the
#' file doesn't exist or if there exists already another dataset with the same
#' name within the specified file.
#'
#' The `size` argument is only used when `storage.mode = 'character'`.  When
#' storing strings HDF5 can use either a fixed or variable length datatype.
#' Setting `size` to a positive integer will use fixed length strings where
#' `size` defines the length.  \pkg{rhdf5} writes null padded strings by default
#' and so to avoid data loss the value provided here should be the length of the
#' longest string.  Setting `size = NULL` will use variable length strings. The
#' choice is probably dependent on the nature of the strings you're writing. The
#' principle difference is that a dataset of variable length strings will not be
#' compressed by HDF5 but each individual string only uses the space it
#' requires, whereas in a fixed length dataset each string is of length uses
#' `size`, but the whole dataset can be compressed. This explored more in the
#' examples below.
#'
#' The \code{filter} argument can take several options matching to compression
#' filters distributed in either with the HDF5 library in \pkg{Rhdf5lib} or via
#' the \pkg{rhdf5filters} package.  The plugins available and the corresponding
#' values for selecting them are shown below:
#'
#' \describe{ \item{zlib: Ubiquitous deflate compression algorithm used in GZIP
#' or ZIP files.  All three options below achieve the same result.}{ \itemize{
#' \item\code{"GZIP"}, \item\code{"ZLIB"}, \item\code{"DEFLATE"} } } \item{szip:
#' Compression algorithm maintained by the HDF5 group.}{ \itemize{
#' \item\code{"SZIP"} } } \item{bzip2}{ \itemize{ \item\code{"BZIP2"} } }
#' \item{BLOSC meta compressor: As a meta-compressor BLOSC wraps several
#' different compression algorithms.  Each of the options below will active a
#' different compression filter. }{ \itemize{ \item\code{"BLOSC_BLOSCLZ"}
#' \item\code{"BLOSC_LZ4"} \item\code{"BLOSC_LZ4HC"} \item\code{"BLOSC_SNAPPY"}
#' \item\code{"BLOSC_ZLIB"} \item\code{"BLOSC_ZSTD"} } } \item{lzf}{ \itemize{
#' \item\code{"LZF"} } } \item{Disable: It is possible to write chunks without
#' any compression applied.}{ \itemize{ \item\code{"NONE"} } } }
#'
#' @param file The filename (character) of the file in which the dataset will be
#'   located. For advanced programmers it is possible to provide an object of
#'   class [H5IdComponent-class] representing a H5 location identifier (file or
#'   group). See [H5Fcreate()], [H5Fopen()], [H5Gcreate()], [H5Gopen()] to
#'   create an object of this kind.
#' @param dataset Name of the dataset to be created. The name can contain group
#'   names, e.g. 'group/dataset', but the function will fail, if the group does
#'   not yet exist.
#' @param dims The dimensions of the array as they will appear in the file.
#'   Note, the dimensions will appear in inverted order when viewing the file
#'   with a C-programm (e.g. HDFView), because the fastest changing dimension in
#'   R is the first one, whereas the fastest changing dimension in C is the last
#'   one.
#' @param maxdims The maximum extension of the array. Use \code{H5Sunlimited()}
#'   to indicate an extensible dimension.
#' @param storage.mode The storage mode of the data to be written. Can be
#'   obtained by \code{storage.mode(mydata)}.
#' @param H5type Advanced programmers can specify the datatype of the dataset
#'   within the file. See \code{h5const("H5T")} for a list of available
#'   datatypes. If \code{H5type} is specified the argument \code{storage.mode}
#'   is ignored. It is recommended to use \code{storage.mode}
#' @param size For `storage.mode='character'` the maximum string length to use.
#'   The default value of `NULL` will result in using variable length strings.
#'   See the details for more information on this option.
#' @param encoding The encoding of the string data type. Valid options are
#'   "ASCII" or "UTF-8".
#' @param chunk The chunk size used to store the dataset. It is an integer
#'   vector of the same length as \code{dims}. This argument is usually set
#'   together with a compression property (argument \code{level}).
#' @param fillValue Standard value for filling the dataset. The storage.mode of
#'   value has to be convertible to the dataset type by HDF5.
#' @param level The compression level used. An integer value between 0 (no
#'   compression) and 9 (highest and slowest compression).
#' @param filter Character defining which compression filter should be applied
#'   to the chunks of the dataset.  See the Details section for more information
#'   on the options that can be provided here.
#' @param shuffle Logical defining whether the byte-shuffle algorithm should be
#'   applied to data prior to compression.
#' @param native An object of class \code{logical}. If TRUE, array-like objects
#'   are treated as stored in HDF5 row-major rather than R column-major
#'   orientation. Using \code{native = TRUE} increases HDF5 file portability
#'   between programming languages. A file written with \code{native = TRUE}
#'   should also be read with \code{native = TRUE}
#' @return Returns (invisibly) `TRUE` if dataset was created successfully and `FALSE` otherwise.
#' @author Bernd Fischer, Mike L. Smith
#' @seealso [h5createFile()], [h5createGroup()], [h5read()], [h5write()]
#' @examples
#'
#' h5createFile("ex_createDataset.h5")
#'
#' # create dataset with compression
#' h5createDataset("ex_createDataset.h5", "A", c(5,8), storage.mode = "integer", chunk=c(5,1), level=6)
#'
#' # create dataset without compression
#' h5createDataset("ex_createDataset.h5", "B", c(5,8), storage.mode = "integer")
#' h5createDataset("ex_createDataset.h5", "C", c(5,8), storage.mode = "double")
#'
#' # create dataset with bzip2 compression
#' h5createDataset("ex_createDataset.h5", "D", c(5,8), storage.mode = "integer",
#'     chunk=c(5,1), filter = "BZIP2", level=6)
#'
#' # create a dataset of strings & define size based on longest string
#' ex_strings <- c('long', 'longer', 'longest')
#' h5createDataset("ex_createDataset.h5", "E",
#'     storage.mode = "character", chunk = 3, level = 6,
#'     dims = length(ex_strings), size = max(nchar(ex_strings)))
#'
#'
#' # write data to dataset
#' h5write(matrix(1:40,nr=5,nc=8), file="ex_createDataset.h5", name="A")
#' # write second column
#' h5write(matrix(1:5,nr=5,nc=1), file="ex_createDataset.h5", name="B", index=list(NULL,2))
#' # write character vector
#' h5write(ex_strings, file = "ex_createDataset.h5", name = "E")
#'
#' h5dump("ex_createDataset.h5")
#'
#' ## Investigating fixed vs variable length string datasets
#'
#' ## create 1000 random strings with length between 50 and 100 characters
#' words <- ceiling(runif(n = 1000, min = 50, max = 100)) |>
#' vapply(FUN = \(x) {
#'  paste(sample(letters, size = x, replace = TRUE), collapse = "")
#' },
#' FUN.VALUE = character(1))
#'
#' ## create two HDF5 files
#' f1 <- tempfile()
#' f2 <- tempfile()
#' h5createFile(f1)
#' h5createFile(f2)
#'
#' ## create two string datasets
#' ## the first is variable length strings, the second fixed at the length of our longest word
#' h5createDataset(f1, "strings", dims = length(words), storage.mode = "character", size = NULL, chunk = 25)
#' h5createDataset(f2, "strings", dims = length(words), storage.mode = "character", size = max(nchar(words)), chunk = 25)
#'
#' ## Write the data
#' h5write(words, f1, "strings")
#' h5write(words, f2, "strings")
#'
#' ## Check file sizes.
#' ## In this example the fixed length string dataset is normally much smaller
#' file.size(f1)
#' file.size(f2)
#'
#' @name h5_createDataset
#' @export h5createDataset
h5createDataset <- function(file, dataset, dims, maxdims = dims, 
                            storage.mode = "double", H5type = NULL, 
                            size = NULL, encoding = NULL,
                            chunk = dims, fillValue, 
                            level = 6, filter = "gzip", shuffle = TRUE,
                            native = FALSE) {
  
  loc = h5checktypeOrOpenLoc(file, native = native)
  on.exit( h5closeitLoc(loc) )
  
  dims <- as.numeric(dims)
  maxdims <- as.numeric(maxdims)

  res <- FALSE
  if (!is.character(dataset)) {
    stop('"dataset" argument must be a character vector of length one.')
  }
  if (H5Lexists(loc$H5Identifier,dataset)) {
      message("Can not create dataset. Object with name '",dataset,"' already exists.")
  } 
  chunk <- .checkArgs_createDataset(dims = dims, maxdims = maxdims, chunk = chunk)

  if ((level > 0) & (is.null(chunk))) {
    warning("Compression (level > 0) requires chunking. Set chunk size to activate compression.")
  }
  if (length(chunk) > 0) {
    chunk[which(chunk == 0)] = 1
  }
  
  ## determine data type
  tid <- .setDataType(H5type, storage.mode, size, 
                      encoding = match.arg(encoding, choices = c("ASCII", "UTF-8", "UTF8")))
  
  dcpl <- .createDCPL(chunk, dims, level, fillValue, dtype = tid, filter = filter, shuffle = shuffle)
  on.exit(H5Pclose(dcpl), add = TRUE)
  
  ## create dataspace
  sid <- H5Screate_simple(dims, maxdims)
  on.exit(H5Sclose(sid), add = TRUE)
  
  did <- H5Dcreate(loc$H5Identifier, dataset, tid, sid, dcpl = dcpl)
  if (is(did, "H5IdComponent")) {
    if (storage.mode[1] == "logical") {
      x = "logical"
      h5writeAttribute(attr = x, h5obj = did, name = "storage.mode")
    }
    H5Dclose(did)
    res <- TRUE
  }
  invisible(res)
}

#' Create HDF5 attribute
#'
#' R function to create an HDF5 attribute and defining its dimensionality.
#'
#' Creates a new attribute and attaches it to an existing HDF5 object. The
#' function will fail, if the file doesn't exist or if there exists already
#' another attribute with the same name for this object.
#'
#' You can use [h5writeAttribute()] immediately. It will create the attribute
#' for you.
#'
#' @param obj The name (character) of the object the attribute will be attatched
#'   to. For advanced programmers it is possible to provide an object of class
#'   [H5IdComponent-class] representing a H5 object identifier (file, group,
#'   dataset). See [H5Fcreate()], [H5Fopen()], [H5Gcreate()], [H5Gopen()],
#'   [H5Dcreate()], [H5Dopen()] to create an object of this kind.
#' @param file The filename (character) of the file in which the dataset will be
#'   located. For advanced programmers it is possible to provide an object of
#'   class [H5IdComponent-class] representing an H5 location identifier. See
#'   [H5Fcreate()], [H5Fopen()], [H5Gcreate()], [H5Gopen()] to create an object
#'   of this kind. The \code{file} argument is not required, if the argument
#'   \code{obj} is of type \code{H5IdComponent}.
#' @param attr Name of the attribute to be created.
#' @param dims The dimensions of the attribute as a numeric vector. If
#'   \code{NULL}, a scalar dataspace will be created instead.
#' @param maxdims The maximum extension of the attribute.
#' @param storage.mode The storage mode of the data to be written. Can be
#'   obtained by \code{storage.mode(mydata)}.
#' @param H5type Advanced programmers can specify the datatype of the dataset
#'   within the file. See \code{h5const("H5T")} for a list of available
#'   datatypes. If \code{H5type} is specified the argument \code{storage.mode}
#'   is ignored. It is recommended to use \code{storage.mode}
#' @param size The maximum string length when \code{storage.mode='character'}.
#'   If this is specified, HDF5 stores each string of \code{attr} as fixed
#'   length character arrays. Together with compression, this should be
#'   efficient.
#'
#'   If this argument is set to \code{NULL}, HDF5 will instead store
#'   variable-length strings.
#' @param encoding The encoding of the string data type i.e. when `storage.mode
#'   = 'character'`. Valid options are "ASCII" and "UTF-8".
#' @param cset *Deprecated in favour of the `encoding` argument.*
#' @param native An object of class \code{logical}. If TRUE, array-like objects
#'   are treated as stored in HDF5 row-major rather than R column-major
#'   orientation. Using \code{native = TRUE} increases HDF5 file portability
#'   between programming languages. A file written with \code{native = TRUE}
#'   should also be read with \code{native = TRUE}
#' @return Returns TRUE is attribute was created successfully and FALSE
#'   otherwise.
#' @author Bernd Fischer
#' @seealso [h5createFile()], [h5createGroup()], [h5createDataset()],
#'   [h5read()], [h5write()], \link{rhdf5}
#' @references \url{https://portal.hdfgroup.org/display/HDF5}
#' @keywords programming interface IO file
#' @examples
#'
#' h5createFile("ex_createAttribute.h5")
#' h5write(1:1, "ex_createAttribute.h5","A")
#' fid <- H5Fopen("ex_createAttribute.h5")
#' did <- H5Dopen(fid, "A")
#' h5createAttribute (did, "time", c(1,10))
#' H5Dclose(did)
#' H5Fclose(fid)
#'
#' @name h5_createAttribute
#' @export h5createAttribute
h5createAttribute <- function(obj, attr, dims, maxdims = dims, file, 
                              storage.mode = "double", H5type = NULL, 
                              size = NULL, encoding = NULL, cset = NULL, 
                              native = FALSE) {
  
    ## remove the cset argument in BioC 3.16
    if(!is.null(cset)) {
      if(is.null(encoding)) 
        encoding <- cset
      message("The 'cset' argument has been deprecated.\n",
              "Please use the argument 'encoding' instead.")
    }
    
    obj = h5checktypeOrOpenObj(obj, file, native = native)
    on.exit(h5closeitObj(obj))
    
    res <- FALSE

    if (is.null(dims)) {
      sid <- H5Screate()
    } else if (is.numeric(dims) & is.numeric(maxdims)) {
      sid <- H5Screate_simple(dims, maxdims)
      if (!is(sid, "H5IdComponent")) {
        message("Can not create attribute. 'dims' or 'maxdims' argument invalid.")
      }
    } else {
      stop("Can not create attribute. 'dims' and 'maxdims' have to be numeric.")
    }

    on.exit(H5Sclose(sid), add = TRUE)
    if (is.null(H5type)) {
        if (is.character(storage.mode)) {
            tid <- switch(storage.mode[1],
                          double = h5constants$H5T["H5T_IEEE_F64LE"],
                          integer = h5constants$H5T["H5T_STD_I32LE"],
                          character = {
                              tid <- H5Tcopy("H5T_C_S1")
                              H5Tset_cset(tid, cset = match.arg(encoding, 
                                                                choices = c("ASCII", "UTF-8", "UTF8")))
                              if (!is.null(size) && !is.numeric(size)) {
                                stop("'size' should be NULL or a number when 'storage.mode=\"character\"'")
                              }
                              H5Tset_size(tid, size) # NULL = variable.
                              tid
                          },
                          H5IdComponent=h5constants$H5T["H5T_STD_REF_OBJ"],
                          { stop("datatype ",storage.mode," not yet implemented. Try 'double', 'integer', or 'character'.") } )
        } else {
            stop("Can not create dataset. 'storage.mode' has to be a character.")
        }
    } else {
        tid <- h5checkConstants("H5T", H5type)
    }
    if(!grepl(pattern = "^[[:digit:]]+$", tid)) {
        message("Can not create attribute. H5type unknown. Check h5const('H5T') for valid types.")
    } else {
        if (H5Aexists(obj$H5Identifier,attr)) {
            message("Can not create attribute. Attribute with name '",attr,"' already exists.")
        } else {
            aid <- H5Acreate(obj$H5Identifier, attr, tid, sid)
            if (is(aid, "H5IdComponent")) {
                H5Aclose(aid)
                res <- TRUE
            }
        }
    }

    res
}

library(rhdf5)

############################################################
context("h5set_extent")
############################################################

## output file name
h5File <- withr::local_tempfile(pattern = "ex_set_extent_", fileext = ".h5")

## populate an example file
D <- 1:20
h5createFile(h5File)
h5createDataset(
  file = h5File,
  dataset = "foo",
  dims = c(1, length(D)),
  maxdims = c(4, length(D))
)
h5write(obj = D, file = h5File, name = "foo")

test_that("Dimensions as expected", {
  expect_identical(dim(h5read(h5File, name = "foo")), c(1L, length(D)))
})

test_that("Changing dataset dimensions", {
  expect_true(h5set_extent(
    file = h5File,
    dataset = "foo",
    dims = c(2, length(D))
  ))
  expect_identical(dim(h5read(h5File, name = "foo")), c(2L, length(D)))
})

test_that("Fail if given a group", {
  expect_true(h5createGroup(file = h5File, group = "baa"))
  expect_error(
    h5set_extent(file = h5File, dataset = "baa", dims = c(1, 1)),
    regexp = "is not a dataset\\.$"
  )
})

test_that("Fail if missing", {
  expect_error(
    h5set_extent(file = h5File, dataset = "missing", dims = c(1, 1)),
    regexp = "does not exist in this HDF5 file."
  )
})

library(rhdf5)

############################################################
context("h5dump")
############################################################

A <- 1:7
B <- 1:18
D <- seq(0, 1, by = 0.1)
## output file name
h5File <- withr::local_tempfile(pattern = "ex_dump", fileext = ".h5")

# create file with group heirachy
h5createFile(h5File)
h5createGroup(file = h5File, group = "foo")
h5createDataset(file = h5File, dataset = "foo/A", dims = c(1, length(A)))
h5write(obj = A, file = h5File, name = "foo/A")
h5createDataset(file = h5File, dataset = "foo/B", dims = c(1, length(B)))
h5write(obj = B, file = h5File, name = "foo/B")
h5createDataset(file = h5File, dataset = "baa", dims = c(1, length(D)))
h5write(obj = D, file = h5File, name = "baa")

test_that("Default arguments", {
  dump_output <- h5dump(file = h5File)
  expect_is(dump_output, "list")
  expect_true(all(c("baa", "foo") %in% names(dump_output)))

  expect_is(dump_output$baa, "matrix")
})

test_that("Check reading only dataset headers", {
  dump_output <- h5dump(file = h5File, load = FALSE)
  expect_is(dump_output$baa, "data.frame")
})

test_that("Changing recursion depth", {
  expect_is(h5dump(file = h5File, recursive = FALSE), "list") %>%
    expect_length(n = 2)
  expect_null(h5dump(file = h5File, recursive = FALSE)$foo)

  expect_identical(h5ls(h5File, recursive = 1), h5ls(h5File, recursive = FALSE))
  expect_identical(h5ls(h5File, recursive = -1), h5ls(h5File, recursive = TRUE))

  expect_error(h5dump(h5File, recursive = 0))
  expect_error(h5dump(h5File, recursive = "FOO"))
  expect_warning((h5dump(h5File, recursive = 1:3)))
})

test_that("Changing traversal order", {
  expect_identical(
    names(h5dump(h5File, order = "H5_ITER_DEC")),
    c("foo", "baa")
  )
  expect_identical(
    names(h5dump(h5File, order = "H5_ITER_INC")),
    c("baa", "foo")
  )
})

library(rhdf5)

############################################################
context("h5createFile")
############################################################

## output file name
h5File <- withr::local_tempfile(pattern = "ex_save", fileext = ".h5")

test_that("Default arguments", {
  expect_true(h5createFile(file = h5File))
  expect_true(file.exists(h5File))
})

test_that("Don't overwrite existing file", {
  expect_message(h5createFile(file = h5File), regexp = "already exists.\n$")
})

############################################################
context("h5createGroup")
############################################################

test_that("Create simple group", {
  expect_true(h5createGroup(file = h5File, group = "foo"))
})

test_that("Create group heirachy", {
  expect_true(h5createGroup(file = h5File, group = "foo/baa"))
})

test_that("Fail if toplevel group missing", {
  ## this is really an error, but doesn't get thrown as one
  h5errorHandling(type = "suppress")
  expect_false(h5createGroup(file = h5File, group = "baa/foo"))
  h5closeAll()
})

############################################################
context("h5createDataset")
############################################################

h5File <- withr::local_tempfile(pattern = "ex_createDS", fileext = ".h5")

## create empty file
h5createFile(file = h5File)

test_that("Create single dataset", {
  expect_true(h5createDataset(file = h5File, dataset = "A", dims = c(2, 1)))
  expect_true("A" %in% names(h5dump(file = h5File)))
  A <- h5read(file = h5File, name = "A")

  expect_is(A, "matrix")
  expect_true(nrow(A) == 2)
  expect_true(ncol(A) == 1)
  expect_is(A[1, 1], "numeric")
})

test_that("Create more datasets with different data types", {
  expect_true(h5createDataset(
    file = h5File,
    dataset = "int",
    dims = c(4, 5),
    storage.mode = "integer"
  ))
  expect_true(h5createDataset(
    file = h5File,
    dataset = "bool",
    dims = c(4, 5),
    storage.mode = "logical"
  ))
  expect_true(h5createDataset(
    file = h5File,
    dataset = "char",
    dims = c(4, 5),
    storage.mode = "character",
    size = 255
  ))

  contents <- h5dump(file = h5File)

  expect_true(all(c("int", "bool", "char") %in% names(contents)))

  expect_is(contents$int, "matrix")
  expect_true(nrow(contents$int) == 4)
  expect_true(ncol(contents$int) == 5)

  expect_is(contents$int[1, 1], "integer")
  expect_is(contents$bool[1, 1], "logical")
  expect_is(contents$char[1, 1], "character")
})

test_that("datasets of fixed and variable length characters can be created", {
  expect_true(
    h5createDataset(
      file = h5File,
      dataset = "variable_length",
      dims = 1,
      storage.mode = "character",
      size = NULL
    )
  )
  expect_true(
    h5createDataset(
      file = h5File,
      dataset = "fixed_length",
      dims = 1,
      storage.mode = "character",
      size = 10
    )
  )

  fid <- H5Fopen(h5File)
  did_var <- H5Dopen(fid, name = "variable_length")
  tid_var <- H5Dget_type(did_var)
  did_fix <- H5Dopen(fid, name = "fixed_length")
  tid_fix <- H5Dget_type(did_fix)

  ## Variable length strings return NULL when queried for size
  expect_true(H5Tis_variable_str(tid_var))
  expect_false(H5Tis_variable_str(tid_fix))
  expect_identical(H5Tget_size(tid_fix), 10L)

  sapply(c(did_var, did_fix), FUN = H5Dclose)
  H5Fclose(fid)
})

test_that("Encoding of string datasets can be set", {
  expect_true(
    h5createDataset(
      file = h5File,
      dataset = "ascii",
      dims = 1,
      storage.mode = "character",
      encoding = "ASCII"
    )
  )
  expect_true(
    h5createDataset(
      file = h5File,
      dataset = "utf-8",
      dims = 1,
      storage.mode = "character",
      encoding = "UTF-8"
    )
  )

  ## UTF8 should be UTF-8 but is accepted for legacy reasons
  expect_silent(
    h5createDataset(
      file = h5File,
      dataset = "utf8",
      dims = 1,
      storage.mode = "character",
      encoding = "UTF8"
    )
  ) |>
    expect_true()

  fid <- H5Fopen(h5File)
  did_ascii <- H5Dopen(fid, name = "ascii")
  tid_ascii <- H5Dget_type(did_ascii)
  did_utf8 <- H5Dopen(fid, name = "utf-8")
  tid_utf8 <- H5Dget_type(did_utf8)

  expect_identical(H5Tget_cset(tid_ascii), 0L)
  expect_identical(H5Tget_cset(tid_utf8), 1L)

  sapply(c(did_ascii, did_utf8), FUN = H5Dclose)
  H5Fclose(fid)
})


test_that("Invalid storage mode arguments", {
  expect_error(h5createDataset(
    file = h5File,
    dataset = "foo",
    dims = c(1, 1),
    storage.mode = "foo"
  ))
  expect_error(h5createDataset(
    file = h5File,
    dataset = "foo",
    dims = c(1, 1),
    storage.mode = 10
  ))
  expect_error(h5createDataset(
    file = h5File,
    dataset = "foo",
    dims = c(1, 1),
    storage.mode = 1L
  ))
  expect_error(h5createDataset(
    file = h5File,
    dataset = "foo",
    dims = c(1, 1),
    storage.mode = FALSE
  ))
})


test_that("Datasets with different compression levels", {
  dataMatrix <- matrix(runif(n = 1e5), nrow = 10000, ncol = 10)

  h5File_0 <- withr::local_tempfile(pattern = "level0_", fileext = ".h5")
  if (file.exists(h5File_0)) {
    file.remove(h5File_0)
  }
  h5createFile(h5File_0)
  expect_true(h5createDataset(
    file = h5File_0,
    dataset = "A",
    dims = dim(dataMatrix),
    level = 0
  ))
  h5write(dataMatrix, file = h5File_0, name = "A")

  h5File_9 <- withr::local_tempfile(pattern = "level9_", fileext = ".h5")
  if (file.exists(h5File_9)) {
    file.remove(h5File_9)
  }
  h5createFile(h5File_9)
  expect_true(h5createDataset(
    file = h5File_9,
    dataset = "A",
    dims = dim(dataMatrix),
    level = 9
  ))
  h5write(dataMatrix, file = h5File_9, name = "A")
  ## expect compressed file to be at least a small as uncompressed
  expect_lte(file.size(h5File_9), file.size(h5File_0))
})


test_that("Extendible datasets", {
  mtx4x3 <- matrix(runif(n = 12), nrow = 4)
  mtx3x3 <- matrix(runif(n = 9), nrow = 3)
  mtx7x2 <- matrix(runif(n = 14), nrow = 7)
  extendible <- H5Sunlimited()
  h5createDataset(
    file = h5File,
    dataset = "extend",
    dims = c(4, 3),
    maxdims = c(extendible, extendible)
  )
  h5write(mtx4x3, file = h5File, name = "extend")
  expect_identical(h5read(h5File, "extend"), mtx4x3)

  ## now extend in first dimension:
  ## [ mtx4x3 ]
  ## [ mtx3x3 ]

  h5set_extent(h5File, "extend", c(7, 3))
  h5write(mtx3x3, file = h5File, name = "extend", index = list(5:7, 1:3))
  expect_identical(h5read(h5File, "extend"), rbind(mtx4x3, mtx3x3))

  ## now extend in the other dimension:
  ## [ mtx4x3 mtx7x2 ]
  ## [ mtx3x3 mtx7x2 ]
  h5set_extent(h5File, "extend", c(7, 5))
  h5write(mtx7x2, file = h5File, name = "extend", index = list(1:7, 4:5))
  expect_identical(
    h5read(h5File, "extend"),
    cbind(rbind(mtx4x3, mtx3x3), mtx7x2)
  )

  ## This case, level = 0, used to lead to an error because the chunking, which is required for
  ## H5Sunlimited, was within a if(level > 0) branch. Mostly we are just checking here that
  ## no error is thrown, but we'll also do the first extension
  h5createDataset(
    file = h5File,
    dataset = "nonCompressed",
    dims = c(4, 3),
    maxdims = c(extendible, extendible),
    level = 0
  )
  h5write(mtx4x3, file = h5File, name = "nonCompressed")
  h5set_extent(h5File, "nonCompressed", c(7, 3))
  h5write(mtx3x3, file = h5File, name = "nonCompressed", index = list(5:7, 1:3))
  expect_identical(h5read(h5File, "nonCompressed"), rbind(mtx4x3, mtx3x3))
})

test_that("Invalid inputs", {
  expect_error(
    suppressWarnings(h5createDataset(
      file = h5File,
      dataset = "fail",
      dims = "twenty"
    )),
    regexp = "Can not create dataset. 'dims' and 'maxdims' must be numeric"
  )
  expect_message(h5createDataset(
    file = h5File,
    dataset = "A",
    dims = c(20, 10)
  )) %>%
    expect_false()
  expect_error(h5createDataset(
    file = h5File,
    dataset = "fail",
    dims = c(-10, 20)
  ))
  expect_error(h5createDataset(
    file = h5File,
    dataset = "fail",
    dims = c(10, 20),
    maxdims = c(20)
  ))
  expect_error(h5createDataset(
    file = h5File,
    dataset = "fail",
    dims = c(10, 20),
    maxdims = c(20, 20),
    chunk = NULL
  ))
  expect_error(h5createDataset(
    file = h5File,
    dataset = "fail",
    dims = c(10, 20),
    maxdims = c(20, 10)
  ))
  expect_warning(h5createDataset(
    file = h5File,
    dataset = "fail",
    dims = c(10, 20),
    level = 1,
    chunk = NULL
  ))

  expect_warning(
    h5createDataset(
      file = h5File,
      dataset = "chunkTooLarge",
      dims = c(10, 20),
      chunk = c(10, 50)
    ),
    regexp = "One or more chunk dimensions exceeded the maximum for the dataset"
  )
})

test_that("Using chunks greater than 4GB", {
  expect_message(h5createDataset(
    file = h5File,
    dataset = "large_double",
    dims = c(25000, 25000),
    storage.mode = "double"
  )) %>%
    expect_true()
  expect_message(h5createDataset(
    file = h5File,
    dataset = "large_int",
    dims = c(50000, 50000),
    storage.mode = "integer"
  )) %>%
    expect_true()
  expect_silent(h5createDataset(
    file = h5File,
    dataset = "small_int",
    dims = c(500, 500),
    storage.mode = "integer"
  )) %>%
    expect_true()
})

############################################################
context("h5createAttribute")
############################################################

h5File <- withr::local_tempfile(pattern = "ex_createAttr", fileext = ".h5")
## create a new file with a single dataset
h5createFile(h5File)
h5write(1:1, h5File, "foo")

test_that("attributes can be added using file name", {
  expect_true(h5createAttribute(
    obj = "foo",
    file = h5File,
    attr = "foo_attr",
    dims = c(1, 1)
  ))
  expect_true(
    "foo_attr" %in% names(h5readAttributes(file = h5File, name = "foo"))
  )
})

test_that("Fail is attribute already exists", {
  expect_false(h5createAttribute(
    obj = "foo",
    file = h5File,
    attr = "foo_attr",
    dims = c(1, 1)
  ))
  expect_message(
    h5createAttribute(
      obj = "foo",
      file = h5File,
      attr = "foo_attr",
      dims = c(1, 1)
    ),
    "Can not create attribute"
  )
})

test_that("Fail if dims or maxdims not numeric", {
  expect_error(h5createAttribute(
    obj = "foo",
    file = h5File,
    attr = "foo_attr2",
    dims = "A"
  ))
  expect_error(h5createAttribute(
    obj = "foo",
    file = h5File,
    attr = "foo_attr2",
    dims = c(1, 1),
    maxdims = "A"
  ))
})

test_that("Invalid storage mode arguments", {
  expect_error(h5createAttribute(
    file = h5File,
    obj = "foo",
    dims = c(1, 1),
    attr = "bad_attr",
    storage.mode = "foo"
  ))
  expect_error(h5createAttribute(
    file = h5File,
    obj = "foo",
    dims = c(1, 1),
    attr = "bad_attr",
    storage.mode = 10
  ))
  expect_error(h5createAttribute(
    file = h5File,
    obj = "foo",
    dims = c(1, 1),
    attr = "bad_attr",
    storage.mode = 1L
  ))
  expect_error(h5createAttribute(
    file = h5File,
    obj = "foo",
    dims = c(1, 1),
    attr = "bad_attr",
    storage.mode = FALSE
  ))
})

test_that("variable string attributes are created correctly", {
  h5createAttribute(
    file = h5File,
    obj = "foo",
    dims = c(1, 1),
    attr = "var_str_attr",
    storage.mode = "character",
    size = NULL
  )

  fhandle <- H5Fopen(h5File)
  dhandle <- H5Dopen(fhandle, "foo")
  ahandle <- H5Aopen(dhandle, "var_str_attr")
  dtype <- H5Aget_type(ahandle)
  expect_null(H5Tget_size(dtype)) # NULL = variable length.
  h5closeAll()

  # For comparison.
  h5createAttribute(
    file = h5File,
    obj = "foo",
    dims = c(1, 1),
    attr = "var_str_attr2",
    storage.mode = "character",
    size = 10
  )

  fhandle <- H5Fopen(h5File)
  dhandle <- H5Dopen(fhandle, "foo")
  ahandle <- H5Aopen(dhandle, "var_str_attr2")
  dtype <- H5Aget_type(ahandle)
  expect_identical(H5Tget_size(dtype), 10L)
  h5closeAll()
})

test_that("string encoding is handled properly", {
  h5createAttribute(
    file = h5File,
    obj = "foo",
    dims = c(1, 1),
    attr = "ascii_str_attr",
    storage.mode = "character",
    size = NULL
  )

  fhandle <- H5Fopen(h5File)
  dhandle <- H5Dopen(fhandle, "foo")
  ahandle <- H5Aopen(dhandle, "ascii_str_attr")
  dtype <- H5Aget_type(ahandle)
  expect_identical(H5Tget_cset(dtype), 0L) # aka ASCII
  h5closeAll()

  # Now Unicode.
  expect_silent(h5createAttribute(
    file = h5File,
    obj = "foo",
    dims = c(1, 1),
    attr = "utf_str_attr",
    storage.mode = "character",
    encoding = "UTF-8",
    size = NULL
  )) |>
    expect_true()

  fhandle <- H5Fopen(h5File)
  dhandle <- H5Dopen(fhandle, "foo")
  ahandle <- H5Aopen(dhandle, "utf_str_attr")
  dtype <- H5Aget_type(ahandle)
  expect_identical(H5Tget_cset(dtype), 1L) # aka UTF8
  h5closeAll()
})

test_that("scalar dataspaces are created properly", {
  # For reference.
  h5createAttribute(
    file = h5File,
    obj = "foo",
    dims = 1,
    attr = "simple_int_attr",
    storage.mode = "integer"
  )
  fhandle <- H5Fopen(h5File)
  dhandle <- H5Dopen(fhandle, "foo")
  ahandle <- H5Aopen(dhandle, "simple_int_attr")
  space <- H5Aget_space(ahandle)
  expect_identical(H5Sget_simple_extent_dims(space)$rank, 1L)
  h5closeAll()

  # Now, creating the scalar space.
  h5createAttribute(
    file = h5File,
    obj = "foo",
    dims = NULL,
    attr = "scalar_int_attr",
    storage.mode = "integer"
  )
  fhandle <- H5Fopen(h5File)
  dhandle <- H5Dopen(fhandle, "foo")
  ahandle <- H5Aopen(dhandle, "scalar_int_attr")
  space <- H5Aget_space(ahandle)
  expect_identical(H5Sget_simple_extent_dims(space)$rank, 0L)
  h5closeAll()
})

library(rhdf5)

############################################################
context("h5writeAttributes")
############################################################

## output file name
h5File <- withr::local_tempfile(pattern = "ex_attr_", fileext = ".h5")

h5createFile(file = h5File)

test_that("Adding attribute to file", {
  fid <- H5Fopen(h5File)

  ## character
  attr <- "foo"
  expect_silent(h5writeAttribute(attr = attr, h5obj = fid, name = "char_attr"))
  ## integer
  attr <- 1L
  expect_silent(h5writeAttribute(attr = attr, h5obj = fid, name = "int_attr"))
  ## numeric
  attr <- 10.0
  expect_silent(h5writeAttribute(
    attr = attr,
    h5obj = fid,
    name = "numeric_attr"
  ))
  ## matrix
  attr <- matrix(1:10, nrow = 2)
  expect_silent(h5writeAttribute(
    attr = attr,
    h5obj = fid,
    name = "matrix_attr"
  ))
  ## logical
  attr <- c(TRUE, FALSE)
  expect_silent(h5writeAttribute(
    attr = attr,
    h5obj = fid,
    name = "logical_attr"
  ))

  H5Fclose(fid)

  attr_back <- h5readAttributes(h5File, name = "/")
  expect_length(attr_back, n = 5)
  expect_true(all(
    c(
      "char_attr",
      "int_attr",
      "numeric_attr",
      "matrix_attr",
      "logical_attr"
    ) %in%
      names(attr_back)
  ))
  expect_is(attr_back$char_attr[1], "character")
  expect_is(attr_back$int_attr[1], "integer")
  expect_is(attr_back$numeric_attr[1], "numeric")
  expect_is(attr_back$logical_attr[1], "logical")
})

test_that("Adding attribute to group", {
  h5createGroup(file = h5File, group = "foo_group")
  fid <- H5Fopen(h5File)
  gid <- H5Gopen(h5loc = fid, name = "foo_group")

  ## character
  attr <- "foo"
  expect_silent(h5writeAttribute(attr = attr, h5obj = gid, name = "char_attr"))
  ## integer
  attr <- 1L
  expect_silent(h5writeAttribute(attr = attr, h5obj = gid, name = "int_attr"))
  ## numeric
  attr <- 10.0
  expect_silent(h5writeAttribute(
    attr = attr,
    h5obj = gid,
    name = "numeric_attr"
  ))
  ## matrix
  attr <- matrix(1:10, nrow = 2)
  expect_silent(h5writeAttribute(
    attr = attr,
    h5obj = gid,
    name = "matrix_attr"
  ))
  ## logical
  attr <- c(TRUE, FALSE)
  expect_silent(h5writeAttribute(
    attr = attr,
    h5obj = gid,
    name = "logical_attr"
  ))

  H5Gclose(gid)
  H5Fclose(fid)

  attr_back <- h5readAttributes(h5File, name = "foo_group")
  expect_length(attr_back, n = 5)
  expect_true(all(
    c(
      "char_attr",
      "int_attr",
      "numeric_attr",
      "matrix_attr",
      "logical_attr"
    ) %in%
      names(attr_back)
  ))
  expect_is(attr_back$char_attr[1], "character")
  expect_is(attr_back$int_attr[1], "integer")
  expect_is(attr_back$numeric_attr[1], "numeric")
  expect_is(attr_back$logical_attr[1], "logical")
})

test_that("Adding attribute to dataset", {
  h5createDataset(file = h5File, dataset = "baa_dataset", dims = c(2, 2))
  fid <- H5Fopen(h5File)
  did <- H5Dopen(fid, name = "baa_dataset")

  ## character
  attr <- "foo"
  h5writeAttribute(attr = attr, h5obj = did, name = "char_attr")
  ## integer
  attr <- 1L
  h5writeAttribute(attr = attr, h5obj = did, name = "int_attr")
  ## numeric
  attr <- 10.0
  h5writeAttribute(attr = attr, h5obj = did, name = "numeric_attr")
  ## matrix
  attr <- matrix(1:10, nrow = 2)
  h5writeAttribute(attr = attr, h5obj = did, name = "matrix_attr")
  ## logical
  attr <- c(TRUE, FALSE)
  expect_silent(h5writeAttribute(
    attr = attr,
    h5obj = did,
    name = "logical_attr"
  ))

  H5Dclose(did)
  H5Fclose(fid)

  attr_back <- h5readAttributes(h5File, name = "baa_dataset")
  expect_length(attr_back, n = 5)
  expect_true(all(
    names(attr_back) %in%
      c("char_attr", "int_attr", "numeric_attr", "matrix_attr", "logical_attr")
  ))
  expect_is(attr_back$char_attr[1], "character")
  expect_is(attr_back$int_attr[1], "integer")
  expect_is(attr_back$numeric_attr[1], "numeric")
  expect_is(attr_back$logical_attr[1], "logical")
})

test_that("Checking other string options when adding attributes", {
  h5createGroup(file = h5File, group = "blah_group")
  fid <- H5Fopen(h5File)
  gid <- H5Gopen(h5loc = fid, name = "blah_group")

  ## variable strings
  attr <- "blah"
  expect_silent(h5writeAttribute(
    attr = attr,
    h5obj = gid,
    name = "char_attr",
    variableLengthString = TRUE
  ))

  ## different encoding
  attr <- "blah2"
  expect_silent(h5writeAttribute(
    attr = attr,
    h5obj = gid,
    name = "char_attr2",
    encoding = "UTF-8"
  ))

  ## as a scalar
  attr <- "blah3"
  expect_silent(h5writeAttribute(
    attr = attr,
    h5obj = gid,
    name = "char_attr3",
    encoding = "UTF-8",
    asScalar = TRUE
  ))
  expect_error(
    h5writeAttribute(
      attr = c(attr, attr),
      h5obj = gid,
      name = "char_attr3",
      encoding = "UTF-8",
      asScalar = TRUE
    ),
    "cannot use"
  )

  H5Gclose(gid)
  H5Fclose(fid)

  attr_back <- h5readAttributes(h5File, name = "blah_group")
  expect_length(attr_back, n = 3)

  expected <- c("char_attr", "char_attr2", "char_attr3")
  expect_identical(sort(expected), sort(names(attr_back)))
  expect_identical(
    unname(unlist(attr_back[expected])),
    c("blah", "blah2", "blah3")
  )
})
#
# test_that("Unable to add logical attribute", {
#     fid <- H5Fopen(h5File)
#     expect_error( h5writeAttribute(attr = FALSE, h5obj = fid, name = "logical_attr"))
#     H5Fclose(fid)
# })

test_that("Overwrite exisiting attribute", {
  fid <- H5Fopen(h5File)
  expect_silent(h5writeAttribute(
    attr = "new_character",
    h5obj = fid,
    name = "char_attr"
  ))
  H5Fclose(fid)

  attr_list <- h5readAttributes(h5File, name = "/")
  expect_identical(attr_list$char_attr[1], "new_character")
})

library(rhdf5)

############################################################
context("h5read_high_memory")
############################################################

## output file name
h5File <- withr::local_tempfile(pattern = "ex_read", fileext = ".h5")

# create file
h5createFile(h5File)

test_that("Read / write vector longer than 2^31-1", {
  ## travis doesn't have resources to create an 8GB vector, so we skip there
  long_vector <- tryCatch(integer(length = (2^31) + 1000), error = function(e) {
    NULL
  })

  if (!is.null(long_vector)) {
    expect_silent(
      h5createDataset(
        file = h5File,
        dataset = "too_long",
        dims = length(long_vector),
        level = 0,
        storage.mode = "integer",
        chunk = 1e6
      )
    )
    expect_silent(
      h5write(obj = long_vector, file = h5File, name = "too_long")
    )

    rm(long_vector)

    expect_silent(tmp <- h5read(file = h5File, name = "too_long")) %>%
      expect_is("integer") %>%
      length() %>%
      expect_equal((2^31) + 1000)
  }
})

"_PACKAGE"

#' rhdf5: An interface between HDF5 and R
#'
#' The rhdf5 package provides two categories of functions:
#' * `h5` functions are high-level R functions that provide a convenient way of
#'   accessing HDF5 files
#' * `H5` functions mirror much of the the HDF5 C API
#'
#' @name rhdf5
#'
#' @import Rhdf5lib
#' @import rhdf5filters
#' @import methods
#'
#' @useDynLib rhdf5
NULL

#' Read the time stamps associated with an HDF5 group or dataset.
#'
#' @param file Character vector of length 1, giving the path to the HDF5 file
#' @param name Path within the HDF5 file to the object whose attributes should
#'   be read. The datasets present in \code{file} can be listed with the
#'  function \code{\link{h5ls}}.
#'
#' @returns A named list of length 4 containing the timestamps on the object.
#' The timestamps themselves are `POSIXct` objects (see
#' [base::DateTimeClasses()]).
#'
#' @details All timestamps are returned in the UTC timezone.  HDF5 objects
#' can have between 0 and 4 timestamps set, depending on the property lists
#' provided when they are created or accessed.  Timestamps that are not tracked
#' will be returned as the UNIX epoch `1970-01-01 UTC`.
#'
#' @examples
#' # example file
#' example_file <- system.file("testfiles", "h5ex_t_array.h5", package = "rhdf5")
#'
#' ## read timestamps on a group
#' h5readTimestamps(example_file, name = "/")
#'
#' ## read timestamps on a datasets
#' h5readTimestamps(example_file, name = "/DS1")
#'
#' @name h5readTimestamps
#' @export
h5readTimestamps <- function(file, name) {
  if (missing(name)) {
    stop(
      "Please provide the name of the object to read timestamps from ",
      "using the 'name' argument. You can use `h5ls()` to list the objects in ",
      "the file",
      call. = FALSE
    )
  }
  loc <- h5checktypeOrOpenLoc(file, readonly = TRUE, native = FALSE)
  on.exit(h5closeitLoc(loc))
  if (!H5Lexists(loc$H5Identifier, name)) {
    stop(
      "Object ",
      name,
      " does not exist in this HDF5 file.\n",
      "Use `h5ls()` to list the objects in the file."
    )
  }
  oid <- H5Oopen(loc$H5Identifier, name)
  on.exit(H5Oclose(oid), add = TRUE)
  info <- H5Oget_info(oid)
  res <- info[4:7]
  return(res)
}

library(rhdf5)

## output file name
h5File <- system.file("testfiles", "h5ex_t_array.h5", package = "rhdf5")

test_that("timestamps can be read", {
  expect_silent(ts <- h5readTimestamps(h5File, "/DS1"))
  expect_is(ts, "list")
  expect_length(ts, 4L)
  expect_identical(names(ts), c("access_time", "modification_time", "change_time", "birth_time"))

  expect_is(ts$access_time, "POSIXct")
  expect_identical(ts$access_time, as.POSIXct(0, tz = "UTC"))
  expect_identical(ts$change_time, as.POSIXct(1515695505, tz = "UTC"))
})

#' Create an attribute for an HDF5 object
#'
#' Creates an attribute, `name`, which is attached to the object specified
#' by the identifier `h5obj`. The attribute name must be unique for the object.
#'
#' @param h5obj An object of class [H5IdComponent-class] representing a H5 object
#' identifier (file, group, or dataset). See [H5Fcreate()], [H5Fopen()],
#' [H5Gcreate()], [H5Gopen()], [H5Dcreate()], or [H5Dopen()] to create an object of this kind.
#' @param name The name of the attribute (character).
#' @param dtype_id A character name of a datatype. See `h5const("H5T")` for
#' possible datatypes. Can also be an integer representing an HDF5 datatype.
#' Only simple datatypes are allowed for attributes.
#' @param h5space An object of class [H5IdComponent-class] representing a H5
#' dataspace. See [H5Dget_space()], [H5Screate_simple()], [H5Screate()] to create an object
#' of this kind.
#'
#' @returns An object of class [H5IdComponent-class] representing a H5 attribute identifier.
#'
#' @export
H5Acreate <- function(h5obj, name, dtype_id, h5space) {
  h5checktype(h5obj, "object")
  if (length(name) != 1 || !is.character(name)) {
    stop("'name' must be a character string of length 1")
  }
  ## dont check if we have an H5T identifier already
  if (!grepl(pattern = "^[[:digit:]]+$", dtype_id)) {
    dtype_id <- h5checkConstants("H5T", dtype_id)
  }
  h5checktype(h5space, "dataspace")
  aid <- .Call(
    "_H5Acreate",
    h5obj@ID,
    name,
    dtype_id,
    h5space@ID,
    PACKAGE = "rhdf5"
  )
  if (aid > 0) {
    h5attribute <- new("H5IdComponent", ID = aid, native = h5obj@native)
  } else {
    message("HDF5: unable to create attribute")
    h5attribute <- FALSE
  }
  invisible(h5attribute)
}

#' Open an attribute for an HDF5 object
#'
#' @param h5obj An object of class [H5IdComponent-class] representing a H5 object
#' identifier (file, group, or dataset). See [H5Fcreate()], [H5Fopen()],
#' [H5Gcreate()], [H5Gopen()], [H5Dcreate()], or [H5Dopen()] to create an object of this kind.
#' @param name The name of the attribute (character).
#' @param objname The name of the object the attribute belongs to.
#' @param n Opens attribute number `n` in the given order and index. Indexing is C-style, base-0,
#' so the first attribute is opened with `n=0`.
#' @param index_type See `h5const("H5_INDEX")` for possible arguments.
#' @param order See `h5const("H5_ITER")` for possible arguments.
#'
#' @returns An object of class [H5IdComponent-class] representing a H5 attribute identifier.
#'
#' @name H5Aopen
NULL

#' @rdname H5Aopen
#' @export
H5Aopen <- function(h5obj, name) {
  h5checktype(h5obj, "object")
  if (length(name) != 1 || !is.character(name)) {
    stop("'name' must be a character string of length 1")
  }
  aid <- .Call("_H5Aopen", h5obj@ID, name, PACKAGE = "rhdf5")
  if (aid > 0) {
    h5attribute <- new("H5IdComponent", ID = aid, native = h5obj@native)
  } else {
    message("HDF5: unable to open attribute")
    h5attribute <- FALSE
  }
  invisible(h5attribute)
}

#' @rdname H5Aopen
#' @export
H5Aopen_by_name <- function(h5obj, objname = ".", name) {
  h5checktype(h5obj, "object")
  if (length(objname) != 1 || !is.character(objname)) {
    stop("'objname' must be a character string of length 1")
  }
  if (length(name) != 1 || !is.character(name)) {
    stop("'name' must be a character string of length 1")
  }
  aid <- .Call("_H5Aopen_by_name", h5obj@ID, objname, name, PACKAGE = "rhdf5")
  if (aid > 0) {
    h5attribute <- new("H5IdComponent", ID = aid, native = h5obj@native)
  } else {
    message("HDF5: unable to open attribute")
    h5attribute <- FALSE
  }
  invisible(h5attribute)
}

#' @rdname H5Aopen
#' @export
H5Aopen_by_idx <- function(
  h5obj,
  n,
  objname = ".",
  index_type = h5default("H5_INDEX"),
  order = h5default("H5_ITER")
) {
  h5checktype(h5obj, "object")
  if (length(objname) != 1 || !is.character(objname)) {
    stop("'objname' must be a character string of length 1")
  }
  index_type <- h5checkConstants("H5_INDEX", index_type)
  order <- h5checkConstants("H5_ITER", order)
  if (length(n) != 1 || !is.numeric(n)) {
    stop("'n' must be an integer of length 1")
  }
  n <- as.integer(n)
  aid <- .Call(
    "_H5Aopen_by_idx",
    h5obj@ID,
    objname,
    index_type,
    order,
    n,
    PACKAGE = "rhdf5"
  )
  if (aid > 0) {
    h5attribute <- new("H5IdComponent", ID = aid, native = h5obj@native)
  } else {
    message("HDF5: unable to open attribute")
    h5attribute <- FALSE
  }
  invisible(h5attribute)
}

#' Check whether an specific attribute exists for an HDF5 object
#'
#' @param h5obj An object of class [H5IdComponent-class] representing a H5 object
#' identifier (file, group, or dataset). See [H5Fcreate()], [H5Fopen()],
#' [H5Gcreate()], [H5Gopen()], [H5Dcreate()], or [H5Dopen()] to create an object of this kind.
#' @param name The name of the attribute (character).
#'
#' @returns A logical value indicating whether an attribute with name `name`
#'   exists for the object specified by `h5obj`.
#'
#' @export
H5Aexists <- function(h5obj, name) {
  h5checktype(h5obj, "object")
  if (length(name) != 1 || !is.character(name)) {
    stop("'name' must be a character string of length 1")
  }
  res <- .Call("_H5Aexists", h5obj@ID, name, PACKAGE = "rhdf5")
  res > 0
}


#' Close an HDF5 attribute
#'
#' @param h5attribute An object of class [H5IdComponent-class] representing a
#' the attribute to be closed.  Normally created by [H5Aopen()] or similar.
#'
#' @seealso [H5Aopen()]
#' @export
H5Aclose <- function(h5attribute) {
  h5checktype(h5attribute, "attribute")
  invisible(.Call("_H5Aclose", h5attribute@ID, PACKAGE = "rhdf5"))
}

#' Delete an specified attribute of an HDF5 object
#'
#' @param h5obj An object of class [H5IdComponent-class] representing a H5 object
#' identifier (file, group, or dataset). See [H5Fcreate()], [H5Fopen()],
#' [H5Gcreate()], [H5Gopen()], [H5Dcreate()], or [H5Dopen()] to create an object of this kind.
#' @param name The name of the attribute (character).
#'
#' @export
H5Adelete <- function(h5obj, name) {
  h5checktype(h5obj, "object")
  if (length(name) != 1 || !is.character(name)) {
    stop("'name' must be a character string of length 1")
  }
  res <- .Call("_H5Adelete", h5obj@ID, name, PACKAGE = "rhdf5")
  res
}

#' Get the name of an HDF5 attribute object
#'
#' Retrieves the name of the attribute specified by an HDF5 attribute object.
#'
#' @param h5attribute An object of class [H5IdComponent-class] representing an
#' attribute.  Normally created by [H5Aopen()] or similar.
#'
#' @returns A character vector of length 1 containing the name of the attribute.
#'
#' @export
H5Aget_name <- function(h5attribute) {
  h5checktype(h5attribute, "attribute")
  name <- .Call("_H5Aget_name", h5attribute@ID, PACKAGE = "rhdf5")
  name
}

#' Get a copy of the attribute dataspace
#'
#' @param h5attribute An object of class [H5IdComponent-class] representing an
#' attribute.  Normally created by [H5Aopen()] or similar.
#'
#' @returns Returns an object of class [H5IdComponent-class] representing a H5
#' dataspace identifier
#'
#' @export
H5Aget_space <- function(h5attribute) {
  h5checktype(h5attribute, "attribute")
  sid <- .Call("_H5Aget_space", h5attribute@ID, PACKAGE = "rhdf5")
  if (sid > 0) {
    h5space <- new("H5IdComponent", ID = sid, native = h5attribute@native)
  } else {
    message("HDF5: unable to create simple data space")
    h5space <- FALSE
  }
  invisible(h5space)
}

#' Get a copy of the attribute datatype
#'
#' @param h5attribute An object of class [H5IdComponent-class] representing an
#' attribute.  Normally created by [H5Aopen()] or similar.
#'
#' @export
H5Aget_type <- function(h5attribute) {
  h5checktype(h5attribute, "attribute")
  tid <- .Call("_H5Aget_type", h5attribute@ID, PACKAGE = "rhdf5")
  invisible(tid)
}

#' Read data from an HDF5 attribute
#'
#' @details Internally, R does not support 64-bit integers. All integers in R are 32-bit
#' integers. By setting bit64conversion='int', a coercing to 32-bit integers is
#' enforced, with the risk of data loss, but with the insurance that numbers
#' are represented as integers. bit64conversion='double' coerces the 64-bit
#' integers to floating point numbers. doubles can represent integers with up
#' to 54-bits, but they are not represented as integer values anymore. For
#' larger numbers there is again a data loss. bit64conversion='bit64' is
#' recommended way of coercing. It represents the 64-bit integers as objects
#' of class 'integer64' as defined in the package 'bit64'. Make sure that you
#' have installed 'bit64'. The datatype 'integer64' is not part of base R, but
#' defined in an external package. This can produce unexpected behaviour when
#' working with the data.
#'
#' @param h5attribute An object of class [H5IdComponent-class] representing an
#' attribute.  Normally created by [H5Aopen()] or similar.
#' @param buf Optional buffer to store retrieved values. The buffer size has to
#' fit the size of the memory space `h5spaceMem`. No extra memory will be
#' allocated for the data. Default is `NULL` which means the function will
#' return the attribute data.
#' @param bit64conversion Defines how 64-bit integers are converted. (See
#' the details section for more information on these options.)
#'
#' @returns If `buf=NULL` returns the contents of the attribute.  Otherwise
#' return 0 if attribute is read successfully.
#'
#' @export
H5Aread <- function(
  h5attribute,
  buf = NULL,
  bit64conversion = c("int", "double", "bit64")
) {
  h5checktype(h5attribute, "attribute")

  bit64conversion <- fix_missing(bit64conversion, "int")
  if (identical(bit64conversion, "default")) {
    bit64conversion <- "int"
    warning(
      "To rely on the `bit64conversion` argument default, ",
      'you should omit it or explicitly set it to its default value (`"int"`).',
      ' Passing `"default"` will be disallowed in the next release cycle.'
    )
  }
  bit64conversion <- match.arg(bit64conversion)
  bit64conv <- switch(
    bit64conversion,
    int = 0L,
    double = 1L,
    bit64 = 2L
  )
  if (bit64conv == 2L && !requireNamespace("bit64", quietly = TRUE)) {
    stop("install package 'bit64' before using bit64conversion='bit64'")
  }

  rval <- .Call("_H5Aread", h5attribute@ID, buf, bit64conv, PACKAGE = "rhdf5")
  if (is(rval, "H5IdComponent")) {
    rval@native <- h5attribute@native
  }

  return(rval)
}

#' Write data to an HDF5 attribute
#'
#' @param h5attribute An object of class [H5IdComponent-class] representing an
#' attribute.  Normally created by [H5Aopen()] or similar.
#' @param buf The data to be written.
#'
#' @export
H5Awrite <- function(h5attribute, buf) {
  h5checktype(h5attribute, "attribute")
  invisible(.Call("_H5Awrite", h5attribute@ID, buf, PACKAGE = "rhdf5"))
}

library(rhdf5)

h5File <- withr::local_tempfile(pattern = "ex_H5A_", fileext = ".h5")
h5createFile(h5File)
h5write(1:15, h5File, "A")

expect_null(h5errorHandling(type = "suppress"))

test_that("writing attributes is silent", {
  expect_silent(fid <- H5Fopen(h5File))
  expect_silent(did <- H5Dopen(fid, "A"))
  expect_silent(sid <- H5Screate_simple(1))
  expect_silent(sid2 <- H5Screate_simple(10))
  expect_silent(tid <- H5Tcopy("H5T_C_S1"))

  ## fixed length strings
  expect_silent(H5Tset_size(tid, 10L))
  expect_silent(aid <- H5Acreate(did, "volume", tid, sid))
  expect_silent(H5Awrite(aid, "liter"))
  expect_silent(H5Aclose(aid))
  expect_silent(aid <- H5Acreate(did, "time", tid, sid))
  expect_silent(H5Awrite(aid, "seconds"))
  expect_silent(H5Aclose(aid))

  ## 64-bit integers
  expect_silent(aid <- H5Acreate(did, "int64", "H5T_NATIVE_INT64", sid))
  expect_silent(H5Awrite(aid, 2^32))
  expect_silent(H5Aclose(aid))

  ## unsigned 32-bit integers
  expect_silent(aid <- H5Acreate(did, "uint32", "H5T_NATIVE_UINT32", sid2))
  expect_silent(H5Awrite(aid, c(1:9, 2^31)))
  expect_silent(H5Aclose(aid))

  expect_silent(H5Sclose(sid))
  expect_silent(H5Sclose(sid2))
  expect_silent(H5Dclose(did))
  expect_silent(H5Fclose(fid))
})


test_that("attributes exist", {
  expect_silent(fid <- H5Fopen(h5File))
  expect_silent(did <- H5Dopen(fid, "A"))

  expect_true(H5Aexists(did, "volume"))
  expect_true(H5Aexists(did, "time"))
  expect_false(H5Aexists(did, "foo"))

  expect_silent(H5Dclose(did))
  expect_silent(H5Fclose(fid))
})

test_that("attributes can be opened and closed", {
  expect_silent(fid <- H5Fopen(h5File))

  expect_silent(aid <- H5Aopen_by_name(fid, objname = "A", name = "volume"))
  expect_output(print(aid), regexp = "volume")
  expect_silent(H5Aclose(aid))
  expect_silent(aid <- H5Aopen_by_name(fid, objname = "A", name = "time"))
  expect_output(print(aid), regexp = "time")
  expect_silent(H5Aclose(aid))

  expect_silent(aid <- H5Aopen_by_idx(fid, n = 2, objname = "A"))
  expect_identical(H5Aget_name(aid), "time")
  expect_silent(H5Aclose(aid))
  expect_silent(aid <- H5Aopen_by_idx(fid, n = 4, objname = "A"))
  expect_identical(H5Aget_name(aid), "volume")
  expect_silent(H5Aclose(aid))

  expect_silent(H5Fclose(fid))

  ## doesn't cope well when a missing attribute is named
  ## H5Aopen_by_name(fid, objname = "A", name = "foobaa")
})

test_that("64-bit integer attributes are read correctly", {
  fid <- H5Fopen(h5File)
  did <- H5Dopen(fid, name = "A")
  aid <- H5Aopen(did, name = "int64")

  expect_warning(H5Aread(aid, bit64conversion = "int")) %>%
    is.na() %>%
    expect_true()

  expect_silent(H5Aread(aid, bit64conversion = "double")) %>%
    expect_equivalent(2^32)

  expect_silent(H5Aread(aid, bit64conversion = "bit64")) %>%
    expect_equivalent(bit64::as.integer64(2^32))

  H5Aclose(aid)
  H5Dclose(did)
  H5Fclose(fid)
})

test_that("unsigned 32-bit integer attributes are read correctly", {
  fid <- H5Fopen(h5File)
  did <- H5Dopen(fid, name = "A")
  aid <- H5Aopen(did, name = "uint32")

  expect_warning(H5Aread(aid, bit64conversion = "int")) |>
    is.na() |>
    any() |>
    expect_true()

  expect_silent(H5Aread(aid, bit64conversion = "double")) |>
    expect_equivalent(c(1:9, 2^31))

  expect_silent(x3 <- H5Aread(aid, bit64conversion = "bit64"))
  expect_equivalent(x3, bit64::as.integer64(c(1:9, 2^31)))
  expect_is(x3, "integer64")

  H5Aclose(aid)
  H5Dclose(did)
  H5Fclose(fid)
})

test_that("attributes can be deleted", {
  expect_silent(fid <- H5Fopen(h5File))
  expect_silent(did <- H5Dopen(fid, "A"))

  ## deleting existing attribute
  expect_true(H5Aexists(did, "volume"))
  expect_identical(H5Adelete(did, "volume"), 0L)
  expect_false(H5Aexists(did, "volume"))

  ## trying to delete non-existant attribute
  expect_identical(H5Adelete(did, "foobaa"), -1L)

  expect_silent(H5Dclose(did))
  expect_silent(H5Fclose(fid))
})

test_that("Missing values in bit64conversion can be passed down", {
  fid <- H5Fopen(h5File)
  did <- H5Dopen(fid, name = "A")
  aid <- H5Aopen(did, name = "uint32")

  f <- function(attribute, bit64conversion) {
    H5Aread(attribute, bit64conversion = bit64conversion)
  }
  expect_warning(f(aid), "To rely on the `bit64conversion` argument default")

  H5Aclose(aid)
  H5Dclose(did)
  H5Fclose(fid)
})

test_that("fixed length string attributes are correct", {
  attr_value <- "Testing"
  attr_name <- "name"

  # create a string datatype with size of 7 bytes
  tid <- H5Tcopy("H5T_C_S1")
  H5Tset_strpad(tid, strpad = "NULLPAD")
  H5Tset_size(tid, nchar(attr_value))

  fid <- H5Fopen(h5File)
  sid <- H5Screate("H5S_SCALAR")
  aid <- H5Acreate(fid, name = attr_name, dtype_id = tid, h5space = sid)

  H5Awrite(aid, attr_value) # string of length 7

  h5closeAll(aid, sid, fid)

  attr <- h5readAttributes(h5File, "/")
  expect_is(attr, class = "list")
  expect_identical(names(attr), attr_name)
  expect_identical(attr$name, attr_value)
})

library(rhdf5)

## output file name
h5File <- withr::local_tempfile(pattern = "ex_read_attr_", fileext = ".h5")

h5createFile(file = h5File)
A <- as.double(1:10)
h5write(A, h5File, "A", )
fid <- H5Fopen(h5File)
did <- H5Dopen(fid, "A")
sid <- H5Screate_simple(10)

## 64-bit integers
aid <- H5Acreate(did, "int64", "H5T_NATIVE_INT64", sid)
H5Awrite(aid, c(1:9, 2^32))
H5Aclose(aid)

## unsigned 32-bit integers
aid <- H5Acreate(did, "uint32", "H5T_NATIVE_UINT32", sid)
H5Awrite(aid, c(1:9, 2^31))
H5Aclose(aid)

H5Sclose(sid)
H5Dclose(did)
H5Fclose(fid)

test_that("64-bit integer attributes are read correctly", {
  expect_warning(x1 <- h5readAttributes(h5File, "A", bit64conversion = "int"))
  expect_true("int64" %in% names(x1) && "uint32" %in% names(x1))
  expect_equivalent(x1$int64, c(1:9, NA))
  expect_equivalent(x1$uint32, c(1:9, NA))

  expect_silent(x2 <- h5readAttributes(h5File, "A", bit64conversion = "double"))
  expect_equivalent(x2$int64, c(1:9, 2^32))
  expect_equivalent(x2$uint32, c(1:9, 2^31))
  expect_is(x2$int64, "array")
  expect_type(x2$int64, "double")

  expect_silent(x3 <- h5readAttributes(h5File, "A", bit64conversion = "bit64"))
  expect_equivalent(x3$int64, c(1:9, 2^32))
  expect_equivalent(x3$uint32, c(1:9, 2^31))
  expect_s3_class(x3$int64, "integer64")
})

#' Add the BZIP2 filter to the chunk processing pipeline.
#'
#' @param h5plist Object of class [H5IdComponent-class] representing a dataset
#' creation property list.
#' @param level Compression level to be used by the selected algorithm.
#'
#' @export
H5Pset_bzip2 <- function(h5plist, level = 2L) {
  if (!is.loaded("_H5Pset_bzip2", PACKAGE = "rhdf5")) {
    stop(
      "BZIP2 filter not found.\nPlease install rhdf5filters, and then reinstall rhdf5."
    )
  }

  h5checktypeAndPLC(h5plist, "H5P_DATASET_CREATE")
  res <- .Call(
    "_H5Pset_bzip2",
    h5plist@ID,
    as.integer(level),
    PACKAGE = "rhdf5"
  )
  invisible(res)
}

#' Add the BLOSC filter to the chunk processing pipeline.
#'
#' @param h5plist Object of class [H5IdComponent-class] representing a dataset
#' creation property list.
#' @param h5tid HDF5 data type id
#' @param method Integer defining which of the compression algorithms provided
#' by BLOSC should be used. (See the details section for the mapping between
#' integers and algorithms).
#' @param level Compression level to be used by the selected algorithm.
#' @param shuffle Logical defining whether the bit-shuffle algorithm should
#' be used prior to compression.  This makes use of the shuffle implementation
#' provide by BLOSC, rather than the HDF5 version.
#'
#' @export
H5Pset_blosc <- function(
  h5plist,
  h5tid,
  method = 1L,
  level = 6L,
  shuffle = TRUE
) {
  if (!is.loaded("_H5Pset_blosc", PACKAGE = "rhdf5")) {
    stop(
      "BLOSC filter not found.\nPlease install rhdf5filters, and then reinstall rhdf5."
    )
  }

  method <- as.integer(method)
  if (method < 1 || method > 6) {
    method <- 1L
    warning("Invalid method selected. Using BLOSC_LZ")
  }

  ## START: simplified reimplementation of C code from H5Zblosc.c
  ## Filter from https://github.com/nexusformat/HDF5-External-Filter-Plugins/
  ## contains a call to blosc_set_local() which determines chunk size & blosc
  ## parameters. This requires calls to HDF5 functions and doesn't play well
  ## with our static linking.  We move this setup code into R code below.
  chunkdims <- H5Pget_chunk(h5plist)
  typesize <- H5Tget_size(h5tid)
  if (typesize > 255) {
    typesize <- 1
  }
  bufsize <- typesize * prod(chunkdims)
  ## END

  h5checktypeAndPLC(h5plist, "H5P_DATASET_CREATE")
  res <- .Call(
    "_H5Pset_blosc",
    h5plist@ID,
    as.integer(method - 1L),
    as.integer(level),
    as.integer(as.logical(shuffle)),
    as.integer(typesize),
    as.integer(bufsize),
    PACKAGE = "rhdf5"
  )
  invisible(res)
}

#' Add the LZF filter to the chunk processing pipeline.
#'
#' @param h5plist Object of class [H5IdComponent-class] representing a dataset
#' creation property list.
#' @param h5tid HDF5 data type id
#'
#' @export
H5Pset_lzf <- function(h5plist, h5tid) {
  if (!is.loaded("_H5Pset_lzf", PACKAGE = "rhdf5")) {
    stop(
      "LZF filter not found.\nPlease install rhdf5filters, and then reinstall rhdf5."
    )
  }

  ## START: simplified reimplementation of C code from lzf_filter.c
  ## Filter from h5py
  ## contains a call to lzf_set_local() which determines chunk size
  ## This requires calls to HDF5 functions and doesn't play well
  ## with our static linking.  We move this setup code into R code below.
  chunkdims <- H5Pget_chunk(h5plist)
  typesize <- H5Tget_size(h5tid)
  bufsize <- typesize * prod(chunkdims)
  ## END

  h5checktypeAndPLC(h5plist, "H5P_DATASET_CREATE")
  res <- .Call(
    "_H5Pset_lzf",
    h5plist@ID,
    as.integer(bufsize),
    PACKAGE = "rhdf5"
  )
  invisible(res)
}

#' HDF5 library constants.
#'
#' Access to HDF5 constants.
#'
#' These functions provide a list of HDF5 constants that are defined in the R
#' package. `h5constType` provides a list of group names and
#' `h5const` gives the constants defined within a group. `h5default`
#' gives the default choice for each group.
#'
#' @param type A character name of a group of constants.
#' @returns A character vector with names of HDF5 constants or groups.
#' @author Bernd Fischer
#' @examples
#'
#' h5constType()[1]
#' h5const(h5constType()[1])
#' @name h5constants
NULL

#' @rdname h5constants
#' @export h5const
h5const <- function(type = "") {
  names(h5constants[[type]])
}

#' @rdname h5constants
#' @export
h5constType <- function() {
  h5constants <- H5loadConstants()
  names(h5constants)
}

#' @rdname h5constants
#' @export
h5default <- function(type = "") {
  names(h5constants[[type]])[1]
}

H5loadConstants <- function() {
  invisible(.Call("_H5constants", PACKAGE = "rhdf5"))
}

h5constants <- list()

h5checkConstants <- function(group, constant) {
  res <- h5constants[[group]][constant[1]]
  if (is.null(res)) {
    stop("unknown 'group' of H5 constants")
  }
  if (length(constant) > 1) {
    warning(
      "H5 constant identifier has more than one value. Only the first value will be used."
    )
  }
  res
}

h5const2Factor <- function(group = "", values) {
  if (!group %in% names(h5constants)) {
    stop("unknown 'group' of H5 constants")
  }
  Levels <- unique(c(h5constants[[group]], values))
  f <- factor(values, levels = Levels)
  m <- match(Levels, h5constants[[group]])
  LevelNames <- as.character(Levels)
  LevelNames[is.finite(m)] <- names(h5constants[[group]])[which(is.finite(m))]
  levels(f) <- LevelNames
  f
}

h5const2String <- function(group = "", values) {
  if (!group %in% names(h5constants)) {
    stop("unknown 'group' of H5 constants")
  }

  group_const <- h5constants[[group]]
  names(group_const)[match(values, group_const)]
}

library(rhdf5)

############################################################
context("h5 defined constants")
############################################################

test_that("const groups", {
  expect_is(h5constType(), "character") %>%
    expect_length(n = 21)
})

test_that("constants", {
  expect_is(h5const("H5F_ACC"), "character") %>%
    expect_length(n = 2)

  expect_null(h5const("foobaa"))
})

test_that("defaults", {
  expect_is(h5default("H5F_ACC"), "character") %>%
    expect_length(n = 1) %>%
    expect_identical(expected = "H5F_ACC_TRUNC")

  expect_null(h5default("foobaa"))
})

## we might deprecate const2Factor and remove this later
# test_that("const2String similar to const2Factor", {
#
#   const_types <- rhdf5::h5constType()
#
#   for(const in const_types) {
#     const_values <- h5constants[[ const ]]
#     expect_equal(
#       as.character(rhdf5:::h5const2Factor(group = const, values = const_values)),
#       rhdf5:::h5const2String(group = const, values = const_values)
#     )
#   }
#
# })

h5getEnumNames <- function(tid) {
  enum_names <- .Call("_h5getEnumNames", tid, PACKAGE = "rhdf5")
  return(enum_names)
}

h5getEnumValues <- function(tid) {
  enum_vals <- .Call("_h5getEnumValues", tid, PACKAGE = "rhdf5")
  return(enum_vals)
}

library(rhdf5)

tid <- H5Tenum_create()
H5Tenum_insert(tid, name = "TRUE", value = 1L)
H5Tenum_insert(tid, name = "FALSE", value = 0L)

test_that("enum details are extracted", {
  expect_identical(h5getEnumNames(tid), c("TRUE", "FALSE"))
  expect_identical(h5getEnumValues(tid), c(1L, 0L))
})

#' Determine whether a filter is available on this system
#' 
#' @param filter_id Integer representing the ID of the filter to be checked.
#' 
#' @export
H5Zfilter_avail <- function(filter_id) {
    filter_id <- as.integer(filter_id)
    res <- .Call("_H5Zfilter_avail", filter_id, PACKAGE = "rhdf5")
    return( res );
}

library(rhdf5)

test_that("Filters can be tested for", {
  ## deflate should always be available. ID = 1
  expect_true(H5Zfilter_avail(1))
  ## Arbitrary filter ID - hopefully doesn't exist
  expect_false(H5Zfilter_avail(999))
})

#' Saves a one or more objects to an HDF5 file.
#' 
#' Saves a number of R objects to an HDF5 file.
#' 
#' The objects will be saved to the HDF5 file. If the file does not exists it
#' will be created. The data can be read again by either [h5dump()]
#' or individually for each dataset by [h5read()].
#' 
#' @param \dots The objects to be saved.
#' @param file The filename (character) of the file in which the dataset will
#' be located. It is also possible to provide an object of
#' class [H5IdComponent-class] representing a H5 location identifier
#' (file or group). See [H5Fcreate()], [H5Fopen()],
#' [H5Gcreate()], [H5Gopen()] to create an object of this
#' kind.
#' @param name A character vector of names for the datasets. The length of the
#' name vector should match the number of objects.
#' @param createnewfile If `TRUE`, a new file will be created if necessary.
#' @param native An object of class \code{logical}. If TRUE, array-like objects
#' are treated as stored in HDF5 row-major rather than R column-major
#' orientation. Using \code{native = TRUE} increases HDF5 file portability
#' between programming languages. A file written with \code{native = TRUE}
#' should also be read with \code{native = TRUE}
#' @return Nothing returned.
#' @author Bernd Fischer
#' @seealso [h5ls()], [h5write()]
#' @examples
#' 
#' A = 1:7;  B = 1:18; D = seq(0,1,by=0.1)
#' h5save(A, B, D, file="ex_save.h5")
#' h5dump("ex_save.h5")
#' 
#' @name h5_save
#' @export h5save
h5save <- function(..., file, name = NULL, createnewfile=TRUE, native = FALSE) {
  N <- length(list(...))

  # get object names
  if (is.null(name)) {
    name <- as.character(substitute(list(...)))[-1L]
  }
  if (length(name) != N) {
    stop("length of 'name' argument  must fit the number of objects to save.")
  }

  loc = h5checktypeOrOpenLoc(file, createnewfile=createnewfile, native = native)

  for (i in seq_len(N)) {
    h5write(list(...)[[i]], file = loc$H5Identifier, name = name[i])
  }

  h5closeitLoc(loc)
  invisible(NULL)
}

#' Delete objects within a HDF5 file
#'
#' Deletes the specified group or dataset from within an HDF5 file.
#'
#' @param file The filename (character) of the file in which the object is
#' located.
#' @param name For `h5delete` the name of the object to be deleted. For
#' `h5deleteAttribute` the name of the object to which the attribute
#' belongs.
#' @author Mike Smith
#' @name h5_delete
#' @export h5delete
h5delete <- function(file, name) {
  loc <- h5checktypeOrOpenLoc(file, native = FALSE)
  on.exit(h5closeitLoc(loc))

  H5Ldelete(h5loc = loc$H5Identifier, name = name)
}

#' Delete attribute
#'
#' Deletes an attribute associated with a group or dataset within an HDF5 file.
#'
#' @param file The filename (character) of the file in which the object is
#' located.
#' @param name The name of the object to which the attribute belongs.
#' @param attribute Name of the attribute to be deleted.
#'
#' @author Mike Smith
#' @name h5_deleteAttribute
#' @export h5deleteAttribute
h5deleteAttribute <- function(file, name, attribute) {
  if (missing(name)) {
    stop(
      "Please provide the name of the object to which the attribute belongs ",
      "using the 'name' argument. You can use `h5ls()` to list the objects in ",
      "the file",
      call. = FALSE
    )
  }
  loc <- h5checktypeOrOpenLoc(file, native = FALSE)
  on.exit(h5closeitLoc(loc))

  res <- FALSE
  if (H5Lexists(loc$H5Identifier, name)) {
    oid <- H5Oopen(loc$H5Identifier, name = name)
    on.exit(H5Oclose(oid), add = TRUE)
    if (H5Aexists(h5obj = oid, name = attribute)) {
      res <- !(H5Adelete(h5obj = oid, name = attribute))
    } else {
      message("Attribute '", attribute, "' not found.")
    }
  } else {
    message(
      "Object '",
      name,
      "' not found in ",
      file,
      ".\n",
      "Use `h5ls()` to list the objects in the file."
    )
  }
  return(invisible(res))
}

#' Deprecated
#'
#' Deprecated in line with changes in the upstream HDF5 library.
#' It will be removed in the next version of rhdf5.
#'
#' @param ... ignored
#'
#' @returns NULL (invisibly)
#'
#' @export
H5Pget_version <- function(...) {
  # A quick check across Bioconductor suggests nobody was using this function
  .Deprecated(
    msg = paste0(
      "H5Pget_version() has been deprecated in line with changes in the upstream HDF5 library. ",
      "It will be removed in the next version of rhdf5."
    )
  )
  invisible(NULL)
}

.h5postProcessDataset <- function(obj, h5dataset) {
  ## warn about NA conversion for integers if 'rhdf5.NA-OK' is missing
  if (storage.mode(obj) == "integer" || is(obj, "integer64")) {
    if (anyNA(obj)) {
      if (!H5Aexists(h5obj = h5dataset, name = "rhdf5-NA.OK")) {
        if (storage.mode(obj) == "integer") {
          na_val <- "-2^31"
        } else if (is(obj, "integer64")) {
          na_val <- "-2^63"
        } else {
          ## we should never end up here
          na_val <- "DEFAULT"
        }
        message(
          "The value ",
          na_val,
          " was detected in the dataset.\n",
          "This has been converted to NA within R."
        )
      }
    }
  } else if (storage.mode(obj) == "character") {
    ## coerce the string "NA" to NA if required
    if (H5Aexists(h5dataset, name = "as.na")) {
      na_char_idx <- (obj == "NA")
      if (any(na_char_idx)) {
        obj[na_char_idx] <- NA_character_
      }
    }
    ## determine if this is ASCII or UTF-8 encoding
    h5type <- H5Dget_type(h5dataset)
    if (H5Tget_cset(h5type) == 1L) {
      Encoding(obj) <- "UTF-8"
    }
  }

  return(obj)
}

h5readDataset <- function(
  h5dataset,
  index = NULL,
  start = NULL,
  stride = NULL,
  block = NULL,
  count = NULL,
  compoundAsDataFrame = TRUE,
  drop = FALSE,
  ...
) {
  h5spaceFile <- H5Dget_space(h5dataset)
  on.exit(H5Sclose(h5spaceFile))
  h5spaceMem <- NULL
  if (!is.null(index)) {
    s <- H5Sget_simple_extent_dims(h5spaceFile)$size
    if (length(index) != length(s)) {
      stop(
        "length of index has to be equal to dimensional extension of HDF5 dataset."
      )
    }

    index_null <- vapply(index, is.null, logical(1))

    size <- .H5Sselect_dim(h5spaceFile, index)
    # size <- .H5Sselect_index( h5spaceFile, index, index_null)
    h5spaceMem <- H5Screate_simple(size, native = h5dataset@native)
    on.exit(H5Sclose(h5spaceMem), add = TRUE)
  } else {
    if (
      any(c(
        !is.null(start),
        !is.null(stride),
        !is.null(count),
        !is.null(block)
      ))
    ) {
      size <- 0
      try({
        size <- H5Sselect_hyperslab(
          h5spaceFile,
          start = start,
          stride = stride,
          count = count,
          block = block
        )
      })
      h5spaceMem <- H5Screate_simple(size, native = h5dataset@native)
      on.exit(H5Sclose(h5spaceMem), add = TRUE)
    }
  }
  obj <- NULL
  tryCatch(
    {
      obj <- H5Dread(
        h5dataset = h5dataset,
        h5spaceFile = h5spaceFile,
        h5spaceMem = h5spaceMem,
        compoundAsDataFrame = compoundAsDataFrame,
        drop = drop,
        ...
      )
    },
    error = function(e) {
      err <- h5checkFilters(h5dataset)
      ## if we fail here it doesn't make it to the usual H5Dclose call
      on.exit(H5Dclose(h5dataset))
      if (nzchar(err)) {
        stop(err, call. = FALSE)
      } else {
        stop(e)
      }
    }
  )

  ## Here we reorder data to match the order requested in index.
  ## The calls to H5Sselect_index will have returned data linearly
  ## from the file, not the potentially random order requested.
  if (!is.null(index)) {
    I <- list()
    for (i in seq_along(index)) {
      if (index_null[i]) {
        I[[i]] <- seq_len(s[i])
      } else {
        ## skip if the index was generated inside this function
        tmp <- unique(index[[i]])
        if (is.unsorted(tmp)) {
          tmp <- sort.int(tmp)
        }
        I[[i]] <- match(index[[i]], tmp)
      }
    }
    obj.dim <- lapply(dim(obj), FUN = seq_len)
    ## only need to compare the dimensions not set automatically
    if (!identical(I[!index_null], obj.dim[!index_null])) {
      obj <- do.call(`[`, c(list(obj), I, drop = FALSE))
    }
  }

  return(obj)
}

#' Reads and write object in HDF5 files
#'
#' Reads objects in HDF5 files. This function can be used to read
#' either full arrays/vectors or subarrays (hyperslabs) from an
#' existing dataset.
#'
#' Read an R object from an HDF5 file. If none of the arguments
#' `start`, `stride`, `block`, `count` are specified, the dataset has the same
#' dimension in the HDF5 file and in memory. If the dataset already exists in
#' the HDF5 file, one can read subarrays, so called hyperslabs from
#' the HDF5 file. The arguments `start`, `stride`, `block`, `count` define the
#' subset of the dataset in the HDF5 file that is to be read/written. See these
#' introductions to hyperslabs:
#' <https://support.hdfgroup.org/HDF5/Tutor/selectsimple.html>,
#' <https://support.hdfgroup.org/HDF5/Tutor/select.html> and
#' <http://ftp.hdfgroup.org/HDF5/Tutor/phypecont.html>. Please note that in
#' R the first dimension is the fastest changing dimension.
#'
#' When viewing the HDF5 datasets with any C-program (e.g. HDFView), the order
#' of dimensions is inverted. In the R interface counting starts with 1,
#' whereas in the C-programs (e.g. HDFView) counting starts with 0.
#'
#' Special cases.  There are a few instances where rhdf5 will make assumptions
#' about the dataset you are reading and treat it slightly differently.  1)
#' complex numbers.  If your datasets is a compound datatype, has only two
#' columns, and these are named 'r' and 'i' rhdf5 will assume the data is
#' intended to be complex numbers and will read this into R's complex type.  If
#' that is not the case, you will need to extract the two values separately
#' using the [Re()] and [Im()] accessors manually.
#'
#' @param file The file name (character) of the file in which the dataset is
#' be located. It is possible to provide an object of
#' class [H5IdComponent-class] representing a H5 location identifier
#' (file or group). See [H5Fcreate()], [H5Fopen()],
#' [H5Gcreate()], [H5Gopen()] to create an object of this
#' kind.
#' @param name The name of the dataset in the HDF5 file. The datasets present
#'   in \code{file} can be listed with the function \code{\link{h5ls}}.
#' @param index List of indices for subsetting. The length of the list has to
#' agree with the dimensional extension of the HDF5 array. Each list element is
#' an integer vector of indices. A list element equal to NULL chooses all
#' indices in this dimension. Counting is R-style 1-based.
#' @param start The start coordinate of a hyperslab (similar to subsetting in
#' R). Counting is R-style 1-based. This argument is ignored, if index is not
#' NULL.
#' @param stride The stride of the hypercube. Read the introduction
#' <http://ftp.hdfgroup.org/HDF5/Tutor/phypecont.html> before using this
#' argument. R behaves like Fortran in this example. This argument is ignored,
#' if index is not NULL.
#' @param block The block size of the hyperslab. Read the introduction
#' <http://ftp.hdfgroup.org/HDF5/Tutor/phypecont.html> before using this
#' argument. R behaves like Fortran in this example. This argument is ignored,
#' if index is not NULL.
#' @param count The number of blocks to be read. This argument is ignored,
#' if index is not NULL.
#' @param native An object of class `logical`. If TRUE, array-like objects
#' are treated as stored in HDF5 row-major rather than R column-major
#' orientation. Using `native = TRUE` increases HDF5 file portability
#' between programming languages. A file written with `native = TRUE`
#' should also be read with `native = TRUE`
#' @param compoundAsDataFrame If true, a compound datatype will be coerced to a
#' data.frame. This is not possible, if the dataset is multi-dimensional.
#' Otherwise the compound datatype will be returned as a list. Nested compound
#' data types will be returned as a nested list.
#' @param callGeneric If TRUE a generic function h5read.classname will be
#' called if it exists depending on the dataset's class attribute within the
#' HDF5 file. This function can be used to convert the standard output of
#' h5read depending on the class attribute. Note that h5read is not a S3
#' generic function. Dispatching is done based on the HDF5 attribute after the
#' standard h5read function.
#' @param read.attributes (logical) If `TRUE`, the HDF5 attributes are read and
#' attached to the respective R object.
#' @param drop (logical) If TRUE, the HDF5 object is read as a vector with `NULL`
#' dim attributes.
#' @param s3 Logical value indicating whether the file argument should be
#' treated as a URL to an Amazon S3 bucket, rather than a local file path.
#' @param s3credentials A list of length three, providing the credentials for
#' accessing files in a private Amazon S3 bucket.
#' @param \dots Further arguments passed to [H5Dread()].
#'
#' @returns `h5read` returns an array with the data read.
#'
#' @author Bernd Fischer, Mike Smith
#' @seealso [h5ls()]
#' @examples
#'
#' h5File <- tempfile(pattern = "ex_hdf5file.h5")
#' h5createFile(h5File)
#'
#' # write a matrix
#' B <- array(seq(0.1, 2.0, by = 0.1), dim = c(5, 2, 2))
#' h5write(B, h5File, "B")
#'
#' # read a matrix
#' E <- h5read(h5File, "B")
#'
#' # write and read submatrix
#' h5createDataset(h5File, "S", c(5, 8), storage.mode = "integer", chunk = c(5, 1), level = 7)
#' h5write(matrix(1:5, nr = 5, nc = 1), file = h5File, name = "S", index = list(NULL, 1))
#' h5read(h5File, "S")
#' h5read(h5File, "S", index = list(NULL, 2:3))
#'
#' # Read a subset of an hdf5 file in a public S3 bucket
#' \donttest{
#' h5read("https://rhdf5-public.s3.eu-central-1.amazonaws.com/rhdf5ex_t_float_3d.h5",
#'   s3 = TRUE, name = "a1", index = list(NULL, 3, NULL)
#' )
#' }
#'
#' @name h5_read
#' @export h5read
h5read <- function(
  file,
  name,
  index = NULL,
  start = NULL,
  stride = NULL,
  block = NULL,
  count = NULL,
  compoundAsDataFrame = TRUE,
  callGeneric = TRUE,
  read.attributes = FALSE,
  drop = FALSE,
  ...,
  native = FALSE,
  s3 = FALSE,
  s3credentials = NULL
) {
  if (missing(name)) {
    stop(
      "Please provide the name of the object to read using the 'name' argument. ",
      "You can use `h5ls()` to list the objects in the file.",
      call. = FALSE
    )
  }

  if (isTRUE(s3)) {
    fapl <- H5Pcreate("H5P_FILE_ACCESS")
    on.exit(H5Pclose(fapl))
    H5Pset_fapl_ros3(fapl, s3credentials)
    loc <- h5checktypeOrOpenLocS3(
      file,
      readonly = TRUE,
      fapl = fapl,
      native = native
    )
  } else {
    loc <- h5checktypeOrOpenLoc(
      file,
      readonly = TRUE,
      fapl = NULL,
      native = native
    )
  }
  on.exit(h5closeitLoc(loc), add = TRUE)

  if (!H5Lexists(loc$H5Identifier, name)) {
    stop(
      "Object '",
      name,
      "' does not exist in this HDF5 file.\n",
      "Use `h5ls()` to list the objects in the file."
    )
  }

  oid <- H5Oopen(loc$H5Identifier, name)
  on.exit(H5Oclose(oid), add = TRUE)
  type <- H5Iget_type(oid)
  num_attrs <- H5Oget_num_attrs(oid)
  if (is.na(num_attrs)) {
    num_attrs <- 0
  }
  if (type == "H5I_GROUP") {
    gid <- H5Gopen(loc$H5Identifier, name)
    obj <- if (.isAnndataNullable(gid)) {
      .h5readNullable(gid)
    } else {
      h5dump(
        gid,
        start = start,
        stride = stride,
        block = block,
        count = count,
        compoundAsDataFrame = compoundAsDataFrame,
        callGeneric = callGeneric,
        ...
      )
    }
    H5Gclose(gid)
  } else if (type == "H5I_DATASET") {
    h5dataset <- H5Dopen(loc$H5Identifier, name)
    on.exit(H5Dclose(h5dataset), add = TRUE)
    for (i in seq_along(index)) {
      if (is.name(index[[i]]) || is.call(index[[i]])) {
        index[[i]] <- eval(index[[i]])
      }
    }
    obj <- h5readDataset(
      h5dataset,
      index = index,
      start = start,
      stride = stride,
      block = block,
      count = count,
      compoundAsDataFrame = compoundAsDataFrame,
      drop = drop,
      ...
    )
    obj <- .h5postProcessDataset(obj = obj, h5dataset = h5dataset)
    cl <- attr(obj, "class")
    if (!is.null(cl) && callGeneric) {
      if (exists(paste("h5read", cl, sep = "."), mode = "function")) {
        obj <- do.call(paste("h5read", cl, sep = "."), args = list(obj = obj))
      }
    }
  } else {
    message("Reading of object type not supported.")
    obj <- NULL
  } ## GROUP
  if (read.attributes && num_attrs > 0 && !is.null(obj)) {
    for (i in seq_len(num_attrs)) {
      A <- H5Aopen_by_idx(loc$H5Identifier, n = i - 1, objname = name)
      attrname <- H5Aget_name(A)
      if (attrname != "dim") {
        attr(obj, attrname) <- H5Aread(A, ...)
      }
      ## Don't put this in on.exit()
      ## A is overwritten in the loop and we lose track of it
      H5Aclose(A)
    }
  }

  obj
}

.isAnndataNullable <- function(gid) {
  ## test attribute existence
  if (!H5Aexists(gid, "encoding-type") || !H5Aexists(gid, "encoding-version")) {
    return(FALSE)
  }

  ## TODO: test attribute values

  ## test datasets exist
  group_data <- h5ls(gid, recursive = FALSE)
  if (!all(c("values", "mask") %in% group_data$name)) {
    return(FALSE)
  }

  return(TRUE)
}

## expects to be called inside h5read
.h5readNullable <- function(gid) {
  ## the way H5Dread treats ENUM is weird and inconsistent with H5Aread
  ## we do some casting as.logical here, but it'd be better elsewhere
  values <- h5read(gid, "values")
  mask <- h5read(gid, "mask")
  values[which(as.logical(mask))] <- NA

  aid <- H5Aopen(gid, name = "encoding-type")
  on.exit(H5Aclose(aid))
  enc_type <- H5Aread(aid)

  if (enc_type == "nullable-boolean") {
    values <- as.logical(values)
  }

  return(values)
}

## These tests are intended to check if we write something to HDF5 and then
## read back into R, we get the same thing.
## Current caveat is that we typically return an array even when there is only
## one dimension.

library(rhdf5)

h5file <- withr::local_tempfile(pattern = "h5_roundtrip_", fileext = ".h5")

test_that("data.frame columns survive a round trip", {
  set.seed(1234)

  test_frame <- data.frame(
    integer = as.integer(1:10),
    ## random words of length 5-20
    words = vapply(
      1:10,
      FUN = function(x) {
        paste(
          sample(c(letters, LETTERS), size = sample(5:20, 1), replace = TRUE),
          collapse = ""
        )
      },
      character(1)
    ),
    stringsAsFactors = FALSE
  )
  test_frame_single <- test_frame["integer"]

  expect_silent(h5write(obj = test_frame, file = h5file, name = "data_frame"))
  expect_silent(h5write(
    obj = test_frame_single,
    file = h5file,
    name = "data_frame2"
  ))

  expect_silent(back_frame <- h5read(file = h5file, name = "data_frame"))
  expect_silent(back_frame2 <- h5read(file = h5file, name = "data_frame2"))
  expect_equivalent(back_frame$integer, test_frame$integer)
  expect_equivalent(back_frame$words, test_frame$words)
})

test_that("character vectors survive a round trip", {
  words <- vapply(
    1:10,
    FUN = function(x) {
      paste(
        sample(c(letters, LETTERS), size = sample(5:20, 1), replace = TRUE),
        collapse = ""
      )
    },
    character(1)
  )

  expect_silent(h5write(obj = words, file = h5file, name = "char"))

  expect_silent(back_words <- h5read(file = h5file, name = "char"))
  expect_equivalent(words, back_words)
})

test_that("UTF-8 strings are preserved", {
  input <- "α ≤ 0.1"
  expect_silent(h5write(obj = input, file = h5file, name = "utf8"))
  expect_silent(output <- h5read(file = h5file, name = "utf8"))
  expect_equivalent(input, output)
  expect_identical(Encoding(output), "UTF-8")
})

test_that("Complex numbers are writen to a compound datatype", {
  h5file <- withr::local_tempfile(pattern = "h5_roundtrip_", fileext = ".h5")

  mat <- matrix(
    complex(length.out = 30, real = 1:30, imaginary = 30:1),
    ncol = 10
  )
  expect_silent(h5write(obj = mat, file = h5file, name = "complex"))

  expect_silent(res <- h5read(file = h5file, name = "complex"))
  expect_is(res, "matrix")
  expect_type(res, "complex")
  expect_identical(res, mat)
  expect_identical(
    h5read(file = h5file, name = "complex", native = TRUE),
    t(mat)
  )
})

H5PLprepend <- function(path) {
  res <- .Call("_H5PLprepend", path, PACKAGE = "rhdf5")
  invisible(res)
}


H5PLsize <- function() {
  size <- .Call("_H5PLsize", PACKAGE = "rhdf5")
  return(size)
}

H5PLget <- function(index) {
  path <- .Call("_H5PLget", as.integer(index - 1), PACKAGE = "rhdf5")
  return(path)
}

h5getPluginPaths <- function() {
  n_paths <- H5PLsize()
  paths <- vapply(seq_len(n_paths), FUN = H5PLget, FUN.VALUE = character(1))
  return(paths)
}

h5writeDatasetHelper <- function(
  obj,
  h5dataset,
  index = NULL,
  start = NULL,
  stride = NULL,
  block = NULL,
  count = NULL
) {
  try({
    h5spaceFile <- H5Dget_space(h5dataset)
    on.exit(H5Sclose(h5spaceFile))
  })

  if (!is.null(index)) {
    s <- H5Sget_simple_extent_dims(h5spaceFile)$size
    if (length(index) != length(s)) {
      stop(
        "length of index has to be equal to dimensional extension of HDF5 dataset."
      )
    }
    for (i in seq_along(index)) {
      if (is.null(index[[i]])) {
        index[[i]] <- seq_len(s[i])
      } else if (is.call(index[[i]])) {
        index[[i]] <- eval(index[[i]])
      }
    }
    try({
      H5Sselect_index(h5spaceFile, index)
    })
    if (length(index) > 1) {
      ## indexing an array
      d <- lengths(index)
      d[d == 0] <- dim(obj)[d == 0]
      dim(obj) <- d
    }
    I <- list()
    for (i in seq_along(index)) {
      m <- match(index[[i]], unique(sort(index[[i]])))
      I[[i]] <- order(m)
      I[[i]] <- I[[i]][!duplicated(m[I[[i]]], fromLast = TRUE)]
    }
    obj <- do.call(`[`, c(list(obj), I))
  } else {
    if (
      any(c(
        !is.null(start),
        !is.null(stride),
        !is.null(block),
        !is.null(count)
      ))
    ) {
      if (is.null(block) && is.null(count)) {
        if (is.null(dim(obj))) {
          block <- 1
          count <- 1
        } else {
          block <- rep(1, length(dim(obj)))
          count <- dim(obj)
        }
      }
      try({
        H5Sselect_hyperslab(
          h5spaceFile,
          start = start,
          stride = stride,
          count = count,
          block = block
        )
      })
    }
  }
  DimMem <- dim(obj)
  if (is.null(DimMem)) {
    DimMem <- length(obj)
  }
  try({
    h5spaceMem <- H5Screate_simple(DimMem)
    on.exit(H5Sclose(h5spaceMem), add = TRUE, after = FALSE)
  })
  try({
    H5Dwrite(
      h5dataset,
      obj,
      h5spaceMem = h5spaceMem,
      h5spaceFile = h5spaceFile
    )
  })

  invisible(NULL)
}

#' Write object to an HDF5 file.
#'
#' Writes an R object to an HDF5 file. This function can be used to write either
#' full arrays/vectors or subarrays (hyperslabs) within an existing dataset.
#'
#' Writes an R object to an HDF5 file. If none of the arguments `start`,
#' `stride`, `block`, `count` is specified, the dataset has the same dimension
#' in the HDF5 file and in memory. If the dataset already exists in the HDF5
#' file, one can write subarrays, (so called hyperslabs) to the HDF5 file. The
#' arguments `start`, `stride`, `block`, `count` define the subset of the
#' dataset in the HDF5 file that is to be written to. See these introductions to
#' hyperslabs: <https://support.hdfgroup.org/HDF5/Tutor/selectsimple.html>,
#' <https://support.hdfgroup.org/HDF5/Tutor/select.html> and
#' <http://ftp.hdfgroup.org/HDF5/Tutor/phypecont.html>. Please note that in
#' R the first dimension is the fastest changing dimension.
#'
#' When viewing the HDF5 datasets with any C-program (e.g. HDFView), the order
#' of dimensions is inverted. In the R interface counting starts with 1, whereas
#' in the C-programs (e.g. HDFView) counting starts with 0.
#'
#' If code `obj` is of type 'complex' then it will be written as a compound
#' datatype to the HDF5, with cols named 'r' and 'i' for the real and
#' imaginary parts respectively.
#'
#' @param obj The R object to be written.
#' @param file The filename (character) of the file in which the dataset will be
#'   located. For advanced programmers it is possible to provide an object of
#'   class [H5IdComponent-class] representing a H5 location identifier (file or
#'   group). See [H5Fcreate()], [H5Fopen()],
#'   [H5Gcreate()], [H5Gopen()] to create an object of this
#'   kind.
#' @param h5loc An object of class [H5IdComponent-class] representing a H5
#'   location identifier (file or group). See [H5Fcreate()],
#'   [H5Fopen()], [H5Gcreate()], [H5Gopen()] to
#'   create an object of this kind.
#' @param name The name of the dataset in the HDF5 file.
#' @param index List of indices for subsetting. The length of the list has to
#'   agree with the dimensional extension of the HDF5 array. Each list col
#'   is an integer vector of indices. A list col equal to `NULL` chooses all
#'   indices in this dimension. Counting is R-style 1-based.
#' @param start The start coordinate of a hyperslab (similar to subsetting in
#'   R). Counting is R-style 1-based. This argument is ignored, if index is not
#'   NULL.
#' @param stride The stride of the hypercube. Read the introduction
#'   <http://ftp.hdfgroup.org/HDF5/Tutor/phypecont.html> before using this
#'   argument. R behaves like Fortran in this example. This argument is ignored,
#'   if index is not NULL.
#' @param block The block size of the hyperslab. Read the introduction
#'   <http://ftp.hdfgroup.org/HDF5/Tutor/phypecont.html> before using this
#'   argument. R behaves like Fortran in this example. This argument is ignored,
#'   if index is not NULL.
#' @param count The number of blocks to be written. This argument is ignored, if
#'   index is not NULL.
#' @param chunk Specifies the number of items to be include in an HDF5 chunk. If
#'   left unspecified the defaults is the smaller of: the total number of
#'   cols or the number of cols that fit within 4GB of memory. If
#'   `DataFrameAsCompound=FALSE` each row of the `data.frame` can be consider an
#'   "col".
#' @param level The compression level. An integer value between 0 (no
#'   compression) and 9 (highest and slowest compression). Only used, if the
#'   dataset does not yet exist. See [h5createDataset()] to create an dataset.
#' @param native An object of class `logical`. If TRUE, array-like objects
#'   are treated as stored in HDF5 row-major rather than R column-major
#'   orientation. Using `native = TRUE` increases HDF5 file portability
#'   between programming languages. A file written with `native = TRUE`
#'   should also be read with `native = TRUE`
#' @param DataFrameAsCompound If true, a `data.frame` will be saved as a
#'   compound data type. Otherwise it is saved like a list. The advantage of
#'   saving a data.frame as a compound data type is that it can be read as a
#'   table from python or with a struct-type from C. The disadvantage is that
#'   the data has to be rearranged on disk and thus can slow down I/O. If fast
#'   reading is required, `DataFrameAsCompound=FALSE` is recommended.
#' @param size The length of the fixed-width string data type, when `obj` is a
#'   character vector. If `NULL`, this is set to the length of the largest
#'   string.
#' @param variableLengthString Whether character vectors should be written as
#'   variable-length strings into the attributes. If `TRUE`, `size` is ignored.
#' @param encoding The encoding of the string data type.  Valid options are
#'   "ASCII" or "UTF-8".
#' @param createnewfile If `TRUE`, a new file will be created if necessary.
#' @param write.attributes (logical) If TRUE, all R-attributes attached to the
#'   object `obj` are written to the HDF5 file.
#' @param \dots Further arguments passed to [H5Dwrite()].
#'
#' @returns `h5write` returns 0 if successful.
#'
#' @author Bernd Fischer, Mike Smith
#'
#' @seealso [h5ls()], [h5createFile()],
#'   [h5createDataset()], [rhdf5]
#' @references <https://portal.hdfgroup.org/display/HDF5>
#' @keywords programming interface IO file
#' @examples
#'
#' h5File <- tempfile(fileext = ".h5")
#' h5createFile(h5File)
#'
#' # write a matrix
#' B <- array(seq(0.1, 2.0, by = 0.1), dim = c(5, 2, 2))
#' attr(B, "scale") <- "liter"
#' h5write(B, h5File, "B")
#'
#' # write a submatrix
#' h5createDataset(h5File, "S", c(5, 8), storage.mode = "integer", chunk = c(5, 1), level = 7)
#' h5write(matrix(1:5, nr = 5, nc = 1), file = h5File, name = "S", index = list(NULL, 1))
#'
#' @name h5_write
#' @export h5write
h5write <- function(obj, file, name, ...) {
  res <- UseMethod("h5write")
  invisible(res)
}

#' @rdname h5_write
#' @export
h5write.default <- function(
  obj,
  file,
  name,
  createnewfile = TRUE,
  write.attributes = FALSE,
  ...,
  native = FALSE
) {
  loc <- h5checktypeOrOpenLoc(
    file,
    createnewfile = createnewfile,
    native = native
  )
  on.exit(h5closeitLoc(loc))

  res <- h5writeDataset(obj, loc$H5Identifier, name, ...)
  if (write.attributes) {
    oid <- H5Oopen(loc$H5Identifier, name)
    type <- H5Iget_type(oid)
    H5Oclose(oid)

    if (type == "H5I_GROUP") {
      h5obj <- H5Gopen(loc$H5Identifier, name)
      on.exit(H5Gclose(h5obj), add = TRUE)
    } else {
      if (type != "H5I_DATASET") {
        stop("Cannot open object of this type")
      }
      h5obj <- H5Dopen(loc$H5Identifier, name)
      on.exit(H5Dclose(h5obj), add = TRUE)
    }
    Attr <- attributes(obj)
    for (i in seq_along(Attr)) {
      h5writeAttribute(Attr[[i]], h5obj, name = names(Attr)[i])
    }
  }
  invisible(res)
}

#' @rdname h5_write
#' @export
h5writeDataset <- function(obj, h5loc, name, ...) {
  h5checktype(h5loc, "loc")
  res <- UseMethod("h5writeDataset")
  invisible(res)
}

#' @rdname h5_write
#' @export
h5writeDataset.data.frame <- function(
  obj,
  h5loc,
  name,
  level = 6,
  chunk,
  DataFrameAsCompound = TRUE,
  ...
) {
  chkDots(...)
  if (DataFrameAsCompound) {
    if (H5Lexists(h5loc, name)) {
      stop(
        "Cannot write data.frame. Object already exists. Subsetting for compound datatype not supported."
      )
    }
    if (!is.null(level)) {
      level <- as.integer(level)
      if (missing(chunk)) {
        chunk <- nrow(obj)
      }
    }
    did <- .Call(
      "_h5createDataFrame",
      obj,
      h5loc@ID,
      name,
      level,
      as.integer(chunk),
      PACKAGE = "rhdf5"
    )
    .Call("_h5writeDataFrame", obj, did, PACKAGE = "rhdf5")
    .Call("_H5Dclose", did, PACKAGE = "rhdf5")
    res <- 0
  } else {
    a <- attr(obj, "names")
    if (is.null(a)) {
      attr(obj, "names") <- sprintf("col%d", seq_len(ncol(obj)))
    } else {
      if (anyDuplicated(a) > 0) {
        a[duplicated(a)] <- sprintf("col%d", seq_len(ncol(obj)))[duplicated(a)]
        attr(obj, "names") <- a
      }
    }
    ## we can't write out factors, so convert any to character
    factor_col <- vapply(obj, is.factor, logical(1))
    if (any(factor_col)) {
      obj[factor_col] <- lapply(
        obj[, factor_col, drop = FALSE],
        FUN = as.character
      )
    }

    res <- h5writeDataset.list(
      obj = obj,
      h5loc = h5loc,
      name = name,
      level = level
    )
  }
  invisible(res)
}

#' @export
h5writeDataset.list <- function(obj, h5loc, name, level = 6, ...) {
  chkDots(...)
  exists <- try({
    H5Lexists(h5loc, name)
  })
  if (exists) {
    message(
      "Existing object within HDF5 file cannot be overwritten with a list object. First delete the group or dataset from the HDF5 file."
    )
  } else {
    N <- names(obj)
    newnames <- is.null(N) || !all(nzchar(N)) || length(N) != length(obj)
    if (newnames) {
      N <- sprintf("ELT%d", seq_along(obj))
    }
    h5createGroup(h5loc, name)
    gid <- H5Gopen(h5loc, name)
    for (i in seq_along(obj)) {
      h5write(obj[[i]], gid, N[i])
    }
    H5Gclose(gid)
  }
}

#' @export
h5writeDataset.matrix <- function(...) {
  h5writeDataset.array(...)
}
#' @export
h5writeDataset.integer <- function(...) {
  h5writeDataset.array(...)
}
#' @export
h5writeDataset.double <- function(...) {
  h5writeDataset.array(...)
}
#' @export
h5writeDataset.logical <- function(...) {
  h5writeDataset.array(...)
}
#' @export
h5writeDataset.character <- function(...) {
  h5writeDataset.array(...)
}
#' @export
h5writeDataset.raw <- function(...) {
  h5writeDataset.array(...)
}
#' @export
h5writeDataset.complex <- function(...) {
  h5writeDataset.array(...)
}

#' @rdname h5_write
#' @export
h5writeDataset.array <- function(
  obj,
  h5loc,
  name,
  index = NULL,
  start = NULL,
  stride = NULL,
  block = NULL,
  count = NULL,
  size = NULL,
  variableLengthString = FALSE,
  encoding = NULL,
  level = 6,
  ...
) {
  chkDots(...)
  exists <- try({
    H5Lexists(h5loc, name)
  })
  if (!exists) {
    if (storage.mode(obj) == "character") {
      if (!variableLengthString && is.null(size)) {
        if (length(obj) > 0) {
          size <- max(nchar(obj, type = "bytes"), na.rm = TRUE)
          ## if any NA, the minimum string length is 2
          if (anyNA(obj) && size < 2) {
            size <- 2
          }
          ## empty string gives size 0, and errors
          if (size == 0) {
            size <- 1
          }
        } else {
          size <- 1
        }
      }
      if (is.null(encoding)) {
        encoding <- if (any(Encoding(obj) == "UTF-8")) "UTF-8" else "ASCII"
      }
    }
    if (is.null(dim(obj))) {
      dim <- length(obj)
    } else {
      dim <- dim(obj)
      if (h5loc@native) dim <- rev(dim)
    }
    h5createDataset(
      h5loc,
      name,
      dim,
      storage.mode = storage.mode(obj),
      size = size,
      encoding = match.arg(encoding, choices = c("ASCII", "UTF-8", "UTF8")),
      chunk = dim,
      level = level
    )
  }
  h5dataset <- H5Dopen(h5loc, name)
  on.exit(H5Dclose(h5dataset))
  h5writeDatasetHelper(
    obj = obj,
    h5dataset = h5dataset,
    index = index,
    start = start,
    stride = stride,
    block = block,
    count = count
  )
  h5writeAttribute(1L, h5dataset, name = "rhdf5-NA.OK")

  if (storage.mode(obj) == "character" && anyNA(obj)) {
    h5writeAttribute(1L, h5dataset, name = "as.na")
    if (any(obj == "NA", na.rm = TRUE)) {
      warning(
        "Both NA_character_ and the string 'NA' detected.\n",
        "These will all be coerced to NA_character_ when read using h5read()"
      )
    }
  }

  invisible(NULL)
}

#' Read all attributes from a given location in an HDF5 file
#'
#' @param file Character vector of length 1, giving the path to the HDF5
#' @param name Path within the HDF5 file to the object whose attributes should
#'   be read. The datasets present in `file` can be listed with the
#'   function [h5ls()].
#' @param native An object of class `logical`. If TRUE, array-like objects
#'   are treated as stored in HDF5 row-major rather than R column-major
#'   orientation.
#' @param \dots Further arguments passed to [H5Aread()].
#'
#' @returns A named list of the same length as the number of attributes attached
#'   to the specific object.  The names of the list entries correspond to the
#'   attribute names.  If no attributes are found an empty list is returned.
#'
#' @name h5_readAttributes
#' @export
h5readAttributes <- function(file, name, native = FALSE, ...) {
  if (missing(name)) {
    stop(
      "Please provide the name of the object to which the attribute belongs ",
      "using the 'name' argument. You can use `h5ls()` to list the objects in ",
      "the file",
      call. = FALSE
    )
  }
  loc <- h5checktypeOrOpenLoc(file, readonly = TRUE, native = native)
  on.exit(h5closeitLoc(loc))
  if (!H5Lexists(loc$H5Identifier, name)) {
    stop(
      "Object ",
      name,
      " does not exist in this HDF5 file.\n",
      "Use `h5ls()` to list the objects in the file."
    )
  }
  oid <- H5Oopen(loc$H5Identifier, name)
  on.exit(H5Oclose(oid), add = TRUE)
  num_attrs <- H5Oget_num_attrs(oid)
  if (is.na(num_attrs)) {
    num_attrs <- 0
  }
  res <- list()
  if (num_attrs > 0) {
    for (i in seq_len(num_attrs)) {
      A <- H5Aopen_by_idx(loc$H5Identifier, n = i - 1, objname = name)
      attrname <- H5Aget_name(A)
      res[[attrname]] <- H5Aread(A, ...)
      tid <- H5Aget_type(A)
      ## if we have an enum type where the levels are only TRUE,FALSE,NA
      ## convert the result to an R logical.  This is consistent with h5py
      if (H5Tget_class(tid) == "H5T_ENUM") {
        enumNames <- h5getEnumNames(tid)
        if (all(enumNames %in% c("TRUE", "FALSE", "NA"))) {
          res[[attrname]] <- as.logical(res[[attrname]])
        }
      }
      H5Aclose(A)
    }
  }
  res
}

#' An S4 class representing an H5 object
#'
#' A class representing a HDF5 identifier handle. HDF5 identifiers represent
#' open files, groups, datasets, dataspaces, attributes, and datatypes.
#'
#' @slot ID `integer` of length 1. Contains the handle of C-type `hid_t`.
#' @slot native An object of class \code{logical}. If TRUE, array-like objects
#'   are treated as stored in HDF5 row-major rather than R column-major
#'   orientation. Using \code{native = TRUE} increases HDF5 file portability
#'   between programming languages. A file written with \code{native = TRUE}
#'   should also be read with \code{native = TRUE}
#'   
#' @param object Object of class `H5IdComponent`
setClass("H5IdComponent",
         slots = c(ID = "character", 
                   native = "logical")
)


#' An S4 class representing H5 references.
#'
#' A class representing one or more HDF5 references.
#'
#' The length of the `val` slot is dependent on both the number and type of
#' references stored in the object. `H5R_OBJECT` references are stored in 8
#' bytes, while `H5R_DATASET_REGION` references require 12 bytes.  The length
#' of `val` will then be a multiple of 8 or 12 respectively.  This also means 
#' that references of different types cannot be combined in a single object.
#'
#' @slot val `raw` vector containing the byte-level representation of each
#'   reference.
#' @slot type `integer` of length 1, which maps to either `H5R_OBJECT` or
#'   `H5R_DATASET_REGION`.
#'
#' @param object Object of class `H5Ref`
setClass("H5Ref",
         slots = c(val = "raw",
                   type = "integer")
)

#' Find the number of attributes associated with an HDF5 object
#'
#' @details These functions are not part of the standard HDF5 C API.
#'
#' @param h5obj An object of class [H5IdComponent-class] representing a H5 object identifier (file, group, or dataset).
#' @param h5loc An object of class [H5IdComponent-class] representing a H5 location identifier (file or group).
#' @param name The name of the object to be checked.
#'
#' @returns Returns a vector of length 1 containing the number of attributes
#' the specified object has.
#'
#' @name H5Oget_num_attrs
NULL

#' @rdname H5Oget_num_attrs
#' @export
H5Oget_num_attrs <- function(h5obj) {
  h5checktype(h5obj, "object")
  n <- .Call("_H5Oget_num_attrs", h5obj@ID, PACKAGE = "rhdf5")
  n
}

#' @rdname H5Oget_num_attrs
#' @export
H5Oget_num_attrs_by_name <- function(h5loc, name) {
  h5checktype(h5loc, "loc")
  if (length(name) != 1 || !is.character(name)) {
    stop("'name' must be a character string of length 1")
  }
  h5obj <- H5Oopen(h5loc, name)
  n <- .Call("_H5Oget_num_attrs", h5obj@ID, PACKAGE = "rhdf5")
  H5Oclose(h5obj)
  n
}

h5loadData <- function(h5loc, L, all=FALSE, ..., native) {

    h5checktype(h5loc,"loc")
    if (length(L) > 0) {
        for (i in seq_len(length(L))) {
            if (is.data.frame(L[[i]])) {
                if (L[[i]]$ltype %in% h5constants[["H5L_TYPE"]][c("H5L_TYPE_HARD","H5L_TYPE_EXTERNAL")]) {
                    if (L[[i]]$otype == h5constants[["H5I_TYPE"]]["H5I_DATASET"]) {
                        L[i] = list(h5read(
                            h5loc, L[[i]]$name, ..., native = native
                        ))
                    } else {
                        L[i] = h5lsConvertToDataframe(
                            L[i], all=all, native=native
                        )
                    }
                } else {
                    L[i] = h5lsConvertToDataframe(L[i], all=all, native=native)
                }
            } else {
                group = H5Gopen(h5loc, names(L)[i])
                L[i] = list(
                    h5loadData(group, L[[i]], all=all, ..., native = native)
                )
                H5Gclose(group)
            }
        }
    }
    L
}

#' Dump the content of an HDF5 file.
#' 
#' @param file The filename (character) of the file in which the dataset will
#' be located. You can also provide an object of class [H5IdComponent-class] 
#' representing a H5 location identifier (file or group). See [H5Fcreate()], 
#' [H5Fopen()], [H5Gcreate()], [H5Gopen()] to create an object of this kind.
#' @param recursive If `TRUE`, the content of the whole group hierarchy is
#' listed. If `FALSE`, Only the content of the main group is shown. If a positive
#' integer is provided this indicates the maximum level of the hierarchy that
#' is shown.
#' @param all If `TRUE`, a longer list of information on each entry is provided.
#' @param index_type See `h5const("H5_INDEX")` for possible arguments.
#' @param order See `h5const("H5_ITER")` for possible arguments.
#' @param load If `TRUE` the datasets are read in, not only the header
#' information. Note, that this can cause memory problems for very large files.
#' In this case choose `load=FALSE` and load the datasets successively.
#' @param s3 Logical value indicating whether the file argument should be
#' treated as a URL to an Amazon S3 bucket, rather than a local file path.
#' @param s3credentials A list of length three, providing the credentials for
#' accessing files in a private Amazon S3 bucket.
#' @param native An object of class `logical`. If TRUE, array-like objects
#' are treated as stored in HDF5 row-major rather than R column-major
#' orientation. Using `native = TRUE` increases HDF5 file portability
#' between programming languages. A file written with `native = TRUE`
#' should also be read with `native = TRUE`
#' @param \dots Arguments passed to [h5read()]
#' 
#' @return Returns a hierarchical list structure representing the HDF5
#' group hierarchy. It either returns the datasets within the list structure
#' (`load=TRUE`) or it returns a `data.frame` for each dataset with the
#' dataset header information (`load=FALSE`).
#' 
#' @author Bernd Fischer, Mike L. Smith
#' @seealso [h5ls()]

#' @keywords programming interface IO file
#' @examples
#' 
#' h5createFile("ex_ls_dump.h5")
#' 
#' # create groups
#' h5createGroup("ex_ls_dump.h5","foo")
#' h5createGroup("ex_ls_dump.h5","foo/foobaa")
#' 
#' # write a matrix
#' B = array(seq(0.1,2.0,by=0.1),dim=c(5,2,2))
#' attr(B, "scale") <- "liter"
#' h5write(B, "ex_ls_dump.h5","foo/B")
#' 
#' # list content of hdf5 file
#' h5dump("ex_ls_dump.h5")
#' 
#' # list content of an hdf5 file in a public S3 bucket
#' \donttest{
#' h5dump(file = "https://rhdf5-public.s3.eu-central-1.amazonaws.com/h5ex_t_array.h5", s3 = TRUE)
#' }
#' 
#' @name h5_dump
#' @export
h5dump <- function( file, recursive = TRUE, load=TRUE, all=FALSE, 
                    index_type = h5default("H5_INDEX"), order = h5default("H5_ITER"), 
                    s3 = FALSE, s3credentials = NULL, ..., native=FALSE) {

    if(isTRUE(s3)) {
        fapl <- H5Pcreate("H5P_FILE_ACCESS")
        on.exit(H5Pclose(fapl))
        H5Pset_fapl_ros3(fapl, s3credentials)
        loc <- h5checktypeOrOpenLocS3(file, readonly = TRUE, fapl = fapl, native = native)
    } else {
        loc <- h5checktypeOrOpenLoc(file, readonly = TRUE, fapl = NULL, native = native)
    }
    on.exit(h5closeitLoc(loc), add = TRUE)
    
    index_type <- h5checkConstants( "H5_INDEX", index_type )
    order <- h5checkConstants( "H5_ITER", order )
    if (is.logical(recursive)) {
        if (recursive) {
            depth = -1L
        } else {
            depth = 1L
        }
    } else if (is.numeric(recursive) | is.integer(recursive) ) {
        depth = as.integer(recursive)
        if( length(recursive) > 1 ) {
            warning("'recursive' must be of length 1.  Only using first value.")
        } else if (recursive == 0) {
            stop("value 0 for 'recursive' is undefined, either a positive number specify the depth to descend or negative for maximum recursion")
        }
    } else {
        stop("'recursive' must be an integer of length 1 or a logical")
    }
    L <- .Call("_h5dump", loc$H5Identifier@ID, depth, index_type, order, PACKAGE='rhdf5')
    if (load) {
        L <- h5loadData( loc$H5Identifier, L, all=all, ..., native=native)
    } else {
        L <- h5lsConvertToDataframe(L, all=all, native=native)
    }
    
    L
}

## only run this test if the S3 VFD is configured in Rhdf5lib
## Code here looks for the public config header generated when Rhdf5lib was built
## The functions throw an error if that is not the case and break these tests
run_test <- FALSE
HDF5_conf_file <- system.file("include/H5pubconf.h", package = "Rhdf5lib")
if (file.exists(HDF5_conf_file)) {
  run_test <- any(grepl(
    x = readLines(HDF5_conf_file),
    "H5_HAVE_ROS3_VFD[[:blank:]]+1"
  ))
}
skip_if_not(run_test, "S3 VFD not configured in Rhdf5lib")

public_S3_url <- "https://rhdf5-public.s3.eu-central-1.amazonaws.com/h5ex_t_array.h5"

test_that("h5ls() works for files in public S3 buckets", {
  skip_on_ci()
  skip_on_bioc()
  skip_if_offline("rhdf5-public.s3.eu-central-1.amazonaws.com")

  expect_silent(h5ls_out <- h5ls(public_S3_url, s3 = TRUE))
  expect_is(h5ls_out, "data.frame")
  expect_true("DS1" %in% h5ls_out$name)
})

test_that("h5dump() works for files in public S3 buckets", {
  skip_on_ci()
  skip_on_bioc()
  skip_if_offline("rhdf5-public.s3.eu-central-1.amazonaws.com")

  expect_silent(h5dump_out <- h5dump(public_S3_url, s3 = TRUE))
  expect_is(h5dump_out, "list")
  expect_equivalent(length(h5dump_out), 1)
  expect_equivalent(dim(h5dump_out$DS1), c(5, 3, 4))
})

#' Set a new dataset extension
#'
#' Set a new dataset extension to an existing dataset in an HDF5 file
#'
#' @param file The filename (character) of the file in which the dataset will
#' be located. For advanced programmers it is possible to provide an object of
#' class [H5IdComponent-class] representing a H5 location identifier
#' (file or group). See [H5Fcreate()], [H5Fopen()],
#' [H5Gcreate()], [H5Gopen()] to create an object of this
#' kind.
#' @param dataset The name of the dataset in the HDF5 file, or an object of
#' class [H5IdComponent-class] representing a H5 dataset identifier. See
#' [H5Dcreate()], or [H5Dopen()] to create an object of
#' this kind.
#' @param dims The dimensions of the array as they will appear in the file.
#' Note, the dimensions will appear in inverted order when viewing the file
#' with a C program (e.g. HDFView), because the fastest changing dimension in
#' R is the first one, whereas the fastest changing dimension in C is the last
#' one.
#' @param native An object of class `logical`. If `TRUE`, array-like objects
#' are treated as stored in HDF5 row-major rather than R column-major
#' orientation. Using `native = TRUE` increases HDF5 file portability
#' between programming languages. A file written with `native = TRUE`
#' should also be read with `native = TRUE`
#'
#' @returns Returns `TRUE` if the dimension of the dataset was changed successfully
#' and `FALSE` otherwise.
#'
#' @author Bernd Fischer, Mike Smith
#' @examples
#'
#' tmpfile <- tempfile()
#' h5createFile(file = tmpfile)
#' h5createDataset(tmpfile, "A", c(10, 12), c(20, 24))
#' h5ls(tmpfile, all = TRUE)[c("dim", "maxdim")]
#' h5set_extent(tmpfile, "A", c(20, 24))
#' h5ls(tmpfile, all = TRUE)[c("dim", "maxdim")]
#'
#' @name h5_set_extent
#' @export h5set_extent
h5set_extent <- function(file, dataset, dims, native = FALSE) {
  if (missing(dataset)) {
    stop(
      "Please provide the name of the dataset using the 'dataset' argument. ",
      "You can use `h5ls()` to list the objects in the file",
      call. = FALSE
    )
  }
  loc <- h5checktypeOrOpenLoc(file, native = native)
  on.exit(h5closeitLoc(loc))

  if (is.character(dataset)) {
    if (!H5Lexists(loc$H5Identifier, dataset)) {
      stop(
        "Object ",
        dataset,
        " does not exist in this HDF5 file.\n",
        "Use `h5ls()` to list the objects in the file."
      )
    }
    did <- H5Oopen(loc$H5Identifier, dataset)
    type <- H5Iget_type(did)
    if (type != "H5I_DATASET") {
      H5Oclose(did)
      stop("'", dataset, "' is not a dataset.")
    }

    if (!H5Dis_chunked(did)) {
      stop(
        "Only chunked datasets can have their extent changed.\n'",
        dataset,
        "' is not chunked."
      )
    }

    res <- H5Dset_extent(did, dims)
    H5Oclose(did)
  } else {
    h5checktype(dataset, "dataset")
    ## Only valid for chunked datasets, so we should check for them
    if (!H5Dis_chunked(did)) {
      stop(
        "Only chunked datasets can have their extent changed.\n'",
        dataset,
        "' is not chunked."
      )
    }
    res <- H5Dset_extent(dataset, dims)
  }

  invisible(res)
}

#' Set how HDF5 error messages are displayed
#'
#' Sets the options for handling HDF5 error messages in the R sessions.
#'
#' @param type 'normal' (default) shows a one line error message in R.
#' 'verbose' shows the whole HDF5 error message. 'suppress' suppresses the HDF5
#' error messages completely.
#' @returns Returns 0 if options are set successfully.
#' @author Bernd Fischer
#' @seealso [rhdf5]
#' @examples
#'
#' h5errorHandling("normal")
#'
#' @name h5_errorHandling
#' @export h5errorHandling
h5errorHandling <- function(type = "normal") {
  t <- switch(
    type,
    "suppress" = 0L,
    "verbose" = 2L,
    1L
  )
  .Call("_h5errorHandling", t, PACKAGE = "rhdf5")

  invisible(NULL)
}

####################################################
## General Property List Operations
####################################################


#' Create a new HDF5 property list
#' 
#' @param type A character name of a property list type. See `h5const("H5P")`
#' for possible property list types.
#' @param native Defunct! Doesn't achieve anything for property lists.
#' 
#' @export
H5Pcreate <- function( type = h5default("H5P"), native = FALSE ) {
  type <- h5checkConstants( "H5P", type )
  pid <- .Call("_H5Pcreate", type, PACKAGE='rhdf5')
  if (pid > 0) {
    h5plist = new("H5IdComponent", ID = pid, native = native)
  } else {
    message("HDF5: unable to create property list")
    h5plist = FALSE
  }
  invisible(h5plist)
}

#' Return the property list class identifier for a property list
#' 
#' @param h5plist [H5IdComponent-class] object representing any type of HDF5 
#' property list.
#' 
#' @export
H5Pget_class <- function( h5plist ) {
  h5checktype(h5plist, "plist")
  pclid <- .Call("_H5Pget_class", h5plist@ID, PACKAGE='rhdf5')
  if (pclid > 0) {
    h5plistclass = new("H5IdComponent", ID = pclid, native = h5plist@native)
  } else {
    message("HDF5: unable to get property list class")
    h5plistclass = FALSE
  }
  invisible(h5plistclass)
}

#' Copy an existing property list to create a new property list
#' 
#' @param h5plist [H5IdComponent-class] object representing the property list
#' to be copied.
#' 
#' @export
H5Pcopy <- function( h5plist ) {
  h5checktype(h5plist, "plist")
  pid <- .Call("_H5Pcopy", h5plist@ID, PACKAGE='rhdf5')
  if (pid > 0) {
    h5plistnew = new("H5IdComponent", ID = pid, native = h5plist@native)
  } else {
    message("HDF5: unable to copy property list")
    h5plistnew = FALSE
  }
  invisible(h5plistnew)
}

#' Close and release a property list
#' 
#' `H5Pclose()` terminates access to a property list. All property lists 
#' should be closed when they no longer need to be accessed. This 
#' frees resources used by the property list.  Failing to call `H5Pclose()`
#' can lead to memory leakage over time.
#' 
#' @param h5plist [H5IdComponent-class] object representing the property list
#' to close.
#'  
#' @export
H5Pclose <- function( h5plist ) {
  h5checktype(h5plist, "plist")
  invisible(.Call("_H5Pclose", h5plist@ID, PACKAGE='rhdf5'))
}

####################################################
## File Creation Properties
####################################################

#' Get version information for objects in a file creation property list
#'
#' @param h5plist [H5IdComponent-class] object representing the file creation property list
#' @returns Named integer vector
#' @export
H5Pget_version <- function(h5plist) {
    h5checktype(h5plist, "plist")
    .Call("_H5Pget_version", h5plist@ID, PACKAGE="rhdf5")
}

#' Get and set the user block size
#' @param h5plist [H5IdComponent-class] object representing the file creation property list
#' @param size of the user block in bytes
#' @rdname H5P_userblock
#' @export
H5Pset_userblock <- function(h5plist, size) {
    h5checktype(h5plist, "plist")
    invisible(.Call("_H5Pset_userblock", h5plist@ID, size, PACKAGE="rhdf5"))
}

#' @rdname H5P_userblock
#' @export
H5Pget_userblock <- function(h5plist) {
    h5checktype(h5plist, "plist")
    .Call("_H5Pget_userblock", h5plist@ID, PACKAGE="rhdf5")
}

#' Get and set the sizes of offsets and lengths used in an HDF5 file
#'
#' @param h5plist [H5IdComponent-class] object representing the file creation property list
#' @param sizeof_addr Offset size in bytes
#' @param sizeof_size Length size in bytes
#' @rdname H5P_sizes
#' @export
H5Pset_sizes <- function(h5plist, sizeof_addr, sizeof_size) {
    h5checktype(h5plist, "plist")
    invisible(.Call("_H5Pset_sizes", h5plist@ID, sizeof_addr, sizeof_size, PACKAGE="rhdf5"))
}

#' @rdname H5P_sizes
#' @export
H5Pget_sizes <- function(h5plist) {
    h5checktype(h5plist, "plist")
    .Call("_H5Pget_sizes", h5plist@ID, PACKAGE="rhdf5")
}

#' Get and set the size of the symbol table B-tree 1/2 rank and the leaf node 1/2 size
#'
#' @param h5plist [H5IdComponent-class] object representing the file creation property list
#' @param ik Symbol table B-tree 1/2 rank
#' @param lk Symbol table leaf node 1/2 size
#' @rdname H5P_sym_k
#' @export
H5Pset_sym_k <- function(h5plist, ik, lk) {
    h5checktype(h5plist, "plist")
    invisible(.Call("_H5Pset_sym_k", h5plist@ID, ik, lk, PACKAGE="rhdf5"))
}

#' @rdname H5P_sym_k
#' @export
H5Pget_sym_k <- function(h5plist) {
    h5checktype(h5plist, "plist")
    .Call("_H5Pget_sym_k", h5plist@ID, PACKAGE="rhdf5")
}

#' Get and set the 1/2 rank of an indexed storage B-tree
#'
#' @param h5plist [H5IdComponent-class] object representing the file creation property list
#' @param ik chunked Storage B-tree 1/2 rank
#' @rdname H5P_istore_k
#' @export
H5Pset_istore_k <- function(h5plist, ik) {
    h5checktype(h5plist, "plist")
    invisible(.Call("_H5Pset_istore_k", h5plist@ID, ik, PACKAGE="rhdf5"))
}

#' @rdname H5P_istore_k
#' @export
H5Pget_istore_k <- function(h5plist) {
    h5checktype(h5plist, "plist")
    .Call("_H5Pget_istore_k", h5plist@ID, PACKAGE="rhdf5")
}

#' Get and set the number of object header message indexes
#'
#' @param h5plist [H5IdComponent-class] object representing the file creation property list
#' @param nindexes Number of shared object header message indexes to be available in files
#' @rdname H5P_shared_mesg_nindexes
#' @export
H5Pset_shared_mesg_nindexes <- function(h5plist, nindexes) {
    h5checktype(h5plist, "plist")
    invisible(.Call("_H5Pset_shared_mesg_nindexes", h5plist@ID, nindexes, PACKAGE="rhdf5"))
}

#' @rdname H5P_shared_mesg_nindexes
#' @export
H5Pget_shared_mesg_nindexes <- function(h5plist) {
    h5checktype(h5plist, "plist")
    .Call("_H5Pget_shared_mesg_nindexes", h5plist@ID, PACKAGE="rhdf5")
}

#' Get and set shared object header message index properties
#'
#' @param h5plist [H5IdComponent-class] object representing the file creation
#'   property list
#' @param index_num Index being configured.  Indices use C-style 0-based counting, so the first index will be numbered 0.
#' @param mesg_type_flags Character specifying the types of messages that may be stored in this index.
#'   Valid values can be found with `h5const(type = "H5O_SHMESG_FLAG")`
#' @param min_mesg_size Minimum message size
#' 
#' @returns `H5Pget_shared_mesg_index()` returns a list of length 2. The first element is the types of messages
#' that may be stored in the index, the second element is the minimum message size.
#' 
#' @rdname H5Pshared_mesg_index
#' @export
H5Pset_shared_mesg_index <- function(h5plist, index_num, 
                                     mesg_type_flags = h5default(type = "H5O_SHMESG_FLAG"), 
                                     min_mesg_size) {
  
    h5checktype(h5plist, "plist")
    mesg_type_flags <- h5checkConstants( "H5O_SHMESG_FLAG", mesg_type_flags )
    invisible(.Call("_H5Pset_shared_mesg_index", h5plist@ID, index_num, 
                    mesg_type_flags, min_mesg_size, PACKAGE="rhdf5"))
}

#' @rdname H5Pshared_mesg_index
#' @export
H5Pget_shared_mesg_index <- function(h5plist, index_num) {
    h5checktype(h5plist, "plist")
    res <- .Call("_H5Pget_shared_mesg_index", h5plist@ID, index_num, PACKAGE="rhdf5")
    return(list(type_flags = h5const2String("H5O_SHMESG_FLAG", res[1]),
                size = res[2]))
}

#' Get and set threshold values for storage of shared object header message indexes
#'
#' @param h5plist [H5IdComponent-class] object representing the file creation property list
#' @param max_list Threshold above which storage shifts from list to B-tree
#' @param min_btree Threshold below which storage reverts to list format
#' @rdname H5P_shared_mesg_phase_change
#' @export
H5Pset_shared_mesg_phase_change <- function(h5plist, max_list, min_btree) {
    h5checktype(h5plist, "plist")
    invisible(.Call("_H5Pset_shared_mesg_phase_change", h5plist@ID, max_list, min_btree, PACKAGE="rhdf5"))
}

#' @rdname H5P_shared_mesg_phase_change
#' @export
H5Pget_shared_mesg_phase_change <- function(h5plist) {
    h5checktype(h5plist, "plist")
    .Call("_H5Pget_shared_mesg_phase_change", h5plist@ID, PACKAGE="rhdf5")
}

####################################################
## File Access Properties
####################################################

#' Set the read-only S3 virtual file driver
#'
#' The read-only S3 virtual file driver can be used to read files hosted
#' remotely on Amazon's S3 storage.
#'
#' @details To access files in a private Amazon S3 bucket you will need to
#'   provide three additional details: The AWS region where the files are
#'   hosted, your AWS access key ID, and your AWS secret access key.  More
#'   information on how to obtain AWS access keys can be found at
#'   \url{https://docs.aws.amazon.com/general/latest/gr/aws-sec-cred-types.html#access-keys-and-secret-access-keys}.
#'   These are provided as a list to the `s3credentials` argument.  If you
#'   are accessing public data this argument should be `NULL`.
#'   
#' @param h5plist [H5IdComponent-class] object representing a file access 
#' property list.
#' @param s3credentials Either \code{NULL} or a list of length 3 specifying the AWS access credentials (see details).
#'
#' @examples
#'
#' ## this doesn't work on the Bioconductor Mac build machine
#' \dontrun{
#' pid <- H5Pcreate("H5P_FILE_ACCESS")
#' H5Pset_fapl_ros3( pid )
#' H5Pclose(pid)
#' }
#' 
#' @export
H5Pset_fapl_ros3 <- function( h5plist, s3credentials = NULL ) {
  
    ## this should really check it's a fapl, not just a plist.
    h5checktype(h5plist, "plist")
  
    ## only do authentication if s3credentials are provided
    if(!is.null(s3credentials)) {
      auth <- TRUE
      aws_region <- s3credentials[[1]]
      access_key_id <- s3credentials[[2]]
      secret_access_key <- s3credentials[[3]]
    } else {
      auth <- FALSE
      aws_region <- access_key_id <- secret_access_key <- ""
    }
  
    res <- .Call('_H5Pset_fapl_ros3', h5plist@ID, auth, 
                 aws_region, access_key_id, secret_access_key, 
                 PACKAGE = "rhdf5")
    invisible(res)
}

#' Control the range of HDF5 library versions that will be compatible with
#' a file.
#' 
#' 
#' @param h5plist [H5IdComponent-class] object representing a file access 
#' property list.
#' @param libver_low,libver_high Define the earliest and latest versions of 
#' the HDF5 library that will be used when writing object in the file.
#' 
#' @name H5P_libver_bounds
NULL

#' @rdname H5P_libver_bounds
#' @export
H5Pset_libver_bounds <- function( h5plist, libver_low = "H5F_LIBVER_EARLIEST", libver_high = "H5F_LIBVER_LATEST") {
  h5checktype(h5plist, "plist")
  libver_low <- h5checkConstants( "H5F_LIBVER", libver_low )
  libver_high <- h5checkConstants( "H5F_LIBVER", libver_high )
  res <- .Call("_H5Pset_libver_bounds", h5plist@ID, 
               libver_low, libver_high, PACKAGE='rhdf5')
  invisible(res)
}

#' @rdname H5P_libver_bounds
#' @export
H5Pget_libver_bounds <- function( h5plist ) {
  h5checktype(h5plist, "plist")
  res <- .Call("_H5Pget_libver_bounds", h5plist@ID, PACKAGE='rhdf5')
  res <- h5const2String("H5F_LIBVER", res)
  names(res) = c("libver_low","libver_high")
  res
}

####################################################
## Link Creation Properties
####################################################

H5Pset_char_encoding <- function( h5plist, encoding = h5default("H5T_CSET")) {
  h5checktypeAndPLC(h5plist, "H5P_LINK_CREATE")
  encoding <- h5checkConstants( "H5T_CSET", encoding )
  res <- .Call("_H5Pset_char_encoding", h5plist@ID, encoding, PACKAGE='rhdf5')
  invisible(res)
}

H5Pget_char_encoding <- function( h5plist ) {
  h5checktypeAndPLC(h5plist, "H5P_LINK_CREATE")
  res <- .Call("_H5Pget_char_encoding", h5plist@ID, PACKAGE='rhdf5')
  res <- h5const2String("H5T_CSET", res)
  res
}

#' Get and set whether to create missing intermediate groups
#'
#' @param h5plist An object of class [H5IdComponent-class] representing a link
#'   creation property list.
#' @param create_groups A logical of length 1 specifying whether missing
#'   groups should be created when a new object is created.  Default is `TRUE`.
#'   
#' @examples  
#' pid <- H5Pcreate("H5P_LINK_CREATE")
#' 
#' ## by default intermediate groups are not created
#' H5Pget_create_intermediate_group( pid )
#' 
#' ## Change the setting so groups will be created
#' 
#' H5Pget_create_intermediate_group( pid )
#' 
#' ## tidy up
#' H5Pclose(pid)
#'
#' @name H5P_create_intermediate_group
NULL

#' @rdname H5P_create_intermediate_group 
#' @export
H5Pset_create_intermediate_group <- function( h5plist, create_groups = TRUE ) {
  
  h5checktypeAndPLC(h5plist, "H5P_LINK_CREATE")
  if(!is.logical(create_groups)) {
    stop("The 'create_groups' argument should be either TRUE or FALSE")
  }
  
  crt_intermed_group = as.integer(create_groups)
  res <- .Call("_H5Pset_create_intermediate_group", h5plist@ID, crt_intermed_group, PACKAGE='rhdf5')
  invisible(res)
}

#' @rdname H5P_create_intermediate_group 
#' @export
H5Pget_create_intermediate_group <- function( h5plist ) {
  h5checktypeAndPLC(h5plist, "H5P_LINK_CREATE")
  res <- .Call("_H5Pget_create_intermediate_group", h5plist@ID, PACKAGE='rhdf5')
  res
}

####################################################
## Dataset Creation Properties
####################################################

#' Get and set the type of storage used to store the raw data for a dataset
#' 
#' Possible options for the `layout` argument are:
#' * `H5D_COMPACT`
#' * `H5D_CONTIGUOUS`
#' * `H5D_CHUNKED`
#' * `H5D_VIRTUAL`
#' 
#' The names of the layout types can also be obtained via `h5const("H5D")`.
#' 
#' @param h5plist An object of class [H5IdComponent-class] representing a dataset creation property list.
#' @param layout A character giving the name of a dataset layout type. 
#' 
#' @name H5P_layout
NULL

#' @rdname H5P_layout
#' @export
H5Pset_layout <- function( h5plist, layout = h5default("H5D") ) {
  h5checktypeAndPLC(h5plist, "H5P_DATASET_CREATE")
  layout <- h5checkConstants( "H5D", layout )
  res <- .Call("_H5Pset_layout", h5plist@ID, layout, PACKAGE='rhdf5')
  invisible(res)
}

#' @rdname H5P_layout
#' @export
H5Pget_layout <- function( h5plist ) {
  h5checktypeAndPLC(h5plist, "H5P_DATASET_CREATE")
  res <- .Call("_H5Pget_layout", h5plist@ID, PACKAGE='rhdf5')
  res <- h5const2String("H5D", res)
  res
}

#' Get and set the size of the chunks used to store a chunked layout dataset
#' 
#' @details Note that a necessary side effect of running this function is that the 
#' layout of the dataset will be changes to `H5D_CHUNKED` if it is not already set to this.
#' 
#' @param h5plist An object of class [H5IdComponent-class] representing a dataset creation property list.
#' @param dim The chunk size used to store the dataset. This argument should be an integer vector of the same length as 
#' the number of dimensions of the dataset the dataset creation property list will be applied to.
#' 
#' @seealso [H5Pset_layout()]
#' 
#' @name H5P_chunk
NULL

#' @rdname H5P_chunk
#' @export
H5Pset_chunk <- function( h5plist, dim ) {
  h5checktypeAndPLC(h5plist, "H5P_DATASET_CREATE")
  if (!is.null(dim) && !h5plist@native) { dim = rev(as.integer(dim)) }
  res <- .Call("_H5Pset_chunk", h5plist@ID, dim, PACKAGE='rhdf5')
  invisible(res)
}

#' @rdname H5P_chunk
#' @export
H5Pget_chunk <- function( h5plist ) {
  h5checktypeAndPLC(h5plist, "H5P_DATASET_CREATE")
  res <- .Call("_H5Pget_chunk", h5plist@ID, PACKAGE='rhdf5')
  res
}

#' Add the deflate compression filter to the chunk processing pipeline.
#'
#' Valid values for the compression level range from 0 (no compression) to 9
#' (best compression, slowest speed). Note that applying this function with
#' `level = 0` does not mean the filter is removed.  It is still part of the
#' filter pipeline, but no compression is performed.  The filter will still need
#' to be available on any system that reads a file created with this setting
#'
#' @param h5plist Object of class [H5IdComponent-class] representing a dataset
#'   creation property list.
#' @param level Integer giving the compression level to use.  Valid values are
#'   from 0 to 9.
#'
#' @export
H5Pset_deflate <- function( h5plist, level ) {
  h5checktypeAndPLC(h5plist, "H5P_DATASET_CREATE")
  level <- as.integer(level)
  res <- .Call("_H5Pset_deflate", h5plist@ID, level, PACKAGE='rhdf5')
  invisible(res)
}

#' Set the fill value for an HDF5 dataset
#' 
#' `H5Pset_fill_value` sets the fill value for a dataset in the dataset creation property list.
#'
#' @param h5plist An object of class [H5IdComponent-class] representing a
#'   dataset creation property list.
#' @param value The default fill value of the dataset. A vector of length 1.
#' 
#' @seealso [H5P_fill_time],[H5Pfill_value_defined]
#'
#' @name H5P_fill_value
NULL

#' @rdname H5P_fill_value
#' @export
H5Pset_fill_value <- function( h5plist, value ) {
  
  if(length(value) > 1L) {
    stop("'value' must be a vector of length 1.")
  }
  
  h5checktypeAndPLC(h5plist, "H5P_DATASET_CREATE")
  storage.mode = storage.mode(value)
  tid <- switch(storage.mode,
                double = h5constants$H5T["H5T_IEEE_F64LE"],
                integer = h5constants$H5T["H5T_STD_I32LE"],
                logical = h5constants$H5T["H5T_STD_I8LE"],
                character = {
                    tid <- H5Tcopy("H5T_C_S1")
                    size <- nchar(value, type = "bytes")
                    H5Tset_size(tid, size)
                    H5Tset_strpad(tid, strpad = "NULLPAD")
                    if(Encoding(value) == "UTF-8") { cset <- "UTF-8" } else { cset <- "ASCII" }
                    H5Tset_cset(tid, cset = cset)
                    tid
                },
                { stop("datatype ",storage.mode," not supported. Try 'double', 'integer', or 'character'.") } )
  res <- .Call("_H5Pset_fill_value", h5plist@ID, tid, value, PACKAGE='rhdf5')
  invisible(res)
}

#' Determine whether a property list has a fill value defined
#'
#' @param h5plist Object of class [H5IdComponent-class] representing a dataset
#'   creation property list.
#'
#' @returns `TRUE` if the fill value is defined, `FALSE` if not.  Will return
#'   `NULL` if there is a problem determining the status of the fill value.
#'
#' @details  Note that the return value for this function is slightly different
#'   from the C version.  The C API provides three return types and can, in the
#'   case that a fill value is defined, differentiate whether the value is the
#'   HDF5 library default or has been set by the application.
#'
#' @export
H5Pfill_value_defined <- function( h5plist ) {
  h5checktypeAndPLC(h5plist, "H5P_DATASET_CREATE")
  res <- .Call("_H5Pfill_value_defined", h5plist@ID, PACKAGE='rhdf5')
  res
}

#' Set the time when fill values are written to a dataset
#'
#' @param h5plist An object of class [H5IdComponent-class] representing a
#'   dataset creation property list.
#' @param fill_time When the fill values should be written.  Possible options
#' can be listed with `h5const("H5D_FILL_TIME")`.
#'
#' @name H5P_fill_time
NULL

#' @rdname H5P_fill_time
#' @export
H5Pset_fill_time <- function( h5plist, fill_time = h5default("H5D_FILL_TIME") ) {
  h5checktypeAndPLC(h5plist, "H5P_DATASET_CREATE")
  fill_time <- h5checkConstants( "H5D_FILL_TIME", fill_time )
  res <- .Call("_H5Pset_fill_time", h5plist@ID, fill_time, PACKAGE='rhdf5')
  invisible(res)
}

#' @rdname H5P_fill_time
#' @export
H5Pget_fill_time <- function( h5plist ) {
  h5checktypeAndPLC(h5plist, "H5P_DATASET_CREATE")
  res <- .Call("_H5Pget_fill_time", h5plist@ID, PACKAGE='rhdf5')
  res <- h5const2String("H5D_FILL_TIME", res)
  res
}

H5Pset_alloc_time <- function( h5plist, alloc_time = h5default("H5D_ALLOC_TIME") ) {
  h5checktypeAndPLC(h5plist, "H5P_DATASET_CREATE")
  alloc_time <- h5checkConstants( "H5D_ALLOC_TIME", alloc_time )
  res <- .Call("_H5Pset_alloc_time", h5plist@ID, alloc_time, PACKAGE='rhdf5')
  invisible(res)
}

H5Pget_alloc_time <- function( h5plist ) {
  h5checktypeAndPLC(h5plist, "H5P_DATASET_CREATE")
  res <- .Call("_H5Pget_alloc_time", h5plist@ID, PACKAGE='rhdf5')
  res <- h5const2String("H5D_ALLOC_TIME", res)
  res
}

#' Query dataset filter properties.
#'
#' Return information about the filter pipeline applied to a dataset creation
#' property list.
#'
#' * `H5Pall_filters_avail()` checks whether all filters required to process a
#' dataset are available to **rhdf5**.  This can be required if reading files
#' created with other HDF5 software. 
#' * `H5Pget_nfilters()` returns the number of
#' filters in the dataset chunk processing pipeline. 
#' * `H5Pget_filter()`
#' provides details of a specific filter in the pipeline. This includes the
#' filter name and the parameters provided to it e.g. compression level.
#'
#' @param h5plist Object of class [H5IdComponent-class] representing a dataset
#'   creation property list.
#' @param idx Integer of length 1.  This argument selects which filter to return
#'   information about.  Indexing is R-style 1-based.
#'   

#' @rdname H5P_filters
#' @export
H5Pall_filters_avail <- function( h5plist ) {
    h5checktypeAndPLC(h5plist, "H5P_DATASET_CREATE")
    res <- .Call("_H5Pall_filters_avail", h5plist@ID, PACKAGE='rhdf5')
    return(res)
}

#' @rdname H5P_filters
#' @export
H5Pget_nfilters <- function( h5plist ) {
    h5checktypeAndPLC(h5plist, "H5P_DATASET_CREATE")
    res <- .Call("_H5Pget_nfilters", h5plist@ID, PACKAGE='rhdf5')
    res
}

#' @rdname H5P_filters
#' @export
H5Pget_filter <- function( h5plist, idx ) {
    h5checktypeAndPLC(h5plist, "H5P_DATASET_CREATE")
    idx <- as.integer(idx)
    
    if( (idx < 1) || (idx > H5Pget_nfilters(h5plist)) ) {
      stop("'idx' argument is outside the range of filters set on this property list.", 
           call. = FALSE)
    } 
    
    res <- .Call("_H5Pget_filter", h5plist@ID, idx-1L, PACKAGE='rhdf5')
    return(res)
}

#' Add the shuffle filter to the chunk processing pipeline.
#' 
#' @param h5plist Object of class [H5IdComponent-class] representing a dataset
#' creation property list.
#' 
#' @returns Returns (invisibly) an integer vector of length 1.  The only
#'   element of this vector will be non-negative if the filter was set
#'   successfully and negative otherwise.
#' 
#' @export
H5Pset_shuffle <- function( h5plist ) {
  h5checktypeAndPLC(h5plist, "H5P_DATASET_CREATE")
  res <- .Call("_H5Pset_shuffle", h5plist@ID, PACKAGE='rhdf5')
  invisible(res)
}

#' Add the N-Bit filter to the chunk processing pipeline.
#'
#' @param h5plist Object of class [H5IdComponent-class] representing a dataset
#'   creation property list.
#'
#' @returns Returns (invisibly) an integer vector of length 1.  The only
#'   element of this vector will be non-negative if the filter was set
#'   successfully and negative otherwise.
#'
#' @export
H5Pset_nbit <- function( h5plist ) {
  h5checktypeAndPLC(h5plist, "H5P_DATASET_CREATE")
  res <- .Call("_H5Pset_nbit", h5plist@ID, PACKAGE = "rhdf5")
  invisible(res)
}

#' Add the SZIP compression filter to the chunk processing pipeline.
#' 
#' @param h5plist Object of class [H5IdComponent-class] representing a dataset
#' creation property list.
#' @param options_mask,pixels_per_block Integer vectors of length 1, setting parameters 
#' of the SZIP algorithm. See \url{https://portal.hdfgroup.org/display/HDF5/H5P_SET_SZIP} for more details.
#' 
#' @references \url{https://portal.hdfgroup.org/display/HDF5/Szip+Compression+in+HDF+Products}
#' 
#' @export
H5Pset_szip <- function( h5plist, options_mask, pixels_per_block ) {
  h5checktypeAndPLC(h5plist, "H5P_DATASET_CREATE")
  options_mask = as.integer(options_mask)
  pixels_per_block = as.integer(pixels_per_block)
  res <- .Call("_H5Pset_szip", h5plist@ID, options_mask, pixels_per_block, PACKAGE='rhdf5')
  invisible(res)
}


####################################################
## Dataset Access Properties
####################################################

#' Set parameters for the raw data chunk cache
#'
#' @param h5plist Object of class [H5IdComponent-class] representing a dataset
#'   access property list.
#' @param rdcc_nslots Integer defining the number of chunk slots in the raw data
#'   chunk cache for this dataset.
#' @param rdcc_nbytes Integer setting the total size of the raw data chunk cache
#'   for this dataset in bytes. In most cases increasing this number will
#'   improve performance, as long as you have enough free memory. The default
#'   size is 1 MB
#' @param rdcc_w0 Numeric value defining the chunk preemption policy.  Must be between
#'   `0` and `1` inclusive.
#'
#' @name H5P_chunk_cache
NULL

#' @rdname H5P_chunk_cache
#' @export
H5Pset_chunk_cache <- function( h5plist, rdcc_nslots, rdcc_nbytes, rdcc_w0 ) {
  h5checktypeAndPLC(h5plist, "H5P_DATASET_ACCESS")
  rdcc_nslots = as.integer(rdcc_nslots)
  rdcc_nbytes = as.integer(rdcc_nbytes)
  rdcc_w0 = as.double(rdcc_w0)
  res <- .Call("_H5Pset_chunk_cache", h5plist@ID, rdcc_nslots, rdcc_nbytes, rdcc_w0, PACKAGE='rhdf5')
  invisible(res)
}


####################################################
## Object Creation Properties
####################################################

#' Set whether to record timestamps for operations performed on an HDF5 object.
#'
#' @details Objects created using high-level **rhdf5** functions like
#'   [h5createDataset()] will have this setting turned off. This was done to
#'   ensure otherwise identical files returned the same md5 hash. This differs
#'   from the default setting in HDF5, which is for objects to record the times
#'   operations were performed on them.
#'
#' @param h5plist An [H5IdComponent-class] object representing an object
#'   creation property list.
#' @param track_times `logical` specifying whether times associated with an
#'   object should recorded.
#'
#' @name H5Pobject_track_times
NULL

#' @rdname H5Pobject_track_times
#' @export
H5Pset_obj_track_times <- function( h5plist, track_times = TRUE ) {
  
  if(!is.logical(track_times) || is.na(track_times)) {
    stop("Argument 'track_times' must be either TRUE or FALSE")
  }

  res <- .Call("_H5Pset_obj_track_times", h5plist@ID, as.integer(track_times), PACKAGE='rhdf5')
  invisible(res)
}

#' @rdname H5Pobject_track_times
#' @export
H5Pget_obj_track_times <- function( h5plist ) {
   res <- .Call("_H5Pget_obj_track_times", h5plist@ID, PACKAGE='rhdf5')
   return(res)
}

####################################################
## Generic Property Operations (Advanced)
####################################################

H5Pequal <- function( h5plistclass1, h5plistclass2 ) {
  h5checktype(h5plistclass1, "plistclass")
  h5checktype(h5plistclass2, "plistclass")
  res <- .Call("_H5Pequal", h5plistclass1@ID, h5plistclass2@ID, PACKAGE='rhdf5')
  as.logical(res)
}

H5Pclose_class <- function( h5plistclass ) {
  h5checktype(h5plistclass, "plistclass")
  invisible(.Call("_H5Pclose_class", h5plistclass@ID, PACKAGE='rhdf5'))
}

library(rhdf5)

h5File <- withr::local_tempfile(pattern = "H5O_", fileext = ".h5")
h5File2 <- withr::local_tempfile(pattern = "H5O_", fileext = ".h5")
h5createFile(h5File)
h5createFile(h5File2)
h5write(1:10, file = h5File, name = "DS1")

test_that("orphan objects can be linked into a file", {
  ## open file and create orphan group
  fid <- H5Fopen(h5File)
  gid <- H5Gcreate_anon(fid)

  ## insert group into file at /foo
  expect_silent(H5Olink(h5obj = gid, h5loc = fid, newLinkName = "foo"))

  H5Gclose(gid)
  H5Fclose(fid)

  ## check new group is in the file
  ls_out <- h5ls(h5File)
  expect_identical(nrow(ls_out), 2L)
  expect_identical(ls_out$name, c("DS1", "foo"))
})

test_that("Objects can be copied in the same file", {
  fid1 <- H5Fopen(h5File)

  expect_silent(H5Ocopy(
    h5loc = fid1,
    name = "DS1",
    h5loc_dest = fid1,
    name_dest = "DS2"
  ))

  H5Fclose(fid1)

  ## check new group is in the file
  ls_out <- h5ls(h5File)
  expect_identical(nrow(ls_out), 3L)
  expect_identical(ls_out$name, c("DS1", "DS2", "foo"))
})

test_that("Objects can be copied in a different file", {
  fid1 <- H5Fopen(h5File)
  fid2 <- H5Fopen(h5File2)

  expect_silent(H5Ocopy(
    h5loc = fid1,
    name = "DS1",
    h5loc_dest = fid2,
    name_dest = "DS1"
  ))

  ## if we want to create a new group hierarchy we can use a link creation property list
  lcpl <- H5Pcreate("H5P_LINK_CREATE")
  on.exit(H5Pclose(lcpl), add = TRUE)
  H5Pset_create_intermediate_group(lcpl, create_groups = TRUE)

  expect_silent(H5Ocopy(
    h5loc = fid1,
    name = "DS1",
    h5loc_dest = fid2,
    name_dest = "/foo/baa/DS1_nested",
    lcpl = lcpl
  ))

  H5Fclose(fid1)
  H5Fclose(fid2)

  ## check new group is in the file
  ls_out <- h5ls(h5File2)
  expect_identical(nrow(ls_out), 4L)
  expect_identical(ls_out$name, c("DS1", "foo", "baa", "DS1_nested"))
})

library(rhdf5)

############################################################
context("H5P functions")
############################################################

test_that("Property list creation & closure", {
  expect_silent(pid <- H5Pcreate())
  expect_is(pid, "H5IdComponent")
  expect_silent(H5Pclose(pid))
})


test_that("Property list creation & closure", {
  expect_silent(pid1 <- H5Pcreate())

  expect_silent(pid2 <- H5Pcopy(pid1))
  expect_is(pid2, "H5IdComponent")

  expect_silent(H5Pclose(pid1))
  expect_silent(H5Pclose(pid2))
})

test_that("setting and getting libhdf5 version bounds", {
  expect_silent(pid1 <- H5Pcreate("H5P_FILE_ACCESS"))

  expect_output(
    default_version_bounds <- H5Pget_libver_bounds(pid1),
    regexp = "^low"
  )
  expect_is(default_version_bounds, "character")

  ## Setters work as expected.
  expect_silent(H5Pset_libver_bounds(
    pid1,
    libver_low = "H5F_LIBVER_V110",
    libver_high = "H5F_LIBVER_LATEST"
  ))
  expect_output(version_bounds <- H5Pget_libver_bounds(pid1), regexp = "^low")
  expect_equivalent(version_bounds, c("H5F_LIBVER_V110", "H5F_LIBVER_LATEST"))

  # Restoring the bounds to their original values.
  expect_silent(H5Pset_libver_bounds(
    pid1,
    libver_low = default_version_bounds[1],
    libver_high = default_version_bounds[2]
  ))
  expect_output(version_bounds <- H5Pget_libver_bounds(pid1), regexp = "^low")
  expect_identical(version_bounds, default_version_bounds)

  expect_silent(H5Pclose(pid1))
})

test_that("Dataset creation properties can be set", {
  expect_silent(pid <- H5Pcreate("H5P_DATASET_CREATE"))

  ## use default layout
  expect_silent(layout <- H5Pget_layout(pid))
  expect_is(layout, "character")
  expect_match(as.character(layout), "H5D_CONTIGUOUS")
  ## change to chunked
  expect_silent(H5Pset_layout(pid, layout = "H5D_CHUNKED"))
  ## check changes
  expect_silent(H5Pget_layout(pid)) %>%
    expect_match("H5D_CHUNKED")

  ## seting chunk sizes
  expect_null(H5Pget_chunk(pid))
  H5Pset_chunk(pid, dim = c(100, 100))
  expect_identical(H5Pget_chunk(pid), c(100L, 100L))

  ## default fill values
  ## I think this is defined by default
  expect_true(H5Pfill_value_defined(pid))
  expect_silent(H5Pset_fill_value(pid, 10))
  expect_silent(H5Pset_fill_value(pid, 10L))
  expect_silent(H5Pset_fill_value(pid, "foo"))
  expect_silent(H5Pset_fill_value(pid, TRUE))
  expect_error(H5Pset_fill_value(pid, sum))

  ## setting whether times are tracked
  expect_silent(H5Pset_obj_track_times(pid, TRUE))
  expect_true(H5Pget_obj_track_times(pid))
  expect_silent(H5Pset_obj_track_times(pid, FALSE))
  expect_false(H5Pget_obj_track_times(pid))

  expect_silent(H5Pclose(pid))
})

library(rhdf5)

test_that("Link creation property list can be created", {
  expect_silent(pid <- H5Pcreate(type = "H5P_LINK_CREATE"))
  expect_is(pid, "H5IdComponent")
  expect_silent(H5Pclose(pid))
})

test_that("Creation of intermediate groups can be toggled", {
  pid <- H5Pcreate(type = "H5P_LINK_CREATE")
  on.exit(H5Pclose(pid))

  expect_silent(H5Pset_create_intermediate_group(pid, create_groups = TRUE))
  expect_true(H5Pget_create_intermediate_group(pid))
  expect_silent(H5Pset_create_intermediate_group(pid, create_groups = FALSE))
  expect_false(H5Pget_create_intermediate_group(pid))
})

test_that("LPCL function error handling works", {
  pid <- H5Pcreate(type = "H5P_LINK_CREATE")
  on.exit(H5Pclose(pid))

  expect_error(
    H5Pset_create_intermediate_group(pid, create_groups = 1),
    regexp = "The 'create_groups' argument should be either TRUE or FALSE"
  )
})

library(rhdf5)

h5File <- withr::local_tempfile(pattern = "H5D_extras_", fileext = ".h5")
h5createFile(h5File)

test_that("we can determine dataset chunk properties", {
  fid <- H5Fopen(h5File)
  sid <- H5Screate_simple(c(100, 100))
  dcpl <- H5Pcreate("H5P_DATASET_CREATE")
  H5Pset_layout(dcpl, layout = "H5D_CONTIGUOUS")
  did1 <- H5Dcreate(
    fid,
    name = "/not_chunked",
    h5space = sid,
    dtype_id = "H5T_NATIVE_INT",
    dcpl = dcpl
  )
  H5Pset_layout(dcpl, layout = "H5D_CHUNKED")
  H5Pset_chunk(dcpl, dim = c(5, 20))
  did2 <- H5Dcreate(
    fid,
    name = "/chunked",
    h5space = sid,
    dtype_id = "H5T_NATIVE_INT",
    dcpl = dcpl
  )

  on.exit(h5closeAll(fid, sid, dcpl, did1, did2))

  expect_false(H5Dis_chunked(did1))
  expect_true(H5Dis_chunked(did2))

  expect_null(H5Dchunk_dims(did1))
  expect_identical(H5Dchunk_dims(did2), c(5L, 20L))
})

library(rhdf5)

dcpl <- H5Pcreate(type = "H5P_DATASET_CREATE")

test_that("Filters can be set", {
  
  expect_gte(H5Pset_nbit(dcpl), 0)
  expect_gte(H5Pset_shuffle(dcpl), 0)
  
  expect_is( H5Pget_nfilters(dcpl), "integer" ) |>
    expect_equal(2L)
  
  ## we can only set szip for writing with Windows versions built after switching to ucrt
  if( (.Platform$OS.type != "windows") || 
     (!is.null(R.version$crt) && R.version$crt == "ucrt") ) {
    expect_gte(H5Pset_szip(dcpl, options_mask = 1L, pixels_per_block = 8L), 0)
    expect_equal(H5Pget_nfilters(dcpl), 3L)
  }

  
})

test_that("Filter information can be retrieved", {
  
  expect_is(filter_info <- H5Pget_filter(dcpl, 1L), "list") |>
    expect_length(2L)
  expect_equal(filter_info[[2]], "nbit")
  
})

test_that("UTF8 strings can be used for fill values", {
  
  fill_value <- "αααα-test"
  
  tf <- tempfile(fileext = ".h5")
  fid <- H5Fcreate(tf)
  sid <- H5Screate_simple(dims = 1)
  tid <- H5Tcopy("H5T_C_S1")
  H5Tset_size(tid, size = nchar(fill_value, type = "bytes")+1)
  H5Tset_cset(tid, "UTF-8")
  
  pid <- H5Pcreate(type = "H5P_DATASET_CREATE")
  expect_silent(H5Pset_fill_value(pid, fill_value))
  
  did1 <- H5Dcreate(h5loc = fid, name = "/strings", dtype_id = tid, dcpl = pid, h5space = sid)

  H5Dclose(did1)
  H5Pclose(pid)
  H5Sclose(sid)
  H5Fclose(fid)
  
  expect_equivalent(h5read(tf, name = "/strings"), fill_value)
  
})

test_that("H5P error handling works", {
  
  expect_silent(pid <- H5Pcreate("H5P_DATASET_CREATE"))
  
  expect_error(H5Pset_obj_track_times(pid, track_times = "TEST"))
  expect_error(H5Pset_obj_track_times(pid, track_times = 1L))
  expect_error(H5Pset_obj_track_times(pid, track_times = NA))
  
  H5Pclose(pid)
})

H5Pclose(dcpl)

library(rhdf5)

test_that("File creation property list can be created", {
  expect_silent(pid <- H5Pcreate(type = "H5P_FILE_CREATE"))
  expect_is(pid, "H5IdComponent")
  expect_silent(H5Pclose(pid))
})


pid <- H5Pcreate(type = "H5P_FILE_CREATE")

test_that("Sizes of symbol table tree can be retrieved", {
  expect_silent(sym_k <- H5Pget_sym_k(pid))
  expect_is(sym_k, "integer")
  expect_identical(names(sym_k), c("ik", "lk"))
})

test_that("Sizes of symbol table tree can be set", {
  expect_silent(H5Pset_sym_k(pid, ik = 20L, lk = 5))
  sym_k <- H5Pget_sym_k(pid)
  expect_equivalent(sym_k, c(20L, 5L))
})

test_that("Sizes of offsets and lengths can be retrieved", {
  expect_silent(h5_sizes <- H5Pget_sizes(pid))
  expect_is(h5_sizes, "integer")
  expect_identical(names(h5_sizes), c("offset", "length"))
})

test_that("Sizes of offsets and lengths can be set", {
  expect_silent(H5Pset_sizes(pid, sizeof_addr = 16L, sizeof_size = 16L))
  h5_sizes <- H5Pget_sizes(pid)
  expect_equivalent(h5_sizes, c(16L, 16L))
})

test_that("Size of userblock can be retrieved", {
  expect_silent(userblock <- H5Pget_userblock(pid))
  expect_is(userblock, "integer")
  expect_identical(userblock, 0L)
})

test_that("Size of userblock can be set", {
  expect_silent(H5Pset_userblock(pid, size = 512L))
  userblock <- H5Pget_userblock(pid)
  expect_identical(userblock, 512L)

  ## valid values are powers of 2 greater than or equal to 512
  # expect_error(H5Pset_userblock(pid, size = 511L))
})

test_that("Sizes of istore can be retrieved", {
  expect_silent(istore <- H5Pget_istore_k(pid))
  expect_is(istore, "integer")
  expect_identical(istore, 32L)
})

test_that("Sizes of istore can be set", {
  expect_silent(H5Pset_istore_k(pid, ik = 64L))
  istore <- H5Pget_istore_k(pid)
  expect_equivalent(istore, 64L)

  ## max value is 2^16
  # expect_error(H5Pset_userblock(pid, size = 66000))
})

test_that("Phase change information can be retrieved", {
  expect_silent(p_change <- H5Pget_shared_mesg_phase_change(pid))
  expect_is(p_change, "integer")
  expect_equivalent(p_change, c(50L, 40L))
})

test_that("Phase change information can be set", {
  expect_silent(H5Pset_shared_mesg_phase_change(
    pid,
    max_list = 25L,
    min_btree = 20L
  ))
  p_change <- H5Pget_shared_mesg_phase_change(pid)
  expect_equivalent(p_change, c(25L, 20L))
})

test_that("Number of object header message indexes can be retrieved", {
  expect_silent(nindexes <- H5Pget_shared_mesg_nindexes(pid))
  expect_is(nindexes, "integer")
  expect_identical(nindexes, 0L)
})

test_that("Number of object header message indexes can be set", {
  expect_silent(H5Pset_shared_mesg_nindexes(pid, nindexes = 8L))
  nindexes <- H5Pget_shared_mesg_nindexes(pid)
  expect_equivalent(nindexes, 8L)
})

test_that("shared object header mesage index properties can be retrieved", {
  ## this can only be run after H5Pset_shared_mesg_nindexes() has been called
  expect_silent(shd_msg_idx <- H5Pget_shared_mesg_index(pid, index_num = 0L))
  expect_is(shd_msg_idx, "list")
  expect_identical(names(shd_msg_idx), c("type_flags", "size"))
  expect_equivalent(shd_msg_idx$type_flags, "H5O_SHMESG_NONE_FLAG")
  expect_equivalent(shd_msg_idx$size, 250)
})

test_that("shared object header mesage index properties can be set", {
  expect_silent(H5Pset_shared_mesg_index(
    pid,
    index_num = 0L,
    mesg_type_flags = "H5O_SHMESG_FILL_FLAG",
    10L
  ))
  shd_msg_idx <- H5Pget_shared_mesg_index(pid, index_num = 0L)
  expect_equivalent(shd_msg_idx$type_flags, "H5O_SHMESG_FILL_FLAG")
  expect_equivalent(shd_msg_idx$size, 10L)
})


H5Pclose(pid)

library(rhdf5)

test_that("Tests for filters work", {
  dcpl <- H5Pcreate(type = "H5P_DATASET_CREATE")

  ## default DCPL has no filters set
  expect_true(nzchar(h5checkFilters(dcpl)) == 0L)

  ## deflate fitlers should always be available
  H5Pset_deflate(dcpl, level = 6)
  expect_true(nzchar(h5checkFilters(dcpl)) == 0L)

  H5Pclose(dcpl)
})

test_that("Missing filters are identified", {
  dcpl <- H5Pcreate(type = "H5P_DATASET_CREATE")

  ## lots of things to mock here!
  local_mocked_bindings(
    H5Pget_nfilters = function(h5plist) 1,
    H5Pall_filters_avail = function(h5plist) 0,
    H5Pget_filter = function(h5plist, index) list(404, "foo_filter"),
    H5Zfilter_avail = function(filter_id) FALSE
  )

  expect_true(grepl(
    pattern = "Missing filters: foo_filter",
    x = h5checkFilters(dcpl)
  ))

  H5Pclose(dcpl)
})

#' Create a link to an object in a different HDF5 file
#'
#' @description `H5Lcreate_external()` creates a new external link. An external
#'   link is a soft link to an object in a different HDF5 file from the location
#'   of the link.
#'
#' @param target_file_name Name of the external HDF5 to link to
#' @param target_obj_name Path to the object in the file specified by
#'   `target_file_name` to link to.
#' @param link_loc [H5IdComponent-class] object giving the location where the
#'   new link should be created. Can represent an HDF5 file or group.
#' @param link_name Name (path) of the new link, relative to the location of
#'   `link_loc`.
#'
#' @examples
#' ## The example below creates a new HDF5 file in a temporary director, and then
#' ## links to the group "/foo" found in the file "multiple_dtypes.h5"
#' ## distributed with the package.
#'
#' h5File1 <- system.file("testfiles", "multiple_dtypes.h5", package = "rhdf5")
#' h5File2 <- tempfile(pattern = "H5L_2_", fileext = ".h5")
#' h5createFile(h5File2)
#'
#' ## open the new file & create a link to the group "/foo" in the original file
#' fid <- H5Fopen(h5File2)
#' H5Lcreate_external(
#'   target_file_name = h5File1, target_obj_name = "/foo",
#'   link_loc = fid, link_name = "/external_link"
#' )
#' H5Fclose(fid)
#'
#' ## check the new file has a group called "/external_link"
#' h5ls(h5File2)
#'
#' @export
H5Lcreate_external <- function(
  target_file_name,
  target_obj_name,
  link_loc,
  link_name
) {
  if (length(target_file_name) != 1 || !is.character(target_file_name)) {
    stop("'target_file_name' must be a character string of length 1")
  }
  target_file_name <- normalizePath(target_file_name, mustWork = FALSE)

  if (length(target_obj_name) != 1 || !is.character(target_obj_name)) {
    stop("'target_obj_name' must be a character string of length 1")
  }

  h5checktype(link_loc, "loc")

  if (length(link_name) != 1 || !is.character(link_name)) {
    stop("'link_name' must be a character string of length 1")
  }

  invisible(.Call(
    "_H5Lcreate_external",
    target_file_name,
    target_obj_name,
    link_loc@ID,
    link_name,
    PACKAGE = "rhdf5"
  ))
}

#' Confirm existence of a link
#'
#' @param h5loc An object of class [H5IdComponent-class] representing a H5
#'   location identifier (file or group).
#' @param name The name of the link to be checked
#'
#' @importFrom utils head
#' @export
H5Lexists <- function(h5loc, name) {
  h5checktype(h5loc, "loc")
  if (length(name) != 1 || !is.character(name)) {
    stop("'name' must be a character string of length 1")
  }

  name <- strsplit(name, split = "/", fixed = TRUE)[[1]]
  name <- name[nzchar(name)]
  Lexists <- TRUE
  i <- 1
  while ((i <= length(name)) && (Lexists)) {
    res <- .Call(
      "_H5Lexists",
      h5loc@ID,
      paste(head(name, n = i), collapse = "/"),
      PACKAGE = "rhdf5"
    )
    Lexists <- res > 0
    i <- i + 1
  }
  Lexists
}

#' Find information about a link
#'
#' @description  `H5Lget_info()` identifies the type of link specified by the the `h5loc`
#'   and `name` arguments. This is more limited than the equivalent function in
#'   the standard HDF5 library.
#'
#' @param h5loc An object of class [H5IdComponent-class] representing a H5
#'   location identifier (file or group).
#' @param name The name of the link to be queried.
#'
#' @returns A character vector of length 1 giving the type of link.  Possible
#'   values are:
#' `H5L_TYPE_HARD`, `H5L_TYPE_SOFT`, `H5L_TYPE_EXTERNAL`, `H5L_TYPE_ERROR`
#'
#' @export
H5Lget_info <- function(h5loc, name) {
  h5checktype(h5loc, "loc")
  if (length(name) != 1 || !is.character(name)) {
    stop("'name' must be a character string of length 1")
  }

  res <- .Call("_H5Lget_info", h5loc@ID, name, PACKAGE = "rhdf5")
  res$type <- h5const2String("H5L_TYPE", res$type)
  res
}

#' Remove a link from a group
#'
#' @param h5loc An object of class [H5IdComponent-class] representing a H5
#'   location identifier (file or group).
#' @param name The name of the link to be deleted.
#'
#' @examples
#'
#' h5file <- tempfile(pattern = "_ex_H5L.h5")
#'
#' # create an hdf5 file and a group
#' h5createFile(h5file)
#' h5createGroup(h5file, "/foo")
#'
#' # reopen file and confirm "/foo" exists but "/baa" does not
#' fid <- H5Fopen(h5file)
#' H5Lexists(fid, "/foo")
#'
#' # remove the link to "/foo" and confirm it no longer exists
#' H5Ldelete(fid, "/foo")
#' H5Lexists(fid, "/foo")
#'
#' H5Fclose(fid)
#'
#' @export
H5Ldelete <- function(h5loc, name) {
  h5checktype(h5loc, "loc")
  if (length(name) != 1 || !is.character(name)) {
    stop("'name' must be a character string of length 1")
  }

  if (!H5Lexists(h5loc, name)) {
    stop("Specified link doesn't exist.")
  }

  res <- .Call("_H5Ldelete", h5loc@ID, name, PACKAGE = "rhdf5")

  if (res < 0) {
    stop("Link deletion failed")
  }
  return(invisible(res))
}

#' Move a link within an HDF5 file
#'
#' @param h5loc An object of class [H5IdComponent-class] representing a H5
#'   location identifier (file or group) where the new link is placed.
#' @param name The name of the link to be moved.
#' @param h5loc_dest [H5IdComponent-class] object representing the H5 location
#'   where the new link should be created.
#' @param name_dest Name of the new link to be created
#' @param lcpl,lapl Link creation and link access property lists to be
#'   associated with the new link.  Leaving these arguments as `NULL` will use
#'   the HDF5 default property lists.
#'
#' @examples
#' ## create an HDF5 file with a single group
#' ## that contains a dataset of 10 numbers
#' h5file <- tempfile(fileext = ".h5")
#' h5createFile(h5file)
#' h5createGroup(h5file, "/foo")
#' h5write(1:10, h5file, name = "/foo/vector1")
#' ## check the structure is what we expect
#' h5ls(h5file)
#'
#' ## open the file, the group where the dataset currently is
#' ## and the root group
#' fid <- H5Fopen(name = h5file)
#' gid1 <- H5Gopen(fid, "/foo")
#' gid2 <- H5Gopen(fid, "/")
#' ## move the dataset to the root of the file and rename it
#' H5Lmove(gid1, "vector1", gid2, "vector_new")
#' h5closeAll()
#' ## check the dataset has moved out of the foo group
#' h5ls(h5file)
#'
#' ## we can also provide the ID of the HDF5 file
#' ## and use the "name" arguments to move between groups
#' fid <- H5Fopen(name = h5file)
#' H5Lmove(fid, "/vector_new", fid, "/foo/vector_newer")
#' H5Fclose(fid)
#' h5ls(h5file)
#'
#' @export
H5Lmove <- function(
  h5loc,
  name,
  h5loc_dest,
  name_dest,
  lcpl = NULL,
  lapl = NULL
) {
  h5checktype(h5loc, "loc")
  h5checktype(h5loc_dest, "loc")

  ## if not provided a creation property list, use the default
  if (is.null(lcpl)) {
    lcpl <- H5Pcreate("H5P_LINK_CREATE")
    on.exit(H5Pclose(lcpl), add = TRUE)
  } else {
    lcpl <- h5checktypeAndPLC(lcpl, "H5P_LINK_CREATE", allowNULL = FALSE)
  }

  ## use default access property list if not given
  if (is.null(lapl)) {
    lapl <- H5Pcreate("H5P_LINK_ACCESS")
    on.exit(H5Pclose(lapl), add = TRUE)
  } else {
    lapl <- h5checktypeAndPLC(lapl, "H5P_LINK_ACCESS", allowNULL = FALSE)
  }

  res <- .Call(
    "_H5Lmove",
    h5loc@ID,
    name,
    h5loc_dest@ID,
    name_dest,
    lcpl,
    lapl,
    PACKAGE = "rhdf5"
  )

  if (res < 0) {
    stop("Link deletion failed")
  }
  return(invisible(res))
}

#' Copy a link from one location to another
#'
#' @param h5loc An object of class [H5IdComponent-class] representing a H5
#' location identifier (file or group) where the new link is placed.
#' @param name The name of the link to be copied.
#' @param h5loc_dest An object of class [H5IdComponent-class] representing
#' the destination file or group where a copied or moved link should be created.
#' @param name_dest The name of the link to be created when copying or moving.
#' @param lcpl,lapl Link creation and link access property lists.  If left as
#' `NULL` the HDF5 defaults will be used.
#'
#' @export
H5Lcopy <- function(
  h5loc,
  name,
  h5loc_dest,
  name_dest,
  lcpl = NULL,
  lapl = NULL
) {
  h5checktype(h5loc, "loc")
  h5checktype(h5loc_dest, "loc")

  ## if not provided a creation property list, use the one from the source
  if (is.null(lcpl)) {
    lcpl <- H5Pcreate("H5P_LINK_CREATE")
    on.exit(H5Pclose(lcpl), add = TRUE)
  } else {
    lcpl <- h5checktypeAndPLC(lcpl, "H5P_LINK_CREATE", allowNULL = FALSE)
  }

  ## use default access property list if not given
  if (is.null(lapl)) {
    lapl <- H5Pcreate("H5P_LINK_ACCESS")
    on.exit(H5Pclose(lapl), add = TRUE)
  } else {
    lapl <- h5checktypeAndPLC(lapl, "H5P_LINK_ACCESS", allowNULL = FALSE)
  }

  res <- .Call(
    "_H5Lcopy",
    h5loc@ID,
    name,
    h5loc_dest@ID,
    name_dest,
    lcpl,
    lapl,
    PACKAGE = "rhdf5"
  )

  if (res < 0) {
    stop("Link deletion failed")
  }
  return(invisible(res))
}

library(rhdf5)

h5File <- withr::local_tempfile(pattern = "H5L_", fileext = ".h5")

expect_true(h5createFile(h5File))
expect_silent(h5write(matrix(1:20, ncol = 2), file = h5File, name = "foo"))

############################################################
context("H5L: Check existance")
############################################################

test_that("Links exist", {
  expect_silent(fid <- H5Fopen(h5File))

  expect_true(H5Lexists(fid, "foo"))
  expect_false(H5Lexists(fid, "baa"))
  expect_error(H5Lexists(fid, 1))

  expect_is(H5Lget_info(fid, "foo"), "list") %>%
    expect_length(n = 4) %>%
    expect_named(expected = c("type", "corder_valid", "corder", "cset"))

  ## this doesn't produce a nice error
  ## H5Lget_info(fid, "baa")

  expect_silent(H5Fclose(fid))
})

############################################################
context("H5Lcreate_external")
############################################################

h5File2 <- withr::local_tempfile(pattern = "H5L_2_", fileext = ".h5")

test_that("links can be created between files", {
  expect_true(h5createFile(h5File2))

  expect_silent(fid <- H5Fopen(h5File2))
  expect_silent(H5Lcreate_external(
    target_file_name = h5File,
    target_obj_name = "/foo",
    link_loc = fid,
    link_name = "external_link"
  ))
  expect_silent(H5Fclose(fid))

  expect_is(h5read(file = h5File2, name = "external_link"), "matrix") %>%
    expect_length(20)
})

############################################################
context("H5Ldelete")
############################################################

test_that("links can be deleted", {
  expect_silent(fid <- H5Fopen(h5File))
  expect_error(H5Ldelete(fid, name = "not_here"), regexp = "link doesn't exist")

  expect_error(
    H5Ldelete(fid, name = 1L),
    regexp = "'name' must be a character string of length 1"
  )
  expect_error(
    H5Ldelete(fid, name = c("foo", "baa")),
    regexp = "'name' must be a character string of length 1"
  )

  ## delete 'foo'
  expect_silent(H5Ldelete(fid, "/foo"))
  expect_silent(H5Fclose(fid))

  ## check there are now no entries left
  expect_is(res <- h5ls(h5File), "data.frame")
  expect_identical(nrow(res), 0L)
})

############################################################
context("Moving Links: H5Lmove")
############################################################

test_that("links can be moved within a file at the same level", {
  expect_silent(h5write(matrix(1:100, ncol = 10), file = h5File, name = "pos1"))
  expect_identical(h5ls(h5File)$name, "pos1")
  expect_silent(fid <- H5Fopen(h5File))
  expect_silent(H5Lmove(
    h5loc = fid,
    name = "pos1",
    h5loc_dest = fid,
    name_dest = "pos2"
  ))
  expect_silent(H5Fclose(fid))
  expect_identical(h5ls(h5File)$name, "pos2")
})


test_that("links can be moved to a new group", {
  expect_silent(fid <- H5Fopen(h5File))
  ## this fails if the group doesn't exist
  expect_error(H5Lmove(
    h5loc = fid,
    name = "pos2",
    h5loc_dest = fid,
    name_dest = "/foo/pos2"
  ))
  ## create the group and it works
  expect_silent(gid <- H5Gcreate(fid, name = "/foo"))
  expect_silent(H5Lmove(
    h5loc = fid,
    name = "pos2",
    h5loc_dest = fid,
    name_dest = "/foo/pos2"
  ))
  expect_silent(H5Gclose(gid))
  expect_silent(H5Fclose(fid))
  expect_identical(h5ls(h5File)$name, c("foo", "pos2"))

  ## we can also pass group ids
  fid <- H5Fopen(h5File)
  gid <- H5Gopen(fid, name = "/foo")
  expect_silent(H5Lmove(
    h5loc = gid,
    name = "pos2",
    h5loc_dest = gid,
    name_dest = "pos3"
  ))
  H5Gclose(gid)
  H5Fclose(fid)
  expect_identical(h5ls(h5File)$name, c("foo", "pos3"))
})


############################################################
context("Copy Links: H5Lcopy")
############################################################

test_that("links can be copied", {
  expect_silent(fid <- H5Fopen(h5File))
  expect_silent(H5Lcopy(
    h5loc = fid,
    name = "/foo/pos3",
    h5loc_dest = fid,
    name_dest = "/foo/pos4"
  ))
  expect_silent(H5Lcopy(
    h5loc = fid,
    name = "/foo/pos3",
    h5loc_dest = fid,
    name_dest = "pos5"
  ))
  H5Fclose(fid)
  contents <- h5ls(h5File)
  expect_identical(contents$group, c("/", "/foo", "/foo", "/"))
  expect_identical(contents$name, c("foo", "pos3", "pos4", "pos5"))
  expect_identical(h5read(h5File, "/foo/pos3"), h5read(h5File, "pos5"))
})

h5lsConvertToDataframe <- function(L, all = FALSE, native) {
  if (is.data.frame(L)) {
    L$ltype <- h5const2String("H5L_TYPE", L$ltype)
    L$otype <- h5const2String("H5I_TYPE", L$otype)
    if (!all) {
      L <- L[, c("group", "name", "otype", "dclass", "dim")]
    }
  } else {
    for (i in seq_along(L)) {
      L[i] <- list(h5lsConvertToDataframe(L[[i]], all = all, native = native))
    }
  }
  L
}

#' List the content of an HDF5 file.
#'
#' @param file The filename (character) of the file in which the dataset will
#' be located. You can also provide an object of class [H5IdComponent-class]
#' representing a H5 location identifier (file or group). See [H5Fcreate()],
#' [H5Fopen()], [H5Gcreate()], [H5Gopen()] to create an object of this kind.
#' @param recursive If `TRUE`, the content of the whole group hierarchy is
#' listed. If `FALSE`, Only the content of the main group is shown. If a positive
#' integer is provided this indicates the maximum level of the hierarchy that
#' is shown.
#' @param all If `TRUE`, a longer list of information on each entry is provided.
#' @param datasetinfo If `FALSE`, datatype and dimensionality information is not
#' provided. This can speed up the content listing for large files.
#' @param index_type See `h5const("H5_INDEX")` for possible arguments.
#' @param order See `h5const("H5_ITER")` for possible arguments.
#' @param s3 Logical value indicating whether the file argument should be
#' treated as a URL to an Amazon S3 bucket, rather than a local file path.
#' @param s3credentials A list of length three, providing the credentials for
#' accessing files in a private Amazon S3 bucket.
#' @param native An object of class `logical`. If TRUE, array-like objects
#' are treated as stored in HDF5 row-major rather than R column-major
#' orientation. Using `native = TRUE` increases HDF5 file portability
#' between programming languages. A file written with `native = TRUE`
#' should also be read with `native = TRUE`
#'
#' @returns `h5ls` returns a `data.frame` with the file content.
#'
#' @author Bernd Fischer, Mike L. Smith
#' @seealso [h5dump()]
#' @references <https://portal.hdfgroup.org/display/HDF5>
#' @keywords programming interface IO file
#' @examples
#'
#' h5File <- tempfile(pattern = "ex_dump.h5")
#' h5createFile(h5File)
#'
#' # create groups
#' h5createGroup(h5File, "foo")
#' h5createGroup(h5File, "foo/foobaa")
#'
#' # write a matrix
#' B <- array(seq(0.1, 2.0, by = 0.1), dim = c(5, 2, 2))
#' attr(B, "scale") <- "liter"
#' h5write(B, h5File, "foo/B")
#'
#' # list content of hdf5 file
#' h5ls(h5File, all = TRUE)
#'
#' # list content of an hdf5 file in a public S3 bucket
#' \donttest{
#' h5ls(file = "https://rhdf5-public.s3.eu-central-1.amazonaws.com/h5ex_t_array.h5", s3 = TRUE)
#' }
#'
#' @export
h5ls <- function(
  file,
  recursive = TRUE,
  all = FALSE,
  datasetinfo = TRUE,
  index_type = h5default("H5_INDEX"),
  order = h5default("H5_ITER"),
  s3 = FALSE,
  s3credentials = NULL,
  native = FALSE
) {
  if (isTRUE(s3)) {
    fapl <- H5Pcreate("H5P_FILE_ACCESS")
    on.exit(H5Pclose(fapl))
    H5Pset_fapl_ros3(fapl, s3credentials)
    loc <- h5checktypeOrOpenLocS3(
      file,
      readonly = TRUE,
      fapl = fapl,
      native = native
    )
  } else {
    loc <- h5checktypeOrOpenLoc(
      file,
      readonly = TRUE,
      fapl = NULL,
      native = native
    )
  }
  on.exit(h5closeitLoc(loc), add = TRUE)

  if (length(datasetinfo) != 1 || !is.logical(datasetinfo)) {
    stop("'datasetinfo' must be a logical of length 1")
  }
  index_type <- h5checkConstants("H5_INDEX", index_type)
  order <- h5checkConstants("H5_ITER", order)
  if (is.logical(recursive)) {
    if (recursive) {
      depth <- -1L
    } else {
      depth <- 1L
    }
  } else if (is.numeric(recursive)) {
    depth <- as.integer(recursive)
    if (length(recursive) > 1) {
      warning("'recursive' must be of length 1.  Only using first value.")
    } else if (recursive == 0) {
      stop(
        "value 0 for 'recursive' is undefined, either a positive integer or negative (maximum recursion)"
      )
    }
  } else {
    stop("'recursive' must be number or a logical")
  }
  di <- as.integer(datasetinfo)
  L <- .Call(
    "_h5ls",
    loc$H5Identifier@ID,
    depth,
    di,
    index_type,
    order,
    loc$H5Identifier@native,
    PACKAGE = "rhdf5"
  )
  h5lsConvertToDataframe(L, all = all, native = loc$H5Identifier@native)
}

#' Write an R object as an HDF5 attribute
#'
#' @param attr The R object to be written as an HDF5 attribute.
#' @param h5obj Normally an object of class [H5IdComponent-class] representing a
#'   H5 object identifier (file, group, or dataset). See
#'   [H5Fcreate()], [H5Fopen()], [H5Gcreate()],
#'   [H5Gopen()], [H5Dcreate()], or [H5Dopen()] to
#'   create an object of this kind.  This argument can also be given the path to
#'   an HDF5 file.
#' @param name The name of the attribute to be written.
#' @param h5loc The location of the group or dataset within a file to which the
#'   attribute should be attached. This argument is only used if the
#'   `h5obj` argument is the path to an HDF5 file, otherwise it is ignored.
#' @param encoding The encoding of the string data type. Valid options are
#'   "ASCII" and "UTF-8".
#' @param variableLengthString Whether character vectors should be written as
#'   variable-length strings into the attributes.
#' @param asScalar Whether length-1 `attr` should be written into a scalar
#'   dataspace.
#' @param checkForNA Whether a `attr` should be checked for `NA`
#'   values before being written.  This only applies of `attr` is of type
#'   logical.  Testing for `NA` values can be slow if the object to be
#'   written is large, so if you are sure no such values will be present this
#'   argument can be used to disable the testing.
#' @name h5_writeAttribute
#' @export
h5writeAttribute <- function(
  attr,
  h5obj,
  name,
  h5loc,
  encoding = NULL,
  variableLengthString = FALSE,
  asScalar = FALSE,
  checkForNA = TRUE
) {
  if (is(attr, "H5IdComponent")) {
    res <- h5writeAttribute.array(attr, h5obj, name, asScalar = TRUE)
  } else {
    res <- UseMethod("h5writeAttribute")
  }
  invisible(res)
}

#' @export
h5writeAttribute.matrix <- function(...) {
  h5writeAttribute.array(...)
}
#' @export
h5writeAttribute.integer <- function(...) {
  h5writeAttribute.array(...)
}
#' @export
h5writeAttribute.double <- function(...) {
  h5writeAttribute.array(...)
}
#' @export
h5writeAttribute.logical <- function(...) {
  h5writeAttribute.array(...)
}
#' @export
h5writeAttribute.character <- function(...) {
  h5writeAttribute.array(...)
}
#' @export
h5writeAttribute.default <- function(attr, h5obj, name, ...) {
  warning(
    "No function found to write attribute of class '",
    class(attr),
    "'. Attribute '",
    name,
    "' is not written to hdf5-file."
  )
}

#' @rdname h5_writeAttribute
h5writeAttribute.array <- function(
  attr,
  h5obj,
  name,
  h5loc,
  encoding = NULL,
  variableLengthString = FALSE,
  asScalar = FALSE,
  checkForNA = TRUE
) {
  if (is.character(h5obj) && file.exists(h5obj)) {
    fid <- H5Fopen(h5obj, flags = "H5F_ACC_RDWR")
    on.exit(H5Fclose(fid))
    h5obj <- H5Oopen(h5loc = fid, name = h5loc)
    on.exit(H5Oclose(h5obj), add = TRUE)
  } else {
    h5checktype(h5obj, "object")
  }

  if (asScalar) {
    if (length(attr) != 1L) {
      stop("cannot use 'asScalar=TRUE' when 'length(attr) > 1'")
    }
    dims <- NULL
  } else {
    dims <- dim(attr)
    if (is.null(dims)) {
      dims <- length(attr)
    }
  }

  size <- NULL
  if (storage.mode(attr) == "character" && !variableLengthString) {
    size <- max(nchar(attr, type = "bytes")) + 1
  }

  if (H5Aexists(h5obj, name)) {
    H5Adelete(h5obj, name)
  }
  storagemode <- storage.mode(attr)
  tid <- NULL
  if (storagemode == "S4" && is(attr, "H5IdComponent")) {
    storagemode <- "H5IdComponent"
  } else if (storagemode == "logical") {
    ## should check for NA values if required
    any_na <- checkForNA && anyNA(attr)

    tid <- H5Tenum_create(dtype_id = "H5T_NATIVE_UCHAR")
    H5Tenum_insert(tid, name = "TRUE", value = 1L)
    H5Tenum_insert(tid, name = "FALSE", value = 0L)
    if (any_na) {
      H5Tenum_insert(tid, name = "NA", value = 255L)
    }
  }

  h5createAttribute(
    h5obj,
    name,
    dims = dims,
    storage.mode = storagemode,
    size = size,
    H5type = tid,
    encoding = match.arg(encoding, choices = c("ASCII", "UTF-8", "UTF8"))
  )
  h5attr <- H5Aopen(h5obj, name)

  DimMem <- dim(attr)
  if (is.null(DimMem)) {
    DimMem <- length(attr)
  }
  h5spaceMem <- H5Screate_simple(DimMem)

  res <- H5Awrite(h5attr, attr)

  H5Sclose(h5spaceMem)
  H5Aclose(h5attr)
  invisible(res)
}

#' Select elements of a dataspace using R-style indexing
#'
#' Combines a hyperslab selection specified by `start`, `stride`, `count` and
#' `block` arguments with the current selection for the dataspace represented by
#' `h5space`.
#'
#' @details `H5Sselect_hyperslab` is similar to, but subtly different from,
#'   [H5Scombine_hyperslab()].  The former modifies the selection of the
#'   dataspace provided in the `h5space` argument, while the later returns a new
#'   dataspace with the combined selection.
#'
#' @param h5space [H5IdComponent-class] object representing a dataspace.
#' @param index A list of integer indices. The length of the list corresponds to
#'   the number of dimensions of the HDF5 array. If a list element is `NULL`,
#'   all elements of the respective dimension are selected.
#'
#' @examples
#'
#' ## create a 1 dimensional dataspace
#' sid <- H5Screate_simple(c(10, 5, 3))
#'
#' ## Select elements that lie in in the rows 1-3, columns 2-4,
#' ## and the entire 3rd dimension
#' H5Sselect_index(sid, list(1:3, 2:4, NULL))
#'
#' ## We can check the number of selected points.
#' ## This should be 27 (3 * 3 * 3)
#' H5Sget_select_npoints(sid)
#'
#' ## always close dataspaces after usage to free resources
#' H5Sclose(sid)
#'
#' @export
H5Sselect_index <- function(h5space, index) {
  h5checktype(h5space, "dataspace")
  dim <- H5Sget_simple_extent_dims(h5space)$size
  if (!is.list(index)) {
    index <- list(index)
  }

  if (length(index) != length(dim)) {
    stop("length of list index not equal to h5space dimensional extension.")
  }

  start <- list()
  count <- list()
  for (i in seq_along(index)) {
    if (is.null(index[[i]])) {
      start[[i]] <- 0
      count[[i]] <- as.numeric(dim[i])
    } else {
      if (any(index[[i]] > dim[i])) {
        stop("index exceeds HDF5-array dimension.")
      }
      if (any(index[[i]] <= 0)) {
        stop("negative indices and 0 not supported.")
      }
      ind <- sort(unique(index[[i]]))
      if (length(ind)) {
        test <- ind[seq_len(length(ind) - 1) + 1] - 1 !=
          ind[seq_len(length(ind) - 1)]
        I <- c(1, which(test) + 1)
      } else {
        I <- 1
      }
      start[[i]] <- ind[I] - 1
      I <- c(I, length(ind) + 1)
      count[[i]] <- I[seq_len(length(I) - 1) + 1] - I[seq_len(length(I) - 1)]
    }
  }
  size <- vapply(count, sum, numeric(1))
  if (!h5space@native) {
    start <- rev(start)
    count <- rev(count)
  }

  .Call("_H5Sselect_index", h5space@ID, start, count, PACKAGE = "rhdf5")
  invisible(size)
}

## internal version of H5Sselect_index.  The index_null argument is passed from
## h5readDataset and indicates whether an index was automatically generated as
## a response to NULL being passed.  These will always be a sequence along
## the respective dimension, so we can bypass some of the (slow) checks
.H5Sselect_index <- function(h5space, index, index_null) {
  h5checktype(h5space, "dataspace")
  dim <- H5Sget_simple_extent_dims(h5space)$size
  if (!is.list(index)) {
    index <- list(index)
  }

  if (length(index) != length(dim)) {
    stop("length of list index not equal to h5space dimensional extension.")
  }

  start <- list()
  count <- list()
  for (i in seq_along(index)) {
    ## no need to do these things if we're sure it's already sorted & unique
    if (index_null[i]) {
      ind <- index[[i]]
      I <- 1
    } else {
      if (any(index[[i]] > dim[i])) {
        stop("index exceeds HDF5-array dimension.")
      }
      if (any(index[[i]] <= 0)) {
        stop("negative indices and 0 not supported.")
      }
      ind <- sort(unique(index[[i]]))
      test <- diff(ind) > 1
      I <- c(1, which(test) + 1)
    }
    start[[i]] <- ind[I] - 1
    I <- c(I, length(ind) + 1)
    count[[i]] <- I[seq_len(length(I) - 1) + 1] - I[seq_len(length(I) - 1)]
  }
  size <- vapply(count, sum, numeric(1))
  if (!h5space@native) {
    start <- rev(start)
    count <- rev(count)
  }

  .Call("_H5Sselect_index", h5space@ID, start, count, PACKAGE = "rhdf5")
  invisible(size)
}

## check that the provided index doesn't violate
## and assumption on the size of the dataset
.validIndex <- function(index, dim) {
  if (any(index > dim)) {
    stop("index exceeds HDF5-array dimension.")
  }
  if (any(index <= 0)) {
    stop("negative indices and 0 not supported.")
  }
}

.H5Sselect_dim <- function(h5space, index) {
  h5checktype(h5space, "dataspace")
  dims <- H5Sget_simple_extent_dims(h5space)$size

  res_dim <- integer(length = length(dims))

  starts <- counts <- strides <- blocks <- list()

  ## creating the set of hyperslabs in each dimension
  for (i in seq_along(index)) {
    if (is.null(index[[i]])) {
      ## null index implies we want everything in this dimension
      res_dim[i] <- dims[i]
      starts[[i]] <- 1
      counts[[i]] <- 1
      strides[[i]] <- 1
      blocks[[i]] <- as.numeric(dims[i])
    } else if (length(index[[i]]) == 0) {
      .validIndex(index[[i]], dims[i])
      res_dim[i] <- 0
      starts[[i]] <- NA
      counts[[i]] <- 0
      strides[[i]] <- 1
      blocks[[i]] <- 1
    } else if (length(index[[i]]) == 1) {
      ## catch the special case of only requesting a single entry
      ## in this dimension. This breaks the loop below in its current form.

      .validIndex(index[[i]], dims[i])

      res_dim[i] <- 1
      starts[[i]] <- index[[i]][1]
      counts[[i]] <- 1
      strides[[i]] <- 1
      blocks[[i]] <- 1
    } else {
      ## two or more entries from this dim

      .validIndex(index[[i]], dims[i])

      index_copy <- sort(unique(floor(index[[i]])))
      res_dim[i] <- length(index_copy)
      start <- count <- stride <- block <- NULL

      ## selecting the optimal break up of the indices
      ## This is not optimised!  We check lags 1:10 and pick the
      ## value with the fewest number of runs.
      if (length(index_copy) > 1) {
        # nolint next: undesirable_function_linter.
        lag <- which.min(sapply(
          seq_len(min(10, length(index_copy) - 1)),
          FUN = function(i, index_copy) {
            i + length(rle(diff(index_copy, lag = i))$lengths)
          },
          index_copy
        ))
      } else {
        lag <- 1
      }

      ## HDF 1.10.7 seems to have a bug in combined hyperslabs when 'start' parameters
      ## are not in increasing order. This operation ensures we don't have a 0-th group
      ## that would be used first, but is really our lag-th group
      hyperslab_groups <- seq_along(index_copy) %% lag
      hyperslab_groups[hyperslab_groups == 0] <- lag
      indices <- split(index_copy, hyperslab_groups)

      for (j in seq_len(lag)) {
        if (length(indices[[j]]) == 1) {
          ## no sequence, just a single entry
          start <- c(start, indices[[j]][1])
          count <- c(count, 1)
          stride <- c(stride, 1)
          ## block is always 1, so define outside of the loop
        } else {
          ## rle for this subset of indices
          differences <- rle(diff(indices[[j]]))
          diff_idx <- 1
          index_copy_idx <- 1

          while (index_copy_idx <= length(indices[[j]])) {
            start <- c(start, indices[[j]][index_copy_idx])
            count <- c(count, differences$lengths[diff_idx] + 1)
            stride <- c(stride, differences$values[diff_idx])
            ## block is always 1, so define outside of the loop

            index_copy_idx <- index_copy_idx + differences$lengths[diff_idx] + 1
            diff_idx <- diff_idx + 1
            if (
              differences$lengths[diff_idx] == 1 &&
                diff_idx < length(differences$lengths)
            ) {
              diff_idx <- diff_idx + 1
            } else {
              differences$lengths[diff_idx] <- differences$lengths[diff_idx] - 1
            }
          }
        }
      }
      block <- rep(1, length(start))

      starts[[i]] <- start
      counts[[i]] <- count
      strides[[i]] <- stride
      blocks[[i]] <- block
    }
  }

  ## create all combinations of hyperslab parameters
  ## using as.matrix() here is more efficient than doing it later
  starts2 <- as.matrix(expand.grid(starts))
  strides2 <- as.matrix(expand.grid(strides))
  counts2 <- as.matrix(expand.grid(counts))
  blocks2 <- as.matrix(expand.grid(blocks))

  for (i in seq_len(nrow(starts2))) {
    op <- ifelse(i == 1, "H5S_SELECT_SET", "H5S_SELECT_OR")
    H5Sselect_hyperslab(
      h5space,
      op = op,
      start = starts2[i, ],
      stride = strides2[i, ],
      count = counts2[i, ],
      block = blocks2[i, ]
    )
  }

  invisible(res_dim)
}

#' HDF5 General Library Functions
#'
#' @description These low level functions provide general library functions for HDF5.
#'
#' @returns
#' * `H5open` initializes the HDF5 library.
#' * `H5close` flushes all data to disk, closes all open identifiers, and cleans up memory.
#' * `H5garbage_collect` cleans up memory.
#' * `H5get_libversion` returns the version number of the HDF5 C-library.
#'
#' @author Bernd Fischer, Mike Smith
#' @examples
#' \dontrun{
#' H5open()
#' H5close()
#' H5garbage_collect()
#' H5get_libversion()
#' }
#' @name H5functions
NULL

#' @rdname H5functions
#' @export
H5open <- function() {
  invisible(.Call("_H5open", PACKAGE = "rhdf5"))
}

#' @rdname H5functions
#' @export
H5close <- function() {
  invisible(.Call("_H5close", PACKAGE = "rhdf5"))
}

#' @rdname H5functions
#' @export
H5garbage_collect <- function() {
  invisible(.Call("_H5garbage_collect", PACKAGE = "rhdf5"))
}

#' @rdname H5functions
#' @export
H5get_libversion <- function() {
  .Call("_H5get_libversion", PACKAGE = "rhdf5")
}

#' Close open HDF5 handles
#'
#' This functions can be used in two ways.  Firstly, it can be passed one or
#' more [H5IdComponent-class] objects and it'll will try to close all of them
#' regardless of the whether they represent a file, group, dataset etc.  This
#' can be easier than making multiple calls to [H5Fclose()], [H5Gclose()], etc.
#'
#' Secondly, occasionally references to HDF5 files, groups, datasets etc can be
#' created and not closed correctly.  Maybe because a function stopped before
#' getting to the close statement, or the open handle was not assigned to an R
#' variable.  If no arguments are provide this function identifies all open
#' handles and closes them.
#'
#' @param ... One or more objects of class [H5IdComponent-class] which should be
#'   closed.  If nothing is provided to the function, all open handles will be
#'   closed.
#'
#' @returns Doesn't return anything. Called for the side-effect of closing open
#'   HDF5 handles.
#'
#' @author Mike Smith
#' @keywords IO file
#' @examples
#'
#'
#' ## create an empty file and then re-open it
#' h5File <- tempfile(pattern = "ex_h5closeAll.h5")
#' h5createFile(h5File)
#' H5Fopen(h5File)
#'
#' ## list all open identifiers
#' h5listIdentifier()
#'
#' ## close all open identifiers and verify
#' h5closeAll()
#' h5listIdentifier()
#'
#' @export h5closeAll
h5closeAll <- function(...) {
  objects <- list(...)
  if (length(objects) == 0) {
    objects <- h5validObjects()
  }
  invisible(lapply(objects, .H5close))
}

.H5close <- function(h5id) {
  isvalid <- H5Iis_valid(h5id)
  if (!isvalid) {
    stop("Error in h5closeAll(). H5Identifier not valid.", call. = FALSE)
  }

  truetype <- as.character(H5Iget_type(h5id))

  closeFunc <- switch(
    truetype,
    H5I_FILE = H5Fclose,
    H5I_GROUP = H5Gclose,
    H5I_DATASET = H5Dclose,
    H5I_GENPROP_LST = H5Pclose,
    H5I_DATASPACE = H5Sclose,
    H5I_ATTR = H5Aclose,
    stop(
      "Error in h5closeAll(). Appropriate close function not found",
      call. = FALSE
    )
  )

  closeFunc(h5id)
}

library(rhdf5)

## disable file locking if required e.g. Solaris, Lustre, NFS etc
if (!h5testFileLocking(tempdir())) {
  h5disableFileLocking()
}

############################################################
context("H5: basic HDF5 functions")
############################################################

test_that("General library functions", {
  expect_silent(H5open())
  expect_silent(H5garbage_collect())
  # expect_silent( H5close() )
  expect_is(H5get_libversion(), "integer") %>%
    expect_named(c("majnum", "minnum", "relnum"))
})

############################################################
context("H5: closing everything")
############################################################

h5File <- withr::local_tempfile(pattern = "H5_", fileext = ".h5")

test_that("h5closeAll closed everything", {
  ## file
  fid <- H5Fcreate(h5File)
  ## dataspace
  sid <- H5Screate_simple(c(10, 5, 3))
  ## dataset
  did <- H5Dcreate(
    fid,
    name = "dataset",
    dtype_id = "H5T_NATIVE_INT8",
    h5space = sid
  )
  ## group
  gid <- H5Gcreate(fid, name = "group")
  ## property list
  ## attribute
  aid <- H5Acreate(did, "volume", "H5T_NATIVE_INT8", sid)
  ## object

  expect_identical(nrow(h5listIdentifier()), 5L)

  expect_silent(h5closeAll())

  ## should be nothing left open
  expect_identical(nrow(h5listIdentifier()), 0L)
})

library(rhdf5)

context("h5save function")
## h5save doesn't close files, so we have to use h5closeAll() after every call!

A <- 1:7
B <- 1:18
D <- seq(0, 1, by = 0.1)
## output file name
h5File <- withr::local_tempfile(pattern = "ex_save", fileext = ".h5")

test_that("Default arguments", {
  expect_silent(h5save(A, B, D, file = h5File))
  h5closeAll()
})

test_that("File exists", {
  expect_true(file.exists(h5File))
  ## remove it for now, we should check overwriting later
  file.remove(h5File)
})

test_that("Changing dataset names", {
  dsetNames <- c("dset1", "dset2", "dset3")
  expect_silent(h5save(A, B, D, file = h5File, name = dsetNames))
  h5closeAll()
  expect_true(file.exists(h5File))
  expect_identical(names(h5dump(h5File)), dsetNames)
})

test_that("Error on wrong number of names", {
  expect_error(h5save(A, B, file = h5File, name = "A"))
  expect_error(h5save(A, B, file = h5File, name = c("A", "B", "C")))
})

test_that("Fail if file doesn't exist", {
  if (file.exists(h5File)) {
    file.remove(h5File)
  }
  expect_error(h5save(A, B, D, file = h5File, createnewfile = FALSE))
  h5closeAll()
})

# test_that("Suppress Internal error messages", {
#    h5errorHandling(type = "suppress")
# })

test_that("Adding to existing file", {
  h5save(A, file = h5File)
  h5closeAll()
  expect_identical(names(h5dump(h5File)), "A")

  h5save(B, D, file = h5File)
  h5closeAll()
  expect_identical(names(h5dump(h5File)), c("A", "B", "D"))
})

test_that("Try to overwrite existing data set with same name", {
  if (file.exists(h5File)) {
    file.remove(h5File)
  }

  expect_null(h5save(A, file = h5File))
  h5closeAll()

  ## this will throw an HDF5 error, but I don't know how to catch it yet
  h5errorHandling(type = "suppress")
  expect_null(h5save(B, file = h5File, name = "A"))
  h5closeAll()

  expect_false(identical(h5read(file = h5File, name = "A"), B))
})

## currently fails hard!
# test_that("Name can take a path", {
#     if(file.exists(h5File))
#         file.remove(h5File)
#
#     h5save(A, file = h5File, name = "/foo/baa")
#     H5close()
# })

#' List all open HDF5 objects.
#'
#' A list of all valid HDF5 identifiers. H5 objects should be closed after usage
#' to release resources.
#'
#' @param native An object of class `logical`. If TRUE, array-like objects
#' are treated as stored in HDF5 row-major rather than R column-major
#' orientation. Using `native = TRUE` increases HDF5 file portability
#' between programming languages. A file written with `native = TRUE`
#' should also be read with `native = TRUE`
#' @returns `h5validObjects` returns a list of [H5IdComponent-class]
#' objects. `h5listIdentifier` prints the valid identifiers on screen and
#' returns NULL.
#' @author Bernd Fischer, Mike Smith
#' @examples
#'
#' h5File <- tempfile("ex_list_identifier.h5")
#'
#' h5createFile(h5File)
#'
#' # create groups
#' h5createGroup(h5File, "foo")
#'
#' h5listIdentifier()
#' h5validObjects()
#'
#' @name h5listObjects
NULL

#' @rdname h5listObjects
#' @export h5listIdentifier
h5listIdentifier <- function() {
  res <- .Call("_h5listIdentifier", PACKAGE = "rhdf5")
  res$type <- h5const2String("H5I_TYPE", res$type)
  res <- as.data.frame(res)
  res
}

#' @rdname h5listObjects
#' @export h5validObjects
h5validObjects <- function(native = FALSE) {
  ids <- .Call("_h5validObjects", PACKAGE = "rhdf5")
  res <- list()
  for (i in seq_along(ids)) {
    res[[i]] <- new("H5IdComponent", ID = ids[i], native = native)
  }
  res
}

h5listOpenObjects <- function(h5file) {
  h5checktype(h5file, "file")
  invisible(.Call("_h5listOpenObjects", h5file@ID, PACKAGE = "rhdf5"))
}

getDatatypeName <- function(type) {
  .Call("_getDatatypeName", type, PACKAGE = "rhdf5")
}

getDatatypeClass <- function(type) {
  .Call("_getDatatypeClass", type, PACKAGE = "rhdf5")
}

#' Print the rhdf5 and libhdf5 version numbers
#'
#' Returns the version number of the Bioconductor package rhdf5 and the
#' C-library libhdf5.
#'
#'
#' @returns A list of major, minor and release number.
#' @author Bernd Fischer, Mike L. Smith
#' @examples
#'
#' h5version()
#'
#' @importFrom utils packageVersion
#' @export h5version
h5version <- function() {
  part1 <- sprintf(
    "This is Bioconductor rhdf5 %s linking to C-library HDF5 %s (Rhdf5lib version: %s)",
    as.character(packageVersion("rhdf5")),
    paste(H5get_libversion(), collapse = "."),
    as.character(packageVersion("Rhdf5lib"))
  )

  part2 <- ifelse(
    requireNamespace("rhdf5filters"),
    paste0(" and rhdf5filters ", as.character(packageVersion("rhdf5filters"))),
    ""
  )
  message(part1, part2)
  invisible(NULL)
}

library(rhdf5)

############################################################
context("Utility functions")
############################################################

test_that("Printing library versions", {
  expect_message(
    h5version(),
    regexp = "This is Bioconductor rhdf5 [0-9.]+ linking to C-library HDF5 [0-9.]+"
  )
})

test_that("We can list created objects", {
  fid <- H5Fcreate(name = withr::local_tempfile())

  expect_is(objects_frame <- h5listIdentifier(), "data.frame")
  expect_is(valid_objects <- h5validObjects(), "list")

  expect_identical(dim(objects_frame), c(1L, 2L))
  expect_length(valid_objects, 1L)

  ## create another objects
  sid <- H5Screate()

  expect_identical(dim(h5listIdentifier()), c(2L, 2L))
  expect_length(h5validObjects(), 2L)

  ## now close them
  H5Sclose(sid)
  H5Fclose(fid)

  expect_identical(dim(h5listIdentifier()), c(0L, 2L))
  expect_length(h5validObjects(), 0)
})

# test_that("Find location of libray", {
#
#    expect_output( Rhdf5lib:::pkgconfig(), regexp = "libhdf5" )
#
#    path <- capture.output( Rhdf5lib:::pkgconfig() )
#    if( Sys.info()[['sysname']] != "Windows" ) {
#        libfile <- gsub(pattern = "^-l", replacement = "", x = path)
#        expect_true( file.exists(libfile) )
#    }
# })

#' H5R - References to objects and regions
#'
#' @description The `H5R` functions can be used for creating or working with
#'   references to specific objects and data regions in an HDF5 file.
#'
#' @author Mike Smith
#' 
#' @examples
#' library(rhdf5)
#' 
#' ## first we'll create a file with a group named "foo" and a
#' ## 1-dimensional dataset named "baa" inside that group.
#' file_name <- tempfile(fileext = ".h5")
#' h5createFile(file_name)
#' h5createGroup(file = file_name, group = "/foo")
#' h5write(1:100, file=file_name, name="/foo/baa")
#'
#'
#' fid <- H5Fopen(file_name)
#' ref_to_group <- H5Rcreate(fid, name = "/foo")
#' ref_to_dataset <- H5Rcreate(fid, name = "/foo/baa")
#' two_refs <- c(ref_to_group, ref_to_dataset)
#' two_refs
#'
#' ## the size of this dataspace is the number of object references
#' ## we want to store
#' sid <- H5Screate_simple(2)
#' tid <- H5Tcopy(dtype_id = "H5T_STD_REF_OBJ")
#' did <- H5Dcreate(fid, name = "object_refs", dtype_id = tid, h5space = sid)
#' H5Dwrite(did, two_refs)
#' H5Dclose(did)
#' H5Sclose(sid)
#' H5Fclose(fid)
#'
#' @name H5R
NULL


#' Create a reference
#' 
#' Creates a reference to an object or dataset selection inside an HDF5 file.
#' 
#' @param h5loc An `H5IdComponent` object representing the location to be pointed to
#' by the created reference.
#' @param name Character string giving the name of the object to be referenced, 
#' relative to the location given by `h5loc`.
#' @param ref_type The type of reference to create.  Accepts either `H5R_OBJECT`
#' or `H5R_DATASET_REGION`.
#' @param h5space An object of class `H5IdComponent` representing a dataspace
#' with a selection set.  This argument is only used if creating a 
#' reference to a dataset region, and will be ignored otherwise.
#' 
#' @return An [H5Ref-class] object storing the reference. 
#' 
#' @export
H5Rcreate <- function(h5loc, name, ref_type = "H5R_OBJECT", h5space = NULL) {
  
  ref_type <- h5checkConstants( "H5R_TYPE", ref_type)
  h5checktypeOrNULL(h5space, type = "dataspace")
  if(is.null(h5space)) {
    if(h5const2String("H5R_TYPE", ref_type) == "H5R_DATASET_REGION") {
      stop("H5R_DATASET_REGION references must be accompanied by a H5 dataspace.")
    } else {
      ## we pass a dataspace ID of -1 if this is an object reference
      h5space <- new("H5IdComponent", ID = "-1", native = FALSE)
    }
  }
  
  ptr <- .Call("_H5Rcreate", h5loc@ID, name, ref_type, h5space@ID, PACKAGE = "rhdf5")
  ref <- new("H5Ref", val = ptr, type = ref_type)
  
  return(ref)
}

#' Open a reference object.
#'
#' Given a reference and the file to which that reference applies,
#' `H5Rdeference()` will open the reference object and return an identifier.
#'
#' @details If `ref` contains more than one reference, only the first reference
#'   will be used.  It must be subset with `[` if one of the other stored
#'   references should be opened.
#'
#' @param ref `H5ref` object containing the reference to be opened.
#' @param h5loc An `H5IdComponent` object representing the file containing the
#'   referenced object.
#'
#' @return An object of class `H5IdComponent` representing the opened object
#'   referenced by `ref`.  This should be closed with the appropriate function
#'   e.g. [H5Dclose()], [H5Oclose()], etc. when no longer needed.
#'
#' @export
H5Rdereference <- function(ref, h5loc) {
  
  oid <- .Call("_H5Rdereference", h5loc@ID, ref@type, ref@val, PACKAGE = "rhdf5")
  obj <- new("H5IdComponent", ID = oid, native = FALSE)
  return(obj)
}

#' Return the name of the object that a reference points to
#'
#' @param ref `H5ref` object containing the reference to be queried.
#' @param h5loc An `H5IdComponent` object representing the file containing the
#'   referenced object.
#'
#' @return Character string of length 1 giving the name of the referenced
#'   object.
#'
#' @export
H5Rget_name <- function(ref, h5loc) {

  name <- .Call("_H5Rget_name", h5loc@ID, ref@type, ref@val, PACKAGE = "rhdf5")
  return(name)
}

#' Identify the type of object that a reference points to
#' 
#' @param ref `H5ref` object containing the reference to be queried.
#' @param h5loc An `H5IdComponent` object representing the file containing the
#'   referenced object.
#'   
#' @return Character string of length 1 identifying the object type.  Valid return
#' values are: `"GROUP"`, `"DATASET"`, and `"NAMED_DATATYPE"`.
#' 
#' @export
H5Rget_obj_type <- function(ref, h5loc) {
  
  object_type <- .Call("_H5Rget_obj_type", h5loc@ID, ref@type, ref@val, PACKAGE = "rhdf5")
  return(object_type)
}

#' Return selection for a reference to dataset region
#' 
#' Given a dataset region reference, this function will return the dataspace
#' and selection required to read the data points indicated by the reference.
#' 
#' @param ref An object of class `H5Ref`.  This function is only valid
#' for reference of type `H5R_DATASET_REGION`, and not `H5R_OBJECT`.
#' @param h5loc An `H5IdComponent` object representing the file containing the
#'   referenced object.
#'
#' @return An object of class `H5IdComponent` representing the dataspace of the
#'   dataset that `ref` points to.  The dataspace will have the selection set
#'   that matches the selection pointed to by `ref`. This should be closed using
#'   [H5Sclose()] when no longer required.
#'
#' @export
H5Rget_region <- function(ref, h5loc) {
  
  if(h5const2String("H5R_TYPE", ref@type) != "H5R_DATASET_REGION") {
    stop("Only references of type H5R_DATASET_REGION can be used.")
  }
  
  space_id <- .Call("_H5Rget_region", h5loc@ID, ref@type, ref@val, PACKAGE = "rhdf5")
  h5space <- new("H5IdComponent", ID = space_id, native = FALSE)
  return(h5space)
}

library(rhdf5)

h5File <- withr::local_tempfile(pattern = "ex_H5R_", fileext = ".h5")
h5createFile(h5File)
h5createGroup(file = h5File, group = "/foo")
h5write(1:100, file = h5File, name = "/foo/baa")

fid <- H5Fopen(h5File)

test_that("object references can be created", {
  expect_silent(ref_to_group <- H5Rcreate(fid, name = "/foo"))
  expect_silent(ref_to_dataset <- H5Rcreate(fid, name = "/foo/baa"))

  expect_is(ref_to_group, "H5Ref")
  expect_is(ref_to_dataset, "H5Ref")

  expect_identical(H5Rget_name(ref = ref_to_group, h5loc = fid), "/foo")
  expect_identical(H5Rget_name(ref = ref_to_dataset, h5loc = fid), "/foo/baa")

  expect_identical(H5Rget_obj_type(ref = ref_to_group, h5loc = fid), "GROUP")
  expect_identical(
    H5Rget_obj_type(ref = ref_to_dataset, h5loc = fid),
    "DATASET"
  )

  expect_silent(gid <- H5Rdereference(ref = ref_to_group, h5loc = fid)) |>
    expect_is("H5IdComponent")
  expect_silent(did <- H5Rdereference(ref = ref_to_dataset, h5loc = fid)) |>
    expect_is("H5IdComponent")

  H5Gclose(gid)
  H5Dclose(did)
})


## get the dataspace for /foo/baa and select three points
did <- H5Dopen(fid, name = "/foo/baa")
h5space <- H5Dget_space(did)
H5Sselect_index(h5space = h5space, c(4, 7, 50))
H5Dclose(did)

test_that("dataset region references can be created", {
  expect_silent(
    ref_to_region <- H5Rcreate(
      fid,
      name = "/foo/baa",
      ref_type = "H5R_DATASET_REGION",
      h5space = h5space
    )
  )

  expect_is(ref_to_region, "H5Ref")

  expect_identical(H5Rget_name(ref = ref_to_region, h5loc = fid), "/foo/baa")

  expect_silent(sid <- H5Rget_region(ref = ref_to_region, h5loc = fid)) |>
    expect_is("H5IdComponent")
  expect_identical(H5Sget_select_npoints(sid), 3)

  expect_identical(H5Rget_obj_type(ref = ref_to_region, h5loc = fid), "DATASET")

  expect_silent(did <- H5Rdereference(ref = ref_to_region, h5loc = fid)) |>
    expect_is("H5IdComponent")

  H5Sclose(sid)
  H5Dclose(did)
})

test_that("H5R error checking works", {
  expect_error(
    H5Rcreate(fid, name = "/foo/baa", ref_type = "H5R_DATASET_REGION"),
    regexp = "H5R_DATASET_REGION references must be accompanied by a H5 dataspace"
  )

  ref_to_dataset <- H5Rcreate(fid, name = "/foo/baa")
  expect_error(
    H5Rget_region(ref = ref_to_dataset, h5loc = fid),
    "Only references of type H5R_DATASET_REGION can be used"
  )
})

test_that("H5Ref methods work", {
  object_ref <- H5Rcreate(fid, name = "/foo/baa", ref_type = "H5R_OBJECT")
  region_ref <- H5Rcreate(
    fid,
    name = "/foo/baa",
    ref_type = "H5R_DATASET_REGION",
    h5space = h5space
  )

  expect_silent(object_ref2 <- c(object_ref, object_ref)) |>
    expect_is("H5Ref")
  expect_silent(region_ref2 <- c(region_ref, region_ref)) |>
    expect_is("H5Ref")

  expect_error(
    c(object_ref, region_ref),
    "All references must be of the same type"
  )
  expect_error(c(object_ref, 1:10), "All objects must be of class 'H5Ref'")

  ## object and region references are different internally but not externally
  expect_identical(length(object_ref), 1L)
  expect_identical(length(object_ref2), 2L)
  expect_identical(length(region_ref), 1L)
  expect_identical(length(region_ref2), 2L)

  expect_identical(length(object_ref[2]), 1L)
  expect_equivalent(object_ref[1], object_ref[2])
})

H5Sclose(h5space)
H5Fclose(fid)

#' @describeIn H5IdComponent Print details of the object to screen.
#'
#' @export
setMethod("show", signature = "H5IdComponent", function(object) {
  res <- .Call("_handleInfo", object@ID, PACKAGE = "rhdf5")
  res$type <- h5const2String("H5I_TYPE", res$type)
  res$type <- substr(res$type, 5, 1000)
  cat(sprintf("HDF5 %s", res$type), if (object@native) "(native)", "\n")
  if (res$type == "DATASPACE") {
    res2 <- H5Sget_simple_extent_dims(object)
    res$info <- c(
      res$info,
      rank = res2$rank,
      size = paste(res2$size, collapse = " x "),
      maxsize = paste(res2$maxsize, collapse = " x ")
    )
  }
  if (res$type == "DATASET") {
    s <- H5Dget_space(object)
    on.exit(H5Sclose(s))
    res2 <- H5Sget_simple_extent_dims(s)
    res$info <- c(
      res$info,
      type = .Call("_getDatatypeName", H5Dget_type(object), PACKAGE = "rhdf5"),
      rank = res2$rank,
      size = paste(res2$size, collapse = " x "),
      maxsize = paste(res2$maxsize, collapse = " x ")
    )
  }
  if (res$type == "ATTR") {
    s <- H5Aget_space(object)
    on.exit(H5Sclose(s))
    res2 <- H5Sget_simple_extent_dims(s)
    names(res$info)[names(res$info) == "name"] <- "objName"
    res$info <- c(
      res$info,
      attrName = H5Aget_name(object),
      type = .Call("_getDatatypeName", H5Aget_type(object), PACKAGE = "rhdf5"),
      rank = res2$rank,
      size = paste(res2$size, collapse = " x "),
      maxsize = paste(res2$maxsize, collapse = " x ")
    )
  }
  if (res$type == "DATATYPE") {
    res$info <- c(
      res$info,
      type = .Call("_getDatatypeName", object@ID, PACKAGE = "rhdf5")
    )
  }
  if (!is.null(res$info)) {
    cat(paste(sprintf("%12s %s\n", names(res$info), res$info), collapse = ""))
  }
  if (res$type %in% c("FILE", "GROUP")) {
    cat("\n")
    x <- h5ls(object, recursive = FALSE)
    x <- format(x, justify = "left")
    x <- x[, -1]
    print(x)
  }
  if (!res$isvalid) {
    cat("\nNo valid identifier.\n")
  }
})


#' @describeIn H5IdComponent Returns a group handle or dataset handle for the
#'   group or dataset `name` in the HDF5 location `h5loc`. `h5loc` can either be a file handle
#'   as returned by [H5Fopen] or a group handle as e.g. returned by `h5f$g1` or
#'   `h5f$'/g1/g2'`.
#'
#' @param e1 An `H5IdComponent` object representing an H5 file or group.
#' @param e2 Character giving the path to an HDF5 group or dataset relative to `e1`.
#'
#' @export
setMethod(`&`, signature = c("H5IdComponent", "character"), function(e1, e2) {
  H5Oopen(e1, e2)
})

#' @describeIn H5IdComponent Reads the HDF5 object `name` in the HDF5 location `x`. `x` can either be
#'   a file handle as returned by [H5Fopen()] or a group handle as e.g. returned by
#'   `h5f$g1` or `h5f$'/g1/g2'`.
#'
#' @param x An `H5IdComponent` object representing an H5 file or group.
#' @param name Character giving the path to an HDF5 group or dataset relative to `x`.
#'
#' @export
setMethod(`$`, signature = "H5IdComponent", function(x, name) {
  h5id <- x
  isvalid <- H5Iis_valid(h5id)
  if (!isvalid) {
    stop("Bad HDF5 ID. File, group, or dataset closed?", call. = FALSE)
  }
  truetype <- H5Iget_type(h5id)
  #   par = list(file=h5id, name=name)
  #   if ( .hasSlot(h5id, "par") ) {
  #     par = c(par, h5id@par[names(h5id@par) %in% c("compoundAsDataFrame","read.attributes")])
  #   }
  if (!truetype %in% c("H5I_FILE", "H5I_GROUP")) {
    stop(
      "The provided H5Identifier is not a location identifier.",
      call. = FALSE
    )
  }
  h5read(file = h5id, name = name)

  #
  #   else {
  #     if (truetype == "H5I_DATASET") {
  #       h5a = H5Aopen(h5obj = h5id, name=)
  #       res = h5readAttributes(h5id, name = name)
  #     } else {
  #       stop("The provided H5Identifier is neither a location identifier nor a dataset identifier.",
  #            call. = FALSE)
  #     }
  #   }
})

#' @describeIn H5IdComponent Writes the assigned object to to the HDF5 file at
#'   location e1. e1 can either be a file handle as returned by [H5Fopen()] or a
#'   group handle as e.g. returned by h5f$g1 or h5f$'/g1/g2's. The storage.mode
#'   of the assigned object has to be compatible to the datatype of the HDF5
#'   dataset. The dimension of the assigned object have to be identical the
#'   dimensions of the HDF5 dataset. To create a new HDF5 dataset with specific
#'   properties (e.g. compression level or chunk size), please use the function
#'   [h5createDataset()] first.
#'
#' @export
setMethod(`$<-`, signature = "H5IdComponent", function(x, name, value) {
  h5id <- x
  isvalid <- H5Iis_valid(h5id)
  if (!isvalid) {
    stop("Bad HDF5 ID. File, group, or dataset closed?", call. = FALSE)
  }
  truetype <- H5Iget_type(h5id)
  if (!truetype %in% c("H5I_FILE", "H5I_GROUP")) {
    stop(
      "The provided H5Identifier is not a location identifier.",
      call. = FALSE
    )
  }
  h5write(value, file = h5id, name = name)
  h5id
})


#' @describeIn H5IdComponent Subsetting of an HDF5 dataset. The function reads a
#'   subset of an HDF5 dataset. The given dimensions have to fit the dimensions
#'   of the HDF5 dataset.
#'
#' @param x Object of class `H5IdComponent` representing the HDF5 dataset from
#'   which to extract element(s) or in which to replace element(s).
#' @param i,j,\dots Indices specifying elements to extract or replace. Indices
#'   are `numeric` vectors or empty (missing) or `NULL`.  Numeric
#'   values are coerced to integer as by [base::as.integer()] (and
#'   hence truncated towards zero).
#' @param drop If `TRUE` the result is coerced to the lowest possible dimension
#'   (see the examples).  This only works for extracting elements, not for the
#'   replacement.  See [base::drop()] for further details.
#'
#' @export
setMethod(
  "[",
  signature = c("H5IdComponent", "ANY", "ANY", "ANY"),
  function(x, i, j, ..., drop = TRUE) {
    h5id <- x
    index <- extract_Nindex_from_syscall(sys.call(), parent.frame())

    isvalid <- H5Iis_valid(h5id)
    if (!isvalid) {
      stop("Bad HDF5 ID. Dataset closed?", call. = FALSE)
    }
    truetype <- H5Iget_type(h5id)
    if (truetype != "H5I_DATASET") {
      stop(
        "The provided H5Identifier is not a dataset identifier and can not be subsetted.",
        call. = FALSE
      )
    }
    res <- h5readDataset(h5dataset = h5id, index = index)
    if (drop) {
      res <- drop(res)
    }
    res
  }
)

#' @describeIn H5IdComponent Subsetting of an HDF5 dataset. The function writes
#'   an R data object to a subset of an HDF5 dataset. The given dimensions have
#'   to fit the dimensions of the HDF5 dataset. The HDF5 dataset has to be
#'   created beforehand, e.g. by [h5createDataset()].
#'
#' @param value Array-like \R object containing value to be inserted into
#' the HDF5 dataset.
#'
#' @export
setMethod(
  `[<-`,
  signature = c("H5IdComponent", "ANY", "ANY", "ANY"),
  function(x, i, j, ..., value) {
    h5id <- x
    index <- extract_Nindex_from_syscall(sys.call(), parent.frame())

    isvalid <- H5Iis_valid(h5id)
    if (!isvalid) {
      stop("Bad HDF5 ID. Dataset closed?", call. = FALSE)
    }
    truetype <- H5Iget_type(h5id)
    if (truetype != "H5I_DATASET") {
      stop(
        "The provided H5Identifier is not a dataset identifier and can not be subsetted.",
        call. = FALSE
      )
    }
    h5writeDatasetHelper(obj = value, h5dataset = h5id, index = index)
    h5id
  }
)


#' @describeIn H5Ref Print details of the object to screen.
#'
#' @export
setMethod("show", signature = "H5Ref", definition = function(object) {
  cat("HDF5 REFERENCE\n")
  cat("Type:", h5const2String("H5R_TYPE", object@type), "\n")
  cat("Length:", length(object), "\n")
})

#' @describeIn H5Ref Return the number of references stored in an `H5Ref`
#' object.
#'
#' @export
setMethod("length", signature = "H5Ref", definition = function(x) {
  if (h5const2String("H5R_TYPE", x@type) == "H5R_OBJECT") {
    div <- 8L
  } else {
    div <- 12L
  }
  return(length(x@val) / div)
})

#' @describeIn H5Ref Combine two or more `H5Ref` objects.  Objects must all
#' contain the same type of reference, either `H5R_OBJECT` or
#' `H5R_DATASET_REFERENCE`.
#'
#' @param x An `H5Ref` object.
#' @param ... Additional `H5Ref` objects to be combined with `x`.
#'
#' @export
setMethod(f = "c", signature = "H5Ref", definition = function(x, ...) {
  elements <- list(x, ...)
  if (length(elements) != 0) {
    ## test all objects are H5Ref class
    valid <- vapply(
      elements,
      FUN = function(x) {
        inherits(x, "H5Ref")
      },
      FUN.VALUE = logical(1L)
    )
    if (!all(valid)) {
      stop("All objects must be of class 'H5Ref'.", call. = FALSE)
    }

    ## test all references are of same type
    types <- vapply(
      elements,
      FUN = function(x) {
        x@type
      },
      FUN.VALUE = integer(1L)
    )
    if (length(unique(types)) != 1) {
      stop("All references must be of the same type.", call. = FALSE)
    }

    items <- unlist(lapply(
      elements,
      FUN = function(x) {
        x@val
      }
    ))
    object <- new("H5Ref", val = items, type = x@type)
  }
  return(object)
})

#' @describeIn H5Ref Subset an `H5Ref` object.
#'
#' @param x An `H5Ref` object.
#' @param i Integer vector giving the indices of references to select.
#'
#' @export
setMethod(f = "[", signature = c("H5Ref", "ANY"), definition = function(x, i) {
  if (h5const2String("H5R_TYPE", x@type) == "H5R_OBJECT") {
    div <- 8L
  } else {
    div <- 12L
  }

  i <- as.integer(i)
  idx <- c(vapply(
    i,
    function(x) ((x - 1L) * div) + (1L:div),
    FUN.VALUE = integer(length = div)
  ))

  object <- new("H5Ref", val = x@val[idx], type = x@type)
  return(object)
})

#' Create a new HDF5 dataset
#'
#' @param h5loc An object of class [H5IdComponent-class] representing a H5
#' location identifier (file or group). See [H5Fcreate()], [H5Fopen()],
#' [H5Gcreate()], [H5Gopen()] to create an object of this kind.
#' @param name Name of the dataset.
#' @param dtype_id A character name of a datatype. See `h5const("H5T")`
#' for possible datatypes. Can also be an integer representing an HDF5 datatype.
#' @param h5space An object of class [H5IdComponent-class] representing a H5 dataspace.
#' See [H5Dget_space()], [H5Screate_simple()], [H5Screate()] to create an object
#' of this kind
#' @param lcpl,dcpl,dapl An objects of class [H5IdComponent-class] representing
#' HDF5 property lists.  Specially these should respectively be: a link creation
#' property list, a dataset creation property list, a dataset access property list
#'
#' @returns An object of class `H5IdComponent` representing the opened dataset.
#'
#' @export
H5Dcreate <- function(
  h5loc,
  name,
  dtype_id,
  h5space,
  lcpl = NULL,
  dcpl = NULL,
  dapl = NULL
) {
  h5checktype(h5loc, "loc")
  if (length(name) != 1 || !is.character(name)) {
    stop("'name' must be a character string of length 1")
  }
  ## dont check if we have an H5T identifier already
  if (!grepl(pattern = "^[[:digit:]]+$", dtype_id)) {
    dtype_id <- h5checkConstants("H5T", dtype_id)
  }
  h5checktype(h5space, "dataspace")
  lcpl <- h5checktypeAndPLC(lcpl, "H5P_LINK_CREATE", allowNULL = TRUE)
  dcpl <- h5checktypeAndPLC(dcpl, "H5P_DATASET_CREATE", allowNULL = TRUE)
  dapl <- h5checktypeAndPLC(dapl, "H5P_DATASET_ACCESS", allowNULL = TRUE)
  did <- .Call(
    "_H5Dcreate",
    h5loc@ID,
    name,
    dtype_id,
    h5space@ID,
    lcpl@ID,
    dcpl@ID,
    dapl@ID,
    PACKAGE = "rhdf5"
  )
  if (did > 0) {
    h5dataset <- new("H5IdComponent", ID = did, native = h5loc@native)
  } else {
    message("HDF5: unable to create dataset")
    h5dataset <- FALSE
  }
  invisible(h5dataset)
}

#' Open an existing HDF5 dataset
#'
#' @param h5loc An object of class [H5IdComponent-class] representing a H5
#' location identifier (file or group).
#' @param name Name of the dataset to open.
#' @param dapl An object of class [H5IdComponent-class] representing a H5 dataset access property list.
#'
#' @returns An object of class `H5IdComponent` representing the opened dataset.
#' To prevent memory leaks this must be closed with a call to [H5Dclose()]
#' when no longer needed.
#'
#' @examples
#' h5file <- tempfile(fileext = ".h5")
#' h5createFile(h5file)
#' h5createDataset(h5file, dataset = "A", dims = 10)
#'
#' fid <- H5Fopen(h5file)
#' did <- H5Dopen(h5loc = fid, name = "A")
#' did
#'
#' ## rember to close open handles
#' H5Dclose(did)
#' H5Fclose(fid)
#'
#' @export
H5Dopen <- function(h5loc, name, dapl = NULL) {
  h5checktype(h5loc, "loc")
  if (length(name) != 1 || !is.character(name)) {
    stop("'filename' must be a character string of length 1")
  }
  dapl <- h5checktypeAndPLC(dapl, "H5P_DATASET_ACCESS", allowNULL = TRUE)
  did <- .Call("_H5Dopen", h5loc@ID, name, dapl@ID, PACKAGE = "rhdf5")
  if (as.numeric(did) > 0) {
    h5dataset <- new("H5IdComponent", ID = did, native = h5loc@native)
  } else {
    message("HDF5: unable to open dataset")
    h5dataset <- FALSE
  }
  invisible(h5dataset)
}

#' Close an open HDF5 dataset
#'
#' @param h5dataset Object of class [H5IdComponent-class] representing an open HDF5
#' dataset
#'
#' @export
H5Dclose <- function(h5dataset) {
  h5checktype(h5dataset, "dataset")
  invisible(.Call("_H5Dclose", h5dataset@ID, PACKAGE = "rhdf5"))
}

#' Return a copy of the HDF5 datatype for a dataset
#'
#' @param h5dataset Object of class [H5IdComponent-class] representing an open HDF5
#' dataset
#'
#' @export
H5Dget_type <- function(h5dataset) {
  h5checktype(h5dataset, "dataset")
  tid <- .Call("_H5Dget_type", h5dataset@ID, PACKAGE = "rhdf5")
  invisible(tid)
}

#' Return a copy of the dataset creation property list for a dataset
#'
#' @param h5dataset Object of class [H5IdComponent-class] representing an open HDF5
#' dataset
#'
#' @export
H5Dget_create_plist <- function(h5dataset) {
  h5checktype(h5dataset, "dataset")
  pid <- .Call("_H5Dget_create_plist", h5dataset@ID, PACKAGE = "rhdf5")
  if (pid > 0) {
    h5plist <- new("H5IdComponent", ID = pid, native = h5dataset@native)
  } else {
    message("HDF5: unable to create property list")
    h5plist <- FALSE
  }
  invisible(h5plist)
}


#' Return a copy of the HDF5 dataspace for a dataset
#'
#' @param h5dataset Object of class [H5IdComponent-class] representing an open HDF5
#' dataset
#'
#' @returns Returns an object of class `H5IdComponent` representing a HDF5
#' dataspace identifier
#'
#' @export
H5Dget_space <- function(h5dataset) {
  h5checktype(h5dataset, "dataset")
  sid <- .Call("_H5Dget_space", h5dataset@ID, PACKAGE = "rhdf5")
  if (sid > 0) {
    h5space <- new("H5IdComponent", ID = sid, native = h5dataset@native)
  } else {
    message("HDF5: unable to create simple data space")
    h5space <- FALSE
  }
  invisible(h5space)
}

#' Find the amount of storage allocated for a dataset
#'
#' `H5Dget_storage_size` returns the amount of storage, in bytes, allocated in
#' an HDF5 file to hold a given dataset.  This is the amount of space required
#' on-disk, which not typically a good indicator of the amount of memory
#' that will be required to read the complete dataset.
#'
#' @param h5dataset Object of class [H5IdComponent-class] representing an open HDF5
#' dataset
#'
#' @returns Returns an integer giving the number of bytes allocated in the file
#' to the dataset.
#'
#' @export
H5Dget_storage_size <- function(h5dataset) {
  h5checktype(h5dataset, "dataset")
  size <- .Call("_H5Dget_storage_size", h5dataset@ID, PACKAGE = "rhdf5")
  return(size)
}

.postProcessDataSet <- function(h5dataset, res) {
  ## handle NA values in logical dataset
  if (H5Aexists(h5obj = h5dataset, name = "storage.mode")) {
    att <- H5Aopen(h5obj = h5dataset, name = "storage.mode")
    on.exit(H5Aclose(att))
    if (H5Aread(h5attribute = att) == "logical") {
      na_idx <- which(res == -128)
      if (any(na_idx)) {
        res[na_idx] <- NA_integer_
      }
      storage.mode(res) <- "logical"
    }
  }

  res
}

#' Read from an HDF5 dataset
#'
#' `H5Dread()` reads a (partial) dataset from an HDF5 file into the R session.
#'
#' @details Internally, R does not support 64-bit integers. All integers in R are 32-bit
#' integers. By setting bit64conversion='int', a coercing to 32-bit integers is
#' enforced, with the risk of data loss, but with the insurance that numbers
#' are represented as integers. bit64conversion='double' coerces the 64-bit
#' integers to floating point numbers. doubles can represent integers with up
#' to 54-bits, but they are not represented as integer values anymore. For
#' larger numbers there is again a data loss. bit64conversion='bit64' is
#' recommended way of coercing. It represents the 64-bit integers as objects
#' of class 'integer64' as defined in the package 'bit64'. Make sure that you
#' have installed 'bit64'. The datatype 'integer64' is not part of base R, but
#' defined in an external package. This can produce unexpected behaviour when
#' working with the data.
#'
#' @param h5dataset Object of class [H5IdComponent-class] representing an open HDF5
#' dataset.
#' @param h5spaceFile An object of class `H5IdComponent` representing a HDF5
#' dataspace. See [H5Dget_space()], [H5Screate_simple()], [H5Screate()] to
#' create an object of this kind.
#' @param h5spaceMem An object of class `H5IdComponent` representing a HDF5
#' dataspace. See [H5Dget_space()], [H5Screate_simple()], [H5Screate()] to
#' create an object of this kind. The dimensions of the dataset in the file and
#' in memory. The dimensions in file and in memory are interpreted in an R-like
#' manner. The first dimension is the fastest changing dimension. When reading
#' the file with a C-program (e.g. HDFView) the order of dimensions will invert,
#' because in C the fastest changing dimension is the last one.
#' @param buf Buffer to hold the read data.  The buffer size has to fit the
#' size of the memory space `h5spaceMem`. No extra memory will be allocated for
#' the data. A pointer to the same data is returned.
#' @param compoundAsDataFrame Logical vector of length 1. If `TRUE`, a compound
#' datatype will be coerced to a `data.frame`. This is not possible, if the
#' dataset is multi-dimensional. Otherwise the compound datatype will be
#' returned as a `list`. Nested compound data types will be returned as a
#' nested `list`.
#' @param bit64conversion Defines how 64-bit integers are converted. (See
#' the details section for more information on these options.)
#' @param drop Logical vector of length 1.  If `TRUE`, the HDF5 object is read
#' as a vector with NULL dim attributes. Default is `FALSE`.
#'
#' @export
H5Dread <- function(
  h5dataset,
  h5spaceFile = NULL,
  h5spaceMem = NULL,
  buf = NULL,
  compoundAsDataFrame = TRUE,
  bit64conversion = c("int", "double", "bit64"),
  drop = FALSE
) {
  h5checktype(h5dataset, "dataset")
  h5checktypeOrNULL(h5spaceFile, "dataspace")
  h5checktypeOrNULL(h5spaceMem, "dataspace")
  if (is.null(h5spaceMem)) {
    sidMem <- NULL
  } else {
    sidMem <- h5spaceMem@ID
  }
  if (is.null(h5spaceFile)) {
    sidFile <- NULL
  } else {
    sidFile <- h5spaceFile@ID
  }

  bit64conversion <- fix_missing(bit64conversion, "int")
  if (identical(bit64conversion, "default")) {
    bit64conversion <- "int"
    warning(
      "To rely on the `bit64conversion` argument default, ",
      'you should omit it or explicitly set it to its default value (`"int"`).',
      ' Passing `"default"` will be disallowed in the next release cycle.'
    )
  }
  bit64conversion <- match.arg(bit64conversion)
  bit64conv <- switch(
    bit64conversion,
    int = 0L,
    double = 1L,
    bit64 = 2L
  )

  if (bit64conv == 2L && !requireNamespace("bit64", quietly = TRUE)) {
    stop("install package 'bit64' before using bit64conversion='bit64'")
  }

  res <- .Call(
    "_H5Dread",
    h5dataset@ID,
    sidFile,
    sidMem,
    buf,
    compoundAsDataFrame,
    bit64conv,
    drop,
    h5dataset@native,
    PACKAGE = "rhdf5"
  )

  res <- .postProcessDataSet(h5dataset, res)
  res
}

#' Write data to dataset
#'
#' @param h5dataset Object of class [H5IdComponent-class] representing an open HDF5
#' dataset.
#' @param buf The R object containing the data to be written to the dataset.
#' @param h5type Datatype of the HDF5 dataset to be written.  If left as `NULL`
#' it will use the dataype of the R object supplied to `buf`.
#' @param h5spaceMem,h5spaceFile [H5IdComponent-class] objects representing the
#' memory and file dataspaces respectively.  If these are left `NULL` dataspaces
#' that match the size and shape of `h5dataset` will be used.
#'
#' @export
H5Dwrite <- function(
  h5dataset,
  buf,
  h5type = NULL,
  h5spaceMem = NULL,
  h5spaceFile = NULL
) {
  h5checktype(h5dataset, "dataset")
  h5checktypeOrNULL(h5spaceFile, "dataspace")
  h5checktypeOrNULL(h5spaceMem, "dataspace")

  if (is.null(h5spaceMem)) {
    sidMem <- NULL
  } else {
    sidMem <- h5spaceMem@ID
  }
  if (is.null(h5spaceFile)) {
    sidFile <- NULL
  } else {
    sidFile <- h5spaceFile@ID
  }
  invisible(.Call(
    "_H5Dwrite",
    h5dataset@ID,
    buf,
    sidFile,
    sidMem,
    h5type,
    h5dataset@native,
    PACKAGE = "rhdf5"
  ))
}

#' Change the dimensions of an HDF5 dataset
#'
#' @details This function can only be applied to datasets that meet the
#'   following criteria:
#' * A chunked dataset with unlimited dimensions
#' * A chunked dataset with fixed dimensions if the new dimension sizes are
#'   less than the maximum sizes set with maxdims
#'
#' @param h5dataset Object of class [H5IdComponent-class] representing an open
#'   HDF5 dataset.
#' @param size An integer vector with the new dimension of the dataset.
#'
#' @returns A logical vector of length 1.  Value will be `TRUE` if the operation
#'   was sucessful and `FALSE` otherwise.
#'
#' @author Bernd Fischer, Mike Smith
#'
#' @export
H5Dset_extent <- function(h5dataset, size) {
  h5checktype(h5dataset, "dataset")
  size <- as.numeric(size)
  if (!h5dataset@native) {
    size <- rev(size)
  }
  res <- .Call("_H5Dset_extent", h5dataset@ID, size, PACKAGE = "rhdf5")
  return(invisible(res >= 0))
}


#' Get the number of chunks in a dataset
#'
#' Retrieves the number of chunks used by an HDF5 dataset.
#'
#' Note, this function only returns the number of chunks that actually have data written to them.
#' It does not return the theoretical number of chunks in a dataset or intersection with a
#' dataspace.  For example, if an empty dataset is created and but no values have been written
#' to it `H5Dget_num_chunks()` will return 0.  This can be seen in the examples below.
#'
#' The C API also provides an optional parameter to constrain the query by providing a dataspace
#' selection.  However this argument is not currently used at the C level and so is ommitted here.
#'
#' @param h5dataset An object of class [H5IdComponent-class] representing the dataset from which chunks will be counted.
#'
#' @returns An integer value indicating the number of chunks present in the dataset or selected region.
#'
#' @examples
#' file <- tempfile(fileext = ".h5")
#' fid <- H5Fcreate(file)
#'
#' ## Create a dataset that will be represented by 4 chunks if complete
#' h5createDataset(file, "data", dims = c(10, 10), chunk = c(5, 5), storage.mode = "integer")
#' did <- H5Dopen(fid, "data")
#' ## Here we return 0 chunks as no values have been written
#' H5Dget_num_chunks(did)
#'
#' ## Now write data to half the dataset
#' h5writeDataset(obj = matrix(1:50, nrow = 10), h5loc = fid, name = "/data", index = list(1:10, 1:5))
#' ## We now see it contains 2 chunks
#' H5Dget_num_chunks(did)
#'
#' ## Now write the complete dataset, overwriting the existing values
#' h5writeDataset(obj = matrix(201:300, nrow = 10), h5loc = fid, name = "/data", index = NULL)
#' ## We now see it contains 4 chunks
#' H5Dget_num_chunks(did)
#'
#' ## Tidy up op handles
#' h5closeAll(did, fid)
#'
#' @export
H5Dget_num_chunks <- function(h5dataset) {
  h5checktype(h5dataset, "dataset")

  ## The C level API requires the dataset dataspace to be provided, even
  ## though the docs suggest making a selection on the dataspace currenrtly has
  ## no effect.
  h5space <- H5Dget_space(h5dataset = h5dataset)
  H5Sselect_all(h5space = h5space)
  on.exit(H5Sclose(h5space))

  h5checktype(h5space, "dataspace")
  res <- .Call(
    "_H5Dget_num_chunks",
    h5dataset@ID,
    h5space@ID,
    PACKAGE = "rhdf5"
  )
  return(res)
}

library(rhdf5)

h5File <- withr::local_tempfile(pattern = "ex_save", fileext = ".h5")
vec <- as.integer(rexp(2000, rate = 1.5))

############################################################
context("Writing Using External Filters")
############################################################

fid <- H5Fcreate(h5File)
sid <- H5Screate_simple(dims = 2000, maxdims = 2000)
tid <- rhdf5:::.setDataType(H5type = NULL, storage.mode = "integer")

test_that("BZIP2 filter works for writing", {
  skip_if_not_installed("rhdf5filters")
  expect_silent(dcpl <- H5Pcreate("H5P_DATASET_CREATE"))
  expect_silent(H5Pset_fill_time(dcpl, "H5D_FILL_TIME_ALLOC"))
  expect_silent(H5Pset_chunk(dcpl, 200))
  expect_silent(H5Pset_bzip2(dcpl))
  expect_silent(did <- H5Dcreate(fid, "bzip2", tid, sid, dcpl = dcpl))
  expect_silent(H5Dwrite(buf = vec, h5dataset = did))
  expect_silent(H5Dclose(did))
  expect_silent(H5Pclose(dcpl))
})

test_that("BLOSC filter works for writing", {
  skip_if_not_installed("rhdf5filters")
  expect_silent(dcpl <- H5Pcreate("H5P_DATASET_CREATE"))
  expect_silent(H5Pset_fill_time(dcpl, "H5D_FILL_TIME_ALLOC"))
  expect_silent(H5Pset_chunk(dcpl, 200))
  expect_silent(H5Pset_blosc(dcpl, tid, method = 1L))
  expect_silent(did <- H5Dcreate(fid, "blosc_lz", tid, sid, dcpl = dcpl))
  expect_silent(H5Dwrite(buf = vec, h5dataset = did))
  expect_silent(H5Dclose(did))
  expect_silent(H5Pclose(dcpl))
})

test_that("LZF filter works for writing", {
  skip_if_not_installed("rhdf5filters", minimum_version = "1.3.4")
  expect_silent(dcpl <- H5Pcreate("H5P_DATASET_CREATE"))
  expect_silent(H5Pset_fill_time(dcpl, "H5D_FILL_TIME_ALLOC"))
  expect_silent(H5Pset_chunk(dcpl, 200))
  expect_silent(H5Pset_lzf(dcpl, tid))
  expect_silent(did <- H5Dcreate(fid, "lzf", tid, sid, dcpl = dcpl))
  expect_silent(H5Dwrite(buf = vec, h5dataset = did))
  expect_silent(H5Dclose(did))
  expect_silent(H5Pclose(dcpl))
})

H5Sclose(sid)
H5Fclose(fid)

############################################################
context("Reading Using External Filters")
############################################################

fid <- H5Fopen(h5File)

test_that("BZIP2 filter works when reading", {
  skip_if_not_installed("rhdf5filters")

  expect_silent(did <- H5Dopen(fid, name = "bzip2"))
  expect_equivalent(H5Dread(did), vec)
  ## if compression worked the dataset should be smaller than 8000 bytes
  expect_lt(H5Dget_storage_size(did), 4 * 2000)
  expect_silent(H5Dclose(did))
})

test_that("BLOSC filter works when reading", {
  skip_if_not_installed("rhdf5filters")

  expect_silent(did <- H5Dopen(fid, name = "blosc_lz"))
  expect_equivalent(H5Dread(did), vec)
  ## if compression worked the dataset should be smaller than 8000 bytes
  expect_lt(H5Dget_storage_size(did), 4 * 2000)
  expect_silent(H5Dclose(did))
})

test_that("LZF filter works when reading", {
  skip_if_not_installed("rhdf5filters", minimum_version = "1.3.4")

  expect_silent(did <- H5Dopen(fid, name = "lzf"))
  expect_equivalent(H5Dread(did), vec)
  ## if compression worked the dataset should be smaller than 8000 bytes
  expect_lt(H5Dget_storage_size(did), 4 * 2000)
  expect_silent(H5Dclose(did))
})

H5Fclose(fid)

h5closeAll()

library(rhdf5)

############################################################
context("h5read")
############################################################

set.seed(1234)
A <- 1L:7L
B <- matrix(1:18, ncol = 2)
C <- c(TRUE, TRUE, FALSE, NA)
D <- seq(0, 1, by = 0.1)
E <- as.raw(sample(0:255, size = 5))
attr(D, "scale") <- "centimeters"
G <- data.frame("col_A" = 1:10, "col_B" = letters[1:10], "col_C" = as.raw(1:10))

## output file name
h5File <- withr::local_tempfile(pattern = "ex_read", fileext = ".h5")

# create file with group hierarchy
h5createFile(h5File)
h5createGroup(file = h5File, group = "foo")
h5createDataset(
  file = h5File,
  dataset = "foo/A",
  dims = c(1, length(A)),
  storage.mode = "integer"
)
h5write(obj = A, file = h5File, name = "foo/A")
h5createDataset(file = h5File, dataset = "foo/B", dims = c(2, length(B) / 2))
h5write(obj = B, file = h5File, name = "foo/B")
h5createDataset(file = h5File, dataset = "baa", dims = c(1, length(D)))
h5write(obj = D, file = h5File, name = "baa", write.attributes = TRUE)
h5write(obj = C, file = h5File, name = "logi")
h5write(obj = E, file = h5File, name = "raw")
h5write(obj = G, file = h5File, name = "data.frame")

test_that("Reading a dataset", {
  expect_silent(baa <- h5read(h5File, name = "baa", read.attributes = TRUE)) %>%
    expect_is("matrix")
  expect_identical(dim(baa), c(1L, length(D)))

  expect_silent(C2 <- h5read(h5File, name = "logi")) %>%
    expect_is("array") %>%
    expect_identical(as.array(C))
  expect_identical(storage.mode(C2), "logical")

  expect_silent(E2 <- h5read(h5File, name = "raw")) %>%
    expect_is("array") %>%
    expect_identical(as.array(E2))
  expect_identical(storage.mode(E2), "raw")
})

test_that("Reading a group", {
  foo <- h5read(h5File, name = "foo")
  expect_is(foo, "list")
  expect_identical(length(foo), 2L)
  expect_true(all(c("A", "B") %in% names(foo)))
})

test_that("Reading a nested dataset", {
  fooA <- h5read(h5File, name = "foo/A")
  expect_is(fooA, "matrix")
  expect_identical(dim(fooA), c(1L, length(A)))
})

test_that("Dropping dimensions", {
  fooA <- h5read(h5File, name = "foo/A", drop = TRUE)
  expect_is(fooA, "integer")
  expect_null(dim(fooA))
  expect_identical(fooA, A)

  ## this drops for matrices too
  fooB <- h5read(h5File, name = "foo/B", drop = TRUE)
  expect_is(fooB, "numeric")
  expect_null(dim(fooB))
  expect_identical(fooB, as.numeric(B))
})

test_that("Reading attributes too", {
  baa <- h5read(h5File, name = "baa", read.attributes = TRUE)
  expect_identical(as.character(attributes(baa)$scale), attributes(D)$scale)
})

test_that("Error if file doesn't exist", {
  expect_error(
    h5read(file = "/foo/baa.h5", name = "missing"),
    regexp = "does not exist.$"
  )
})

test_that("Error if asking for something that isn't there", {
  expect_error(
    h5read(file = h5File, name = "missing"),
    regexp = "does not exist in this HDF5 file."
  )
})


test_that("writing & reading empty vectors", {
  h5File <- withr::local_tempfile(pattern = "ex_read", fileext = ".h5")
  expect_true(h5createFile(h5File))
  expect_silent(h5write(obj = character(0), file = h5File, name = "char"))
  expect_silent(h5write(obj = integer(0), file = h5File, name = "int"))
  expect_silent(h5write(obj = double(0), file = h5File, name = "double"))
  expect_silent(h5write(obj = logical(0), file = h5File, name = "logical"))
  expect_silent(h5write(obj = raw(0), file = h5File, name = "raw"))
  # expect_silent(h5write(obj = factor(levels = c("L1", "L2")), file = h5File, name = "factor"))

  ## testing some different datatypes
  fid <- H5Fopen(h5File)
  sid <- H5Screate_simple(0)
  did1 <- H5Dcreate(
    fid,
    "unit32",
    dtype_id = "H5T_NATIVE_UINT32",
    h5space = sid
  )
  did2 <- H5Dcreate(
    fid,
    "unit64",
    dtype_id = "H5T_NATIVE_UINT64",
    h5space = sid
  )
  h5closeAll(did1, did2, sid, fid)

  expect_silent(tmp <- h5read(file = h5File, name = "char")) %>%
    expect_is("character") %>%
    expect_length(0)
  expect_silent(h5read(file = h5File, name = "int")) %>%
    expect_is("array") %>%
    expect_length(0) %>%
    storage.mode() %>%
    expect_identical("integer")
  expect_silent(h5read(file = h5File, name = "double")) %>%
    expect_is("array") %>%
    expect_length(0) %>%
    storage.mode() %>%
    expect_identical("double")
  expect_silent(h5read(file = h5File, name = "logical")) %>%
    expect_is("array") %>%
    expect_length(0) %>%
    storage.mode() %>%
    expect_identical("logical")
  expect_silent(h5read(file = h5File, name = "raw")) %>%
    expect_is("array") %>%
    expect_length(0) %>%
    storage.mode() %>%
    expect_identical("raw")
  expect_silent(h5read(file = h5File, name = "unit32")) %>%
    expect_is("array") %>%
    expect_length(0) %>%
    storage.mode() %>%
    expect_identical("integer")
  expect_silent(h5read(file = h5File, name = "unit64")) %>%
    expect_is("array") %>%
    expect_length(0) %>%
    storage.mode() %>%
    expect_identical("integer")
})

test_that("writing & reading empty arrays", {
  h5File <- withr::local_tempfile(pattern = "ex_read", fileext = ".h5")
  expect_true(h5createFile(h5File))
  expect_silent(h5write(
    obj = matrix(nrow = 0, ncol = 0),
    file = h5File,
    name = "mat"
  ))

  expect_silent(tmp <- h5read(file = h5File, name = "mat")) %>%
    expect_is("matrix") %>%
    expect_length(0)
})

test_that("reading & writing scalar dataspaces", {
  h5File <- withr::local_tempfile(pattern = "ex_read", fileext = ".h5")
  expect_silent(fid <- H5Fcreate(h5File))
  expect_silent(sid <- H5Screate(type = "H5S_SCALAR"))
  expect_silent(tid <- H5Tcopy("H5T_C_S1"))
  expect_silent(H5Tset_size(tid, 12))
  expect_silent(did <- H5Dcreate(fid, "scalar", tid, h5space = sid))
  expect_silent(H5Dwrite(did, "test string"))
  expect_silent(H5Dclose(did))
  expect_silent(H5Sclose(sid))
  expect_silent(H5Fclose(fid))
})

test_that("we can read anndata nullable arrays", {
  h5File <- system.file("testfiles", "nullable_examples.h5", package = "rhdf5")

  expect_identical(
    h5read(h5File, name = "nullable_boolean"),
    c(TRUE, FALSE, NA)
  )
  expect_equivalent(
    h5read(h5File, name = "nullable_integer"),
    c(1L, NA, 3L, 4L)
  )
})

############################################################
context("NA values")
############################################################

## output file name
h5File <- withr::local_tempfile(pattern = "ex_read", fileext = ".h5")

h5createFile(h5File)

test_that("NA characters are supported", {
  expect_silent(h5write(c(NA_character_, LETTERS), h5File, "NA_char"))
  expect_true(any(is.na(h5read(h5File, name = "NA_char"))))

  expect_warning(
    h5write(c(NA_character_, LETTERS, "NA"), h5File, "NA_char_2"),
    "Both NA_character_ and the string 'NA' detected"
  )
})

test_that("No warnings are generated for integers containing NA written from R", {
  expect_silent(h5write(c(NA_integer_, 1:5), h5File, "NA_int"))
  expect_silent(na_int <- h5read(h5File, name = "NA_int"))
  expect_true(is.na(na_int[1]))
})

test_that("Warnings are generated for integers containing NA written outside rhdf5", {
  ## remove the rhdf5-NA.OK attribute to simulate data not written by rhdf5
  fid <- H5Fopen(name = h5File)
  did <- H5Dopen(fid, name = "NA_int")
  H5Adelete(did, "rhdf5-NA.OK")
  H5Dclose(did)
  H5Fclose(fid)
  expect_message(
    h5read(h5File, name = "NA_int"),
    "The value -2^31 was detected in the dataset",
    fixed = TRUE
  )
})

############################################################
context("indexing")
############################################################

A <- matrix(1:100, ncol = 10)
B <- array(1:1000, dim = c(10, 10, 10))

## output file name
h5File <- withr::local_tempfile(pattern = "ex_read", fileext = ".h5")

# create file with group hierarchy
h5createFile(h5File)
h5write(obj = A, file = h5File, name = "A")
h5write(obj = B, file = h5File, name = "B")

test_that("Works with a dimension of length 1", {
  expect_silent(A2 <- h5read(h5File, name = "A", index = list(NULL, 5)))
  expect_is(A2, "matrix")
  expect_identical(ncol(A2), 1L)
  expect_identical(nrow(A2), 10L)
  expect_identical(A2[, 1], A[, 5])
})


test_that("indices that resolve to a single hyperslab are ok", {
  expect_silent(
    A2 <- h5read(h5File, name = "A", index = list(2:3, c(1, 2, 4, 5)))
  )
  expect_is(A2, "matrix")
  expect_identical(ncol(A2), 4L)
  expect_identical(nrow(A2), 2L)
  expect_identical(A2, A[2:3, c(1, 2, 4, 5)])
})

test_that("Columns specified multiple times", {
  expect_silent(
    A2 <- h5read(h5File, name = "A", index = list(NULL, c(9, 1, 1, 5)))
  )
  expect_identical(ncol(A2), 4L)
  expect_identical(nrow(A2), 10L)
  expect_identical(A2[, 2], A[, 1])
})


test_that("Indexing multiple dimensions works", {
  expect_silent(
    A2 <- h5read(h5File, name = "A", index = list(c(1, 3), c(1, 5, 10)))
  )
  expect_identical(ncol(A2), 3L)
  expect_identical(nrow(A2), 2L)
  expect_identical(A2[2, 3], A[3, 10])

  expect_silent(
    B2 <- h5read(h5File, name = "B", index = list(c(1, 8, 10), NULL, NULL))
  )
  expect_identical(dim(B2), c(3L, 10L, 10L))
  expect_identical(B2[3, , ], B[10, , ])
  expect_silent(
    B2 <- h5read(h5File, name = "B", index = list(c(8), NULL, c(4, 6)))
  )
  expect_identical(dim(B2), c(1L, 10L, 2L))
  expect_identical(B2[1, 6, ], B[8, 6, c(4, 6)])
})


test_that("Empty index retain dimensionality", {
  expect_silent(
    A2 <- h5read(h5File, name = "A", index = list(integer(0), 5))
  ) %>%
    expect_is("matrix")
  expect_identical(dim(A2), c(0L, 1L))
  expect_silent(
    A2 <- h5read(h5File, name = "A", index = list(integer(0), 1:5))
  ) %>%
    expect_is("matrix")
  expect_identical(dim(A2), c(0L, 5L))
  expect_silent(
    A2 <- h5read(h5File, name = "A", index = list(integer(0), integer(0)))
  ) %>%
    expect_is("matrix")
  expect_identical(dim(A2), c(0L, 0L))

  expect_silent(
    B2 <- h5read(h5File, name = "B", index = list(integer(0), integer(0), 5))
  ) %>%
    expect_is("array")
  expect_identical(dim(B2), c(0L, 0L, 1L))
  expect_silent(
    B2 <- h5read(h5File, name = "B", index = list(integer(0), 1:5, 6))
  ) %>%
    expect_is("array")
  expect_identical(dim(B2), c(0L, 5L, 1L))
  expect_silent(
    B2 <- h5read(
      h5File,
      name = "B",
      index = list(integer(0), integer(0), integer(0))
    )
  ) %>%
    expect_is("array")
  expect_identical(dim(B2), c(0L, 0L, 0L))
})

############################################################
context("64-bit conversion")
############################################################

## output file name
h5File <- withr::local_tempfile(pattern = "ex_read", fileext = ".h5")

# create file with integers of different types
h5createFile(h5File)
h5createDataset(h5File, "int32", dims = 50, storage.mode = "integer")
h5createDataset(h5File, "int64", dims = 51, storage.mode = "integer64")
h5createDataset(h5File, "uint32", dims = 50, H5type = "H5T_STD_U32LE")
h5write(obj = 1:50, file = h5File, name = "int32")
h5write(obj = c(1:50, 2^32), file = h5File, name = "int64")
h5write(obj = 2^31 + 1:50, file = h5File, name = "uint32")

test_that("Signed 32bit integers are unchanged for all conversion arguments", {
  expect_is(
    x1 <- h5read(h5File, name = "int32", bit64conversion = "int"),
    "array"
  )
  expect_identical(storage.mode(x1), "integer")
  expect_is(
    x2 <- h5read(h5File, name = "int32", bit64conversion = "double"),
    "array"
  )
  expect_identical(storage.mode(x2), "integer")
  expect_is(
    x3 <- h5read(h5File, name = "int32", bit64conversion = "bit64"),
    "array"
  )
  expect_identical(storage.mode(x3), "integer")

  expect_identical(x1, x2)
  expect_identical(x1, x3)
})

test_that("signed 64-bit integers are converted", {
  expect_is(
    x1 <- h5read(h5File, name = "int64", bit64conversion = "int"),
    "array"
  ) %>%
    expect_warning()
  expect_identical(x1[51], NA_integer_)
  expect_identical(storage.mode(x1), "integer")

  expect_is(
    x2 <- h5read(h5File, name = "int64", bit64conversion = "double"),
    "array"
  )
  expect_identical(x2, array(c(1:50, 2^32)))
  expect_identical(storage.mode(x2), "double")

  expect_is(
    x3 <- h5read(h5File, name = "int64", bit64conversion = "bit64"),
    "integer64"
  )
  expect_identical(x3, as.array(bit64::as.integer64(c(1:50, 2^32))))
  expect_identical(storage.mode(x3), "double")
})

test_that("Unsigned 32bit integers are converted to NA out of range", {
  expect_warning(x1 <- h5read(h5File, name = "uint32", bit64conversion = "int"))
  expect_true(all(is.na(x1)))
})

test_that("Unsigned 32bit integers are converted properly to double/bit64", {
  expect_is(
    x2 <- h5read(h5File, name = "uint32", bit64conversion = "double"),
    "array"
  )
  expect_identical(storage.mode(x2), "double")
  expect_equivalent(x2, 2^31 + 1:50)

  expect_is(
    x3 <- h5read(h5File, name = "uint32", bit64conversion = "bit64"),
    "integer64"
  )
  expect_identical(storage.mode(x3), "double")
  expect_identical(class(x3), "integer64")
  expect_true(all(x3 > 2^31))
})

############################################################
context("Using filters other than ZLIB")
###########################################################

test_that("Reading SZIP", {
  szip_file <- system.file("testfiles", "h5ex_d_szip.h5", package = "rhdf5")
  expect_silent(h5read(szip_file, "DS1")) %>%
    expect_is("matrix") %>%
    dim() %>%
    expect_equal(c(64, 32))
})

test_that("Failing to read BLOSC", {
  blosc_file <- system.file("testfiles", "h5ex_d_blosc.h5", package = "rhdf5")
  expect_silent(h5read(blosc_file, "dset"))
})

test_that("unsigned native read matches expected ordering (issue #157)", {
  test_file_157 <- system.file(
    "testfiles",
    "test_issue157.h5",
    package = "rhdf5"
  )
  signed_read <- h5read(test_file_157, "signed")
  signed_native <- h5read(test_file_157, "signed", native = TRUE)
  unsigned_read <- h5read(test_file_157, "unsigned")
  unsigned_native <- h5read(test_file_157, "unsigned", native = TRUE)

  expect_identical(signed_read, t(signed_native))
  expect_identical(unsigned_read, t(unsigned_native))
})

library(rhdf5)

h5File <- withr::local_tempfile(pattern = "H5D_", fileext = ".h5")

expect_true(h5createFile(h5File))
expect_silent(h5write(matrix(1:200, ncol = 2), file = h5File, name = "foo"))

## The property list interface is really limited at the moment
## so there aren't many functions that we can check
test_that("we can extract the property lists", {
  expect_silent(fid <- H5Fopen(h5File))
  expect_silent(did <- H5Dopen(fid, name = "foo"))

  expect_silent(pid <- H5Dget_create_plist(did))
  expect_output(print(pid), "HDF5 GENPROP_LST")

  expect_silent(H5Pclose(pid))
  expect_silent(H5Dclose(did))
  expect_silent(H5Fclose(fid))
})

test_that("dataset size is reported", {
  expect_silent(fid <- H5Fopen(h5File))
  expect_silent(did <- H5Dopen(fid, name = "foo"))

  expect_silent(dset_size <- H5Dget_storage_size(did))
  expect_is(dset_size, "integer")
  expect_gt(dset_size, 0)

  expect_silent(H5Dclose(did))
  expect_silent(H5Fclose(fid))
})

test_that("we can change the size of a dataset", {
  h5createDataset(
    file = h5File,
    dataset = "/size_changer",
    dims = c(0, 0),
    maxdims = c(H5Sunlimited(), 1000),
    chunk = c(100, 100),
    storage.mode = "integer"
  )

  fid <- H5Fopen(h5File)
  did <- H5Dopen(fid, name = "/size_changer")
  on.exit(h5closeAll(did, fid))

  sid <- H5Dget_space(did)
  expect_identical(H5Sget_simple_extent_dims(sid)$size, c(0L, 0L))
  H5Sclose(sid)

  ## change both i and j a few times
  for (i in seq(100L, 1000L, by = 200L)) {
    for (j in seq(0L, 1000L, by = 500L)) {
      expect_true(H5Dset_extent(did, size = c(i, j)))
      sid <- H5Dget_space(did)
      expect_identical(H5Sget_simple_extent_dims(sid)$size, c(i, j))
      H5Sclose(sid)
    }
  }

  ## can't set outside of maxdim
  expect_false(H5Dset_extent(did, size = c(2000, 2000)))
  ## size remain where we set it last
  sid <- H5Dget_space(did)
  expect_identical(H5Sget_simple_extent_dims(sid)$size, c(i, j))
  H5Sclose(sid)
})

test_that("we can find the number of chunks used by a dataset", {
  ## Create a dataset that will be represented by 4 chunks if complete
  h5createDataset(
    h5File,
    "data",
    dims = c(10, 10),
    chunk = c(5, 5),
    storage.mode = "integer"
  )

  fid <- H5Fopen(h5File)
  did <- H5Dopen(fid, "/data")
  ## Here we return 0 chunks as no values have been written
  expect_identical(H5Dget_num_chunks(did), 0L)

  ## Now write data to half the dataset
  h5writeDataset(
    obj = matrix(1:50, nrow = 10),
    h5loc = fid,
    name = "/data",
    index = list(1:10, 1:5)
  )
  ## We now see it contains 2 chunks
  expect_identical(H5Dget_num_chunks(did), 2L)

  ## Now writing the complte dataset, overwriting the existing values
  h5writeDataset(
    obj = matrix(201:300, ncol = 10),
    h5loc = fid,
    name = "/data",
    index = NULL
  )
  ## We now see it contains 4 chunks
  expect_identical(H5Dget_num_chunks(did), 4L)

  ## Tidy up op handles
  h5closeAll(did, fid)
})

## ----setup, echo = FALSE, include=FALSE---------------------------------------
set.seed(1234)

library(rhdf5)
library(dplyr)
library(ggplot2)
library(BiocParallel)

# R CMD check asks we use no more than 2 cores
run_on_platform <- .Platform$OS.type == "unix" && !nzchar(Sys.getenv("_R_CHECK_LIMIT_CORES_"))

## ----create data, echo=TRUE, warning=FALSE------------------------------------
m1 <- matrix(rep(1:20000, each = 100), ncol = 20000, byrow = FALSE)
ex_file <- tempfile(fileext = ".h5")
h5write(m1, file = ex_file, name = "counts", level = 6)

## ----extract1, echo = TRUE----------------------------------------------------
system.time(
  res1 <- h5read(
    file = ex_file, name = "counts",
    index = list(NULL, 1:10000)
  )
)

## ----extract2, echo = TRUE----------------------------------------------------
index <- list(NULL, seq(from = 1, to = 20000, by = 2))
system.time(
  res2 <- h5read(
    file = ex_file, name = "counts",
    index = index
  )
)

## ----extract3, echo = TRUE----------------------------------------------------
start <- c(1, 1)
stride <- c(1, 2)
block <- c(100, 1)
count <- c(1, 10000)
system.time(
  res3 <- h5read(
    file = ex_file, name = "counts", start = start,
    stride = stride, block = block, count = count
  )
)
identical(res2, res3)

## ----chooseColunns, eval = TRUE-----------------------------------------------
columns <- sample(x = seq_len(20000), size = 1000, replace = FALSE) %>%
  sort()
f1 <- function(cols, name) {
  h5read(
    file = ex_file, name = name,
    index = list(NULL, cols)
  )
}

## ----singleReads, eval = run_on_platform, cache = TRUE------------------------
system.time(res4 <- vapply(
  X = columns, FUN = f1,
  FUN.VALUE = integer(length = 100),
  name = "counts"
))

## ----createChunked, echo = TRUE, eval = TRUE, results='hide'------------------
h5createDataset(
  file = ex_file, dataset = "counts_chunked",
  dims = dim(m1), storage.mode = "integer",
  chunk = c(100, 100), level = 6
)
h5write(obj = m1, file = ex_file, name = "counts_chunked")

## ----read_chunked, eval = TRUE------------------------------------------------
system.time(res5 <- vapply(
  X = columns, FUN = f1,
  FUN.VALUE = integer(length = 100),
  name = "counts_chunked"
))

## -----------------------------------------------------------------------------
f2 <- function(block_size = 100) {
  cols_grouped <- split(columns, (columns - 1) %/% block_size)
  do.call(cbind, lapply(cols_grouped, f1, name = "counts_chunked"))
}
system.time(f2())

## ----benchmark, echo = FALSE, cache = TRUE------------------------------------
bm <- bench::mark(
  f2(10), f2(25), f2(50), f2(100),
  f2(250), f2(500), f2(1000),
  f2(2000), f2(5000), f2(10000),
  iterations = 3,
  check = FALSE,
  time_unit = "s",
  memory = FALSE,
  filter_gc = FALSE
)

bm2 <- data.frame(
  block_size = gsub(".*\\(([0-9]+)\\)", "\\1", bm$expression) |>
    as.integer() |>
    rep(each = 3),
  time = unlist(bm$time)
)

## ----echo = FALSE, fig.width=6, fig.height=3, fig.wide = TRUE-----------------
ggplot(bm2, aes(x = block_size, y = time)) +
  geom_point() +
  scale_x_log10() +
  theme_bw() +
  ylab("time (seconds)")

## ----hyperslab-benchmark, eval = run_on_platform, echo = FALSE, fig.width=6, fig.height=3, fig.wide = TRUE, fig.cap='The time taken to join hyperslabs increases expontentially with the number of join operations.  These timings are taken with no reading occuring, just the creation of a dataset selection.'----
## this code demonstrates the exponential increase in time as the
## number of hyberslab unions increases

select_index <- function(n = 1) {
  ## open the dataspace for the count table
  fid <- H5Fopen(ex_file)
  did <- H5Dopen(fid, name = "counts")
  sid <- H5Dget_space(did)

  ## column choice based on number of unions required
  columns <- c(head(1:10001, n = -n), head(seq(10001 - n + 2, 20000, 2), n = n - 1))
  index <- list(100, columns)
  H5Sselect_index(sid, index = index)

  ## tidy up
  H5Sclose(sid)
  H5Dclose(did)
  H5Fclose(fid)
}

bm <- bench::mark(
  select_index(1), select_index(2), select_index(5),
  select_index(10), select_index(20), select_index(50),
  select_index(100), select_index(200), select_index(500),
  select_index(1000), select_index(2000), select_index(5000),
  select_index(10000),
  iterations = 3,
  check = FALSE,
  time_unit = "s",
  memory = FALSE,
  filter_gc = FALSE
)

bm2 <- data.frame(
  n = gsub(".*\\(([0-9]+)\\)", "\\1", bm$expression) |>
    as.integer() |>
    rep(each = 3),
  time = unlist(bm$time)
)

ggplot(bm2, aes(x = n, y = time)) +
  geom_point() +
  scale_x_log10() +
  scale_y_log10() +
  theme_bw() +
  xlab("number of hyperslab unions") +
  ylab("time (seconds)")

## ----example-dsets------------------------------------------------------------
dsets <- lapply(1:10, FUN = \(i) {
  matrix(runif(10000000), ncol = 100)
})
names(dsets) <- paste0("dset_", 1:10)

## -----------------------------------------------------------------------------
simple_writer <- function(file_name, dsets) {
  fid <- H5Fcreate(name = file_name)
  on.exit(H5Fclose(fid))

  for (i in seq_along(dsets)) {
    dset_name <- paste0("dset_", i)
    h5createDataset(
      file = fid, dataset = dset_name,
      dims = dim(dsets[[i]]), chunk = c(10000, 10)
    )
    h5writeDataset(dsets[[i]], h5loc = fid, name = dset_name)
  }
}

## -----------------------------------------------------------------------------
## Write a single dataset to a temporary file
## Arguments:
## - dset_name: The name of the dataset to be created
## - dset: The dataset to be written
split_tmp_h5 <- function(dset_name, dset) {
  ## create a tempory HDF5 file for this dataset
  file_name <- tempfile(pattern = "par", fileext = ".h5")
  fid <- H5Fcreate(file_name)
  on.exit(H5Fclose(fid))

  ## create and write the dataset
  ## we use some predefined chunk sizes
  h5createDataset(
    file = fid, dataset = dset_name,
    dims = dim(dset), chunk = c(10000, 10)
  )
  h5writeDataset(dset, h5loc = fid, name = dset_name)

  return(c(file_name, dset_name))
}

## Gather scattered datasets into a final single file
## Arguments:
## - output_file: The path to the final HDF5 to be created
## - input: A data.frame with two columns containing the paths to the temp
## files and the name of the dataset inside that file
gather_tmp_h5 <- function(output_file, input) {
  ## create the output file
  fid <- H5Fcreate(name = output_file)
  on.exit(H5Fclose(fid))

  ## iterate over the temp files and copy the named dataset into our new file
  for (i in seq_len(nrow(input))) {
    fid2 <- H5Fopen(input$file[i])
    H5Ocopy(fid2, input$dset[i], h5loc_dest = fid, name_dest = input$dset[i])
    H5Fclose(fid2)
  }
}

## ----define-split-gather------------------------------------------------------
split_and_gather <- function(output_file, input_dsets, BPPARAM = NULL) {
  if (is.null(BPPARAM)) {
    BPPARAM <- BiocParallel::SerialParam()
  }

  ## write each of the matrices to a separate file
  tmp <-
    bplapply(seq_along(input_dsets),
      FUN = function(i) {
        split_tmp_h5(
          dset_name = names(input_dsets)[i],
          dset = input_dsets[[i]]
        )
      },
      BPPARAM = BPPARAM
    )

  ## create a table of file and the dataset names
  input_table <- do.call(rbind, tmp) |>
    as.data.frame()
  names(input_table) <- c("file", "dset")

  ## copy all datasets from temp files in to final output
  gather_tmp_h5(output_file = output_file, input = input_table)

  ## remove the temporary files
  file.remove(input_table$file)
}

## ----eval = FALSE-------------------------------------------------------------
# split_and_gather(tempfile(),
#   input_dsets = dsets,
#   BPPARAM = MulticoreParam(workers = 2)
# )

## ----run-writing-benchmark, eval = run_on_platform, cache = TRUE, message=FALSE, echo=FALSE----
bench_results <- bench::mark(
  "simple writer" = simple_writer(file_name = tempfile(), dsets = dsets),
  "split/gather - 1 core" = split_and_gather(tempfile(),
    input_dsets = dsets,
    BPPARAM = NULL
  ),
  "split/gather - 2 cores" = split_and_gather(tempfile(),
    input_dsets = dsets,
    BPPARAM = MulticoreParam(workers = 2)
  ),
  "split/gather - 4 cores" = split_and_gather(tempfile(),
    input_dsets = dsets,
    BPPARAM = MulticoreParam(workers = 4)
  ),
  iterations = 2,
  check = FALSE,
  time_unit = "s",
  memory = FALSE,
  filter_gc = FALSE
)
bench_results[, c("expression", "min", "median")]

## ----fake-timings, eval = !run_on_platform, message = FALSE, echo = FALSE-----
# bench_results <- data.frame(median = 4:1)

## ----sessionInfo, echo=FALSE--------------------------------------------------
sessionInfo()

H5Tcreate <- function(type, size) {
  type <- h5checkConstants("H5T_CLASS", type)

  allowed_types <- c("H5T_STRING", "H5T_COMPOUND", "H5T_ENUM", "H5T_OPAQUE")
  if (!type %in% h5constants$H5T_CLASS[allowed_types]) {
    stop(
      "H5Tcreate can only be used with the following data types:\n",
      paste(allowed_types, collapse = " ")
    )
  }

  invisible(.Call(
    "_H5Tcreate",
    as.integer(type),
    as.integer(size),
    PACKAGE = "rhdf5"
  ))
}

#' Copy an existing datatype
#'
#' @param dtype_id Datatype to copy.  Can either be a character
#' specifying a predefined HDF5 datatype (see `h5const("H5T")` for valid
#' options) or the ID of an already created datatype.
#'
#' @export
H5Tcopy <- function(dtype_id = h5default(type = "H5T")) {
  if (is.numeric(dtype_id)) {
    dtype_id <- as.integer(dtype_id)
  } else {
    dtype_id <- h5checkConstants("H5T", dtype_id)
  }
  invisible(.Call("_H5Tcopy", dtype_id, PACKAGE = "rhdf5"))
}

#' Retrieve or set the type of padding used by string datatype
#'
#' @param dtype_id ID of HDF5 datatype to query or modify.
#' @param size The new datatype size in bytes.
#'
#' @name H5T_size
NULL

#' @rdname H5T_size
#' @export
H5Tset_size <- function(dtype_id = h5default(type = "H5T"), size) {
  # string constant type_id do not make sense, because they are not allowed to be changed
  if (!grepl(pattern = "^[[:digit:]]+$", dtype_id)) {
    stop("Argument 'dtype_id' should be created by a call to H5Tcopy()")
  }
  size <- as.integer(size)
  invisible(.Call("_H5Tset_size", dtype_id, size, PACKAGE = "rhdf5"))
}

#' @rdname H5T_size
#' @export
H5Tget_size <- function(dtype_id) {
  if (missing(dtype_id)) {
    stop("Argument 'dtype_id' must be supplied")
  }

  .Call("_H5Tget_size", dtype_id, PACKAGE = "rhdf5")
}

#' Retrieve or set the type of padding used by string datatype
#'
#' @param dtype_id ID of HDF5 datatype to query or modify.
#' @param strpad Character vector of length 1 specifying the type of padding
#' to use.  Valid options are `NULLTERM`, `NULLPAD` and `SPACEPAD`.
#'
#' @name H5T_strpad
NULL

#' @rdname H5T_strpad
#' @export
H5Tset_strpad <- function(dtype_id, strpad = "NULLPAD") {
  strpad_int <- switch(
    strpad,
    NULLTERM = 0L,
    NULLPAD = 1L,
    SPACEPAD = 2L,
    stop(
      "Invalid value to 'strpad' argument.\n",
      "Valid options are: 'NULLTERM', 'NULLPAD', 'SPACEPAD'"
    )
  )

  .Call("_H5Tset_strpad", dtype_id, strpad_int, PACKAGE = "rhdf5")
}

#' @rdname H5T_strpad
#' @export
H5Tget_strpad <- function(dtype_id) {
  if (missing(dtype_id)) {
    stop("Argument 'dtype_id' must be supplied")
  }

  .Call("_H5Tget_strpad", dtype_id, PACKAGE = "rhdf5")
}

#' Retrieve or set the character set to be used in a string datatype.
#'
#' @param dtype_id ID of HDF5 datatype to query or modify.
#' @param cset Encoding to use for string types. Valid options are 'ASCII' and
#' 'UTF-8'.
#'
#' @name H5T_cset
NULL

#' @rdname H5T_cset
#' @export
H5Tset_cset <- function(dtype_id, cset = "ASCII") {
  cset_int <- switch(
    cset,
    "ASCII" = 0L,
    "UTF8" = 1L,
    "UTF-8" = 1L,
    stop(
      "Invalid value to 'cset' argument.\n",
      "Valid options are: 'ASCII', 'UTF-8'"
    )
  )

  .Call("_H5Tset_cset", dtype_id, cset_int, PACKAGE = "rhdf5")
}

#' @rdname H5T_cset
#' @export
H5Tget_cset <- function(dtype_id) {
  if (missing(dtype_id)) {
    stop("Argument 'dtype_id' must be supplied")
  }

  .Call("_H5Tget_cset", dtype_id, PACKAGE = "rhdf5")
}

#' Determine whether a datatype is a variable length string
#'
#' @param dtype_id ID of HDF5 datatype to query.
#'
#' @export
H5Tis_variable_str <- function(dtype_id) {
  if (missing(dtype_id)) {
    stop("Argument 'dtype_id' must be supplied")
  }

  res <- .Call("_H5Tis_variable_str", dtype_id, PACKAGE = "rhdf5")
  if (res < 0) {
    stop("Unable to determine whether datatype is a variable length string")
  }

  return(as.logical(res))
}

#' Retrieve or set the precision of an HDF5 datatype
#'
#' @param dtype_id ID of HDF5 datatype to set precision of.
#' @param precision The number of bytes of precision for the datatype.
#'
#' @returns
#' * `H5Tget_precision()` returns an integer giving the number of
#' significant bits used by the given datatype.
#' * `H5Tset_precision()` is call for its side-effect of modifying the
#' precision of a datatype.  It will invisibly return `TRUE` if this is
#' successful and will stop with an error if the operation fails.
#'
#' @name H5T_precision
NULL

#' @rdname H5T_precision
#' @export
H5Tset_precision <- function(dtype_id, precision) {
  if (missing(dtype_id)) {
    stop("Argument 'dtype_id' must be supplied")
  }

  precision <- as.integer(precision)
  if (precision < 1) {
    stop("'precision' argument must be greater than 0.")
  }

  res <- .Call(
    "_H5Tset_precision",
    dtype_id,
    as.integer(precision),
    PACKAGE = "rhdf5"
  )
  if (res < 0) {
    stop("Unable to set data type precision")
  }

  return(invisible(TRUE))
}

#' @rdname H5T_precision
#' @export
H5Tget_precision <- function(dtype_id) {
  if (missing(dtype_id)) {
    stop("Argument 'dtype_id' must be supplied")
  }

  precision <- .Call("_H5Tget_precision", dtype_id, PACKAGE = "rhdf5")

  return(precision)
}

#' Create or modify an HDF5 enum datatype
#'
#' @param dtype_id ID of HDF5 datatype to work with.  For `H5Tenum_create`, this
#'   is the identifier of the base data type, and must be an integer e.g.
#'   `H5T_NATIVE_INT`. For `H5Tenum_insert` this will be a datatype identifier
#'   created by `H5Tenum_create`.
#' @param name The name of a the new enum member.  This is analogous to a
#'   "level" in an R factor.
#' @param value The value of the new member.  Must be compatible with the base
#'   datatype defined by `dtype_id`.
#'
#' @returns
#' * `H5Tinsert_enum()` returns an character representing the H5 identifier
#' of the new datatype.
#' * `H5Tset_precision()` is called for its side-effect of modifying the
#' existing datatype.  It will invisibly
#' return `TRUE` if this is successful `FALSE` if not.
#'
#' @examples
#' tid <- H5Tenum_create(dtype_id = "H5T_NATIVE_UCHAR")
#' H5Tenum_insert(tid, name = "TRUE", value = 1L)
#' H5Tenum_insert(tid, name = "FALSE", value = 0L)
#'
#' @name H5T_enum
NULL

#' @rdname H5T_enum
#' @export
H5Tenum_create <- function(dtype_id = "H5T_NATIVE_INT") {
  dtype_id <- h5checkConstants("H5T", dtype_id)
  .Call("_H5Tenum_create", dtype_id, PACKAGE = "rhdf5")
}

#' @rdname H5T_enum
#' @export
H5Tenum_insert <- function(dtype_id, name, value) {
  if (!is.integer(value)) {
    stop("The 'value' argument must be an integer.")
  }

  res <- .Call("_H5Tenum_insert", dtype_id, name, value)

  return(invisible(res >= 0))
}

#' Get details of HDF5 data types
#'
#' @param dtype_id ID of HDF5 datatype to work with.  Normally created with
#' a function like `H5Tcopy` or `H5Tenum_create`.
#'
#' @returns
#' * `H5Tget_class()` returns an character vector of length 1 giving the
#' class of the data type.
#' * `H5Tget_nmembers()` returns the number of members in the given
#' datatype.  Will fail with an error if the supplied datatype is not of type
#' `H5T_COMPUND` or `H5T_ENUM`.
#'
#' @examples
#' ## create an enum datatype with two entries
#' tid <- H5Tenum_create(dtype_id = "H5T_NATIVE_UCHAR")
#' H5Tenum_insert(tid, name = "TRUE", value = 1L)
#' H5Tenum_insert(tid, name = "FALSE", value = 0L)
#'
#' H5Tget_class(tid)
#' H5Tget_nmembers(tid)
#'
#' @name H5T_ops
NULL

#' @rdname H5T_ops
#' @export
H5Tget_class <- function(dtype_id) {
  type <- .Call("_H5Tget_class", dtype_id, PACKAGE = "rhdf5")
  return(type)
}

#' @rdname H5T_ops
#' @export
H5Tget_nmembers <- function(dtype_id) {
  H5T_class <- H5Tget_class(dtype_id)
  if (!H5T_class %in% c("H5T_COMPOUND", "H5T_ENUM")) {
    stop(
      "The data type of 'dtype_id' must be either 'H5T_COMPOUND' or 'H5T_ENUM'"
    )
  }

  n_members <- .Call("_H5Tget_nmembers", dtype_id, PACKAGE = "rhdf5")
  return(n_members)
}

library(rhdf5)

tid <- H5Tcopy("H5T_C_S1")
integer_tid <- H5Tcopy("H5T_STD_U32LE")

test_that("String padding can be read and changed", {
  expect_silent(tid2 <- H5Tset_strpad(dtype_id = tid, strpad = "NULLTERM"))
  expect_identical(H5Tget_strpad(tid), 0L)
  expect_silent(tid2 <- H5Tset_strpad(dtype_id = tid, strpad = "NULLPAD"))
  expect_identical(H5Tget_strpad(tid), 1L)
  expect_silent(tid2 <- H5Tset_strpad(dtype_id = tid, strpad = "SPACEPAD"))
  expect_identical(H5Tget_strpad(tid), 2L)
})

test_that("String character set can be read and changed", {
  expect_identical(H5Tget_cset(tid), 0L)

  expect_silent(H5Tset_cset(tid, cset = "UTF-8")) |>
    expect_gte(0)

  expect_identical(H5Tget_cset(tid), 1L)
})

test_that("H5T error handling works", {
  expect_error(H5Tget_strpad())
  expect_error(H5Tset_strpad(dtype_id = tid, strpad = "FOOBAA"))

  expect_error(H5Tget_size())
  expect_error(H5Tset_size(dtype_id = "H5T_C_S1"))

  expect_error(H5Tget_cset())
  expect_error(H5Tget_cset(dtype_id = tid, cset = "FOOBAA"))
})

test_that("Precision can be modified", {
  expect_identical(H5Tget_precision(integer_tid), 32L)
  expect_true(H5Tset_precision(integer_tid, precision = 8))
  expect_identical(H5Tget_precision(integer_tid), 8L)

  expect_error(
    H5Tget_precision(),
    regexp = "Argument 'dtype_id' must be supplied"
  )
  expect_error(
    H5Tset_precision(),
    regexp = "Argument 'dtype_id' must be supplied"
  )
  expect_error(
    H5Tset_precision(integer_tid, 0),
    regexp = "'precision' argument must be greater than 0"
  )
})

test_that("Enum datatypes can be created and modified", {
  expect_silent(tid <- H5Tenum_create(dtype_id = "H5T_NATIVE_UCHAR"))
  expect_is(tid, "character")

  expect_true(H5Tenum_insert(tid, name = "TRUE", value = 1L))
  expect_true(H5Tenum_insert(tid, name = "FALSE", value = 0L))
})

# Copied from S4Arrays
#' @importFrom utils tail
extract_Nindex_from_syscall <- function(call, eframe) {
  Nindex <- lapply(seq_len(length(call) - 2L), function(i) {
    subscript <- call[[2L + i]]
    if (missing(subscript)) {
      return(NULL)
    }
    subscript <- eval(subscript, envir = eframe, enclos = eframe)
    if (is.null(subscript)) {
      return(integer(0))
    }
    subscript
  })
  argnames <- tail(names(call), n = -2L)
  if (!is.null(argnames)) {
    Nindex <- Nindex[!(argnames %in% c("drop", "exact", "value"))]
  }
  if (length(Nindex) == 1L && is.null(Nindex[[1L]])) {
    Nindex <- Nindex[0L]
  }
  # Custom patch to allow x[]
  if (length(Nindex) == 0L) {
    Nindex <- NULL
  }
  Nindex
}

#' Identifies the filters required to read a dataset
#' If filters aren't available it will try to identify them
#' and print the names to the user.
#' @keywords internal
h5checkFilters <- function(h5id) {
  truetype <- H5Iget_type(h5id)

  if (truetype == "H5I_DATASET") {
    pid <- H5Dget_create_plist(h5id)
    on.exit(H5Pclose(pid))
  } else if (truetype == "H5I_GENPROP_LST") {
    ## we require this to be a DATASET creation plist
    pid <- h5checktypeAndPLC(h5id, "H5P_DATASET_CREATE")
  }

  nfilters <- H5Pget_nfilters(pid)
  if (nfilters > 0 && H5Pall_filters_avail(pid) == 0) {
    err <- "Unable to read dataset.\nNot all required filters available.\n"
    missing <- NULL
    for (i in seq_len(nfilters)) {
      filter <- H5Pget_filter(pid, i)
      avail <- H5Zfilter_avail(filter_id = filter[[1]])
      if (!avail) {
        missing <- c(missing, filter[[2]])
      }
    }
    err <- paste0(err, "Missing filters: ", paste(missing, collapse = " "))
    return(err)
  } else {
    return("")
  }
}

#!/bin/bash

# The rhdf5 package will contain a complete installation of the HDF5 C library.
# No further downloads from HDF5 are necessary. 
# This file contains code for bioconductor administrators.

if [ "$1" = "" ]; then
   echo "Please give version number as parameter"
   exit 0
fi

VERSION=$1
WEBDIR=http://www.hdfgroup.org/ftp/HDF5/prev-releases/hdf5-${VERSION}
# WEBDIR=http://www.hdfgroup.org/ftp/HDF5/current
echo "download HDF5-$VERSION from $WEBDIR"
echo "#############"
echo "## download source for linux and mac"
echo "#############"
mkdir source
rm -f src/hdf5small.tgz
cd source
wget ${WEBDIR}/src/hdf5-${VERSION}.tar.gz
tar -xzf hdf5-${VERSION}.tar.gz
cd hdf5-${VERSION}
SCRIPT="source(\"../../inst/downloadHDF5/replacestr.R\")"
echo ${SCRIPT}
echo ${SCRIPT} | R --arch=x86_64 --slave --vanilla
rm -rf c++
rm -rf examples
rm -rf fortran
rm -rf hl
rm -rf perform
rm -rf release_docs
rm -rf test
rm -rf testpar
rm -rf tools
rm -rf vms
rm -rf windows
cd ..
mv hdf5-${VERSION} hdf5
tar -czf hdf5small.tgz hdf5
cd ..
mv source/hdf5small.tgz src/
echo "#############"
echo "## download precompiled win32 libraries"
echo "#############"
mkdir win32
cd win32
wget ${WEBDIR}/bin/windows/HDF5-${VERSION}_win_x86.zip
unzip -q HDF5-${VERSION}_win_x86.zip
cd ..
rm -rf src/libwin
mkdir src/libwin
mkdir src/libwin/i386
cp win32/dll/hdf5dll.dll src/libwin/i386
cp win32/dll/szip.dll src/libwin/i386
cp win32/dll/zlib1.dll src/libwin/i386
echo "#############"
echo "## download precompiled win64 libraries"
echo "#############"
mkdir win64
cd win64
wget ${WEBDIR}/bin/windows/HDF5-${VERSION}_win_x64.zip
unzip -q HDF5-${VERSION}_win_x64.zip
cd ..
mkdir src/libwin/x64
cp win64/dll/hdf5dll.dll src/libwin/x64/hdf5dll-64.dll
cp win64/dll/szip.dll src/libwin/x64/szip-64.dll
cp win64/dll/zlib1.dll src/libwin/x64/zlib1-64.dll
echo "#############"
echo "## download static cygwin libraries to obtain windows header files"
echo "#############"
mkdir static
cd static
wget ${WEBDIR}/bin/windows/hdf5-${VERSION}_cygwin_x86_static.zip
unzip -q hdf5-${VERSION}_cygwin_x86_static.zip
sed "s/#define H5_HAVE_FEATURES_H 1/\/\*\ #define H5_HAVE_FEATURES_H 1\*\//g" include/H5pubconf.h > tmp.txt
mv -f tmp.txt include/H5pubconf.h
cd ..
rm -rf src/includeWin
mkdir src/includeWin
mv static/include/* src/includeWin

# cleanup
rm -rf win32
rm -rf win64
rm -rf static
rm -rf source

---
title: "**rhdf5** Practical Tips"
author:
- name: Mike L. Smith
  affiliation:
    - EMBL Heidelberg
    - German Network for Bioinformatics Infrastructure (de.NBI)
package: rhdf5
output:
  BiocStyle::html_document:
    toc_float: true
abstract: |
  Provides discussion and practical examples for effectively using *rhdf5*
  and the HDF5 file format.
vignette: |
  %\VignetteIndexEntry{rhdf5 Practical Tips}
  %\VignetteEncoding{UTF-8}
  %\VignetteEngine{knitr::rmarkdown}
editor_options:
  chunk_output_type: console
---

```{r setup, echo = FALSE, include=FALSE}
set.seed(1234)

library(rhdf5)
library(dplyr)
library(ggplot2)
library(BiocParallel)

# R CMD check asks we use no more than 2 cores
run_on_platform <- .Platform$OS.type == "unix" && !nzchar(Sys.getenv("_R_CHECK_LIMIT_CORES_"))
```

# Introduction

There are scenarios where the most intuitive approach to working with *rhdf5* or HDF5 will not be the most efficient.  This may be due to unfamiliar bottlenecks when working with data on-disk rather than in memory, or idiosyncrasies in either the HDF5 library itself or the *rhdf5* package.  This vignette is intended to present a collection of hints for circumventing some common pitfalls.

# Reading subsets of data

One of the cool features about the HDF5 file format is the ability to read subsets of the data without (necessarily) having to read the entire file, keeping both the memory usage and execution times of these operations to a minimum.  However this is not always as performant as one might hope.

To demonstrate we'll create some example data.  This takes the form of a matrix with 100 rows and 20,000 columns, where the content of each column is the index of the column i.e. column 10 contains the value 10 repeated, column 20 contains 20 repeated etc.  This is just so we can easily check we've extracted the correct columns. We then write this matrix to an HDF5 file, calling the dataset 'counts'. ^[You'll probably see a warning here regarding chunking, something we'll touch on later]

```{r create data, echo=TRUE, warning=FALSE}
m1 <- matrix(rep(1:20000, each = 100), ncol = 20000, byrow = FALSE)
ex_file <- tempfile(fileext = ".h5")
h5write(m1, file = ex_file, name = "counts", level = 6)
```
## Using the `index` argument

Now we'll use the `index` argument to selectively extract the first 10,000 columns and time how long this takes.

```{r extract1, echo = TRUE}
system.time(
  res1 <- h5read(
    file = ex_file, name = "counts",
    index = list(NULL, 1:10000)
  )
)
```

Next, instead of selecting 10,000 consecutive columns we'll ask for every other column.  This should still return the same amount of data and since our dataset is not chunked involves reading the same volume from disk.

```{r extract2, echo = TRUE}
index <- list(NULL, seq(from = 1, to = 20000, by = 2))
system.time(
  res2 <- h5read(
    file = ex_file, name = "counts",
    index = index
  )
)
```

We can see this is marginally slower, because there's a small overhead in selecting this disjoint set of columns, but it's only marginal and using the `index` argument looks sufficient.

## Using hyperslab selections

If you're new to R, but have experience with HDF5 you might be more familiar with using HDF5's hyperslab selection method^[The parameters for defining hyperslab selection `start`, `stride`, `block`, & `count` are not particularly intuitive if you are used to R's index selection methods.  More examples discussing how to specify them can be found at [www.hdfgroup.org](https://portal.hdfgroup.org/display/HDF5/Reading+From+or+Writing+To+a+Subset+of+a+Dataset).  The following code defines the parameters to select every other column, the same as in our previous example.

```{r extract3, echo = TRUE}
start <- c(1, 1)
stride <- c(1, 2)
block <- c(100, 1)
count <- c(1, 10000)
system.time(
  res3 <- h5read(
    file = ex_file, name = "counts", start = start,
    stride = stride, block = block, count = count
  )
)
identical(res2, res3)
```

This runs in a similar time to when we used the `index` argument in the example above, and the call to `identical()` confirms we're returning the same data.  In fact, under the hood, *rhdf5* converts the `index` argument into `start`, `stride`, `block`, & `count` before accessing the file, which is why the performance is so similar.

If there is a easily described pattern to the regions you want to access e.g. a single block or a regular spacing, then either of these approaches is effective.

## Irregular selections

However, things get a little more tricky if you want an irregular selection of data, which is actually a pretty common operation.  For example, imagine wanting to select a random set of columns from our data.  If there isn't a regular pattern to the columns you want to select, what are the options?  Perhaps the most obvious thing we can try is to skip the use of either `index` or the hyperslab parameters and use 10,000 separate read operations instead.  Below we choose a random selection of columns^[in the interested of time we actually select only 1,000 columns here] and then apply the function `f1()` to each in turn.

```{r, chooseColunns, eval = TRUE}
columns <- sample(x = seq_len(20000), size = 1000, replace = FALSE) %>%
  sort()
f1 <- function(cols, name) {
  h5read(
    file = ex_file, name = name,
    index = list(NULL, cols)
  )
}
```

```{r singleReads, eval = run_on_platform, cache = TRUE}
system.time(res4 <- vapply(
  X = columns, FUN = f1,
  FUN.VALUE = integer(length = 100),
  name = "counts"
))
```

This is clearly a terrible idea, it takes ages!  For reference, using the `index` argument with this set of columns takes `r system.time(h5read(file = ex_file, name = "counts", index = list(NULL, columns)))['elapsed']` seconds.  This poor performance is driven by two things:

1. Our dataset was created as a single chunk.  This means for each access the entire dataset is read from disk, which we end up doing thousands of times.
2. *rhdf5* does a lot of validation on the objects that are passed around internally.  Within a call to `h5read()` HDF5 identifiers are created for the file, dataset, file dataspace, and memory dataspace, each of which are checked for validity.  This overhead is negligible when only one call to `h5read()` is made, but be
comes significant when we make thousands of separate calls.

There's not much more you can do if the dataset is not chunked appropriately, and using the `index` argument is reasonable.  However storing data in this format defeats one of HDF5's key utilities, namely rapid random access.  As such it's probably fairly rare to encounter datasets that aren't chunked in a more meaningful manner.  With this in mind we'll create a new dataset in our file, based on the same matrix but this time split into 100 $\times$ 100 chunks.

```{r createChunked, echo = TRUE, eval = TRUE, results='hide'}
h5createDataset(
  file = ex_file, dataset = "counts_chunked",
  dims = dim(m1), storage.mode = "integer",
  chunk = c(100, 100), level = 6
)
h5write(obj = m1, file = ex_file, name = "counts_chunked")
```

If we rerun the same code, but reading from the chunked datasets we get an idea for how much time is wasted extracting the entire dataset over and over.

```{r read_chunked, eval = TRUE}
system.time(res5 <- vapply(
  X = columns, FUN = f1,
  FUN.VALUE = integer(length = 100),
  name = "counts_chunked"
))
```

This is still quite slow, and the remaining time is being spent on the overheads associated with multiple calls to `h5read()`.  To reduce these the function `f2()`^[This is not the greatest function ever, things like the file name are hardcoded out of sight, but it illustrates the technique.] defined below splits the list of columns we want to return into sets grouped by the parameter `block_size`.  In the default case this means any columns between 1 & 100 will be placed together, then any between 101 & 200, etc.  We then `lapply()` our previous `f1()` function over these groups.  The effect here is to reduce the number of calls to `h5read()`, while keeping the number of hyperslab unions down by not having too many columns in any one call.

```{r}
f2 <- function(block_size = 100) {
  cols_grouped <- split(columns, (columns - 1) %/% block_size)
  do.call(cbind, lapply(cols_grouped, f1, name = "counts_chunked"))
}
system.time(f2())
```

```{r benchmark, echo = FALSE, cache = TRUE}
bm <- bench::mark(
  f2(10), f2(25), f2(50), f2(100),
  f2(250), f2(500), f2(1000),
  f2(2000), f2(5000), f2(10000),
  iterations = 3,
  check = FALSE,
  time_unit = "s",
  memory = FALSE,
  filter_gc = FALSE
)

bm2 <- data.frame(
  block_size = gsub(".*\\(([0-9]+)\\)", "\\1", bm$expression) |>
    as.integer() |>
    rep(each = 3),
  time = unlist(bm$time)
)
```

We can see this has a significant effect, although it's still an order of magnitude slower than when we were dealing with regularly spaced subsets.  The efficiency here will vary based on a number of factors including the size of the dataset chunks and the sparsity of the column index, and you varying the `block_size` argument will produce differing performances.  The plot below shows the timings achieved by providing a selection of values to `block_size`.  It suggests the optimal parameter in this case is probably a block size of `r bm2 %>% arrange(time) %>% slice(1) %>% .$block_size`, which took `r bm2 %>% arrange(time) %>% slice(1) %>% .$time %>% round(2)` seconds - noticeably faster than when passing all columns to the `index` argument in a single call.

```{r, echo = FALSE, fig.width=6, fig.height=3, fig.wide = TRUE}
ggplot(bm2, aes(x = block_size, y = time)) +
  geom_point() +
  scale_x_log10() +
  theme_bw() +
  ylab("time (seconds)")
```

### Using hyperslab selection tools

If we were stuck with the single-chunk dataset and want to minimise the number of read operations, it's necessary to create larger selections than the single column approach used above.  We could again consider using the HDF5 hyperslab selection tools, and if it's not easy to discern an underlying pattern to the selection, perhaps the simplest way of approaching this with the would be to create one selection for each column.  You could then use functions like `H5Scombine_hyperslab()` or `H5Scombine_select()` to iteratively join these selections until all columns were selected, and then perform the read operation.

### Slowdown when selecting unions of hyperslabs

Unfortunately, this approach doesn't scale very well.  This is because creating unions of hyperslabs is currently very slow in HDF5 (see [Union of non-consecutive hyperslabs is very slow](https://forum.hdfgroup.org/t/union-of-non-consecutive-hyperslabs-is-very-slow/5062) for another report of this behaviour), with the performance penalty increasing exponentially relative to the number of unions.  The plot below shows the the exponential increase in time as the number of hyberslab unions increases.

```{r, hyperslab-benchmark, eval = run_on_platform, echo = FALSE, fig.width=6, fig.height=3, fig.wide = TRUE, fig.cap='The time taken to join hyperslabs increases expontentially with the number of join operations.  These timings are taken with no reading occuring, just the creation of a dataset selection.'}
## this code demonstrates the exponential increase in time as the
## number of hyberslab unions increases

select_index <- function(n = 1) {
  ## open the dataspace for the count table
  fid <- H5Fopen(ex_file)
  did <- H5Dopen(fid, name = "counts")
  sid <- H5Dget_space(did)

  ## column choice based on number of unions required
  columns <- c(head(1:10001, n = -n), head(seq(10001 - n + 2, 20000, 2), n = n - 1))
  index <- list(100, columns)
  H5Sselect_index(sid, index = index)

  ## tidy up
  H5Sclose(sid)
  H5Dclose(did)
  H5Fclose(fid)
}

bm <- bench::mark(
  select_index(1), select_index(2), select_index(5),
  select_index(10), select_index(20), select_index(50),
  select_index(100), select_index(200), select_index(500),
  select_index(1000), select_index(2000), select_index(5000),
  select_index(10000),
  iterations = 3,
  check = FALSE,
  time_unit = "s",
  memory = FALSE,
  filter_gc = FALSE
)

bm2 <- data.frame(
  n = gsub(".*\\(([0-9]+)\\)", "\\1", bm$expression) |>
    as.integer() |>
    rep(each = 3),
  time = unlist(bm$time)
)

ggplot(bm2, aes(x = n, y = time)) +
  geom_point() +
  scale_x_log10() +
  scale_y_log10() +
  theme_bw() +
  xlab("number of hyperslab unions") +
  ylab("time (seconds)")
```

## Summary

Efficiently extracting arbitrary subsets of a HDF5 dataset with *rhdf5* is a balancing act between the number of hyperslab unions, the number of calls to `h5read()`, and the number of times a chunk is read. Many of the lessons learnt will creating this document have been incorporated into the `h5read()` function.  Internally, this function attempts to find the balance by looking for patterns in the data selection requested, and minimises the number of hyperslab unions and read operations required to extract the requested data.


# Writing in parallel

Using `r BiocStyle::Biocpkg('rhdf5')` it isn't possible to open an HDF5 file and write multiple datasets in parallel.  However we can try to mimic this behaviour by writing each dataset to it's own HDF5 file in parallel and then using the function `H5Ocopy()` to efficiently populate a complete final file.  We'll test this approach here.

## Example data

First lets create some example data to we written to our HDF5 files.  The code below creates a list of 10 matrices, filled with random values between 0 and 1.  We then name the entries in the list `dset_1` etc.

```{r example-dsets}
dsets <- lapply(1:10, FUN = \(i) {
  matrix(runif(10000000), ncol = 100)
})
names(dsets) <- paste0("dset_", 1:10)
```

## Serial writing of datasets

Now lets define a function that takes our list of datasets and writes all of them to a single HDF5 file.

```{r}
simple_writer <- function(file_name, dsets) {
  fid <- H5Fcreate(name = file_name)
  on.exit(H5Fclose(fid))

  for (i in seq_along(dsets)) {
    dset_name <- paste0("dset_", i)
    h5createDataset(
      file = fid, dataset = dset_name,
      dims = dim(dsets[[i]]), chunk = c(10000, 10)
    )
    h5writeDataset(dsets[[i]], h5loc = fid, name = dset_name)
  }
}
```

An example of calling this function would look like: `simple_writer(file_name = "my_datasets.h5", dsets = dsets)`.  This would create the file `my_datasets.h5` and it will contain the 10 datasets we created above, each named `dset_1` etc, which are the names we gave the list elements.

## Parallel writing of datasets

Now lets created two functions to tests our split / gather approach to creating the final file.  The first of the functions below will create a temporary file with a random name and write a single dataset to this file.  The second function expects to be given a table of temporary files and the name of the dataset they contain.  It will then use `H5Ocopy()` to write each of these into a single output file.


```{r}
## Write a single dataset to a temporary file
## Arguments:
## - dset_name: The name of the dataset to be created
## - dset: The dataset to be written
split_tmp_h5 <- function(dset_name, dset) {
  ## create a tempory HDF5 file for this dataset
  file_name <- tempfile(pattern = "par", fileext = ".h5")
  fid <- H5Fcreate(file_name)
  on.exit(H5Fclose(fid))

  ## create and write the dataset
  ## we use some predefined chunk sizes
  h5createDataset(
    file = fid, dataset = dset_name,
    dims = dim(dset), chunk = c(10000, 10)
  )
  h5writeDataset(dset, h5loc = fid, name = dset_name)

  return(c(file_name, dset_name))
}

## Gather scattered datasets into a final single file
## Arguments:
## - output_file: The path to the final HDF5 to be created
## - input: A data.frame with two columns containing the paths to the temp
## files and the name of the dataset inside that file
gather_tmp_h5 <- function(output_file, input) {
  ## create the output file
  fid <- H5Fcreate(name = output_file)
  on.exit(H5Fclose(fid))

  ## iterate over the temp files and copy the named dataset into our new file
  for (i in seq_len(nrow(input))) {
    fid2 <- H5Fopen(input$file[i])
    H5Ocopy(fid2, input$dset[i], h5loc_dest = fid, name_dest = input$dset[i])
    H5Fclose(fid2)
  }
}
```

Finally we need to create a wrapper function that brings our split and gather functions together.  Like the `simple_writer()` function we created earlier, this takes the name of an output file and the list of datasets to be written as input.  We can also provide a `BiocParallelParam` instance from `r BiocStyle::Biocpkg("BiocParallel")` to trial writing the temporary file in parallel.  If the `BPPARAM` argument isn't provided then they will be written in serial.

```{r, define-split-gather}
split_and_gather <- function(output_file, input_dsets, BPPARAM = NULL) {
  if (is.null(BPPARAM)) {
    BPPARAM <- BiocParallel::SerialParam()
  }

  ## write each of the matrices to a separate file
  tmp <-
    bplapply(seq_along(input_dsets),
      FUN = function(i) {
        split_tmp_h5(
          dset_name = names(input_dsets)[i],
          dset = input_dsets[[i]]
        )
      },
      BPPARAM = BPPARAM
    )

  ## create a table of file and the dataset names
  input_table <- do.call(rbind, tmp) |>
    as.data.frame()
  names(input_table) <- c("file", "dset")

  ## copy all datasets from temp files in to final output
  gather_tmp_h5(output_file = output_file, input = input_table)

  ## remove the temporary files
  file.remove(input_table$file)
}
```

An example of calling this using two cores on your local machine is:

```{r, eval = FALSE}
split_and_gather(tempfile(),
  input_dsets = dsets,
  BPPARAM = MulticoreParam(workers = 2)
)
```

Below we can see some timings comparing calling `simple_writer()` with `split_and_gather()` using 1, 2, and 4 cores.

```{r, run-writing-benchmark, eval = run_on_platform, cache = TRUE, message=FALSE, echo=FALSE}
bench_results <- bench::mark(
  "simple writer" = simple_writer(file_name = tempfile(), dsets = dsets),
  "split/gather - 1 core" = split_and_gather(tempfile(),
    input_dsets = dsets,
    BPPARAM = NULL
  ),
  "split/gather - 2 cores" = split_and_gather(tempfile(),
    input_dsets = dsets,
    BPPARAM = MulticoreParam(workers = 2)
  ),
  "split/gather - 4 cores" = split_and_gather(tempfile(),
    input_dsets = dsets,
    BPPARAM = MulticoreParam(workers = 4)
  ),
  iterations = 2,
  check = FALSE,
  time_unit = "s",
  memory = FALSE,
  filter_gc = FALSE
)
bench_results[, c("expression", "min", "median")]
```

```{r, fake-timings, eval = !run_on_platform, message = FALSE, echo = FALSE}
bench_results <- data.frame(median = 4:1)
```

We can see from our benchmark results that there is some performance improvement to be achieved by using the parallel approach.  Based on the median times of out three iterations using two cores sees an speedup of `r round(bench_results$median[1] / bench_results$median[3], 2)` and `r round(bench_results$median[1] / bench_results$median[4], 1)` with 4 cores.  This isn't quite linear, presumably because there are overheads involved both in using a two-step process and initialising the parallel workers, but it is a noticeable improvement.

# Session info {.unnumbered}

```{r sessionInfo, echo=FALSE}
sessionInfo()
```

---
title: "rhdf5 - HDF5 interface for R"
author:
- name: Bernd Fischer
  affiliation: DKFZ
- name: Mike L. Smith
  affiliation: de.NBI & EMBL Heidelberg
package: rhdf5
output:
  BiocStyle::html_document
vignette: |
  %\VignetteIndexEntry{rhdf5 - HDF5 interface for R}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

```{r cleanup, echo=FALSE, include=FALSE}
if(file.exists('myhdf5file.h5'))
    file.remove('myhdf5file.h5')
if(file.exists('newfile.h5'))
    file.remove('newfile.h5')
if(file.exists('newfile2.h5'))
    file.remove('newfile2.h5')
if(file.exists('newfile3.h5'))
    file.remove('newfile3.h5')
```

# Introduction
The package is an R interface for HDF5. On the one hand it implements
**R** interfaces to many of the low level functions from the C
interface. On the other hand it provides high level convenience
functions on **R** level to make a usage of HDF5 files more easy.

#Installation of the HDF5 package
To install the `r Biocpkg("rhdf5")` package, you need a current version
(>3.5.0) of **R** (www.r-project.org). After installing **R** you can
run the following commands from the **R** command shell to install `r Biocpkg("rhdf5")`.

```{r installation,eval=FALSE}
install.packages("BiocManager")
BiocManager::install("rhdf5")
```

# High level R-HDF5 functions

## Creating an HDF5 file and group hierarchy

An empty HDF5 file is created by
```{r createHDF5file}
library(rhdf5)
h5createFile("myhdf5file.h5")
```

The HDF5 file can contain a group hierarchy. We create a number of
groups and list the file content afterwards.
```{r create groups}
h5createGroup("myhdf5file.h5","foo")
h5createGroup("myhdf5file.h5","baa")
h5createGroup("myhdf5file.h5","foo/foobaa")
h5ls("myhdf5file.h5")
```

## Writing and reading objects

Objects can be written to the HDF5 file. Attributes attached to an
object are written as well, if `write.attributes=TRUE` is
given as argument to `h5write`. Note that not all
**R**-attributes can be written as HDF5 attributes.

```{r writeMatrix}
A = matrix(1:10,nr=5,nc=2)
h5write(A, "myhdf5file.h5","foo/A")
B = array(seq(0.1,2.0,by=0.1),dim=c(5,2,2))
attr(B, "scale") <- "liter"
h5write(B, "myhdf5file.h5","foo/B")
C = matrix(paste(LETTERS[1:10],LETTERS[11:20], collapse=""),
  nr=2,nc=5)
h5write(C, "myhdf5file.h5","foo/foobaa/C")
df = data.frame(1L:5L,seq(0,1,length.out=5),
  c("ab","cde","fghi","a","s"), stringsAsFactors=FALSE)
h5write(df, "myhdf5file.h5","df")
h5ls("myhdf5file.h5")
D = h5read("myhdf5file.h5","foo/A")
E = h5read("myhdf5file.h5","foo/B")
F = h5read("myhdf5file.h5","foo/foobaa/C")
G = h5read("myhdf5file.h5","df")
```

If a dataset with the given `name` does not yet exist, a
dataset is created in the HDF5 file and the object `obj` is
written to the HDF5 file. If a dataset with the given `name`
already exists and the datatype and the dimensions are the same as for
the object `obj`, the data in the file is overwritten. If the
dataset already exists and either the datatype or the dimensions are
different, `h5write()` fails.

## Writing and reading objects with file, group and dataset handles

File, group and dataset handles are a simpler way to read (and partially to write) HDF5 files.
A file is opened by `H5Fopen`.

```{r accessorH5Fopen}
h5f = H5Fopen("myhdf5file.h5")
h5f
```

The `$` and `&` operators can be used to access the next group level. While the `$` operator reads the object from disk, the `&` operator returns a group or dataset handle.

```{r accessorDF}
h5f$df
h5f&'df'
```

Both of the following code lines return the matrix `C`. Note however, that the first version reads the whole tree `/foo` in memory and then subsets to `/foobaa/C`, and the second version only reads the matrix `C`. The first `$` in `h5f$foo$foobaa$C` reads the dataset, the other `$` are accessors of a list. Remind that this can have severe consequences for large datasets and datastructures.

```{r accessorC1}
h5f$foo$foobaa$C
h5f$"/foo/foobaa/C"
```

One can as well return a dataset handle for a matrix and then read the matrix in chunks for out-of-memory computations. \warning{Please read the next section on subsetting, chunking and compression for more details}.

```{r accessorB1}
h5d = h5f&"/foo/B"
h5d[]
h5d[3,,]
```

The same works as well for writing to datasets. \warning{Remind that it is only guarenteed that the data is written on disk after a call to `H5Fflush` or after closing of the file.}
```{r accessorB2}
h5d[3,,] = 1:4
H5Fflush(h5f)
```

Remind again that in the following code the first version does not change the data on disk, but the second does.
```{r accessorB3,eval=FALSE}
h5f$foo$B = 101:120
h5f$"/foo/B" = 101:120
```

It is important to close all dataset, group, and file handles when not used anymore
```{r accessorClose1}
H5Dclose(h5d)
H5Fclose(h5f)
```
or close all open HDF5 handles in the environment by
```{r accessorClose2}
h5closeAll()
```

\subsection{Writing and reading with subsetting, chunking and compression}
The `r Biocpkg("rhdf5")` package provides two ways of subsetting. One can
specify the submatrix with the **R**-style index lists or with the HDF5
style hyperslabs. Note, that the two next examples below show two
alternative ways for reading and writing the exact same
submatrices. Before writing subsetting or hyperslabbing, the dataset
with full dimensions has to be created in the HDF5 file. This can be
achieved by writing once an array with full dimensions as in Section
\ref{sec_writeMatrix} or by creating a dataset. Afterwards the dataset
can be written sequentially.

\paragraph{Influence of chunk size and compression level} The chosen
chunk size and compression level have a strong impact on the reading
and writing time as well as on the resulting file size. In an example
an integer vector of size 10e7 is written to an HDF5 file. The file is
written in subvectors of size 10'000. The definition of the chunk size
influences the reading as well as the writing time. If the chunk size
is much smaller or much larger than actually used, the runtime
performance decreases dramatically. Furthermore the file size is
larger for smaller chunk sizes, because of an overhead. The
compression can be much more efficient when the chunk size is very
large. The following figure illustrates the runtime and file size
behaviour as a function of the chunk size for a small toy dataset.


![](../inst/demoChunkSize/chunksize-1.png)

After the creation of the dataset, the data can be written
sequentially to the HDF5 file. Subsetting in **R**-style needs the
specification of the argument index to `h5read()` and
`h5write()`.

```{r writeMatrixSubsetting}
h5createDataset("myhdf5file.h5", "foo/S", c(5,8),
                storage.mode = "integer", chunk=c(5,1), level=7)
h5write(matrix(1:5,nr=5,nc=1), file="myhdf5file.h5",
        name="foo/S", index=list(NULL,1))
h5read("myhdf5file.h5", "foo/S")
h5write(6:10, file="myhdf5file.h5",
        name="foo/S", index=list(1,2:6))
h5read("myhdf5file.h5", "foo/S")
h5write(matrix(11:40,nr=5,nc=6), file="myhdf5file.h5",
        name="foo/S", index=list(1:5,3:8))
h5read("myhdf5file.h5", "foo/S")
h5write(matrix(141:144,nr=2,nc=2), file="myhdf5file.h5",
        name="foo/S", index=list(3:4,1:2))
h5read("myhdf5file.h5", "foo/S")
h5write(matrix(151:154,nr=2,nc=2), file="myhdf5file.h5",
        name="foo/S", index=list(2:3,c(3,6)))
h5read("myhdf5file.h5", "foo/S")
h5read("myhdf5file.h5", "foo/S", index=list(2:3,2:3))
h5read("myhdf5file.h5", "foo/S", index=list(2:3,c(2,4)))
h5read("myhdf5file.h5", "foo/S", index=list(2:3,c(1,2,4,5)))
```

The HDF5 hyperslabs are defined by some of the arguments
`start`, `stride`, `count`, and
`block`. These arguments are not effective, if the argument
`index` is specified.

```{r writeMatrixHyperslab}
h5createDataset("myhdf5file.h5", "foo/H", c(5,8), storage.mode = "integer",
                chunk=c(5,1), level=7)
h5write(matrix(1:5,nr=5,nc=1), file="myhdf5file.h5", name="foo/H",
        start=c(1,1))
h5read("myhdf5file.h5", "foo/H")
h5write(6:10, file="myhdf5file.h5", name="foo/H",
        start=c(1,2), count=c(1,5))
h5read("myhdf5file.h5", "foo/H")
h5write(matrix(11:40,nr=5,nc=6), file="myhdf5file.h5", name="foo/H",
        start=c(1,3))
h5read("myhdf5file.h5", "foo/H")
h5write(matrix(141:144,nr=2,nc=2), file="myhdf5file.h5", name="foo/H",
        start=c(3,1))
h5read("myhdf5file.h5", "foo/H")
h5write(matrix(151:154,nr=2,nc=2), file="myhdf5file.h5", name="foo/H",
        start=c(2,3), stride=c(1,3))
h5read("myhdf5file.h5", "foo/H")
h5read("myhdf5file.h5", "foo/H",
       start=c(2,2), count=c(2,2))
h5read("myhdf5file.h5", "foo/H",
       start=c(2,2), stride=c(1,2),count=c(2,2))
h5read("myhdf5file.h5", "foo/H",
       start=c(2,1), stride=c(1,3),count=c(2,2), block=c(1,2))
```

## Saving multiple objects to an HDF5 file (h5save)

A number of objects can be written to the top level group of an HDF5
file with the function `h5save()` (as analogous to the base
**R** function `save()`).
```{r h5save}
A = 1:7;  B = 1:18; D = seq(0,1,by=0.1)
h5save(A, B, D, file="newfile2.h5")
h5dump("newfile2.h5")
```

## List the content of an HDF5 file

The function `h5ls()` provides some ways of viewing the content of an HDF5 file.

```{r h5ls}
h5ls("myhdf5file.h5")
h5ls("myhdf5file.h5", all=TRUE)
h5ls("myhdf5file.h5", recursive=2)
```

## Dump the content of an HDF5 file

The function `h5dump()` is similar to the function `h5ls()`. If
used with the argument `load=FALSE`, it produces the same result
as `h5ls()`, but with the group structure resolved as a hierarchy
of lists. If the default argument `load=TRUE` is used all
datasets from the HDF5 file are read.

```{r h5dump}
h5dump("myhdf5file.h5",load=FALSE)
D <- h5dump("myhdf5file.h5")
```

## Reading HDF5 files with external software

The content of the HDF5 file can be checked with the command line tool
**h5dump** (available on linux-like systems with the HDF5 tools
package installed) or with the graphical user interface **HDFView**
(http://www.hdfgroup.org/hdf-java-html/hdfview/) available for all
major platforms.

```{r h5dump2, eval=FALSE}
system2("h5dump", "myhdf5file.h5")
```
*Please note, that arrays appear as transposed matrices when opening it
with a C-program (**h5dump** or **HDFView**). This is due to the fact the
fastest changing dimension on C is the last one, but on R it is the
first one (as in Fortran).*

## Removing content from an HDF5 file

As well as adding content to an HDF5 file, it is possible to remove entries using the function `h5delete()`.  To demonstrate it's use, we'll first list the contents of a file and examine the size of the file in bytes.

```{r h5delete1}
h5ls("myhdf5file.h5", recursive=2)
file.size("myhdf5file.h5")
```

We then use `h5delete()` to remove the **df** dataset by providing the file name and the name of the dataset, e.g.

```{r h5delete2}
h5delete(file = "myhdf5file.h5", name = "df")
h5ls("myhdf5file.h5", recursive=2)
```

We can see that the **df** entry has now disappeared from the listing.  In most cases, if you have a heirachy within the file, `h5delete()`  will remove children of the deleted entry too.  In this example we remove **foo** and the datasets below it are deleted too.  Notice too that the size of the file as decreased.

```{r h5delete3}
h5delete(file = "myhdf5file.h5", name = "foo")
h5ls("myhdf5file.h5", recursive=2)
file.size("myhdf5file.h5")
```

*N.B. `h5delete()` does not explicitly traverse the tree to remove child nodes.  It only removes the named entry, and HDF5 will then remove child nodes if they are now orphaned.  Hence it won't delete child nodes if you have a more complex structure where a child node has multiple parents and only one of these is removed.*

# 64-bit integers

**R** does not support a native datatype for 64-bit integers. All integers in **R** are
32-bit integers. When reading 64-bit integers from a HDF5-file, you
may run into troubles. `r Biocpkg("rhdf5")` is able to deal with 64-bit integers, but
you still should pay attention.

As an example, we create an HDF5 file that contains 64-bit integers.

```{r bit64integer1}
x = h5createFile("newfile3.h5")

D = array(1L:30L,dim=c(3,5,2))
d = h5createDataset(file="newfile3.h5", dataset="D64", dims=c(3,5,2),H5type="H5T_NATIVE_INT64")
h5write(D,file="newfile3.h5",name="D64")
```

There are three different ways of reading 64-bit integers in
**R**. `H5Dread()` and `h5read()` have the argument
`bit64conversion` the specify the conversion method.

By setting `bit64conversion='int'`, a coercing to 32-bit
integers is enforced, with the risk of data loss, but with the
insurance that numbers are represented as native integers.

```{r bit64integer2}
D64a = h5read(file="newfile3.h5",name="D64",bit64conversion="int")
D64a
storage.mode(D64a)
```

`bit64conversion='double'` coerces the 64-bit integers to floating
point numbers. doubles can represent integers with up to 54-bits, but
they are not represented as integer values anymore. For larger numbers
there is still a data loss.

```{r bit64integer3}
D64b = h5read(file="newfile3.h5",name="D64",bit64conversion="double")
D64b
storage.mode(D64b)
```

`bit64conversion='bit64'` is the recommended way of coercing. It
represents the 64-bit integers as objects of class *integer64* as
defined in the package `r CRANpkg("bit64")`. Make sure that you have installed
`r CRANpkg("bit64")`.
*The datatype *integer64* is not part of base **R**, but defined
in an external package. This can produce unexpected behaviour when
working with the data.* When choosing this option the package `r CRANpkg("bit64")`
will be loaded.

```{r bit64integer4}
D64c = h5read(file="newfile3.h5",name="D64",bit64conversion="bit64")
D64c
class(D64c)
```

<!--
##Large integer data types

The following table gives an overview of the limits of the different integer representations in R and in HDF5.

\definecolor{Gray1}{gray}{0.85}
\definecolor{Gray2}{gray}{0.8}
\definecolor{Gray3}{gray}{0.75}
\definecolor{LightBlue}{rgb}{0.88,0.88,1}

\newcommand{\N}{-}
\newcommand{\Y}{\cellcolor{Gray2}+}

\begin{tabular}{|l|r||c|c|c||c|c|c|c|}
\hline
\rowcolor{LightBlue}
\multicolumn{2}{|c||}{value} &
\multicolumn{3}{c||}{R-datatype} &
\multicolumn{4}{c|}{HDF5 datatype}\\
\rowcolor{LightBlue}
\multicolumn{2}{|c||}{} &
integer & double & integer64 &
I32 & U32 & I64 & U64 \\
\hline
\hline
$\phantom{-}2^{64}$ & 18446744073709551616 &
\phantom{\vdots} - \phantom{\vdots}& - & - &
- & - & - & - \\
\hline
$\phantom{-}2^{64}-1$ & 18446744073709551615 &
\phantom{\vdots} - \phantom{\vdots}& - & - &
- & - & - & \Y \\\hline
$\phantom{-}$\vdots & \vdots &
\vdots & \vdots & \vdots &
\vdots & \vdots & \vdots & \cellcolor{Gray2}\vdots \\
\hline
$\phantom{-}2^{63}$ & 9223372036854775808 &
\phantom{\vdots} - \phantom{\vdots} & - & - &
- & - & - & \Y \\\hline
$\phantom{-}2^{63}-1$ & 9223372036854775807  &
\phantom{\vdots} - \phantom{\vdots} & - & \Y &
- & - & \Y & \Y \\\hline
$\phantom{-}$\vdots & \vdots &
\vdots & \vdots & \cellcolor{Gray2}\vdots &
\vdots & \vdots & \cellcolor{Gray2}\vdots & \cellcolor{Gray2}\vdots \\
\hline
$\phantom{-}2^{53}$ & 9007199254740992 &
\phantom{\vdots} - \phantom{\vdots} & - & \Y &
- & - & \Y & \Y \\\hline
$\phantom{-}2^{53}-1$ & 9007199254740991 &
\phantom{\vdots} - \phantom{\vdots} & \Y & \Y &
- & - & \Y & \Y \\\hline
$\phantom{-}$\vdots & \vdots &
\vdots & \cellcolor{Gray2}\vdots & \cellcolor{Gray2}\vdots &
\vdots & \vdots & \cellcolor{Gray2}\vdots & \cellcolor{Gray2}\vdots \\
\hline
$\phantom{-}2^{32}$ & 4294967296 &
\phantom{\vdots} - \phantom{\vdots} & \Y & \Y &
- & - & \Y & \Y \\\hline
$\phantom{-}2^{32}-1$ & 4294967295 &
\phantom{\vdots} - \phantom{\vdots} & \Y & \Y &
- & \Y & \Y & \Y \\\hline
$\phantom{-}$\vdots & \vdots &
\vdots & \cellcolor{Gray2}\vdots & \cellcolor{Gray2}\vdots &
\vdots & \cellcolor{Gray2}\vdots & \cellcolor{Gray2}\vdots & \cellcolor{Gray2}\vdots \\
\hline
$\phantom{-}2^{31}$ & 2147483648 &
\phantom{\vdots} - \phantom{\vdots} & \Y & \Y &
- & \Y & \Y & \Y \\\hline
$\phantom{-}2^{31}-1$ & 2147483647 &
\phantom{\vdots}\Y\phantom{\vdots} & \Y & \Y &
\Y & \Y & \Y & \Y \\\hline
$\phantom{-}$\vdots & \vdots &
\cellcolor{Gray2}\vdots & \cellcolor{Gray2}\vdots & \cellcolor{Gray2}\vdots &
\cellcolor{Gray2}\vdots & \cellcolor{Gray2}\vdots & \cellcolor{Gray2}\vdots & \cellcolor{Gray2}\vdots \\
\hline
$\phantom{-}2^0$ & 1 &
\phantom{\vdots}\Y\phantom{\vdots} & \Y & \Y &
\Y & \Y & \Y & \Y \\\hline
$\phantom{-}0$ & 0 &
\phantom{\vdots}\Y\phantom{\vdots} & \Y & \Y &
\Y & \Y & \Y & \Y \\\hline
$-2^0$ & -1 &
\phantom{\vdots}\Y\phantom{\vdots} & \Y & \Y &
\Y & - & \Y & - \\\hline
$\phantom{-}$\vdots & \vdots &
\cellcolor{Gray2}\vdots & \cellcolor{Gray2}\vdots & \cellcolor{Gray2}\vdots &
\cellcolor{Gray2}\vdots & \vdots & \cellcolor{Gray2}\vdots & \vdots \\
\hline
$-2^{31}+1$ & -2147483647 &
\phantom{\vdots}\Y\phantom{\vdots} & \Y & \Y &
\Y & - & \Y & - \\\hline
$-2^{31}$ & -2147483648 &
\cellcolor{Gray2}\phantom{\vdots}NA\phantom{\vdots} & \Y & \Y &
\Y & - & \Y & - \\\hline
$-2^{31}-1$ & -2147483649 &
\phantom{\vdots} - \phantom{\vdots} & \Y & \Y &
- & - & \Y & - \\\hline
$\phantom{-}$\vdots & \vdots &
\vdots & \cellcolor{Gray2}\vdots & \cellcolor{Gray2}\vdots &
\vdots & \vdots & \cellcolor{Gray2}\vdots & \vdots \\
\hline
$-2^{53}+1$ & -9007199254740991 &
\phantom{\vdots} - \phantom{\vdots} & \Y & \Y &
- & - & \Y & - \\\hline
$-2^{53}$ & -9007199254740992 &
\phantom{\vdots} - \phantom{\vdots} & - & \Y &
- & - & \Y & - \\\hline
$\phantom{-}$\vdots & \vdots &
\vdots & \vdots & \cellcolor{Gray2}\vdots &
\vdots & \vdots & \cellcolor{Gray2}\vdots & \vdots \\
\hline
$-2^{63}+1$ & -9223372036854775807 &
\phantom{\vdots} - \phantom{\vdots} & - & \Y &
- & - & \Y & - \\\hline
$-2^{63}$ & -9223372036854775808 &
\phantom{\vdots} - \phantom{\vdots} & - & \cellcolor{Gray2}NA &
- & - & \Y & - \\\hline
$-2^{63}-1$ & -9223372036854775809 &
\phantom{\vdots} - \phantom{\vdots} & - & - &
- & - & - & - \\\hline
\end{tabular}


From the table it becomes obvious that some integer values in HDF5
files cannot be displayed in R. Note that this can happen for both
64-bit integer as well as for unsigned 32-bit integer. When generating
an HDF5 file, it is recommended to use signed 32-bit integers.
-->

# Low level HDF5 functions
## Creating an HDF5 file and a group hierarchy

Create a file.
```{r createfile,quiet=FALSE}
library(rhdf5)
h5file = H5Fcreate("newfile.h5")
h5file
```

and a group hierarchy
```{r create_groups, quiet=FALSE}
h5group1 <- H5Gcreate(h5file, "foo")
h5group2 <- H5Gcreate(h5file, "baa")
h5group3 <- H5Gcreate(h5group1, "foobaa")
h5group3
```

## Writing data to an HDF5 file

Create 4 different simple and scalar data spaces. The data space sets the dimensions for the datasets.

```{r createdataspace, quiet=FALSE}
d = c(5,7)
h5space1 = H5Screate_simple(d,d)
h5space2 = H5Screate_simple(d,NULL)
h5space3 = H5Scopy(h5space1)
h5space4 = H5Screate("H5S_SCALAR")
h5space1
H5Sis_simple(h5space1)
```

Create two datasets, one with integer and one with floating point numbers.

```{r create_dataset}
h5dataset1 = H5Dcreate( h5file, "dataset1", "H5T_IEEE_F32LE", h5space1 )
h5dataset2 = H5Dcreate( h5group2, "dataset2", "H5T_STD_I32LE", h5space1 )
h5dataset1
```

Now lets write data to the datasets.
```{r writedata}
A = seq(0.1,3.5,length.out=5*7)
H5Dwrite(h5dataset1, A)
B = 1:35
H5Dwrite(h5dataset2, B)
```

To release resources and to ensure that the data is written on disk,
we have to close datasets, dataspaces, and the file. There are
different functions to close datasets, dataspaces, groups, and files.
```{r closefile}
H5Dclose(h5dataset1)
H5Dclose(h5dataset2)

H5Sclose(h5space1)
H5Sclose(h5space2)
H5Sclose(h5space3)
H5Sclose(h5space4)

H5Gclose(h5group1)
H5Gclose(h5group2)
H5Gclose(h5group3)

H5Fclose(h5file)
```

<!--
% We can now check how it looks like on disk.
% ```{r h5dump}
% system("h5dump newfile2.h5")
% ```
% Please note, that arrays appear as transposed matrices when opening it with a C-program (h5dump). This is due to the fact the fastest changing dimension on C is the last one, but on \R~ it is the first one (as in Fortran).
-->

# Session Info

```{r sessioninfo}
sessionInfo()
```

```{r cleanup_after, echo=FALSE, include=FALSE}
for(file in c('myhdf5file.h5', 'newfile.h5', 'newfile2.h5', 'newfile3.h5')) {
    if(file.exists(file)) {
        file.remove( file )
    }
}
```

---
title: "Reading HDF5 Files In The Cloud"
author:
- name: Mike L. Smith
  affiliation: de.NBI & EMBL Heidelberg
package: rhdf5
output:
  BiocStyle::html_document
vignette: |
  %\VignetteIndexEntry{Reading HDF5 Files In The Cloud}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

```{r setup, include=FALSE}
knitr::opts_chunk$set(echo = TRUE)
```

The `r Biocpkg("rhdf5")` provides limited support for read-only access to HDF5 files stored in Amazon S3 buckets.  This is implemented via the [HDF5 S3 Virtual File Driver](https://portal.hdfgroup.org/display/HDF5/Virtual+File+Drivers+-+S3+and+HDFS) and allows access to HDF5 files hosted in both public and private S3 buckets.  

Currently only the functions `h5ls()`, `h5dump()` and `h5read()` are supported.

```{r, load-library}
library(rhdf5)
```

# Public S3 Buckets

To access a file in a public Amazon S3 bucket you provide the file's URL to the `file` argument.  You also need to set the argument `s3 = TRUE`, otherwise `h5ls()` will treat the URL as a path on the local disk fail.

```{r, public-h5ls, error = TRUE, purl = FALSE}
public_S3_url <- "https://rhdf5-public.s3.eu-central-1.amazonaws.com/h5ex_t_array.h5"
h5ls(file = public_S3_url,
     s3 = TRUE)
```

The same arguments are also valid for using `h5dump()` to retrieve the contents of a file.

```{r, public-h5dump, error = TRUE, purl = FALSE}
public_S3_url <- "https://rhdf5-public.s3.eu-central-1.amazonaws.com/h5ex_t_cmpd.h5"
h5dump(file = public_S3_url,
     s3 = TRUE)
```

In addition to examining and reading whole files, we can also extract just a subset, without needed to read or download the entire file.  In the example below we use `h5ls()` to examine a file in an S3 bucket and identify the name of a dataset within it (`a1`) and the number of dimensions for that dataset (3).  We can then use `h5read()` along with the `name` and `index` arguments to read only a subset of the dataset into our R session.

```{r, public-h5read, error = TRUE, purl = FALSE}
public_S3_url <- 'https://rhdf5-public.s3.eu-central-1.amazonaws.com/rhdf5ex_t_float_3d.h5'
h5ls(file = public_S3_url, s3 = TRUE)
h5read(public_S3_url, 
       name = "a1", 
       index = list(1:2, 3, NULL),
       s3 = TRUE)
```

# Private S3 Buckets

To access files in a private Amazon S3 bucket you will need to provide three additional details: The AWS region where the files are hosted, your AWS access key ID, and your AWS secret access key.  More information on how to obtain AWS access keys can be found under [AWS Security Credentials](https://docs.aws.amazon.com/general/latest/gr/aws-sec-cred-types.html#access-keys-and-secret-access-keys).

These three values need to be stored in a list like below.  *Important note: for now they must be in this specific order.*

```{r, private-mock-credentials}
## these are example credentials and will not work
s3_cred <- list(
    aws_region = "eu-central-1",
    access_key_id = "AKIAIOSFODNN7EXAMPLE",
    secret_access_key = "wJalrXUtnFEMI/K7MDENG/bPxRfiCYEXAMPLEKEY"
)
```

Finally we pass this list to `h5ls()` via the `s3credentials` argument.  

```{r, private-h5ls, eval = FALSE}
public_S3_url <- "https://rhdf5-private.s3.eu-central-1.amazonaws.com/h5ex_t_array.h5"
h5ls(file = public_S3_url,
     s3 = TRUE,
     s3credentials = s3_cred)
```

The `s3credentials` arguments is used in exactly the same way for `h5dump()` and `h5read()`.

# Session Info
```{r sessioninfo}
sessionInfo()
```

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/Deprecated.R
\name{H5Pget_version}
\alias{H5Pget_version}
\title{Deprecated}
\usage{
H5Pget_version(...)
}
\arguments{
\item{...}{ignored}
}
\value{
NULL (invisibly)
}
\description{
Deprecated in line with changes in the upstream HDF5 library.
It will be removed in the next version of rhdf5.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/H5P.R
\name{H5Pobject_track_times}
\alias{H5Pobject_track_times}
\alias{H5Pset_obj_track_times}
\alias{H5Pget_obj_track_times}
\title{Set whether to record timestamps for operations performed on an HDF5 object.}
\usage{
H5Pset_obj_track_times(h5plist, track_times = TRUE)

H5Pget_obj_track_times(h5plist)
}
\arguments{
\item{h5plist}{An \linkS4class{H5IdComponent} object representing an object
creation property list.}

\item{track_times}{\code{logical} specifying whether times associated with an
object should recorded.}
}
\description{
Set whether to record timestamps for operations performed on an HDF5 object.
}
\details{
Objects created using high-level \strong{rhdf5} functions like
\code{\link[=h5createDataset]{h5createDataset()}} will have this setting turned off. This was done to
ensure otherwise identical files returned the same md5 hash. This differs
from the default setting in HDF5, which is for objects to record the times
operations were performed on them.
}

\name{&-methods}
\docType{methods}
\alias{&,H5IdComponent,ANY-method}
\title{Methods for Function \code{&} in Package \pkg{rhdf5}}
\description{
Methods for function \code{&} in package \pkg{rhdf5}.
}
\section{Methods}{
\describe{

\item{\code{signature(e1 = "H5IdComponent", e2 = "ANY")}}{
Returns a group handle or dataset handle for the group or dataset e2 in the HDF5 location e1. e1 can either be a file handle as returned by H5Fopen() or a group handle as e.g. returned by h5f$g1 or h5f$'/g1/g2's.
}
}}
\keyword{methods}
\keyword{ programming }
\keyword{ interface }
\keyword{ IO }
\keyword{ file }

\name{h5delete}
\alias{h5delete}

\title{Delete contents of HDF5 file}

\description{Deletes the specfied group or dataset from within an HDF5 file.}

\usage{
    h5delete( file, name )
}

\arguments{
  \item{file}{The filename (character) of the file in which the object is located.}
  \item{name}{The names of the object to be deleted.}
}

\author{Mike Smith}

\keyword{ file }

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/H5D_extras.R
\name{H5Dchunk_dims}
\alias{H5Dchunk_dims}
\title{Return the dimensions of a dataset chunk}
\usage{
H5Dchunk_dims(h5dataset)
}
\arguments{
\item{h5dataset}{Object of class \linkS4class{H5IdComponent} representing an open HDF5
dataset.}
}
\value{
If the supplied dataset is chunked returns a vector, with length
equal to the rank of the dataset, containing the size of the dataset
dimensions.  Returns \code{NULL} if the given dataset is not chunked.
}
\description{
Return the dimensions of a dataset chunk
}
\details{
This function does not map directly to the HDF5 C API but is
included as a useful addition.
}
\author{
Mike Smith
}

\name{h5const}
\alias{h5const}
\alias{h5constType}
\alias{h5default}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{HDF5 library constants.}
\description{
Access to HDF5 constants.
}
\usage{
h5const     (type = "")
h5default   (type = "")
h5constType ()
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{type}{A character name of a group of constants.}
}
\details{
These functions provide a list of HDF5 constants that are defined in the R package. \code{h5constType} provides a list of group names and  \code{h5const} gives the constants defined within a group. \code{h5default} gives the default choice for each group.
}
\value{
A character vector with names of HDF5 constants or groups.
}
\references{\url{https://portal.hdfgroup.org/display/HDF5}}
\author{Bernd Fischer}
\seealso{
\link{rhdf5}
}
\examples{
h5constType()[1]
h5const(h5constType()[1])
}
\keyword{ programming }
\keyword{ interface }
\keyword{ IO }
\keyword{ file }

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/h5writeAttr.R
\name{h5_writeAttribute}
\alias{h5_writeAttribute}
\alias{h5writeAttribute}
\alias{h5writeAttribute.array}
\title{Write an R object as an HDF5 attribute}
\usage{
h5writeAttribute(
  attr,
  h5obj,
  name,
  h5loc,
  encoding = NULL,
  variableLengthString = FALSE,
  asScalar = FALSE,
  checkForNA = TRUE
)

\method{h5writeAttribute}{array}(
  attr,
  h5obj,
  name,
  h5loc,
  encoding = NULL,
  variableLengthString = FALSE,
  asScalar = FALSE,
  checkForNA = TRUE
)
}
\arguments{
\item{attr}{The R object to be written as an HDF5 attribute.}

\item{h5obj}{Normally an object of class \linkS4class{H5IdComponent} representing a
H5 object identifier (file, group, or dataset). See
\code{\link[=H5Fcreate]{H5Fcreate()}}, \code{\link[=H5Fopen]{H5Fopen()}}, \code{\link[=H5Gcreate]{H5Gcreate()}},
\code{\link[=H5Gopen]{H5Gopen()}}, \code{\link[=H5Dcreate]{H5Dcreate()}}, or \code{\link[=H5Dopen]{H5Dopen()}} to
create an object of this kind.  This argument can also be given the path to
an HDF5 file.}

\item{name}{The name of the attribute to be written.}

\item{h5loc}{The location of the group or dataset within a file to which the
attribute should be attached. This argument is only used if the
\code{h5obj} argument is the path to an HDF5 file, otherwise it is ignored.}

\item{encoding}{The encoding of the string data type. Valid options are
"ASCII" and "UTF-8".}

\item{variableLengthString}{Whether character vectors should be written as
variable-length strings into the attributes.}

\item{asScalar}{Whether length-1 \code{attr} should be written into a scalar
dataspace.}

\item{checkForNA}{Whether a \code{attr} should be checked for \code{NA}
values before being written.  This only applies of \code{attr} is of type
logical.  Testing for \code{NA} values can be slow if the object to be
written is large, so if you are sure no such values will be present this
argument can be used to disable the testing.}
}
\description{
Write an R object as an HDF5 attribute
}

\name{HDF5 Object Interface}
\alias{H5O}
\alias{H5Oopen}
\alias{H5Oclose}
\alias{H5Oget_num_attrs}
\alias{H5Oget_num_attrs_by_name}
%\alias{H5Oget_info}
%\alias{H5Oget_info_by_name}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{HDF5 Object Interface}
\description{
The Object interface, H5O, functions manipulate objects in an HDF5 file. This interface is designed to be used in conjunction with the Links interface (H5L).
}
\usage{
H5Oopen  (h5loc, name)
H5Oclose (h5obj)
H5Oget_num_attrs(h5obj)
H5Oget_num_attrs_by_name(h5loc, name)
}
% H5Oget_info         (h5obj)
% H5Oget_info_by_name (h5loc, name)
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{h5obj}{An object of class \code{\link{H5IdComponent}} representing a H5 object identifier (file, group, or dataset). See \code{\link{H5Fcreate}}, \code{\link{H5Fopen}}, \code{\link{H5Gcreate}}, \code{\link{H5Gopen}}, \code{\link{H5Dcreate}}, or \code{\link{H5Dopen}} to create an object of this kind.}
  \item{h5loc}{An object of class \code{\link{H5IdComponent}} representing a H5 location identifier (file or group). See \code{\link{H5Fcreate}}, \code{\link{H5Fopen}}, \code{\link{H5Gcreate}}, \code{\link{H5Gopen}} to create an object of this kind.}
  \item{name}{The name of the link to be checked.}
}
\details{
Interface to the HDF5 C-library libhdf5. See \url{https://portal.hdfgroup.org/display/HDF5/Objects} for further details.
}
\value{
\code{H5Oopen} opens an object (a file, group, or dataset) and returns an object of class \code{\link{H5IdComponent}}. \code{H5Oclose} closed the object again. \code{H5Oget_num_attrs} and \code{H5Oget_num_attrs_by_name} return the number of attributes of an object.
}
\references{\url{https://portal.hdfgroup.org/display/HDF5}}
\author{Bernd Fischer}
\seealso{
\link{rhdf5}
}
\examples{
# create an hdf5 file and write something
h5createFile("ex_H5O.h5")
h5createGroup("ex_H5O.h5","foo")
B = array(seq(0.1,2.0,by=0.1),dim=c(5,2,2))
h5write(B, "ex_H5O.h5","foo/B")

# reopen file and dataset and get object info
fid <- H5Fopen("ex_H5O.h5")
oid = H5Oopen(fid, "foo")
H5Oget_num_attrs(oid)
H5Oclose(oid)
H5Fclose(fid)

}
\keyword{ programming }
\keyword{ interface }
\keyword{ IO }
\keyword{ file }

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/H5constants.R
\name{h5constants}
\alias{h5constants}
\alias{h5const}
\alias{h5constType}
\alias{h5default}
\title{HDF5 library constants.}
\usage{
h5const(type = "")

h5constType()

h5default(type = "")
}
\arguments{
\item{type}{A character name of a group of constants.}
}
\value{
A character vector with names of HDF5 constants or groups.
}
\description{
Access to HDF5 constants.
}
\details{
These functions provide a list of HDF5 constants that are defined in the R
package. \code{h5constType} provides a list of group names and
\code{h5const} gives the constants defined within a group. \code{h5default}
gives the default choice for each group.
}
\examples{

h5constType()[1]
h5const(h5constType()[1])
}
\author{
Bernd Fischer
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/H5P.R
\name{H5P_fill_time}
\alias{H5P_fill_time}
\alias{H5Pset_fill_time}
\alias{H5Pget_fill_time}
\title{Set the time when fill values are written to a dataset}
\usage{
H5Pset_fill_time(h5plist, fill_time = h5default("H5D_FILL_TIME"))

H5Pget_fill_time(h5plist)
}
\arguments{
\item{h5plist}{An object of class \linkS4class{H5IdComponent} representing a
dataset creation property list.}

\item{fill_time}{When the fill values should be written.  Possible options
can be listed with \code{h5const("H5D_FILL_TIME")}.}
}
\description{
Set the time when fill values are written to a dataset
}

\name{HDF5 Attribute Interface}
\alias{H5A}
\alias{H5Acreate}
\alias{H5Aclose}
\alias{H5Adelete}
\alias{H5Aexists}
\alias{H5Aget_name}
\alias{H5Aget_space}
\alias{H5Aget_type}
\alias{H5Aopen}
\alias{H5Aopen_by_idx}
\alias{H5Aopen_by_name}
\alias{H5Aread}
\alias{H5Awrite}
\title{HDF5 Attribute Interface}
\description{These functions create and manipulate attributes and information about attributes. }
\usage{
H5Acreate       (h5obj, name, dtype_id, h5space)
H5Aclose        (h5attribute)
H5Adelete       (h5obj, name)
H5Aexists       (h5obj, name)
H5Aget_name     (h5attribute)
H5Aget_space    (h5attribute)
H5Aget_type     (h5attribute)
H5Aopen         (h5obj, name)
H5Aopen_by_idx  (h5obj, n, objname = ".", index_type = h5default("H5_INDEX"), 
                 order = h5default("H5_ITER"))
H5Aopen_by_name (h5obj, objname = ".", name)
H5Aread         (h5attribute, buf = NULL)
H5Awrite        (h5attribute, buf)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{h5obj}{An object of class \code{\link{H5IdComponent}} representing a H5 object identifier (file, group, or dataset). See \code{\link{H5Fcreate}}, \code{\link{H5Fopen}}, \code{\link{H5Gcreate}}, \code{\link{H5Gopen}}, \code{\link{H5Dcreate}}, or \code{\link{H5Dopen}} to create an object of this kind.}
  \item{name}{The name of the attribute (character).}
  \item{dtype_id}{A character name of a datatype. See \code{h5const("H5T")} for possible datatypes. Can also be an integer representing an HDF5 datatype. Only simple datatypes are allowed for atttributes.}
  \item{h5space}{An object of class \code{\link{H5IdComponent}} representing a H5 dataspace. See \code{\link{H5Dget_space}}, \code{\link{H5Screate_simple}}, \code{\link{H5Screate}} to create an object of this kind.}
  \item{h5attribute}{An object of class \code{\link{H5IdComponent}} represnting a H5 attribute as created by \code{H5Acreate} or \code{H5Aopen}}
  \item{n}{Opens attribute number n in the given order and index. The first attribute is opened with n=0.}
  \item{objname}{The name of the object the attribute belongs to.}
  \item{index_type}{See \code{h5const("H5_INDEX")} for possible arguments.}
  \item{order}{See \code{h5const("H5_ITER")} for possible arguments.}
  \item{buf}{Reading and writing buffer containing the data to written/read. When using the buffer for reading, the buffer size has to fit the size of the memory space \code{h5spaceMem}. No extra memory will be allocated for the data. A pointer to the same data is returned.}
}
\details{
Interface to the HDF5 C-library libhdf5. See \url{https://portal.hdfgroup.org/display/HDF5/Attributes} for further details.
}
\value{
\code{H5Acreate}, \code{H5Aopen}, \code{H5Aopen_by_name}, \code{H5Aopen_by_idx}  return an object of class \code{\link{H5IdComponent}} representing a H5 attribute identifier.

\code{H5Aget_space} returns an object of class \code{\link{H5IdComponent}} representing a H5 dataspace identifier.

\code{H5Aread} returns an array with the read data.

The other functions return the standard return value from their respective C-functions.
}
\references{\url{https://portal.hdfgroup.org/display/HDF5}}
\author{Bernd Fischer}
\seealso{
\link{rhdf5}
}
\examples{
# create a file and write something
h5createFile("ex_H5A.h5")
h5write(1:15, "ex_H5A.h5","A")

# write an attribute 'unit' to 'A'
fid <- H5Fopen("ex_H5A.h5")
did <- H5Dopen(fid, "A")
sid <- H5Screate_simple(c(1,1))
tid <- H5Tcopy("H5T_C_S1")

H5Tset_size(tid, 10L)
aid <- H5Acreate(did, "unit", tid, sid)
aid
H5Awrite(aid, "liter")
H5Aclose(aid)
H5Sclose(sid)
H5Aexists(did, "unit")
H5Dclose(did)
H5Fclose(fid)
h5dump("ex_H5A.h5")
}
\keyword{ programming }
\keyword{ interface }
\keyword{ IO }
\keyword{ file }

\name{HDF5 Dataset Interface}
\alias{H5D}
\alias{H5Dcreate}
\alias{H5Dopen}
\alias{H5Dclose}
\alias{H5Dget_type}
\alias{H5Dget_create_plist}
\alias{H5Dget_storage_size}
\alias{H5Dget_space}
\alias{H5Dread}
\alias{H5Dwrite}
\alias{H5Dset_extent}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{HDF5 Dataset Interface}
\description{
These functions create and manipulate dataset objects, and set and retrieve their constant or persistent properties.
}
\usage{
H5Dcreate           (h5loc, name, dtype_id, h5space, lcpl=NULL, dcpl=NULL, dapl=NULL)
H5Dopen             (h5loc, name, dapl=NULL)
H5Dclose            (h5dataset)
H5Dget_space        (h5dataset)
H5Dget_type         (h5dataset)
H5Dget_create_plist (h5dataset)
H5Dget_storage_size (h5dataset)
H5Dread             (h5dataset, h5spaceFile = NULL, h5spaceMem = NULL,
                     buf = NULL, compoundAsDataFrame = TRUE,
                     bit64conversion, drop = FALSE)
H5Dwrite            (h5dataset, buf, h5spaceMem = NULL, h5spaceFile = NULL)
H5Dset_extent       (h5dataset, size)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{h5loc}{An object of class \code{\link{H5IdComponent}} representing a H5 location identifier (file or group). See \code{\link{H5Fcreate}}, \code{\link{H5Fopen}}, \code{\link{H5Gcreate}}, \code{\link{H5Gopen}} to create an object of this kind.}
  \item{name}{Name of the dataset (character).}
  \item{dtype_id}{A character name of a datatype. See \code{h5const("H5T")} for possible datatypes. Can also be an integer representing an HDF5 datatype.}
  \item{h5space}{An object of class \code{\link{H5IdComponent}} representing a H5 dataspace. See \code{\link{H5Dget_space}}, \code{\link{H5Screate_simple}}, \code{\link{H5Screate}} to create an object of this kind.}
  \item{h5dataset}{An object of class \code{\link{H5IdComponent}} representing a H5 dataset. See \code{\link{H5Dcreate}}, \code{\link{H5Dopen}} to create an object of this kind.}
  \item{h5spaceFile,h5spaceMem}{An object of class \code{\link{H5IdComponent}} representing a H5 dataspace. See \code{\link{H5Dget_space}}, \code{\link{H5Screate_simple}}, \code{\link{H5Screate}} to create an object of this kind. The dimensions of the dataset in the file and in memory. The dimensions in file and in memory are interpreted in an R-like manner. The first dimension is the fastest changing dimension. When reading the file with a C-program (e.g. HDFView) the order of dimensions will invert, because in C the fastest changing dimension is the last one.}
  \item{buf}{Reading and writing buffer containing the data to written/read. When using the buffer for reading, the buffer size has to fit the size of the memory space \code{h5spaceMem}. No extra memory will be allocated for the data. A pointer to the same data is returned.}
  \item{compoundAsDataFrame}{If true, a compound datatype will be coerced to a data.frame. This is not possible, if the dataset is multi-dimensional. Otherwise the compound datatype will be returned as a list. Nested compound data types will be returned as a nested list.}
  \item{bit64conversion}{Defines, how 64-bit integers are converted. Internally, R does not support 64-bit integers. All integers in R are 32-bit integers. By setting bit64conversion='int', a coercing to 32-bit integers is enforced, with the risc of data loss, but with the insurance that numbers are represented as integers. bit64conversion='double' coerces the 64-bit integers to floating point numbers. doubles can represent integers with up to 54-bits, but they are not represented as integer values anymore. For larger numbers there is again a data loss. bit64conversion='bit64' is recommended way of coercing. It represents the 64-bit integers as objects of class 'integer64' as defined in the package 'bit64'. Make sure that you have installed 'bit64'. The datatype 'integer64' is not part of base R, but defined in an external package. This can produce unexpected behaviour when working with the data.}
  \item{drop}{(logical) If TRUE, the HDF5 object is read as a vector with NULL dim attributes.}
  \item{size}{An integer vector with the new dimension of the dataset. Calling this function is only valid for chunked datasets.}
  \item{lcpl}{An object of class \code{\link{H5IdComponent}} representing a H5 link creation property list. See \code{\link{H5Pcreate}}, \code{\link{H5Pcopy}} to create an object of this kind.}
  \item{dcpl}{An object of class \code{\link{H5IdComponent}} representing a H5 dataset creation property list. See \code{\link{H5Pcreate}}, \code{\link{H5Pcopy}} to create an object of this kind.}
  \item{dapl}{An object of class \code{\link{H5IdComponent}} representing a H5 dataset access property list. See \code{\link{H5Pcreate}}, \code{\link{H5Pcopy}} to create an object of this kind.}
}
\details{
Interface to the HDF5 C-library libhdf5. See \url{https://portal.hdfgroup.org/display/HDF5/Datasets} for further details.
}
\value{
\code{H5Dcreate} and \code{H5Dopen} return an object of class \code{\link{H5IdComponent}} represinting a H5 dataset identifier.

\code{H5Dget_space} returns an object of class \code{\link{H5IdComponent}} representing a H5 dataspace identifier.

\code{H5Dread} returns an array with the read data.

The other functions return the standard return value from their respective C-functions.
}
\references{\url{https://portal.hdfgroup.org/display/HDF5}}
\author{Bernd Fischer}
\seealso{
\link{rhdf5}
}
\examples{
# write a dataset
fid <- H5Fcreate("ex_H5D.h5")
fid
sid <- H5Screate_simple(c(10,5,3))
sid
did <- H5Dcreate(fid, "A", "H5T_STD_I32LE", sid)
did
H5Dwrite(did, 1L:150L, h5spaceMem = sid, h5spaceFile = sid)
H5Dclose(did)
H5Sclose(sid)
H5Fclose(fid)

# read a dataset
fid <- H5Fopen("ex_H5D.h5")
fid
did <- H5Dopen(fid, "A")
did
sid <- H5Dget_space(did)
sid
B <- H5Dread(did)
B
H5Dclose(did)
H5Sclose(sid)
H5Fclose(fid)

# write a subarray
fid <- H5Fopen("ex_H5D.h5")
fid
did <- H5Dopen(fid, "A")
did
sid <- H5Dget_space(did)
sid
H5Sselect_index(sid, list(1:3,2:4,2))
sidmem <- H5Screate_simple(c(3,3,1))
sidmem
A = array(-801:-809,dim=c(3,3,1))
H5Dwrite(did, A, h5spaceMem = sidmem, h5spaceFile = sid)
H5Dread(did)
H5Sclose(sid)
H5Dclose(did)
H5Sclose(sidmem)
H5Fclose(fid)
}
\keyword{ programming }
\keyword{ interface }
\keyword{ IO }
\keyword{ file }

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/H5S_extras.R
\name{H5Sselect_index}
\alias{H5Sselect_index}
\title{Select elements of a dataspace using R-style indexing}
\usage{
H5Sselect_index(h5space, index)
}
\arguments{
\item{h5space}{\linkS4class{H5IdComponent} object representing a dataspace.}

\item{index}{A list of integer indices. The length of the list corresponds to
the number of dimensions of the HDF5 array. If a list element is \code{NULL},
all elements of the respective dimension are selected.}
}
\description{
Combines a hyperslab selection specified by \code{start}, \code{stride}, \code{count} and
\code{block} arguments with the current selection for the dataspace represented by
\code{h5space}.
}
\details{
\code{H5Sselect_hyperslab} is similar to, but subtly different from,
\code{\link[=H5Scombine_hyperslab]{H5Scombine_hyperslab()}}.  The former modifies the selection of the
dataspace provided in the \code{h5space} argument, while the later returns a new
dataspace with the combined selection.
}
\examples{

## create a 1 dimensional dataspace
sid <- H5Screate_simple(c(10,5,3))

## Select elements that lie in in the rows 1-3, columns 2-4, 
## and the entire 3rd dimension
H5Sselect_index(sid, list(1:3, 2:4, NULL))

## We can check the number of selected points. 
## This should be 27 (3 * 3 * 3)
H5Sget_select_npoints(sid)

## always close dataspaces after usage to free resources
H5Sclose(sid)

}

\name{HDF5 Datatype Interface}
\alias{H5T}
\alias{H5Tcopy}
\alias{H5Tset_size}
\alias{H5Tget_size}
\alias{H5Tset_strpad}
\alias{H5Tget_strpad}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{HDF5 Datatype Interface}
\description{
These functions create and manipulate the datatype which describes elements of a dataset. 
}
\usage{
H5Tcopy      (dtype_id = h5default(type = "H5T"))
H5Tset_size  (dtype_id = h5default(type = "H5T"), size)
H5Tget_size  (dtype_id)
H5Tset_strpad(dtype_id, strpad = "NULLPAD")
H5Tget_strpad(dtype_id)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{dtype_id}{A character name of a datatype. See \code{h5const("H5T")} 
  for possible datatypes. Can also be an integer representing an HDF5 datatype.}
  \item{size}{The total size in bytes.}
  \item{strpad}{Character string repsenting the type of padding to be used.  
  Valid options are 'NULLTERM', 'NULLPAD', 'SPACEPAD'}
}
\details{
Interface to the HDF5 C-library libhdf5. See \url{https://portal.hdfgroup.org/display/HDF5/Datatypes} for further details.
}
\value{
The functions return the standard return value from their respective C-functions.
}
\references{\url{https://portal.hdfgroup.org/display/HDF5}}
\author{Bernd Fischer}
\seealso{
\link{rhdf5}
}
\examples{
# create character datatype with string length 10
tid <- H5Tcopy("H5T_C_S1")
H5Tset_size(tid, 10L)

# List all predefined types implemented in the R-interface
h5const("H5T")

# List all available type classes (not all of them are implemented)
h5const("H5T_CLASS")
}
\keyword{ programming }
\keyword{ interface }
\keyword{ IO }
\keyword{ file }

\name{$-methods}
\docType{methods}
\alias{$,H5IdComponent-method}
\title{Methods for Function \code{$} in Package \pkg{rhdf5}}
\description{
Methods for function \code{$} in package \pkg{rhdf5}.
}
\section{Methods}{
\describe{

\item{\code{signature(x = "H5IdComponent")}}{
Reads the HDF5 object e2 in the HDF5 location e1. e1 can either be a file handle as returned by H5Fopen() or a group handle as e.g. returned by h5f$g1 or h5f$'/g1/g2's.
}

}}
\keyword{methods}
\keyword{ programming }
\keyword{ interface }
\keyword{ IO }
\keyword{ file }

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/h5modifier.R
\name{h5_set_extent}
\alias{h5_set_extent}
\alias{h5set_extent}
\title{Set a new dataset extension}
\usage{
h5set_extent(file, dataset, dims, native = FALSE)
}
\arguments{
\item{file}{The filename (character) of the file in which the dataset will
be located. For advanced programmers it is possible to provide an object of
class \linkS4class{H5IdComponent} representing a H5 location identifier
(file or group). See \code{\link{H5Fcreate}}, \code{\link{H5Fopen}},
\code{\link{H5Gcreate}}, \code{\link{H5Gopen}} to create an object of this
kind.}

\item{dataset}{The name of the dataset in the HDF5 file, or an object of
class \linkS4class{H5IdComponent} representing a H5 dataset identifier. See
\code{\link{H5Dcreate}}, or \code{\link{H5Dopen}} to create an object of
this kind.}

\item{dims}{The dimensions of the array as they will appear in the file.
Note, the dimensions will appear in inverted order when viewing the file
with a C program (e.g. HDFView), because the fastest changing dimension in
R is the first one, whereas the fastest changing dimension in C is the last
one.}

\item{native}{An object of class \code{logical}. If \code{TRUE}, array-like objects
are treated as stored in HDF5 row-major rather than R column-major
orientation. Using \code{native = TRUE} increases HDF5 file portability
between programming languages. A file written with \code{native = TRUE}
should also be read with \code{native = TRUE}}
}
\value{
Returns 0 if the dimension of the dataset was changed successfully
and a negative value otherwise.
}
\description{
Set a new dataset extension to an existing dataset in an HDF5 file
#'
}
\examples{

tmpfile <- tempfile()
h5createFile(file=tmpfile)
h5createDataset(tmpfile, "A", c(10,12), c(20,24))
h5ls(tmpfile, all=TRUE)[c("dim", "maxdim")]
h5set_extent(tmpfile, "A", c(20,24))
h5ls(tmpfile, all=TRUE)[c("dim", "maxdim")]

}
\author{
Bernd Fischer
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/H5D.R
\name{H5Dwrite}
\alias{H5Dwrite}
\title{Write data to dataset}
\usage{
H5Dwrite(h5dataset, buf, h5spaceMem = NULL, h5spaceFile = NULL)
}
\arguments{
\item{h5dataset}{Object of class \linkS4class{H5IdComponent} representing an open HDF5
dataset.}

\item{buf}{The R object containing the data to be written to the dataset.}

\item{h5spaceMem, h5spaceFile}{\linkS4class{H5IdComponent} objects representing the
memory and file dataspaces respectively.  If these are left \code{NULL} dataspaces
that match the size and shape of \code{h5dataset} will be used.}
}
\description{
Write data to dataset
}

\name{h5save}
\alias{h5save}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{Saves a series of objects to an HDF5 file.}
\description{Saves a number of R objects to an HDF5 file.}
\usage{
h5save(..., file, name = NULL, createnewfile = TRUE, native = FALSE)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{\dots}{The objects to be saved.}
  \item{file}{The filename (character) of the file in which the dataset will be located. For advanced programmers it is possible to provide an object of class \code{\link{H5IdComponent}} representing a H5 location identifier (file or group). See \code{\link{H5Fcreate}}, \code{\link{H5Fopen}}, \code{\link{H5Gcreate}}, \code{\link{H5Gopen}} to create an object of this kind.}
  \item{name}{A character vector of names for the datasets. The length of the name vector should match the number of objects.}
  \item{createnewfile}{If TRUE, a new file will be created if necessary.}
  \item{native}{An object of class \code{logical}. If TRUE, array-like objects are treated as stored in HDF5 row-major rather than R column-major orientation. Using \code{native = TRUE} increases HDF5 file portability between programming languages. A file written with \code{native = TRUE} should also be read with \code{native = TRUE}}.
}
\details{
The objects will be saved to the HDF5 file. If the file does not exists it will be created. The data can be read again by either \code{\link{h5dump}} or individually for each dataset by \code{\link{h5read}}.
}
\value{Nothing returned.}
\references{\url{https://portal.hdfgroup.org/display/HDF5}}
\author{Bernd Fischer}
\seealso{
\code{\link{h5ls}}, \code{\link{h5write}}, \link{rhdf5}
}
\examples{
A = 1:7;  B = 1:18; D = seq(0,1,by=0.1)
h5save(A, B, D, file="ex_save.h5")
h5dump("ex_save.h5")
}
\keyword{ programming }
\keyword{ interface }
\keyword{ IO }
\keyword{ file }

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/H5D.R
\name{H5Dget_storage_size}
\alias{H5Dget_storage_size}
\title{Find the amount of storage allocated for a dataset}
\usage{
H5Dget_storage_size(h5dataset)
}
\arguments{
\item{h5dataset}{Object of class \linkS4class{H5IdComponent} representing an open HDF5
dataset}
}
\value{
Returns an integer giving the number of bytes allocated in the file
to the dataset.
}
\description{
\code{H5Dget_storage_size} returns the amount of storage, in bytes, allocated in
an HDF5 file to hold a given dataset.  This is the amount of space required
on-disk, which not typically a good indicator of the amount of memory
that will be required to read the complete dataset.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/H5F.R
\name{H5Fget_name}
\alias{H5Fget_name}
\title{Retrieve the name of the file to which an object belongs}
\usage{
H5Fget_name(h5obj)
}
\arguments{
\item{h5obj}{An object of class \linkS4class{H5IdComponent}.  Despite this being
an H5F function, it works equally well on H5 file, group, dataset and
attribute datatypes.}
}
\description{
Retrieve the name of the file to which an object belongs
}
\examples{

## use an example file and show its location
h5file <- system.file("testfiles", "h5ex_t_array.h5", package = "rhdf5")
h5file

## open a file handle and confirm we can identify the file it points to
fid <- H5Fopen(h5file)
H5Fget_name(fid)

## H5Fget_name() can be applied to group and dataset handles too
gid <- H5Gopen(fid, name = "/")
did <- H5Dopen(fid, name = "DS1")
H5Fget_name(gid)
H5Fget_name(did)

## tidy up
H5Dclose(did)
H5Gclose(gid)
H5Fclose(fid)

}

\name{h5createGroup}
\alias{h5createGroup}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{Create HDF5 group}
\description{
Creates a group within an HDF5 file.
}
\usage{
h5createGroup (file, group)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{file}{The filename (character) of the file in which the dataset will be located. For advanced programmers it is possible to provide an object of class \code{\link{H5IdComponent}} representing a H5 location identifier (file or group). See \code{\link{H5Fcreate}}, \code{\link{H5Fopen}}, \code{\link{H5Gcreate}}, \code{\link{H5Gopen}} to create an object of this kind.}
  \item{group}{The name of the new group. The name can contain a hierarchy of groupnames, e.g. 'group1/group2/newgroup', but the function will fail if the top level group do not exists.}
}
\details{
Creates a new group within an HDF5 file. 
}
\value{Returns TRUE is group was created successfully and FALSE otherwise.}
\references{\url{https://portal.hdfgroup.org/display/HDF5}}
\author{Bernd Fischer}
\seealso{
\code{\link{h5createFile}}, \code{\link{h5createDataset}}, \code{\link{h5read}}, \code{\link{h5write}}, \link{rhdf5}
}
\examples{
h5createFile("ex_createGroup.h5")

# create groups
h5createGroup("ex_createGroup.h5","foo")
h5createGroup("ex_createGroup.h5","foo/foobaa")

h5ls("ex_createGroup.h5")
}
\keyword{ programming }
\keyword{ interface }
\keyword{ IO }
\keyword{ file }

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/H5G.R
\name{H5Gcreate}
\alias{H5Gcreate}
\title{Create a new HDF5 group and link it to a location in a file}
\usage{
H5Gcreate(h5loc, name)
}
\arguments{
\item{h5loc}{An object of class \linkS4class{H5IdComponent}}

\item{name}{Name of the new group to be created.}
}
\description{
\code{H5Gcreate} is used to a new group and link it into a file.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/H5P.R
\name{H5Pset_filter}
\alias{H5Pset_filter}
\title{Add a filter to the dataset filter pipeline.}
\usage{
H5Pset_filter(h5plist, filter_id, is_mandatory = FALSE, cd_values)
}
\arguments{
\item{h5plist}{Object of class \linkS4class{H5IdComponent} representing a dataset
creation property list.}

\item{filter_id}{Integer of length 1, giving the ID of the filter to be used.}

\item{is_mandatory}{Logical of length 1.  Filters can be either optional or
mandatory.  If this argument is set to \code{FALSE} the filter won't be applied
to a chunk in the case of failure, but the data will still be written.
Setting to \code{TRUE} will result in a failure when writing the dataset if the
filter fails for some reason.}

\item{cd_values}{Integer vector giving parameters to be supplied to the
filter. No guidance is given for the number of values supplied here, it is
specific to each filter and the user is expected to know appropriate
options for the requested filter.}
}
\description{
Add a filter to the dataset filter pipeline.
}

\name{h5write}
\alias{h5read}
\alias{h5readAttributes}
\alias{h5write}
\alias{h5write.default}
\alias{h5writeDataset}
\alias{h5writeDataset.data.frame}
\alias{h5writeDataset.list}
\alias{h5writeDataset.matrix}
\alias{h5writeDataset.integer}
\alias{h5writeDataset.double}
\alias{h5writeDataset.logical}
\alias{h5writeDataset.character}
\alias{h5writeDataset.array}
\alias{h5writeAttribute}
\alias{h5writeAttribute.matrix}
\alias{h5writeAttribute.integer}
\alias{h5writeAttribute.double}
\alias{h5writeAttribute.logical}
\alias{h5writeAttribute.character}
\alias{h5writeAttribute.array}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{Reads and write object in HDF5 files}
\description{
Reads and writes objects in HDF5 files. This function can be used to read and write either full arrays/vectors or subarrays (hyperslabs) within an existing dataset.
}
\usage{
h5read                      (file, name, index=NULL,
                             start=NULL, stride=NULL, block=NULL,
                             count=NULL, compoundAsDataFrame = TRUE,
                             callGeneric = TRUE,
                             read.attributes = FALSE, drop = FALSE,
                             ..., native = FALSE,
                             s3 = FALSE, s3credentials = NULL)
h5readAttributes            (file, name, native = FALSE)
h5write                     (obj, file, name, ...)
h5write.default             (obj, file, name, 
                             createnewfile = TRUE,
                             write.attributes = FALSE, ...,
                             native = FALSE)
h5writeDataset              (obj, h5loc, name, ...)
h5writeDataset.data.frame   (obj, h5loc, name, level=6, chunk,
                             DataFrameAsCompound = TRUE)
h5writeDataset.list         (obj, h5loc, name, level=6)
h5writeDataset.matrix       (...)
h5writeDataset.integer      (...)
h5writeDataset.double       (...)
h5writeDataset.logical      (...)
h5writeDataset.character    (...)
h5writeDataset.array        (obj, h5loc, name, index = NULL,
                             start=NULL, stride=NULL, block=NULL, count=NULL,
                             size=NULL, level=6)
h5writeAttribute            (attr, h5obj, name, ...)
h5writeAttribute.matrix     (...)
h5writeAttribute.integer    (...)
h5writeAttribute.double     (...)
h5writeAttribute.logical    (...)
h5writeAttribute.character  (...)
h5writeAttribute.array      (attr, h5obj, name, size)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{obj}{The R object to be written.}
  \item{attr}{The R object to be written as an HDF5 attribute.}
  \item{file}{The filename (character) of the file in which the dataset will be located. For advanced programmers it is possible to provide an object of class \code{\link{H5IdComponent}} representing a H5 location identifier (file or group). See \code{\link{H5Fcreate}}, \code{\link{H5Fopen}}, \code{\link{H5Gcreate}}, \code{\link{H5Gopen}} to create an object of this kind.}
  \item{h5loc}{An object of class \code{\link{H5IdComponent}} representing a H5 location identifier (file or group). See \code{\link{H5Fcreate}}, \code{\link{H5Fopen}}, \code{\link{H5Gcreate}}, \code{\link{H5Gopen}} to create an object of this kind.}
  \item{h5obj}{An object of class \code{\link{H5IdComponent}} representing a H5 object identifier (file, group, or dataset). See \code{\link{H5Fcreate}}, \code{\link{H5Fopen}}, \code{\link{H5Gcreate}}, \code{\link{H5Gopen}}, \code{\link{H5Dcreate}}, or \code{\link{H5Dopen}} to create an object of this kind.}
  \item{name}{The name of the dataset in the HDF5 file. The name of the attribute for hwriteAttribute.}
  \item{index}{List of indices for subsetting. The length of the list has to agree with the dimensional extension of the HDF5 array. Each list element is an integer vector of indices. A list element equal to NULL choses all indices in this dimension. Counting is R-style 1-based.}
  \item{start}{The start coordinate of a hyperslab (similar to subsetting in R). Counting is R-style 1-based. This argument is ignored, if index is not NULL.}
  \item{stride}{The stride of the hypercube. Read the introduction \url{http://ftp.hdfgroup.org/HDF5/Tutor/phypecont.html} before using this argument. R behaves like Fortran in this example. This argument is ignored, if index is not NULL.}
  \item{block}{The block size of the hyperslab. Read the introduction \url{http://ftp.hdfgroup.org/HDF5/Tutor/phypecont.html} before using this argument. R behaves like Fortran in this example. This argument is ignored, if index is not NULL.}
  \item{count}{The number of blocks to be written. This argument is ignored, if index is not NULL.}
  \item{level}{The compression level. An integer value between 0 (no compression) and 9 (highest and slowest compression). Only used, if the dataset does not yet exist. See \code{\link{h5createDataset}} to create an dataset.}
  \item{chunk}{Specifies the number of items to be include in an HDF5 chunk.  When writing a \code{data.frame} this represents the number of rows to be included in a chunk.  If left unspecified the defaults is the smaller of: the total number of rows or the number of rows that fit within 4GB of memory.}
  \item{native}{An object of class \code{logical}. If TRUE, array-like objects are treated as stored in HDF5 row-major rather than R column-major orientation. Using \code{native = TRUE} increases HDF5 file portability between programming languages. A file written with \code{native = TRUE} should also be read with \code{native = TRUE}}.
  \item{compoundAsDataFrame}{If true, a compound datatype will be coerced to a data.frame. This is not possible, if the dataset is multi-dimensional. Otherwise the compound datatype will be returned as a list. Nested compound data types will be returned as a nested list.}
  \item{DataFrameAsCompound}{If true, a data.frame will be saved as a compound data type. Otherwise it is saved like a list. The advantage of saving a data.frame as a compound data type is that it can be read as a table from python or with a struct-type from C. The disadvantage is that the data has to be rearranged on disk and thus can slow down I/O. If fast reading is required, DataFrameAsCompound=FALSE is recommended.}
  \item{callGeneric}{If TRUE a generic function h5read.classname will be called if it exists depending on the dataset's class attribute within the HDF5 file. This function can be used to convert the standard output of h5read depending on the class attribute. Note that h5read is not a S3 generic function. Dispatching is done based on the HDF5 attribute after the standard h5read function.}
  \item{size}{The length of string data type. Variable lengt strings are not yet supported.}
  \item{createnewfile}{If TRUE, a new file will be created if necessary.}
  \item{read.attributes}{(logical) If TRUE, the HDF5 attributes are read and attached to the respective R object.}
  \item{drop}{(logical) If TRUE, the HDF5 object is read as a vector with NULL dim attributes.}
  \item{write.attributes}{(logical) If TRUE, all R-attributes attached to the object \code{obj} are written to the HDF5 file.}
  \item{s3}{Logical value indicating whether the file argument should be 
  treated as a URL to an Amazon S3 bucket, rather than a local file path.}
  \item{s3credentials}{A list of length three, providing the credentials for accessing files in a private Amazon S3 bucket.}
  \item{\dots}{Further arguments passed to \code{\link{H5Dread}}.}
}
\details{
Read/writes an R object from/to an HDF5 file. If neither of the arguments \code{start, stride, block, count} is specified, the dataset has the same dimension in the HDF5 file and in memory. If the dataset already exists in the HDF5 file, one can read/write subarrays, so called hyperslabs from/to the HDF5 file. The arguments \code{start, stride, block, count} define the subset of the dataset in the HDF5 file that is to be read/written. See these introductions to hyperslabs: \url{https://support.hdfgroup.org/HDF5/Tutor/selectsimple.html}, \url{https://support.hdfgroup.org/HDF5/Tutor/select.html} and \url{http://ftp.hdfgroup.org/HDF5/Tutor/phypecont.html}. Please note that in R the first dimension is the fastest changing dimension.

When viewing the HDF5 datasets with any C-program (e.g. HDFView), the order of dimensions is inverted. In the R interface counting starts with 1, whereas in the C-programs (e.g. HDFView) counting starts with 0.
}
\value{
\code{h5read} returns an array with the data read. 

\code{h5readAttributes} returns a list of all HDF5 attributes of object \code{name}.

\code{h5write} returns 0 if successful.
}
\references{\url{https://portal.hdfgroup.org/display/HDF5}}
\author{Bernd Fischer}
\seealso{
\code{\link{h5ls}}, \code{\link{h5createFile}}, \code{\link{h5createDataset}}, \link{rhdf5}
}
\examples{
h5createFile("ex_hdf5file.h5")

# write a matrix
B = array(seq(0.1,2.0,by=0.1),dim=c(5,2,2))
attr(B, "scale") <- "liter"
h5write(B, "ex_hdf5file.h5","B")

# read a matrix
E = h5read("ex_hdf5file.h5","B")

# write and read submatrix
h5createDataset("ex_hdf5file.h5", "S", c(5,8), storage.mode = "integer", chunk=c(5,1), level=7)
h5write(matrix(1:5,nr=5,nc=1), file="ex_hdf5file.h5", name="S", index=list(NULL,1))
h5read("ex_hdf5file.h5", "S")
h5read("ex_hdf5file.h5", "S", index=list(NULL,2:3))

# Read a subset of an hdf5 file in a public S3 bucket
\donttest{
h5read('https://rhdf5-public.s3.eu-central-1.amazonaws.com/rhdf5ex_t_float_3d.h5', 
      s3 = TRUE, name = "a1", index = list(NULL, 3, NULL))
}

}
\keyword{ programming }
\keyword{ interface }
\keyword{ IO }
\keyword{ file }

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/H5R.R
\name{H5R}
\alias{H5R}
\title{H5R - References to objects and regions}
\description{
The \code{H5R} functions can be used for creating or working with
references to specific objects and data regions in an HDF5 file.
}
\examples{
library(rhdf5)

## first we'll create a file with a group named "foo" and a
## 1-dimensional dataset named "baa" inside that group.
file_name <- tempfile(fileext = ".h5")
h5createFile(file_name)
h5createGroup(file = file_name, group = "/foo")
h5write(1:100, file=file_name, name="/foo/baa")


fid <- H5Fopen(file_name)
ref_to_group <- H5Rcreate(fid, name = "/foo")
ref_to_dataset <- H5Rcreate(fid, name = "/foo/baa")
two_refs <- c(ref_to_group, ref_to_dataset)
two_refs

## the size of this dataspace is the number of object references
## we want to store
sid <- H5Screate_simple(2)
tid <- H5Tcopy(dtype_id = "H5T_STD_REF_OBJ")
did <- H5Dcreate(fid, name = "object_refs", dtype_id = tid, h5space = sid)
H5Dwrite(did, two_refs)
H5Dclose(did)
H5Sclose(sid)
H5Fclose(fid)

}
\author{
Mike Smith
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/h5delete.R
\name{h5_delete}
\alias{h5_delete}
\alias{h5delete}
\title{Delete objects within a HDF5 file}
\usage{
h5delete(file, name)
}
\arguments{
\item{file}{The filename (character) of the file in which the object is
located.}

\item{name}{For \code{h5delete} the name of the object to be deleted. For
\code{h5deleteAttribute} the name of the object to which the attribute
belongs.}
}
\description{
Deletes the specified group or dataset from within an HDF5 file.
}
\author{
Mike Smith
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/H5L.R
\name{H5Ldelete}
\alias{H5Ldelete}
\title{Remove a link from a group}
\usage{
H5Ldelete(h5loc, name)
}
\arguments{
\item{h5loc}{An object of class \linkS4class{H5IdComponent} representing a H5
location identifier (file or group).}

\item{name}{The name of the link to be deleted.}
}
\description{
Remove a link from a group
}
\examples{

# create an hdf5 file and a group
h5createFile("ex_H5L.h5")
h5createGroup("ex_H5L.h5","/foo")

# reopen file and confirm "/foo" exists but "/baa" does not
fid <- H5Fopen("ex_H5L.h5")
H5Lexists(fid, "/foo")

# remove the link to "/foo" and confirm it no longer exists
H5Ldelete(fid, "/foo")
H5Lexists(fid, "/foo")

H5Fclose(fid)

}

\name{$<--methods}
\docType{methods}
\alias{$<-,H5IdComponent-method}
\title{ ~~ Methods for Function \code{$<-} in Package \pkg{rhdf5} ~~}
\description{
Methods for function \code{$<-} in package \pkg{rhdf5}.
}
\section{Methods}{
\describe{

\item{\code{signature(x = "H5IdComponent")}}{
Writes the assigned object to to the HDF5 file at location e1. e1 can either be a file handle as returned by H5Fopen() or a group handle as e.g. returned by h5f$g1 or h5f$'/g1/g2's. The storage.mode of the assigned object has to be compatible to the datatype of the HDF5 dataset. The dimension of the assigned object have to be identical the dimensions of the HDF5 dataset. To create a new HDF5 dataset with specific properties (e.g. compression level or chunk size), please use the function h5createDataset first.
}

}}
\keyword{methods}
\keyword{ programming }
\keyword{ interface }
\keyword{ IO }
\keyword{ file }

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/H5O.R
\name{H5Oclose}
\alias{H5Oclose}
\title{Close an HDF5 object}
\usage{
H5Oclose(h5obj)
}
\arguments{
\item{h5obj}{An object of class \linkS4class{H5IdComponent} representing an open
HDF5 object.}
}
\description{
Close an HDF5 object
}
\seealso{
\code{\link[=H5Oopen]{H5Oopen()}}
}

\name{h5set_extent}
\alias{h5set_extent}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{Set a new dataset extension}
\description{Set a new dataset extension to an existing dataset in an HDF5 file}
\usage{
h5set_extent(file, dataset, dims, native = FALSE)
}
\arguments{
  \item{file}{The filename (character) of the file in which the dataset will be located. For advanced programmers it is possible to provide an object of class \code{\link{H5IdComponent}} representing a H5 location identifier (file or group). See \code{\link{H5Fcreate}}, \code{\link{H5Fopen}}, \code{\link{H5Gcreate}}, \code{\link{H5Gopen}} to create an object of this kind.}
  \item{dataset}{The name of the dataset in the HDF5 file, or an object of class \code{\link{H5IdComponent}} representing a H5 dataset identifier. See \code{\link{H5Dcreate}}, or \code{\link{H5Dopen}} to create an object of this kind.}
  \item{dims}{The dimensions of the array as they will appear in the file. Note, the dimensions will appear in inverted order when viewing the file with a C-programm (e.g. HDFView), because the fastest changing dimension in R is the first one, whereas the fastest changing dimension in C is the last one.}
  \item{native}{An object of class \code{logical}. If TRUE, array-like objects are treated as stored in HDF5 row-major rather than R column-major orientation. Using \code{native = TRUE} increases HDF5 file portability between programming languages. A file written with \code{native = TRUE} should also be read with \code{native = TRUE}}.
}
\value{Returns 0 if the dimension of the dataset was changed successfully and a negative value otherwise.}
\references{\url{https://portal.hdfgroup.org/display/HDF5}}
\author{Bernd Fischer}
\seealso{\link{rhdf5}}
\examples{
tmpfile <- tempfile()
h5createFile(file=tmpfile)
h5createDataset(tmpfile, "A", c(10,12), c(20,24))
h5ls(tmpfile, all=TRUE)[c("dim", "maxdim")]
h5set_extent(tmpfile, "A", c(20,24))
h5ls(tmpfile, all=TRUE)[c("dim", "maxdim")]
}
\keyword{ programming }
\keyword{ interface }
\keyword{ IO }
\keyword{ file }

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/H5P.R
\name{H5Pset_shuffle}
\alias{H5Pset_shuffle}
\title{Add the shuffle filter to the chunk processing pipeline.}
\usage{
H5Pset_shuffle(h5plist)
}
\arguments{
\item{h5plist}{Object of class \linkS4class{H5IdComponent} representing a dataset
creation property list.}
}
\value{
Returns (invisibly) an integer vector of length 1.  The only
element of this vector will be non-negative if the filter was set
successfully and negative otherwise.
}
\description{
Add the shuffle filter to the chunk processing pipeline.
}

\name{HDF5 Link Create Property List Interface}
\alias{H5P_LINK_CREATE}
\alias{H5Pset_char_encoding}
\alias{H5Pget_char_encoding}
\alias{H5Pset_create_intermediate_group}
\alias{H5Pget_create_intermediate_group}
\title{HDF5 Link Create Property List Interface}
\description{The functions, macros, and subroutines listed here are used to manipulate link creation property list objects in various ways, including to reset property values. With the use of property lists, HDF5 functions have been implemented and can be used in applications with many fewer parameters than would be required without property lists.}
\usage{
H5Pset_char_encoding               ( h5plist, encoding  = h5default("H5T_CSET"))
H5Pget_char_encoding               ( h5plist )
H5Pset_create_intermediate_group   ( h5plist, crt_intermed_group )
H5Pget_create_intermediate_group   ( h5plist )
}
\arguments{
  \item{h5plist}{An object of class \code{\link{H5IdComponent}} representing a H5 property list identifier of class H5P_LINK_CREATE. See \code{\link{H5Pcreate}} or \code{\link{H5Pcopy}} to create an object of this kind.}
  \item{encoding}{A character name of an encoding type. See \code{h5const("H5T_CSET")} for possible property list types. Can also be an integer representing an HDF5 encoding type.}
  \item{crt_intermed_group}{Logical. If TRUE intermediate groups are created.}
}
\details{
Interface to the HDF5 C-library libhdf5. See \url{https://portal.hdfgroup.org/display/HDF5/Attribute+and+Link+Creation+Properties} for further details. See \link{H5P} for documentation of more functions to manupulate property lists of other property list classes. 
}
\value{
The functions return the standard return value from their respective C-functions.
}
\references{\url{https://portal.hdfgroup.org/display/HDF5}}
\author{Bernd Fischer}
\seealso{
\link{rhdf5}, \link{H5P}
}
\examples{
pid <- H5Pcreate("H5P_LINK_CREATE")
H5Pset_char_encoding( pid, "H5T_CSET_ASCII")
H5Pget_char_encoding( pid)
H5Pset_create_intermediate_group(pid, TRUE)
H5Pget_create_intermediate_group(pid)
H5Pclose(pid)
}
\keyword{ programming }
\keyword{ interface }
\keyword{ IO }
\keyword{ file }

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/H5D.R
\name{H5Dcreate}
\alias{H5Dcreate}
\title{Create a new HDF5 dataset}
\usage{
H5Dcreate(
  h5loc,
  name,
  dtype_id,
  h5space,
  lcpl = NULL,
  dcpl = NULL,
  dapl = NULL
)
}
\arguments{
\item{h5loc}{An object of class \linkS4class{H5IdComponent} representing a H5
location identifier (file or group). See \code{\link[=H5Fcreate]{H5Fcreate()}}, \code{\link[=H5Fopen]{H5Fopen()}},
\code{\link[=H5Gcreate]{H5Gcreate()}}, \code{\link[=H5Gopen]{H5Gopen()}} to create an object of this kind.}

\item{name}{Name of the dataset.}

\item{dtype_id}{A character name of a datatype. See \code{h5const("H5T")}
for possible datatypes. Can also be an integer representing an HDF5 datatype.}

\item{h5space}{An object of class \linkS4class{H5IdComponent} representing a H5 dataspace.
See \code{\link[=H5Dget_space]{H5Dget_space()}}, \code{\link[=H5Screate_simple]{H5Screate_simple()}}, \code{\link[=H5Screate]{H5Screate()}} to create an object
of this kind}

\item{lcpl, dcpl, dapl}{An objects of class \linkS4class{H5IdComponent} representing
HDF5 property lists.  Specially these should respectively be: a link creation
property list, a dataset creation property list, a dataset access property list}
}
\value{
An object of class \code{H5IdComponent} representing the opened dataset.
}
\description{
Create a new HDF5 dataset
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/H5P.R
\name{H5Pcreate}
\alias{H5Pcreate}
\title{Create a new HDF5 property list}
\usage{
H5Pcreate(type = h5default("H5P"), native = FALSE)
}
\arguments{
\item{type}{A character name of a property list type. See \code{h5const("H5P")}
for possible property list types.}

\item{native}{Defunct! Doesn't achieve anything for property lists.}
}
\description{
Create a new HDF5 property list
}

\name{h5errorHandling}
\alias{h5errorHandling}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{handling of HDF5 error messages}
\description{Sets the options for handling HDF5 error messages.}
\usage{
h5errorHandling (type="normal")
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{type}{'normal' (default) shows a one line error message in R. 'verbose' shows the whole HDF5 error message. 'suppress' suppresses the HDF5 error messages completely.}
}
\details{
Sets the options for HDF5 error hanlding.
}
\value{Returns 0 if options are set successfully.}
\references{\url{https://portal.hdfgroup.org/display/HDF5}}
\author{Bernd Fischer}
\seealso{
\link{rhdf5}
}
\examples{
h5errorHandling("normal")
}
\keyword{ programming }
\keyword{ interface }
\keyword{ IO }
\keyword{ file }

\name{HDF5 Identifier Interface}
\alias{H5I}
\alias{H5Iget_type}
\alias{H5Iget_name}
\alias{H5Iis_valid}
\title{HDF5 Identifier Interface}
\description{These functions provides tools for working with object identifiers and object names.}
\usage{
H5Iget_type(h5identifier)
H5Iget_name(h5obj)
H5Iis_valid(h5identifier)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{h5identifier}{An object of class \code{\link{H5IdComponent}} representing a H5 identifier (file, group, dataset, dataspace, datatype, attribute). See e.g. \code{\link{H5Fcreate}}, \code{\link{H5Fopen}}, \code{\link{H5Gcreate}}, \code{\link{H5Gopen}}, \code{\link{H5Dcreate}}, \code{\link{H5Dopen}} to create an object of this kind.}
  \item{h5obj}{An object of class \code{\link{H5IdComponent}} representing a H5 object identifier (file, group, or dataset). See \code{\link{H5Fcreate}}, \code{\link{H5Fopen}}, \code{\link{H5Gcreate}}, \code{\link{H5Gopen}}, \code{\link{H5Dcreate}}, or \code{\link{H5Dopen}} to create an object of this kind.}
}
\details{
Interface to the HDF5 C-library libhdf5. See \url{https://portal.hdfgroup.org/display/HDF5/Identifiers} for further details.
}
\value{\code{H5Iget_type} returns the type of the H5 identifier, \code{H5Iget_name} the name of the object, and \code{H5Iis_valid} checks if the object is a valid H5 identifier. }
\references{\url{https://portal.hdfgroup.org/display/HDF5}}
\author{Bernd Fischer}
\seealso{
\link{rhdf5}
}
\examples{
# create an hdf5 file and write something
h5createFile("ex_H5I.h5")
h5createGroup("ex_H5I.h5","foo")
B = array(seq(0.1,2.0,by=0.1),dim=c(5,2,2))
h5write(B, "ex_H5I.h5","foo/B")

# reopen file and dataset and get object info
fid <- H5Fopen("ex_H5I.h5")
oid = H5Oopen(fid, "foo")
H5Iget_type(oid)
H5Oclose(oid)
H5Fclose(fid)

}
\keyword{ programming }
\keyword{ interface }
\keyword{ IO }
\keyword{ file }

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/h5create.R
\name{h5_createAttribute}
\alias{h5_createAttribute}
\alias{h5createAttribute}
\title{Create HDF5 attribute}
\usage{
h5createAttribute(
  obj,
  attr,
  dims,
  maxdims = dims,
  file,
  storage.mode = "double",
  H5type = NULL,
  size = NULL,
  encoding = NULL,
  cset = NULL,
  native = FALSE
)
}
\arguments{
\item{obj}{The name (character) of the object the attribute will be attatched
to. For advanced programmers it is possible to provide an object of class
\linkS4class{H5IdComponent} representing a H5 object identifier (file, group,
dataset). See \code{\link[=H5Fcreate]{H5Fcreate()}}, \code{\link[=H5Fopen]{H5Fopen()}}, \code{\link[=H5Gcreate]{H5Gcreate()}}, \code{\link[=H5Gopen]{H5Gopen()}},
\code{\link[=H5Dcreate]{H5Dcreate()}}, \code{\link[=H5Dopen]{H5Dopen()}} to create an object of this kind.}

\item{attr}{Name of the attribute to be created.}

\item{dims}{The dimensions of the attribute as a numeric vector. If
\code{NULL}, a scalar dataspace will be created instead.}

\item{maxdims}{The maximum extension of the attribute.}

\item{file}{The filename (character) of the file in which the dataset will be
located. For advanced programmers it is possible to provide an object of
class \linkS4class{H5IdComponent} representing an H5 location identifier. See
\code{\link[=H5Fcreate]{H5Fcreate()}}, \code{\link[=H5Fopen]{H5Fopen()}}, \code{\link[=H5Gcreate]{H5Gcreate()}}, \code{\link[=H5Gopen]{H5Gopen()}} to create an object
of this kind. The \code{file} argument is not required, if the argument
\code{obj} is of type \code{H5IdComponent}.}

\item{storage.mode}{The storage mode of the data to be written. Can be
obtained by \code{storage.mode(mydata)}.}

\item{H5type}{Advanced programmers can specify the datatype of the dataset
within the file. See \code{h5const("H5T")} for a list of available
datatypes. If \code{H5type} is specified the argument \code{storage.mode}
is ignored. It is recommended to use \code{storage.mode}}

\item{size}{The maximum string length when \code{storage.mode='character'}.
If this is specified, HDF5 stores each string of \code{attr} as fixed
length character arrays. Together with compression, this should be
efficient.

If this argument is set to \code{NULL}, HDF5 will instead store
variable-length strings.}

\item{encoding}{The encoding of the string data type i.e. when \code{storage.mode = 'character'}. Valid options are "ASCII" and "UTF-8".}

\item{cset}{\emph{Deprecated in favour of the \code{encoding} argument.}}

\item{native}{An object of class \code{logical}. If TRUE, array-like objects
are treated as stored in HDF5 row-major rather than R column-major
orientation. Using \code{native = TRUE} increases HDF5 file portability
between programming languages. A file written with \code{native = TRUE}
should also be read with \code{native = TRUE}}
}
\value{
Returns TRUE is attribute was created successfully and FALSE
otherwise.
}
\description{
R function to create an HDF5 attribute and defining its dimensionality.
}
\details{
Creates a new attribute and attaches it to an existing HDF5 object. The
function will fail, if the file doesn't exist or if there exists already
another attribute with the same name for this object.

You can use \code{\link[=h5writeAttribute]{h5writeAttribute()}} immediately. It will create the attribute
for you.
}
\examples{

h5createFile("ex_createAttribute.h5")
h5write(1:1, "ex_createAttribute.h5","A")
fid <- H5Fopen("ex_createAttribute.h5")
did <- H5Dopen(fid, "A")
h5createAttribute (did, "time", c(1,10))
H5Dclose(did)
H5Fclose(fid)

}
\references{
\url{https://portal.hdfgroup.org/display/HDF5}
}
\seealso{
\code{\link[=h5createFile]{h5createFile()}}, \code{\link[=h5createGroup]{h5createGroup()}}, \code{\link[=h5createDataset]{h5createDataset()}},
\code{\link[=h5read]{h5read()}}, \code{\link[=h5write]{h5write()}}, \link{rhdf5}
}
\author{
Bernd Fischer
}
\keyword{IO}
\keyword{file}
\keyword{interface}
\keyword{programming}

\name{h5createAttribute}
\alias{h5createAttribute}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{Create HDF5 attribute}
\description{R function to create an HDF5 attribute and defining its dimensionality.
}
\usage{
h5createAttribute (obj, attr, dims, maxdims = dims, file, 
                   storage.mode = "double", H5type = NULL, size=NULL,
                   native = FALSE)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{obj}{The name (character) of the object the attribute will be attatched to. For advanced programmers it is possible to provide an object of class \code{\link{H5IdComponent}} representing a H5 object identifier (file, group, dataset). See \code{\link{H5Fcreate}}, \code{\link{H5Fopen}}, \code{\link{H5Gcreate}}, \code{\link{H5Gopen}}, \code{\link{H5Dcreate}}, \code{\link{H5Dopen}} to create an object of this kind.}
  \item{file}{The filename (character) of the file in which the dataset will be located. For advanced programmers it is possible to provide an object of class \code{\link{H5IdComponent}} representig an H5 location identifier. See \code{\link{H5Fcreate}}, \code{\link{H5Fopen}}, \code{\link{H5Gcreate}}, \code{\link{H5Gopen}} to create an object of this kind. The \code{file} argument is not required, if the argument \code{obj} is of type \code{H5IdComponent}.}
  \item{attr}{Name of the attribute to be created.}
  \item{dims}{The dimension of the attribute.}
  \item{maxdims}{The maximum extension of the attribute.}
  \item{storage.mode}{The storage mode of the data to be written. Can be obtained by \code{storage.mode(mydata)}.}
  \item{H5type}{Advanced programmers can specify the datatype of the dataset within the file. See \code{h5const("H5T")} for a list of available datatypes. If \code{H5type} is specified the argument \code{storage.mode} is ignored. It is recommended to use \code{storage.mode}}
  \item{size}{For \code{storage.mode='character'} the maximum string length has to be specified. HDF5 then stores the string as fixed length character vectors. Together with compression, this should be efficient.}
  \item{native}{An object of class \code{logical}. If TRUE, array-like objects are treated as stored in HDF5 row-major rather than R column-major orientation. Using \code{native = TRUE} increases HDF5 file portability between programming languages. A file written with \code{native = TRUE} should also be read with \code{native = TRUE}}.
}
\details{
Creates a new attribute and attaches it to an existing HDF5 object. The function will fail, if the file doesn't exist or if there exists already another attribute with the same name for this object. 

You can use \code{\link{h5writeAttribute}} immediately. It will create the attribute for you.
}
\value{Returns TRUE is attribute was created successfully and FALSE otherwise.}
\references{\url{https://portal.hdfgroup.org/display/HDF5}}
\author{Bernd Fischer}
\seealso{
\code{\link{h5createFile}}, \code{\link{h5createGroup}}, \code{\link{h5createDataset}}, \code{\link{h5read}}, \code{\link{h5write}}, \link{rhdf5}
}
\examples{
h5createFile("ex_createAttribute.h5")
h5write(1:1, "ex_createAttribute.h5","A")
fid <- H5Fopen("ex_createAttribute.h5")
did <- H5Dopen(fid, "A")
h5createAttribute (did, "time", c(1,10))
H5Dclose(did)
H5Fclose(fid)
}
\keyword{ programming }
\keyword{ interface }
\keyword{ IO }
\keyword{ file }

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/H5G.R
\name{H5Gopen}
\alias{H5Gopen}
\title{Open a specified group}
\usage{
H5Gopen(h5loc, name)
}
\arguments{
\item{h5loc}{An object of class \linkS4class{H5IdComponent} representing a H5
file or group that contains the group to be opened.}

\item{name}{Name of the group to open.}
}
\value{
An object of class \linkS4class{H5IdComponent} representing the opened
group.  When access to the group is no longer needed this should be released
with \code{\link[=H5Gclose]{H5Gclose()}} to prevent resource leakage.
}
\description{
Open a specified group
}
\seealso{
\code{\link[=H5Gclose]{H5Gclose()}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/H5P.R
\name{H5P_layout}
\alias{H5P_layout}
\alias{H5Pset_layout}
\alias{H5Pget_layout}
\title{Get and set the type of storage used to store the raw data for a dataset}
\usage{
H5Pset_layout(h5plist, layout = h5default("H5D"))

H5Pget_layout(h5plist)
}
\arguments{
\item{h5plist}{An object of class \linkS4class{H5IdComponent} representing a dataset creation property list.}

\item{layout}{A character giving the name of a dataset layout type.}
}
\description{
Possible options for the \code{layout} argument are:
\itemize{
\item \code{H5D_COMPACT}
\item \code{H5D_CONTIGUOUS}
\item \code{H5D_CHUNKED}
\item \code{H5D_VIRTUAL}
}
}
\details{
The names of the layout types can also be obtained via \code{h5const("H5D")}.
}

\name{h5testFileLocking}
\alias{h5testFileLocking}
\alias{h5enableFileLocking}
\alias{h5disableFileLocking}

\title{Test and set file locking for HDF5}

\description{HDF5 1.10 uses file locking by default.  On some file systems
  this is not available, and the HDF5 library will throw an error if the user
  attempts to create or access a file located on such a file system.  These
  functions help identify if file locking is available without throwing an 
  error, and allow the locking to be disabled for the duration of the R
  session if needed.}

\usage{
h5testFileLocking(location)
h5disableFileLocking()
h5enableFileLocking()
}

\arguments{
  \item{location}{The name of a directory or file to test.  If an existing 
  directory is provided a temporary file will be created in this folder.  
  If non-existant location is provided a file with the name will be created,
  tested for file locking, and then removed.  Providing an existing file will
  result in an error.}
}

\value{
  \code{h5testFileLocking} returns \code{TRUE} if a file can be successfully
  locked at the specified location, or \code{FALSE} otherwise.
  
  \code{h5disableFileLocking} and \code{h5enableFileLocking} set are called
  for the side effect of setting or unsetting the environment variable
  \code{HDF5_USE_FILE_LOCKING} and do not return anything.
}

\details{
\code{h5testFileLocking} will create a temporary file and then attempt to apply
a file lock using the appropriate function within the HDF5 library. The
success or failure of the locking is then recorded and the temporary file 
removed.  Even relatively low level functions such as \code{\link{H5Fcreate}}
will fail inelegantly if file locking fails.

\code{h5disableFileLocking} will set the environment variable 
\code{RHDF5_USE_FILE_LOCKING=FALSE}, which is the recommended was to disable
this behaviour if file locking is not supported.  This will only persist within
the current R session.  You can set the environment variable outside of R if 
this is a more general issue on your system.

\code{h5enableFileLocking} will unset the \code{RHDF5_USE_FILE_LOCKING}.

More discussion of HDF5's use of file locking can be found online e.g.
https://forum.hdfgroup.org/t/hdf5-1-10-0-and-flock/3761/4 or 
https://forum.hdfgroup.org/t/hdf5-files-on-nfs/3985/5 
}

\author{Mike Smith}

\examples{

## either a file name or directory can be tested
file <- tempfile()
dir <- tempdir()

h5testFileLocking(dir)
h5testFileLocking(file)

## we can check for file locking, and disable if needed
if( !h5testFileLocking(dir) ) {
  h5disableFileLocking()
}

}
\keyword{ IO }
\keyword{ file }

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/H5S.R
\name{H5Sclose}
\alias{H5Sclose}
\title{Close and release a dataspace}
\usage{
H5Sclose(h5space)
}
\arguments{
\item{h5space}{Object of class \linkS4class{H5IdComponent} representing the
dataspace to be closed.}
}
\description{
Close and release a dataspace
}
\seealso{
\code{\link[=H5Screate]{H5Screate()}}
}

\name{HDF5 Dataset Access Property List Interface}
\alias{H5P_DATASET_ACCESS}
\alias{H5Pset_chunk_cache}
\alias{H5Pget_chunk_cache}
\title{HDF5 Dataset Access Property List Interface}
\description{The functions, macros, and subroutines listed here are used to manipulate dataset access property list objects in various ways, including to reset property values. With the use of property lists, HDF5 functions have been implemented and can be used in applications with many fewer parameters than would be required without property lists.}
\usage{
H5Pset_chunk_cache                 ( h5plist, rdcc_nslots, rdcc_nbytes, rdcc_w0 )
% H5Pget_chunk_cache                 ( dapl_id, rdcc_nslots, rdcc_nbytes, rdcc_w0 )
}
\arguments{
  \item{h5plist}{An object of class \code{\link{H5IdComponent}} representing a H5 property list identifier of class H5P_DATASET_ACCESS. See \code{\link{H5Pcreate}} or \code{\link{H5Pcopy}} to create an object of this kind.}
  \item{rdcc_nslots}{An integer. The number of chunk slots in the raw data chunk cache for this dataset.}
  \item{rdcc_nbytes}{An integer. The total size of the raw data chunk cache for this dataset.}
  \item{rdcc_w0}{double. The chunk preemption policy for this dataset.}
}
\details{
Interface to the HDF5 C-library libhdf5. See \url{https://portal.hdfgroup.org/display/HDF5/Dataset+Access+Properties} for further details. See \link{H5P} for documentation of more functions to manupulate property lists of other property list classes. 
}
\value{
The functions return the standard return value from their respective C-functions.
}
\references{\url{https://portal.hdfgroup.org/display/HDF5}}
\author{Bernd Fischer}
\seealso{
\link{rhdf5}, \link{H5P}
}
\examples{
pid <- H5Pcreate("H5P_DATASET_ACCESS")
H5Pset_chunk_cache( pid, 100, 10000, 0.5)
H5Pclose(pid)
}
\keyword{ programming }
\keyword{ interface }
\keyword{ IO }
\keyword{ file }

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/H5R.R
\name{H5Rdereference}
\alias{H5Rdereference}
\title{Open a reference object.}
\usage{
H5Rdereference(ref, h5loc)
}
\arguments{
\item{ref}{\code{H5ref} object containing the reference to be opened.}

\item{h5loc}{An \code{H5IdComponent} object representing the file containing the
referenced object.}
}
\value{
An object of class \code{H5IdComponent} representing the opened object
referenced by \code{ref}.  This should be closed with the appropriate function
e.g. \code{\link[=H5Dclose]{H5Dclose()}}, \code{\link[=H5Oclose]{H5Oclose()}}, etc. when no longer needed.
}
\description{
Given a reference and the file to which that reference applies,
\code{H5Rdeference()} will open the reference object and return an identifier.
}
\details{
If \code{ref} contains more than one reference, only the first reference
will be used.  It must be subset with \code{[} if one of the other stored
references should be opened.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/h5create.R
\name{h5_createFile}
\alias{h5_createFile}
\alias{h5createFile}
\title{Create HDF5 file}
\usage{
h5createFile(file)
}
\arguments{
\item{file}{The filename of the HDF5 file.}
}
\value{
Returns (invisibly) \code{TRUE} is file was created successfully and \code{FALSE} otherwise.
}
\description{
R function to create an empty HDF5 file.
}
\details{
Creates an empty HDF5 file.
}
\examples{

h5createFile("ex_createFile.h5")

# create groups
h5createGroup("ex_createFile.h5","foo")
h5createGroup("ex_createFile.h5","foo/foobaa")

h5ls("ex_createFile.h5")

}
\seealso{
\code{\link[=h5createGroup]{h5createGroup()}}, \code{\link[=h5createDataset]{h5createDataset()}},
\code{\link[=h5read]{h5read()}}, \code{\link[=h5write]{h5write()}}, \link{rhdf5}
}
\author{
Bernd Fischer
}

\name{h5listIdentifier}
\alias{h5listIdentifier}
\alias{h5validObjects}
\title{list all valid H5 identifier.}
\description{A list of all valid H5 identifier. H5 objects should be closed after usage to release resources.}
\usage{
h5listIdentifier()
h5validObjects(native = FALSE)
}
\arguments{
  \item{native}{An object of class \code{logical}. If TRUE, array-like objects are treated as stored in HDF5 row-major rather than R column-major orientation. Using \code{native = TRUE} increases HDF5 file portability between programming languages. A file written with \code{native = TRUE} should also be read with \code{native = TRUE}}.
}
\value{
\code{h5validObjects} returns a list of \code{\link{H5IdComponent}} objects. \code{h5listIdentifier} prints the valid identifiers on screen and returns NULL.
}
\references{\url{https://portal.hdfgroup.org/display/HDF5}}
\author{Bernd Fischer}
\seealso{
\link{rhdf5}
}
\examples{
h5createFile("ex_list_identifier.h5")

# create groups
h5createGroup("ex_list_identifier.h5","foo")

h5listIdentifier()
h5validObjects()
}
\keyword{ programming }
\keyword{ interface }
\keyword{ IO }
\keyword{ file }

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/H5L.R
\name{H5Lget_info}
\alias{H5Lget_info}
\title{Find information about a link}
\usage{
H5Lget_info(h5loc, name)
}
\arguments{
\item{h5loc}{An object of class \linkS4class{H5IdComponent} representing a H5
location identifier (file or group).}

\item{name}{The name of the link to be queried.}
}
\value{
A character vector of length 1 giving the type of link.  Possible
values are:
\code{H5L_TYPE_HARD}, \code{H5L_TYPE_SOFT}, \code{H5L_TYPE_EXTERNAL}, \code{H5L_TYPE_ERROR}
}
\description{
\code{H5Lget_info()} identifies the type of link specified by the the \code{h5loc}
and \code{name} arguments. This is more limited than the equivalent function in
the standard HDF5 library.
}

\name{HDF5 Dataset Create Property List Interface}
\alias{H5P_DATASET_CREATE}
\alias{H5Pset_layout}
\alias{H5Pget_layout}
\alias{H5Pset_chunk}
\alias{H5Pget_chunk}
\alias{H5Pset_deflate}
\alias{H5Pset_fill_value}
\alias{H5Pget_fill_value}
\alias{H5Pfill_value_defined}
\alias{H5Pset_fill_time}
\alias{H5Pget_fill_time}
\alias{H5Pset_alloc_time}
\alias{H5Pget_alloc_time}
\alias{H5Pset_filter}
\alias{H5Pall_filters_avail}
\alias{H5Pget_nfilters}
\alias{H5Pget_filter1}
\alias{H5Pget_filter2}
\alias{H5Pget_filter_by_id1}
\alias{H5Pget_filter_by_id2}
\alias{H5Pmodify_filter}
\alias{H5Premove_filter}
\alias{H5Pset_fletcher32}
\alias{H5Pset_nbit}
\alias{H5Pset_scaleoffset}
\alias{H5Pset_shuffle}
\alias{H5Pset_szip}
\alias{H5Pset_bzip2}
\alias{H5Pset_blosc}
\alias{H5Pset_external}
\alias{H5Pget_external_count}
\alias{H5Pget_external}
\title{HDF5 Dataset Create Property List Interface}
\description{The functions, macros, and subroutines listed here are used to manipulate dataset creation property list objects in various ways, including to reset property values. With the use of property lists, HDF5 functions have been implemented and can be used in applications with many fewer parameters than would be required without property lists.}
\usage{
H5Pset_layout              ( h5plist, layout = h5default("H5D") )
H5Pget_layout              ( h5plist )
H5Pset_chunk               ( h5plist, dim )
H5Pget_chunk               ( h5plist )
H5Pset_deflate             ( h5plist, level )
H5Pset_fill_value          ( h5plist, value )
% H5Pget_fill_value                  ( plist_id, type_id, value )
H5Pfill_value_defined      ( h5plist )
H5Pset_fill_time           ( h5plist, fill_time = h5default("H5D_FILL_TIME") )
H5Pget_fill_time           ( h5plist )
H5Pset_alloc_time          ( h5plist, alloc_time = h5default("H5D_ALLOC_TIME") )
H5Pget_alloc_time          ( h5plist )
% H5Pset_filter                      ( plist_id, filter_id, flags, cd_nelmts, cd_values[] )
H5Pall_filters_avail       ( h5plist )
% H5Pget_nfilters                    ( plist )
% H5Pget_filter1                     ( plist_id, idx, flags, cd_nelmts, cd_values, namelen, name[] )
% H5Pget_filter2                     ( plist_id, idx, flags, cd_nelmts, cd_values[], namelen, name[], filter_config )
% H5Pget_filter_by_id1               ( plist_id, filter_id, flags, cd_nelmts, cd_values[], namelen, name[] )
% H5Pget_filter_by_id2               ( plist_id, filter_id, flags, cd_nelmts, cd_values[], namelen, name[], filter_config )
% H5Pmodify_filter                   ( plist_id, filter_id, flags, cd_nelmts, cd_values[] )
% H5Premove_filter                   ( plist_id, filter )
% H5Pset_fletcher32                  ( plist_id )
% H5Pset_nbit                        ( plist_id )
% H5Pset_scaleoffset                 ( plist_id, scale_type, scale_factor )
H5Pset_shuffle             ( h5plist )
H5Pset_szip                ( h5plist, options_mask, pixels_per_block )
% H5Pset_external          ( plist, *name, offset, size )
% H5Pget_external_count    ( plist )
% H5Pget_external                    ( plist, idx, name_size, *name, *offset, *size )
H5Pset_blosc               ( h5plist, h5tid, method = 1L, level = 6L, shuffle = TRUE )
H5Pset_bzip2               ( h5plist, level = 2L )  
}
\arguments{
  \item{h5plist}{An object of class \code{\link{H5IdComponent}} representing a H5 property list identifier of class H5P_DATASET_CREATE. See \code{\link{H5Pcreate}} or \code{\link{H5Pcopy}} to create an object of this kind.}
  \item{layout}{A character name of a dataset layout type. See \code{h5const("H5D")} for possible property list types. Can also be an integer representing an HDF5 dataset layout type.}
  \item{dim}{The chunk size used to store the dataset. It is an integer vector of the same length as the dataset \code{dims}.}
  \item{level}{The compression level used. An integer value between 0 (no compression) and 9 (highest and slowest compression).}
  \item{value}{Standard value for filling the dataset. The storage.mode of value has to be convertable to the dataset type by HDF5.}
  \item{fill_time}{A character name of a H5D_FILL_TIME type. See \code{h5const("H5D_FILL_TIME")} for possible values. Can also be an integer representing an HDF5 H5D_FILL_TIME type.}
  \item{alloc_time}{A character name of a H5D_ALLOC_TIME type. See \code{h5const("H5D_ALLOC_TIME")} for possible property list types. Can also be an integer representing an HDF5 H5D_ALLOC_TIME type.}
  \item{h5tid}{HDF5 type ID.}
  \item{method}{When using the BLOSC filter, defines which compression tool should be used.}
  \item{shuffle}{Logical value determining whether byte shuffling should be applied before compression is applied. This only applies to the BLOSC filter.}
  \item{options_mask}{See \url{https://portal.hdfgroup.org/display/HDF5/H5P_SET_SZIP} for more details.}
  \item{pixels_per_block}{See \url{https://portal.hdfgroup.org/display/HDF5/H5P_SET_SZIP} for more details.}
}
\details{
Interface to the HDF5 C-library libhdf5. See \url{https://portal.hdfgroup.org/display/HDF5/Dataset+Creation+Properties} for further details. See \link{H5P} for documentation of more functions to manupulate property lists of other property list classes. 
}
\value{
The functions return the standard return value from their respective C-functions.
}
\references{
  \url{https://portal.hdfgroup.org/display/HDF5},
  \url{https://portal.hdfgroup.org/display/HDF5/Szip+Compression+in+HDF+Products}
}
\author{Bernd Fischer, Mike L. Smith}
\seealso{
\link{rhdf5}, \link{H5P}
}
\examples{
pid <- H5Pcreate("H5P_DATASET_CREATE")
H5Pset_fill_time( pid, "H5D_FILL_TIME_ALLOC" )
H5Pset_chunk(pid, c(1000,1,1))
H5Pset_deflate(pid, 6)

H5Pget_layout( pid )
H5Pfill_value_defined( pid )
H5Pget_fill_time( pid )
H5Pget_alloc_time( pid )
H5Pget_chunk( pid)

H5Pclose(pid)
}
\keyword{ programming }
\keyword{ interface }
\keyword{ IO }
\keyword{ file }

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/H5F.R
\name{H5Fflush}
\alias{H5Fflush}
\title{Flush all buffers associated with a file to disk}
\usage{
H5Fflush(h5file, scope = h5default("H5F_SCOPE"))
}
\arguments{
\item{h5file}{\linkS4class{H5IdComponent} representing any object associated with
the file to be flushed.}

\item{scope}{Specifies whether the scope of the flushing action is global
(flushes the entire virtual file) or local (flushes only the specified
file). Valid values are \code{H5F_SCOPE_GLOBAL} and \code{H5F_SCOPE_LOCAL}.}
}
\description{
Flush all buffers associated with a file to disk
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/h5readAttributes.R
\name{h5_readAttributes}
\alias{h5_readAttributes}
\alias{h5readAttributes}
\title{Read all attributes from a given location in an HDF5 file}
\usage{
h5readAttributes(file, name, native = FALSE, ...)
}
\arguments{
\item{file}{Character vector of length 1, giving the path to the HDF5}

\item{name}{Path within the HDF5 file to the object whose attributes should
be read.}

\item{native}{An object of class \code{logical}. If TRUE, array-like objects
are treated as stored in HDF5 row-major rather than R column-major
orientation.}

\item{\dots}{Further arguments passed to \code{\link{H5Aread}}.}
}
\value{
A named list of the same length as the number of attributes attached
to the specific object.  The names of the list entries correspond to the
attribute names.  If no attributes are found an empty list is returned.
}
\description{
Read all attributes from a given location in an HDF5 file
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/H5P.R
\name{H5Pclose}
\alias{H5Pclose}
\title{Close and release a property list}
\usage{
H5Pclose(h5plist)
}
\arguments{
\item{h5plist}{\linkS4class{H5IdComponent} object representing the property list
to close.}
}
\description{
\code{H5Pclose()} terminates access to a property list. All property lists
should be closed when they no longer need to be accessed. This
frees resources used by the property list.  Failing to call \code{H5Pclose()}
can lead to memory leakage over time.
}

\name{h5createDataset}
\alias{h5createDataset}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{Create HDF5 dataset}
\description{R function to create an HDF5 dataset and defining its dimensionality and compression behaviour.
}
\usage{
h5createDataset (file, dataset, 
		dims, maxdims = dims, 
		storage.mode = "double", H5type = NULL, 
		size = NULL, chunk = dims, fillValue, 
		level = 6, filter = "gzip", shuffle = TRUE,
        native = FALSE)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{file}{The filename (character) of the file in which the dataset will be located. For advanced programmers it is possible to provide an object of class \code{\link{H5IdComponent}} representing a H5 location identifier (file or group). See \code{\link{H5Fcreate}}, \code{\link{H5Fopen}}, \code{\link{H5Gcreate}}, \code{\link{H5Gopen}} to create an object of this kind.}
  \item{dataset}{Name of the dataset to be created. The name can contain group names, e.g. 'group/dataset', but the function will fail, if the group does not yet exist.}
  \item{dims}{The dimensions of the array as they will appear in the file. Note, the dimensions will appear in inverted order when viewing the file with a C-programm (e.g. HDFView), because the fastest changing dimension in R is the first one, whereas the fastest changing dimension in C is the last one.}
  \item{maxdims}{The maximum extension of the array. Use \code{H5Sunlimited()} to indicate an extensible dimension.}
  \item{storage.mode}{The storage mode of the data to be written. Can be obtained by \code{storage.mode(mydata)}.}
  \item{H5type}{Advanced programmers can specify the datatype of the dataset within the file. See \code{h5const("H5T")} for a list of available datatypes. If \code{H5type} is specified the argument \code{storage.mode} is ignored. It is recommended to use \code{storage.mode}}
  \item{size}{For \code{storage.mode='character'} the maximum string length has
  to be specified. rhdf5 writes null padded strings by dafault, thus the value
  provided here should be the length of the longest string.  HDF5 then stores
  the string as fixed length character vectors. Together with compression, this
  should be efficient.}
  \item{chunk}{The chunk size used to store the dataset. It is an integer vector of the same length as \code{dims}. This argument is usually set together with a compression property (argument \code{level}). }
  \item{fillValue}{Standard value for filling the dataset. The storage.mode of value has to be convertable to the dataset type by HDF5.}
  \item{level}{The compression level used. An integer value between 0 (no compression) and 9 (highest and slowest compression).}
  \item{filter}{Character defining which compression filter should be applied 
  to the chunks of the dataset.  See the Details section for more information
  on the options that can be provided here.}
  \item{shuffle}{Logical defining whether the byte-shuffle algorithm should be 
  applied to data prior to compression.}
  \item{native}{An object of class \code{logical}. If TRUE, array-like objects are treated as stored in HDF5 row-major rather than R column-major orientation. Using \code{native = TRUE} increases HDF5 file portability between programming languages. A file written with \code{native = TRUE} should also be read with \code{native = TRUE}}.
}
\details{
Creates a new dataset in an existing HDF5 file. The function will fail if the 
file doesn't exist or if there exists already another dataset with the same 
name within the specified file.

The \code{filter} argument can take several options matching to compression
filters distributed in either with the HDF5 library in \pkg{Rhdf5lib} or via the 
\pkg{rhdf5filters} package.  The plugins available and the corresponding values 
for selecting them are shown below:

\describe{
\item{zlib:  Ubiquitous deflate compression algrithm used in GZIP or ZIP files.  
    All three options below achieve the same result.}{
    \itemize{
        \item{\code{"GZIP"}}, 
        \item{\code{"ZLIB"}}, 
        \item{\code{"DEFLATE"}}
    }
}
\item{szip: Compression algorithm maintained by the HDF5 group.}{
    \itemize{
        \item{\code{"SZIP"}}
    }
}
\item{bzip2}{
    \itemize{
        \item{\code{"BZIP2"}}
    }
}
\item{BLOSC meta compressor: As a meta-compressor BLOSC wraps several different
    compression algorithms.  Each of the options below will active a different 
    compression filter. }{
    \itemize{
        \item{\code{"BLOSC_BLOSCLZ"}}
        \item{\code{"BLOSC_LZ4"}}
        \item{\code{"BLOSC_LZ4HC"}}
        \item{\code{"BLOSC_SNAPPY"}}
        \item{\code{"BLOSC_ZLIB"}}
        \item{\code{"BLOSC_ZSTD"}}
    }
}
\item{Disable: It is possible to write chunks without and compression 
    applied.}{
    \itemize{
        \item{\code{"NONE"}}
    }
}
}
}

\value{Returns TRUE is dataset was created successfully and FALSE otherwise.}
\references{\url{https://portal.hdfgroup.org/display/HDF5}}
\author{Bernd Fischer, Mike L. Smith}
\seealso{
\code{\link{h5createFile}}, \code{\link{h5createGroup}}, \code{\link{h5read}}, \code{\link{h5write}}, \link{rhdf5}
}
\examples{
h5createFile("ex_createDataset.h5")

# create dataset with compression
h5createDataset("ex_createDataset.h5", "A", c(5,8), storage.mode = "integer", chunk=c(5,1), level=6)

# create dataset without compression
h5createDataset("ex_createDataset.h5", "B", c(5,8), storage.mode = "integer")
h5createDataset("ex_createDataset.h5", "C", c(5,8), storage.mode = "double")

# create a dataset of strings & define size based on longest string
ex_strings <- c('long', 'longer', 'longest')
h5createDataset("ex_createDataset.h5", "D",  
    storage.mode = "character", chunk = 3, level = 6,
    dims = length(ex_strings), size = max(nchar(ex_strings)))


# write data to dataset
h5write(matrix(1:40,nr=5,nc=8), file="ex_createDataset.h5", name="A")
# write second column
h5write(matrix(1:5,nr=5,nc=1), file="ex_createDataset.h5", name="B", index=list(NULL,2))
# write character vector
h5write(ex_strings, file = "ex_createDataset.h5", name = "D")

h5dump("ex_createDataset.h5")
}
\keyword{ programming }
\keyword{ interface }
\keyword{ IO }
\keyword{ file }

\name{h5ls}
\alias{h5ls}
\alias{h5dump}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{List the content of an HDF5 file.}
\description{
Lists the content of an HDF5 file.
}
\usage{
h5ls   (file,
        recursive = TRUE,
        all = FALSE, 
        datasetinfo = TRUE,
        index_type = h5default("H5_INDEX"),
        order = h5default("H5_ITER"), 
        s3 = FALSE, 
        s3credentials = NULL,
        native = FALSE)
	    
h5dump (file,
        recursive = TRUE,
        load = TRUE,
        all = FALSE,
        index_type = h5default("H5_INDEX"),
        order = h5default("H5_ITER"), 
        s3 = FALSE, 
        s3credentials = NULL,
        ..., 
        native = FALSE)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{file}{The filename (character) of the file in which the dataset will be located. For advanced programmers it is possible to provide an object of class \code{\link{H5IdComponent}} representing a H5 location identifier (file or group). See \code{\link{H5Fcreate}}, \code{\link{H5Fopen}}, \code{\link{H5Gcreate}}, \code{\link{H5Gopen}} to create an object of this kind.}
  \item{recursive}{If TRUE, the content of the whole group hierarchy is listed. If FALSE, Only the content of the main group is shown. If a positive integer is provided this indicates the maximum level of the hierarchy that is shown.}
  \item{all}{If TRUE, a longer list of information on each entry is provided.}
  \item{datasetinfo}{If FALSE, datatype and dimensionality information is not provided. This can speed up the content listing for large files.}
  \item{index_type}{See \code{h5const("H5_INDEX")} for possible arguments.}
  \item{order}{See \code{h5const("H5_ITER")} for possible arguments.}
  \item{load}{If TRUE the datasets are read in, not only the header information. Note, that this can cause memory problems for very large files. In this case choose \code{load=FALSE} and load the datasets successively.}
  \item{s3}{Logical value indicating whether the file argument should be 
  treated as a URL to an Amazon S3 bucket, rather than a local file path.}
  \item{s3credentials}{A list of length three, providing the credentials for accessing files in a private Amazon S3 bucket.}
  \item{native}{An object of class \code{logical}. If TRUE, array-like objects are treated as stored in HDF5 row-major rather than R column-major orientation. Using \code{native = TRUE} increases HDF5 file portability between programming languages. A file written with \code{native = TRUE} should also be read with \code{native = TRUE}}.
  \item{\dots}{Arguments passed to \code{\link{h5read}}}
}
\details{
\code{h5ls} lists the content of an HDF5 file including group structure and datasets. It returns the content as a data.frame. You can use \code{h5dump(file="myfile.h5", load=FALSE)} to obtain the dataset information in a hierarchical list structure. Usually the datasets are loaded individually with \code{\link{h5read}}, but you have the possibility to load the complete content of an HDF5 file with \code{h5dump}
}
\value{
\code{h5ls} returns a data.frame with the file content.

\code{h5dump} returns a hierarchical list structure representing the HDF5 group hierarchy. It either returns the datasets within the list structure (\code{load=TRUE}) or it returns a data.frame for each datset with the dataset header information \code{load=FALSE}.
}
\references{\url{https://portal.hdfgroup.org/display/HDF5}}
\author{Bernd Fischer, Mike L. Smith}
\seealso{
\code{\link{h5read}}, \code{\link{h5write}}, \link{rhdf5}
}
\examples{
h5createFile("ex_ls_dump.h5")

# create groups
h5createGroup("ex_ls_dump.h5","foo")
h5createGroup("ex_ls_dump.h5","foo/foobaa")

# write a matrix
B = array(seq(0.1,2.0,by=0.1),dim=c(5,2,2))
attr(B, "scale") <- "liter"
h5write(B, "ex_ls_dump.h5","foo/B")

# list content of hdf5 file
h5ls("ex_ls_dump.h5",all=TRUE)
h5dump("ex_ls_dump.h5")

# list content of an hdf5 file in a public S3 bucket
\donttest{
h5ls(file = "https://rhdf5-public.s3.eu-central-1.amazonaws.com/h5ex_t_array.h5", s3 = TRUE)
h5dump(file = "https://rhdf5-public.s3.eu-central-1.amazonaws.com/h5ex_t_array.h5", s3 = TRUE)
}

}
\keyword{ programming }
\keyword{ interface }
\keyword{ IO }
\keyword{ file }

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/H5P.R
\name{H5Pcopy}
\alias{H5Pcopy}
\title{Copy an existing property list to create a new property list}
\usage{
H5Pcopy(h5plist)
}
\arguments{
\item{h5plist}{\linkS4class{H5IdComponent} object representing the property list
to be copied.}
}
\description{
Copy an existing property list to create a new property list
}

\name{HDF5 Property List Interface}
\alias{H5P}
\alias{H5Pcreate}
\alias{H5Pcopy}
\alias{H5Pget_class}
\alias{H5Pclose}
\alias{H5Pclose_class}
\alias{H5Pequal}
\alias{H5Pset_libver_bounds}
\alias{H5Pget_libver_bounds}
\alias{H5Pset_obj_track_times}
\alias{H5Pget_obj_track_times}
\title{HDF5 Property List Interface}
\description{The functions, macros, and subroutines listed here are used to manipulate property list objects in various ways, including to reset property values. With the use of property lists, HDF5 functions have been implemented and can be used in applications with many fewer parameters than would be required without property lists.}
\usage{
H5Pcreate             (type = h5default("H5P"), native = FALSE)
H5Pcopy               (h5plist)
H5Pget_class          (h5plist)
H5Pclose              (h5plist)
H5Pclose_class        (h5plistclass)
H5Pequal              (h5plistclass1, h5plistclass2)
H5Pset_libver_bounds  (h5plist, 
                       libver_low = "H5F_LIBVER_EARLIEST", 
                       libver_high = "H5F_LIBVER_LATEST")
H5Pget_libver_bounds  (h5plist)
H5Pset_obj_track_times(h5plist, track_times = TRUE)
H5Pget_obj_track_times(h5plist)
}
\arguments{
  \item{type}{A character name of a property list type. See \code{h5const("H5P")} for possible property list types. Can also be an integer representing an HDF5 property list type.}
  \item{native}{An object of class \code{logical}. If TRUE, array-like objects are treated as stored in HDF5 row-major rather than R column-major orientation. Using \code{native = TRUE} increases HDF5 file portability between programming languages. A file written with \code{native = TRUE} should also be read with \code{native = TRUE}}.
  \item{h5plist}{An object of class \code{\link{H5IdComponent}} representing a H5 property list identifier. See \code{\link{H5Pcreate}} or \code{\link{H5Pcopy}} to create an object of this kind.}
  \item{h5plistclass, h5plistclass1, h5plistclass2}{An object of class \code{\link{H5IdComponent}} representing a H5 property list class identifier. See \code{\link{H5Pget_class}} to create an object of this kind.}
  \item{libver_low}{A character value representing the lower bound on the library version for reading or writing the HDF5 file. See \code{h5const("H5F_LIBVER")} for possible arguments. Default is "H5F_LIBVER_EARLIEST"}
  \item{libver_high}{A character value representing the higher bound on the library version for reading or writing the HDF5 file. See \code{h5const("H5F_LIBVER")} for possible arguments. Default is "H5F_LIBVER_LATEST"}
  \item{track_times}{\code{logical} specifying whether times associated with an object are being recorded.}
}
\details{
Interface to the HDF5 C-library libhdf5. See \url{https://portal.hdfgroup.org/display/HDF5/Property+Lists} for further details.
}
\value{
\code{H5Pcreate} and \code{H5Pcopy} return an object of class \code{\link{H5IdComponent}} representing a H5 property list identifier.

\code{H5Pget_class} returns an object of class \code{\link{H5IdComponent}} representing a H5 property list class identifier.

The other functions return the standard return value from their respective C-functions.
}
\references{\url{https://portal.hdfgroup.org/display/HDF5}}
\author{Bernd Fischer, Mike L. Smith}
\seealso{
\link{rhdf5}, \link{H5P_DATASET_CREATE}
}
\examples{
pid <- H5Pcreate()
pid2 <- H5Pcopy(pid)
pclid <- H5Pget_class(pid)
H5Pclose_class(pclid)
H5Pclose(pid)
H5Pclose(pid2)
}
\keyword{ programming }
\keyword{ interface }
\keyword{ IO }
\keyword{ file }

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/H5P.R
\name{H5Pset_shared_mesg_index}
\alias{H5Pset_shared_mesg_index}
\alias{H5Pget_shared_mesg_index}
\title{Get and set shared object header message index properties}
\usage{
H5Pset_shared_mesg_index(
  h5plist,
  index_num,
  mesg_type_flags = h5default(type = "H5O_SHMESG_FLAG"),
  min_mesg_size
)

H5Pget_shared_mesg_index(h5plist, index_num)
}
\arguments{
\item{h5plist}{\linkS4class{H5IdComponent} object representing the file creation
property list}

\item{index_num}{Index being configured.  Indices use C-style 0-based counting, so the first index will be numbered 0.}

\item{mesg_type_flags}{Character specifying the types of messages that may be stored in this index.
Valid values can be found with \code{h5const(type = "H5O_SHMESG_FLAG")}}

\item{min_mesg_size}{Minimum message size}
}
\value{
\code{H5Pget_shared_mesg_index()} returns a list of length 2. The first element is the types of messages
that may be stored in the index, the second element is the minimum message size.
}
\description{
Get and set shared object header message index properties
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/H5S.R
\name{H5Sset_extent_simple}
\alias{H5Sset_extent_simple}
\title{Set the size of a dataspace}
\usage{
H5Sset_extent_simple(h5space, dims, maxdims)
}
\arguments{
\item{h5space}{\linkS4class{H5IdComponent} object representing a dataspace.}

\item{dims}{Dimension of the dataspace. This argument is similar to the dim
attribute of an array. When viewing the HDF5 dataset with an C-program
(e.g. HDFView), the dimensions appear in inverted order, because the
fastest changing dimension in R is the first one, and in C its the last
one.}

\item{maxdims}{Maximum extension of the dimension of the dataset in the
file. If not provided, it is set to \code{dims}.}
}
\description{
Set the size of a dataspace
}

\name{HDF5 File Interface}
\alias{H5F}
\alias{H5Fcreate}
\alias{H5Fopen}
\alias{H5Fclose}
\alias{H5Fflush}
\alias{H5Fis_hdf5}
\alias{H5Fget_filesize}
\alias{H5Fget_name}
\alias{H5Fget_create_plist}
\alias{H5Fget_access_plist}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{HDF5 File Interface}
\description{
These functions are designed to provide file-level access to HDF5 files. 
}
\usage{
H5Fcreate           (name, flags = h5default("H5F_ACC"), fcpl = NULL,
                     fapl = NULL, native = FALSE)
H5Fopen             (name, flags = h5default("H5F_ACC_RD"), fapl = NULL, 
                     native = FALSE)
H5Fclose            (h5file)
H5Fflush            (h5file, scope = h5default("H5F_SCOPE"))
H5Fis_hdf5          (name, showWarnings = TRUE)
H5Fget_filesize     (h5file)
H5Fget_name         (h5obj)
H5Fget_create_plist (h5file)
H5Fget_access_plist (h5file)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{name}{The filename of the HDF5 file.}
  \item{flags}{See \code{h5const("H5F_ACC")} for possible arguments.}
  \item{fcpl}{An object of class \code{\link{H5IdComponent}} representing a H5 file creation property list. See \code{\link{H5Pcreate}}, \code{\link{H5Pcopy}} to create an object of this kind.}
  \item{fapl}{An object of class \code{\link{H5IdComponent}} representing a H5 file access property list. See \code{\link{H5Pcreate}}, \code{\link{H5Pcopy}} to create an object of this kind.}
  \item{native}{An object of class \code{logical}. If TRUE, array-like objects are treated as stored in HDF5 row-major rather than R column-major orientation. Using \code{native = TRUE} increases HDF5 file portability between programming languages. A file written with \code{native = TRUE} should also be read with \code{native = TRUE}}.
  \item{h5file}{An object of class \code{\link{H5IdComponent}} representing a H5 file identifier as created by \code{H5Fcreate} or \code{H5Fopen}.}
  \item{scope}{See \code{h5const("H5F_ACC_RD")} for possible arguments.}
  \item{showWarnings}{If TRUE (default), a warning is given if an open HDF5 handle exists for this file.}
  \item{h5obj}{An object of class \code{\link{H5IdComponent}} representing a H5 object identifier (file, group, or dataset). See \code{\link{H5Fcreate}}, \code{\link{H5Fopen}}, \code{\link{H5Gcreate}}, \code{\link{H5Gopen}}, \code{\link{H5Dcreate}}, or \code{\link{H5Dopen}} to create an object of this kind.}
}
\details{
Interface to the HDF5 C-library libhdf5. See \url{https://portal.hdfgroup.org/display/HDF5/Files} for further details.
}
\value{
\code{H5Fcreate} and \code{H5Fopen} return an object of class \code{\link{H5IdComponent}} representing a H5 file identifier.

\code{H5Fis_hdf5} returns TRUE, if the file is an HDF5 file, or FALSE otherwise. In the case the file doesn't exist, NA is returned.

The other functions return the standard return value from their respective C-functions.
}
\references{\url{https://portal.hdfgroup.org/display/HDF5}}
\author{Bernd Fischer}
\seealso{
\link{rhdf5}
}
\examples{
fid <- H5Fcreate("ex_H5F.h5")
fid
H5Fclose(fid)
fid2 <- H5Fopen("ex_H5F.h5")
fid2
H5Fclose(fid2)
}
\keyword{ programming }
\keyword{ interface }
\keyword{ IO }
\keyword{ file }

\name{HDF5 File Access Property List Interface}
\alias{H5P_FILE_ACCESS}
\alias{H5Pset_fapl_ros3}
\title{HDF5 File Access Property List Interface}
\description{The functions, macros, and subroutines listed here are used to 
    manipulate file access property lists (\code{fapl}) objects in various 
    ways.}
\usage{
H5Pset_fapl_ros3  ( h5plist, s3credentials = NULL)
}
\arguments{
  \item{h5plist}{An object of class \code{\link{H5IdComponent}} representing a H5 property list identifier of class H5P_FILE_ACCESS. See \code{\link{H5Pcreate}} or \code{\link{H5Pcopy}} to create an object of this kind.}
  \item{s3credentials}{Either \code{NULL} or a list of length 3 specifying the AWS access credentials (see details).}
}
\details{
To access files in a private Amazon S3 bucket you will need to provide three 
additional details: The AWS region where the files are hosted, your AWS access 
key ID, and your AWS secret access key.  More information on how to obtain AWS
access keys can be found at \url{https://docs.aws.amazon.com/general/latest/gr/aws-sec-cred-types.html#access-keys-and-secret-access-keys}.
These are provided as a list to the \code{s3credentials} argument.  If you 
are accessing public data this argument should be \code{NULL}.

See \url{https://portal.hdfgroup.org/display/HDF5/File+Access+Properties} for 
further details. See \link{H5P} for documentation of more functions to 
manupulate property lists of other property list classes. 
}

\value{
The functions return the standard return value from their respective C-functions.
}

\references{\url{https://portal.hdfgroup.org/display/HDF5}}
\author{Mike L. Smith}
\seealso{
    \link{H5P}
}
\examples{

## creating a fapl for accessing a public S3 bucket
\donttest{
pid <- H5Pcreate("H5P_FILE_ACCESS")
H5Pset_fapl_ros3( pid )
H5Pclose(pid)
}

## creating a fapl for accessing a private S3 bucket
## and provding required S3 credentials list

## these are example credentials and will not provide access
s3_cred <- list(
    aws_region = "eu-central-1",
    access_key_id = "AKIAIOSFODNN7EXAMPLE",
    secret_access_key = "wJalrXUtnFEMI/K7MDENG/bPxRfiCYEXAMPLEKEY"
)

\donttest{
pid <- H5Pcreate("H5P_FILE_ACCESS")
H5Pset_fapl_ros3( pid, s3credentials = s3_cred )
H5Pclose(pid)
}

}
\keyword{ interface }
\keyword{ IO }
\keyword{ file }

\name{HDF5 Link Interface}
\alias{H5L}
\alias{H5Lexists}
\alias{H5Lget_info}
\alias{H5Lcreate_external}
\alias{H5Ldelete}
\alias{H5Lcopy}
\alias{H5Lmove}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{HDF5 Link Interface}
\description{
The Link interface, H5L, functions create and manipulate links in an HDF5 group. This interface includes functions that enable the creation and use of user-defined link classes.
}
\usage{
H5Lcreate_external (target_file_name, target_obj_name, link_loc, link_name)
H5Lexists          (h5loc, name)
H5Lget_info        (h5loc, name)
H5Ldelete          (h5loc, name)
H5Lcopy            (h5loc, name, h5loc_dest, name_dest, lcpl = NULL, lapl = NULL )
H5Lmove            (h5loc, name, h5loc_dest, name_dest, lcpl = NULL, lapl = NULL )
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{target_file_name}{the relative or absoulte target file name containing the target object.}
  \item{target_obj_name}{the absolute path and name of the target object within the target file.}
  \item{link_loc}{An object of class \code{\link{H5IdComponent}} representing a H5 location identifier (file or group) where the new link is placed.}
  \item{link_name}{The name of the new link.}
  \item{h5loc}{An object of class \code{\link{H5IdComponent}} representing a H5 location identifier (file or group). See \code{\link{H5Fcreate}}, \code{\link{H5Fopen}}, \code{\link{H5Gcreate}}, \code{\link{H5Gopen}} to create an object of this kind.}
  \item{h5loc_dest}{An object of class \code{\link{H5IdComponent}} representing
  the destination file or group where a copied or moved link should be created.}
  \item{name}{The name of the link to be checked, copied or moved.}
  \item{name_dest}{The name of the link to be created when copying or moving.}
  \item{lcpl}{Link creation property list.}
  \item{lapl}{Link access property list.}
}
\details{
Interface to the HDF5 C-library libhdf5. See \url{https://portal.hdfgroup.org/display/HDF5/Links} for further details.

If \code{name} consists of a relative path containing group names, the function \code{H5Lexists} checks recursively if the links exists which is a different behaviour to the C-function.
}
\value{
\code{H5Lexists} returns boolean TRUE if the link exists and FALSE otherwise.

\code{H5Lget_info} returns a list with the entries of the C-structure \code{H5L_info_t}.
}
\references{\url{https://portal.hdfgroup.org/display/HDF5}}
\author{Bernd Fischer, Mike Smith}
\seealso{
\link{rhdf5}
}
\examples{
# create an hdf5 file and a group
h5createFile("ex_H5L.h5")
h5createGroup("ex_H5L.h5","foo")

# reopen file and get link info
fid <- H5Fopen("ex_H5L.h5")
H5Lexists(fid, "foo")
H5Lexists(fid, "baa")
H5Lget_info(fid, "foo")

H5Ldelete(fid, "foo")
H5Lexists(fid, "foo")

H5Fclose(fid)
}
\keyword{ programming }
\keyword{ interface }
\keyword{ IO }
\keyword{ file }

\name{HDF5 Dataspace Interface}
\alias{H5S}
\alias{H5Screate}
\alias{H5Screate_simple}
\alias{H5Scopy}
\alias{H5Sclose}
\alias{H5Sis_simple}
\alias{H5Sget_simple_extent_dims}
\alias{H5Sselect_hyperslab}
\alias{H5Sselect_index}
\alias{H5Sset_extent_simple}
\alias{H5Sunlimited}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{HDF5 Dataspace Interface}
\description{
These functions create and manipulate the dataspace in which to store the elements of a dataset.
}
\usage{
H5Screate                 (type = h5default("H5S"), native = FALSE)
H5Screate_simple          (dims, maxdims, native = FALSE)
H5Scopy                   (h5space)
H5Sclose                  (h5space)
H5Sis_simple              (h5space)
H5Sget_simple_extent_dims (h5space)
H5Sset_extent_simple      (h5space, dims, maxdims)
H5Sselect_hyperslab       (h5space, op = h5default("H5S_SELECT"), 
                           start = NULL, stride = NULL, count = NULL,
                           block = NULL)
H5Sselect_index           (h5space, index)
H5Sunlimited              ()
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{type}{See \code{h5const("H5S")} for possible types.}
  \item{dims}{Dimension of the dataspace. This argument is similar to the dim attribute of an array. When viewing the HDF5 dataset with an C-program (e.g. HDFView), the dimensions appear in inverted order, because the fastest changing dimension in R is the first one, and in C its the last one.}
  \item{maxdims}{Maximum extension of the dimension of the dataset in the file. If not provided, it is set to dims.}
  \item{native}{An object of class \code{logical}. If TRUE, array-like objects are treated as stored in HDF5 row-major rather than R column-major orientation. Using \code{native = TRUE} increases HDF5 file portability between programming languages. A file written with \code{native = TRUE} should also be read with \code{native = TRUE}}.
  \item{h5space}{An object of class \code{\link{H5IdComponent}} representing a H5 dataspace identifier. See \code{\link{H5Dget_space}}, \code{\link{H5Screate_simple}}, \code{\link{H5Screate}} to create an object of this kind.}
  \item{index}{A list of integer indices. The length of the list corresponds to the number of dimensions of the HDF5 array.}
  \item{op}{See h5const("H5S_SELECT") for possible arguments.}
  \item{start}{The start coordinate of a hyperslab (similar to subsetting in R). Counting is R-style 1-based.}
  \item{stride}{The stride of the hypercube. Read the introduction \url{http://ftp.hdfgroup.org/HDF5/Tutor/phypecont.html} before using this argument. R behaves like Fortran in this example.}
  \item{count}{The number of blocks to be written.}
  \item{block}{The block size of the hyperslab. Read the introduction \url{http://ftp.hdfgroup.org/HDF5/Tutor/phypecont.html} before using this argument. R behaves like Fortran in this example.}
}
\details{
Interface to the HDF5 C-library libhdf5. See \url{https://portal.hdfgroup.org/display/HDF5/Dataspaces} for further details.

As an introduction to use hyperslabs see these tutorials: See these introductions to hyperslabs: \url{https://support.hdfgroup.org/HDF5/Tutor/selectsimple.html}, \url{https://support.hdfgroup.org/HDF5/Tutor/select.html} and \url{http://ftp.hdfgroup.org/HDF5/Tutor/phypecont.html}. Please note that in R the first dimension is the fastest changing dimension. When viewing the HDF5 datasets with any C-program (e.g. HDFView), the order of dimensions is inverted. In the R interface counting starts with 1, whereas in the C-programs (e.g. HDFView) counting starts with 0.

\code{H5Sselect_index}  is not part of the standard HDF5 C interface. It performes an iterative call to H5select_points by iterating through the given index positions. This function avoids a for loop in R. If a list element is NULL, all elements of the respective dimension are considered.
}
\value{
\code{H5Screate}, \code{H5Screate_simple}, and \code{H5Scopy} return an object of class \code{\link{H5IdComponent}} representing a dataspace.

\code{H5Sis_simple} returns a boolean.

\code{H5Sget_simple_extent_dims} returns an integer vector.

\code{H5Sunlimited} is a simple macro to return the constant \code{H5S_UNLIMITED} that can be provided to the \code{maxdims} arguments of \code{H5Screate_simple} to create and extensible dataspace.

The other functions return the standard return value from their respective C-functions.
}
\references{\url{https://portal.hdfgroup.org/display/HDF5}}
\author{Bernd Fischer}
\seealso{
\link{rhdf5}
}
\examples{
sid <- H5Screate_simple(c(10,5,3))
sid
H5Sis_simple(sid)
H5Sget_simple_extent_dims(sid)

# select a subarray (called hyperslab in the hdf5 community).
# The next h5write can use this to write a subarray
H5Sselect_index(sid, list(1:3,2:4,2))

# always close dataspaces after usage to free recources
H5Sclose(sid)
sid
}
\keyword{ programming }
\keyword{ interface }
\keyword{ IO }
\keyword{ file }

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/H5A.R
\name{H5Aread}
\alias{H5Aread}
\title{Read data from an HDF5 attribute}
\usage{
H5Aread(h5attribute, buf = NULL, bit64conversion)
}
\arguments{
\item{h5attribute}{An object of class \linkS4class{H5IdComponent} representing an
attribute.  Normally created by \code{\link[=H5Aopen]{H5Aopen()}} or similar.}

\item{buf}{Optional buffer to store retrieved values. The buffer size has to
fit the size of the memory space \code{h5spaceMem}. No extra memory will be
allocated for the data. Default is \code{NULL} which means the function will
return the attribute data.}

\item{bit64conversion}{Defines how 64-bit integers are converted. (See
the details section for more information on these options.)}
}
\value{
If \code{buf=NULL} returns the contents of the attribute.  Otherwise
return 0 if attribute is read successfully.
}
\description{
Read data from an HDF5 attribute
}
\details{
Internally, R does not support 64-bit integers. All integers in R are 32-bit
integers. By setting bit64conversion='int', a coercing to 32-bit integers is
enforced, with the risk of data loss, but with the insurance that numbers
are represented as integers. bit64conversion='double' coerces the 64-bit
integers to floating point numbers. doubles can represent integers with up
to 54-bits, but they are not represented as integer values anymore. For
larger numbers there is again a data loss. bit64conversion='bit64' is
recommended way of coercing. It represents the 64-bit integers as objects
of class 'integer64' as defined in the package 'bit64'. Make sure that you
have installed 'bit64'. The datatype 'integer64' is not part of base R, but
defined in an external package. This can produce unexpected behaviour when
working with the data.
}

\name{HDF5 General Library Functions}
\alias{H5}
\alias{H5open}
\alias{H5close}
\alias{H5garbage_collect}
\alias{H5get_libversion}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{HDF5 General Library Functions}
\description{
These low level functions provide general general libary functions for HDF5.
}
\usage{
H5open             ()
H5close            ()
H5garbage_collect  ()
H5get_libversion   ()
}
\details{
These low level functions provide general general libary functions for HDF5 C-library libhdf5. See \url{https://portal.hdfgroup.org/display/HDF5/Library} for further details.
}
\value{
\code{H5open} initializes the HDF5 library. \code{H5close} flushes all data to disk, closes all open identifiers, and cleans up memory. \code{H5garbage_collect} cleans up memory. \code{H5get_libversion} returns the version number of the HDF5 C-library.
}
\references{\url{https://portal.hdfgroup.org/display/HDF5}}
\author{Bernd Fischer}
\seealso{
\code{\link{h5version}}, \link{rhdf5}
}
\examples{

# test for file locking
if( !h5testFileLocking( tempdir() ) ) {
      h5disableFileLocking()
}

H5open()
H5close()
H5garbage_collect()
H5get_libversion()
}
\keyword{ programming }
\keyword{ interface }
\keyword{ IO }
\keyword{ file }

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/H5A.R
\name{H5Acreate}
\alias{H5Acreate}
\title{Create an attribute for an HDF5 object}
\usage{
H5Acreate(h5obj, name, dtype_id, h5space)
}
\arguments{
\item{h5obj}{An object of class \linkS4class{H5IdComponent} representing a H5 object
identifier (file, group, or dataset). See \code{\link[=H5Fcreate]{H5Fcreate()}}, \code{\link[=H5Fopen]{H5Fopen()}},
\code{\link[=H5Gcreate]{H5Gcreate()}}, \code{\link[=H5Gopen]{H5Gopen()}}, \code{\link[=H5Dcreate]{H5Dcreate()}}, or \code{\link[=H5Dopen]{H5Dopen()}} to create an object of this kind.}

\item{name}{The name of the attribute (character).}

\item{dtype_id}{A character name of a datatype. See \code{h5const("H5T")} for
possible datatypes. Can also be an integer representing an HDF5 datatype.
Only simple datatypes are allowed for atttributes.}

\item{h5space}{An object of class \linkS4class{H5IdComponent} representing a H5
dataspace. See \code{\link[=H5Dget_space]{H5Dget_space()}}, \code{\link[=H5Screate_simple]{H5Screate_simple()}}, \code{\link[=H5Screate]{H5Screate()}} to create an object
of this kind.}
}
\value{
An object of class \linkS4class{H5IdComponent} representing a H5 attribute identifier.
}
\description{
Creates an attribute, \code{name}, which is attached to the object specified
by the identifier \code{h5obj}. The attribute name must be unique for the object.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/H5O_extras.R
\name{H5Oget_num_attrs}
\alias{H5Oget_num_attrs}
\alias{H5Oget_num_attrs_by_name}
\title{Find the number of attributes associated with an HDF5 object}
\usage{
H5Oget_num_attrs(h5obj)

H5Oget_num_attrs_by_name(h5loc, name)
}
\arguments{
\item{h5obj}{An object of class \linkS4class{H5IdComponent} representing a H5 object identifier (file, group, or dataset).}

\item{h5loc}{An object of class \linkS4class{H5IdComponent} representing a H5 location identifier (file or group).}

\item{name}{The name of the object to be checked.}
}
\value{
Returns a vector of length 1 containing the number of attributes
the specified object has.
}
\description{
Find the number of attributes associated with an HDF5 object
}
\details{
These functions are not part of the standard HDF5 C API.
}

\name{[-methods}
\docType{methods}
\alias{[,H5IdComponent-method}
\title{Methods for Function \code{[} in Package \pkg{rhdf5}}
\description{
Methods for function \code{[} in package \pkg{rhdf5}.
}
\section{Methods}{
\describe{

\item{\code{signature(x = "H5IdComponent")}}{
 Subsetting of an HDF5 dataset. The function reads a subset of an HDF5 dataset. The given dimensions have to fit the dimensions of the HDF5 dataset.
}
}}
\keyword{methods}
\keyword{ programming }
\keyword{ interface }
\keyword{ IO }
\keyword{ file }

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/H5S.R
\name{H5Sunlimited}
\alias{H5Sunlimited}
\title{Retrieve value for \code{H5S_UNLIMITED} constant}
\usage{
H5Sunlimited()
}
\description{
The value for \code{H5S_UNLIMITED} can be provided to the \code{maxdims} argument of \link{H5Screate_simple}
to indicate that the maximum size of the corresponding dimension is unlimited.
}
\seealso{
\link{H5Screate_simple}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/H5P_extras.R
\name{H5Pset_lzf}
\alias{H5Pset_lzf}
\title{Add the LZF filter to the chunk processing pipeline.}
\usage{
H5Pset_lzf(h5plist, h5tid)
}
\arguments{
\item{h5plist}{Object of class \linkS4class{H5IdComponent} representing a dataset
creation property list.}

\item{h5tid}{HDF5 data type id}
}
\description{
Add the LZF filter to the chunk processing pipeline.
}

\name{h5createFile}
\alias{h5createFile}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{Create HDF5 file}
\description{R function to create an empty HDF5 file.}
\usage{
h5createFile (file)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{file}{The filename of the HDF5 file.}
}
\details{
Creates an empty HDF5 file.
}
\value{Returns TRUE is file was created successfully and FALSE otherwise.}
\references{\url{https://portal.hdfgroup.org/display/HDF5}}
\author{Bernd Fischer}
\seealso{
\code{\link{h5createGroup}}, \code{\link{h5createDataset}}, \code{\link{h5read}}, \code{\link{h5write}}, \link{rhdf5}
}
\examples{
h5createFile("ex_createFile.h5")

# create groups
h5createGroup("ex_createFile.h5","foo")
h5createGroup("ex_createFile.h5","foo/foobaa")

h5ls("ex_createFile.h5")
}
\keyword{ programming }
\keyword{ interface }
\keyword{ IO }
\keyword{ file }

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/H5D.R
\name{H5Dread}
\alias{H5Dread}
\title{Read from an HDF5 dataset}
\usage{
H5Dread(
  h5dataset,
  h5spaceFile = NULL,
  h5spaceMem = NULL,
  buf = NULL,
  compoundAsDataFrame = TRUE,
  bit64conversion,
  drop = FALSE
)
}
\arguments{
\item{h5dataset}{Object of class \linkS4class{H5IdComponent} representing an open HDF5
dataset.}

\item{h5spaceFile}{An object of class \code{H5IdComponent} representing a HDF5
dataspace. See \code{\link[=H5Dget_space]{H5Dget_space()}}, \code{\link[=H5Screate_simple]{H5Screate_simple()}}, \code{\link[=H5Screate]{H5Screate()}} to
create an object of this kind.}

\item{h5spaceMem}{An object of class \code{H5IdComponent} representing a HDF5
dataspace. See \code{\link[=H5Dget_space]{H5Dget_space()}}, \code{\link[=H5Screate_simple]{H5Screate_simple()}}, \code{\link[=H5Screate]{H5Screate()}} to
create an object of this kind. The dimensions of the dataset in the file and
in memory. The dimensions in file and in memory are interpreted in an R-like
manner. The first dimension is the fastest changing dimension. When reading
the file with a C-program (e.g. HDFView) the order of dimensions will invert,
because in C the fastest changing dimension is the last one.}

\item{buf}{Buffer to hold the read data.  The buffer size has to fit the
size of the memory space \code{h5spaceMem}. No extra memory will be allocated for
the data. A pointer to the same data is returned.}

\item{compoundAsDataFrame}{Logical vector of length 1. If \code{TRUE}, a compound
datatype will be coerced to a \code{data.frame}. This is not possible, if the
dataset is multi-dimensional. Otherwise the compound datatype will be
returned as a \code{list}. Nested compound data types will be returned as a
nested \code{list}.}

\item{bit64conversion}{Defines how 64-bit integers are converted. (See
the details section for more information on these options.)}

\item{drop}{Logical vector of length 1.  If \code{TRUE}, the HDF5 object is read
as a vector with NULL dim attributes. Default is \code{FALSE}.}
}
\description{
\code{H5Dread()} reads a (partial) dataset from an HDF5 file into the R session.
}
\details{
Internally, R does not support 64-bit integers. All integers in R are 32-bit
integers. By setting bit64conversion='int', a coercing to 32-bit integers is
enforced, with the risk of data loss, but with the insurance that numbers
are represented as integers. bit64conversion='double' coerces the 64-bit
integers to floating point numbers. doubles can represent integers with up
to 54-bits, but they are not represented as integer values anymore. For
larger numbers there is again a data loss. bit64conversion='bit64' is
recommended way of coercing. It represents the 64-bit integers as objects
of class 'integer64' as defined in the package 'bit64'. Make sure that you
have installed 'bit64'. The datatype 'integer64' is not part of base R, but
defined in an external package. This can produce unexpected behaviour when
working with the data.
}

\name{HDF5 Group Interface}
\alias{H5G}
\alias{H5Gcreate}
\alias{H5Gcreate_anon}
\alias{H5Gopen}
\alias{H5Gclose}
\alias{H5Gget_info}
\alias{H5Gget_info_by_idx}
\alias{H5Gget_info_by_name}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{HDF5 Group Interface}
\description{
The Group interface functions create and manipulate groups of objects in an HDF5 file. 
}
\usage{
H5Gcreate      (h5loc, name)
H5Gcreate_anon (h5loc)
H5Gopen        (h5loc, name)
H5Gclose       (h5group)
H5Gget_info    (h5loc)
H5Gget_info_by_idx  (h5loc, n, group_name = ".", 
                       index_type = h5default("H5_INDEX"), 
		       order = h5default("H5_ITER"))
H5Gget_info_by_name (h5loc, group_name)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{h5loc}{An object of class \code{\link{H5IdComponent}} representing a H5 location identifier (file or group). See \code{\link{H5Fcreate}}, \code{\link{H5Fopen}}, \code{\link{H5Gcreate}}, \code{\link{H5Gopen}} to create an object of this kind.}
  \item{name}{Name of the group.}
  \item{h5group}{An object of class \code{\link{H5IdComponent}} representing a H5 group identifier. See \code{\link{H5Gcreate}}, \code{\link{H5Gopen}} to create an object of this kind.}
  \item{n}{Position in the index of the group for which information is retrieved (Counting is 1-based).}
  \item{group_name}{An additional group name specifying the group for which information is sought. It is interpreted relative to \code{h5loc}.}
  \item{index_type}{See \code{h5const("H5_INDEX")} for possible arguments.}
  \item{order}{See \code{h5const("H5_ITER")} for possible arguments.}
}
\details{
Interface to the HDF5 C-library libhdf5. See \url{https://portal.hdfgroup.org/display/HDF5/Groups} for further details.
}
\value{
\code{H5Gcreate}, \code{H5Gcreate_anon}, and \code{H5Gopen} return an object of class \code{\link{H5IdComponent}} representing a H5 group identifier.

\code{H5Gget_info}, \code{H5Gget_info_by_idx}, and \code{H5Gget_info_by_name} return a list with the group information.

The other functions return the standard return value from their respective C-functions.
}
\references{\url{https://portal.hdfgroup.org/display/HDF5}}
\author{Bernd Fischer}
\seealso{
\link{rhdf5}
}
\examples{
fid <- H5Fcreate("ex_H5G.h5")
gid <- H5Gcreate(fid, "foo")
gid
H5Gget_info(gid)
H5Gclose(gid)

H5Gget_info_by_idx(fid,1)
H5Gget_info_by_name(fid,"foo")

H5Fclose(fid)
}
\keyword{ programming }
\keyword{ interface }
\keyword{ IO }
\keyword{ file }

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/H5S.R
\name{H5Sselect_valid}
\alias{H5Sselect_valid}
\title{Check that a selection is valid}
\usage{
H5Sselect_valid(h5space)
}
\arguments{
\item{h5space}{\linkS4class{H5IdComponent} object representing a dataspace.}
}
\description{
Check that a selection is valid
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/H5P.R
\name{H5Pset_sizes}
\alias{H5Pset_sizes}
\alias{H5Pget_sizes}
\title{Get and set the sizes of offsets and lengths used in an HDF5 file}
\usage{
H5Pset_sizes(h5plist, sizeof_addr, sizeof_size)

H5Pget_sizes(h5plist)
}
\arguments{
\item{h5plist}{\linkS4class{H5IdComponent} object representing the file creation property list}

\item{sizeof_addr}{Offset size in bytes}

\item{sizeof_size}{Length size in bytes}
}
\description{
Get and set the sizes of offsets and lengths used in an HDF5 file
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/H5A.R
\name{H5Aexists}
\alias{H5Aexists}
\title{Check whether an specific attribute exists for an HDF5 object}
\usage{
H5Aexists(h5obj, name)
}
\arguments{
\item{h5obj}{An object of class \linkS4class{H5IdComponent} representing a H5 object
identifier (file, group, or dataset). See \code{\link[=H5Fcreate]{H5Fcreate()}}, \code{\link[=H5Fopen]{H5Fopen()}},
\code{\link[=H5Gcreate]{H5Gcreate()}}, \code{\link[=H5Gopen]{H5Gopen()}}, \code{\link[=H5Dcreate]{H5Dcreate()}}, or \code{\link[=H5Dopen]{H5Dopen()}} to create an object of this kind.}

\item{name}{The name of the attribute (character).}
}
\description{
Check whether an specific attribute exists for an HDF5 object
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/H5P.R
\name{H5P_chunk}
\alias{H5P_chunk}
\alias{H5Pset_chunk}
\alias{H5Pget_chunk}
\title{Get and set the size of the chunks used to store a chunked layout dataset}
\usage{
H5Pset_chunk(h5plist, dim)

H5Pget_chunk(h5plist)
}
\arguments{
\item{h5plist}{An object of class \linkS4class{H5IdComponent} representing a dataset creation property list.}

\item{dim}{The chunk size used to store the dataset. This argument should be an integer vector of the same length as
the number of dimensions of the dataset the dataset creation property list will be applied to.}
}
\description{
Get and set the size of the chunks used to store a chunked layout dataset
}
\details{
Note that a necessary side effect of running this function is that the
layout of the dataset will be changes to \code{H5D_CHUNKED} if it is not already set to this.
}
\seealso{
\code{\link[=H5Pset_layout]{H5Pset_layout()}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/H5D.R
\name{H5Dget_space}
\alias{H5Dget_space}
\title{Return a copy of the HDF5 dataspace for a dataset}
\usage{
H5Dget_space(h5dataset)
}
\arguments{
\item{h5dataset}{Object of class \linkS4class{H5IdComponent} representing an open HDF5
dataset}
}
\value{
Returns an object of class \code{H5IdComponent} representing a HDF5
dataspace identifier
}
\description{
Return a copy of the HDF5 dataspace for a dataset
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/H5G.R
\name{H5Gclose}
\alias{H5Gclose}
\title{Close a specified group}
\usage{
H5Gclose(h5group)
}
\arguments{
\item{h5group}{An object of class \linkS4class{H5IdComponent} representing a H5
group.  Typically created via \code{\link[=H5Gopen]{H5Gopen()}} or \code{\link[=H5Gcreate]{H5Gcreate()}}.}
}
\description{
Close a specified group
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/H5I.R
\name{H5Iget_type}
\alias{H5Iget_type}
\title{Find the type of an object}
\usage{
H5Iget_type(h5identifier)
}
\arguments{
\item{h5identifier}{Object of class \linkS4class{H5IdComponent}.}
}
\value{
Returns a character vector of length 1 containing the HDF5 type
for the supplied identifier.
}
\description{
Possible types returned by the function are:
\itemize{
\item \code{H5I_FILE}
\item \code{H5I_GROUP}
\item \code{H5I_DATATYPE}
\item \code{H5I_DATASPACE}
\item \code{H5I_DATASET}
\item \code{H5I_ATTR}
}
}
\examples{
h5file <- system.file("testfiles", "h5ex_t_array.h5", package="rhdf5")
fid <- H5Fopen(h5file)
gid <- H5Gopen(fid, "/")

## identify the HDF5 types for these identifiers
H5Iget_type(fid)
H5Iget_type(gid)

## tidy up
H5Gclose(gid)
H5Fclose(fid)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/H5F.R
\name{H5Fclose}
\alias{H5Fclose}
\title{Close access to an HDF5 file}
\usage{
H5Fclose(h5file)
}
\arguments{
\item{h5file}{\linkS4class{H5IdComponent} representing an HDF5 file ID.  Typically
created via \code{\link[=H5Fcreate]{H5Fcreate()}} or \code{\link[=H5Fopen]{H5Fopen()}}.}
}
\description{
Close access to an HDF5 file
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/Rhdf5.R
\name{h5version}
\alias{h5version}
\title{Print the rhdf5 and libhdf5 version numbers}
\usage{
h5version()
}
\value{
A list of major, minor and release number.
}
\description{
Returns the version number of the Bioconductor package rhdf5 and the
C-library libhdf5.
}
\examples{

h5version()

}
\author{
Bernd Fischer, Mike L. Smith
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/H5F.R
\name{H5Fcreate}
\alias{H5Fcreate}
\title{Create an HDF5 file}
\usage{
H5Fcreate(
  name,
  flags = h5default("H5F_ACC"),
  fcpl = NULL,
  fapl = NULL,
  native = FALSE
)
}
\arguments{
\item{name}{The name of the HDF5 file to create.}

\item{flags}{See \code{h5const("H5F_ACC")} for possible arguments.}

\item{fcpl, fapl}{Object object of class \linkS4class{H5IdComponent}.  This should
representing a file creation property list and a file access property list
respectively. See \code{\link[=H5Pcreate]{H5Pcreate()}} or  \code{\link[=H5Pcopy]{H5Pcopy()}} to create objects of this
kind.  Leaving as \code{NULL} will use the default HDF5 settings which are often
sufficient.}

\item{native}{An object of class \code{logical}. If \code{TRUE}, array-like
objects are treated as stored in HDF5 row-major rather than R column-major
orientation. Using \code{native = TRUE} increases HDF5 file portability
between programming languages. A file written with \code{native = TRUE}
should also be read with \code{native = TRUE}.}
}
\description{
Create an HDF5 file
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/H5S.R
\name{H5Scombine_hyperslab}
\alias{H5Scombine_hyperslab}
\title{Perform operation between an existing selection and an another
hyperslab definition.}
\usage{
H5Scombine_hyperslab(
  h5space,
  op = h5default("H5S_SELECT"),
  start = NULL,
  stride = NULL,
  count = NULL,
  block = NULL
)
}
\arguments{
\item{h5space}{\linkS4class{H5IdComponent} object representing a dataspace.}

\item{op}{Character string defined the operation used to join the two
dataspaces.  See \code{h5const("H5S_SELECT")} for the list of available options.}

\item{start, stride, count, block}{Integer vectors, each with length equal
to the rank of the dataspace.  These parameters define the new hyperslab
to select.}
}
\value{
An \linkS4class{H5IdComponent} object representing a new dataspace
with the generated selection.
}
\description{
Combines a hyperslab selection specified by \code{start}, \code{stride}, \code{count} and
\code{block} arguments with the current selection for the dataspace
represented by \code{h5space}.
}
\examples{

## create a 1 dimensional dataspace
sid_1 <- H5Screate_simple(dims = 20)

## select a single block of 5 points in sid_1
## this is equivalent to [11:16] in R syntax
H5Sselect_hyperslab(sid_1, start = 11, stride = 1, 
                    block = 5, count = 1)#

## combine the existing selection with a new
## selection consisting of 2 blocks each of 1 point
## equivalent to [c(3,5)] in R syntax
sid_2 <- H5Scombine_hyperslab(sid_1, op = "H5S_SELECT_OR",
                              start = 3, stride = 2, 
                              block = 1, count = 2)

## confirm we have selected 5 in our original dataspace
## and 7 points in the newly created dataspace
H5Sget_select_npoints(sid_1)
H5Sget_select_npoints(sid_2)

## tidy up
H5Sclose(sid_1)
H5Sclose(sid_2)

}
\seealso{
\code{\link[=H5Scombine_select]{H5Scombine_select()}}, \code{\link[=H5Sselect_hyperslab]{H5Sselect_hyperslab()}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/H5T.R
\name{H5T_size}
\alias{H5T_size}
\alias{H5Tset_size}
\alias{H5Tget_size}
\title{Retrieve or set the type of padding used by string datatype}
\usage{
H5Tset_size(dtype_id = h5default(type = "H5T"), size)

H5Tget_size(dtype_id)
}
\arguments{
\item{dtype_id}{ID of HDF5 datatype to query or modify.}

\item{size}{The new datatype size in bytes.}
}
\description{
Retrieve or set the type of padding used by string datatype
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/H5G.R
\name{H5Gcreate_anon}
\alias{H5Gcreate_anon}
\title{Create a new HDF5 group without linking it into a file}
\usage{
H5Gcreate_anon(h5loc)
}
\arguments{
\item{h5loc}{An object of class \linkS4class{H5IdComponent} specifying the file in
which the new group is to be created.}
}
\value{
\code{H5Gcreate_anon} returns an object of class \linkS4class{H5IdComponent}
representing the newly created group.  However at this point is is still
anonymous, and must be linked into the file structure via \code{\link[=H5Olink]{H5Olink()}}.
If this is not done, the group will be deleted from the file when it
is closed.
}
\description{
Create a new HDF5 group without linking it into a file
}
\seealso{
\code{\link[=H5Gcreate]{H5Gcreate()}}, \code{\link[=H5Olink]{H5Olink()}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/H5L.R
\name{H5Lcopy}
\alias{H5Lcopy}
\title{Copy a link from one location to another}
\usage{
H5Lcopy(h5loc, name, h5loc_dest, name_dest, lcpl = NULL, lapl = NULL)
}
\arguments{
\item{h5loc}{An object of class \linkS4class{H5IdComponent} representing a H5
location identifier (file or group) where the new link is placed.}

\item{name}{The name of the link to be copied.}

\item{h5loc_dest}{An object of class \linkS4class{H5IdComponent} representing
the destination file or group where a copied or moved link should be created.}

\item{name_dest}{The name of the link to be created when copying or moving.}

\item{lcpl, lapl}{Link creation and link access property lists.  If left as
\code{NULL} the HDF5 defaults will be used.}
}
\description{
Copy a link from one location to another
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/H5P.R
\name{H5Pset_deflate}
\alias{H5Pset_deflate}
\title{Add the deflate compression filter to the chunk processing pipeline.}
\usage{
H5Pset_deflate(h5plist, level)
}
\arguments{
\item{h5plist}{Object of class \linkS4class{H5IdComponent} representing a dataset
creation property list.}

\item{level}{Integer giving the compression level to use.  Valid values are
from 0 to 9.}
}
\description{
Valid values for the compression level range from 0 (no compression) to 9
(best compression, slowest speed). Note that applying this function with
\code{level = 0} does not mean the filter is removed.  It is still part of the
filter pipeline, but no compression is performed.  The filter will still need
to be available on any system that reads a file created with this setting
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/H5I.R
\name{H5Iis_valid}
\alias{H5Iis_valid}
\title{Determine whether an identifier is valid}
\usage{
H5Iis_valid(h5identifier)
}
\arguments{
\item{h5identifier}{Object of class \linkS4class{H5IdComponent}.}
}
\value{
A logical of length 1.  \code{TRUE} is the identifier is valid,
\code{FALSE} if not.
}
\description{
An identifier is no longer valid after it has been closed.
}
\examples{

h5file <- system.file("testfiles", "h5ex_t_array.h5", package="rhdf5")
fid <- H5Fopen(h5file)

## test whether the identifer to the opened file is valid
H5Iis_valid(fid)

## the file ID is no longer valid after it has been closed
H5Fclose(fid)
H5Iis_valid(fid)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/H5P_extras.R
\name{H5Pset_bzip2}
\alias{H5Pset_bzip2}
\title{Add the BZIP2 filter to the chunk processing pipeline.}
\usage{
H5Pset_bzip2(h5plist, level = 2L)
}
\arguments{
\item{h5plist}{Object of class \linkS4class{H5IdComponent} representing a dataset
creation property list.}

\item{level}{Compression level to be used by the selected algorithm.}
}
\description{
Add the BZIP2 filter to the chunk processing pipeline.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/H5P.R
\name{H5Pset_szip}
\alias{H5Pset_szip}
\title{Add the SZIP compression filter to the chunk processing pipeline.}
\usage{
H5Pset_szip(h5plist, options_mask, pixels_per_block)
}
\arguments{
\item{h5plist}{Object of class \linkS4class{H5IdComponent} representing a dataset
creation property list.}

\item{options_mask, pixels_per_block}{Integer vectors of length 1, setting parameters
of the SZIP algorithm. See \url{https://portal.hdfgroup.org/display/HDF5/H5P_SET_SZIP} for more details.}
}
\description{
Add the SZIP compression filter to the chunk processing pipeline.
}
\references{
\url{https://portal.hdfgroup.org/display/HDF5/Szip+Compression+in+HDF+Products}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/H5T.R
\name{H5Tis_variable_str}
\alias{H5Tis_variable_str}
\title{Determine whether a datatype is a variable length string}
\usage{
H5Tis_variable_str(dtype_id)
}
\arguments{
\item{dtype_id}{ID of HDF5 datatype to query.}
}
\description{
Determine whether a datatype is a variable length string
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/H5P.R
\name{H5Pset_shared_mesg_nindexes}
\alias{H5Pset_shared_mesg_nindexes}
\alias{H5Pget_shared_mesg_nindexes}
\title{Get and set the number of object header message indexes}
\usage{
H5Pset_shared_mesg_nindexes(h5plist, nindexes)

H5Pget_shared_mesg_nindexes(h5plist)
}
\arguments{
\item{h5plist}{\linkS4class{H5IdComponent} object representing the file creation property list}

\item{nindexes}{Number of shared object header message indexes to be available in files}
}
\description{
Get and set the number of object header message indexes
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/H5F.R
\name{H5Fget_plist}
\alias{H5Fget_plist}
\alias{H5Fget_create_plist}
\alias{H5Fget_access_plist}
\title{Get property lists associated with an HDF5 file}
\usage{
H5Fget_create_plist(h5file)

H5Fget_access_plist(h5file)
}
\arguments{
\item{h5file}{An object of class \linkS4class{H5IdComponent} representing a H5
file identifier.  Typically produced by \code{\link[=H5Fopen]{H5Fopen()}} or \code{\link[=H5Fcreate]{H5Fcreate()}}.}
}
\description{
Get property lists associated with an HDF5 file
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/H5I.R
\name{H5Iget_name}
\alias{H5Iget_name}
\title{Retrieve the name of an object from a given identifier}
\usage{
H5Iget_name(h5obj)
}
\arguments{
\item{h5obj}{An object of class \linkS4class{H5IdComponent}.  Can represent a
file, group, dataset or attribute.}
}
\description{
Retrieve the name of an object from a given identifier
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/H5A.R
\name{H5Aget_name}
\alias{H5Aget_name}
\title{Get the name of an HDF5 attribute object}
\usage{
H5Aget_name(h5attribute)
}
\arguments{
\item{h5attribute}{An object of class \linkS4class{H5IdComponent} representing an
attribute.  Normally created by \code{\link[=H5Aopen]{H5Aopen()}} or similar.}
}
\value{
A character vector of length 1 containing the name of the attribute.
}
\description{
Retrieves the name of the attribute specified by an HDF5 attribute object.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/H5R.R
\name{H5Rget_name}
\alias{H5Rget_name}
\title{Return the name of the object that a reference points to}
\usage{
H5Rget_name(ref, h5loc)
}
\arguments{
\item{ref}{\code{H5ref} object containing the reference to be queried.}

\item{h5loc}{An \code{H5IdComponent} object representing the file containing the
referenced object.}
}
\value{
Character string of length 1 giving the name of the referenced
object.
}
\description{
Return the name of the object that a reference points to
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/H5P.R
\name{H5Pget_class}
\alias{H5Pget_class}
\title{Return the property list class identifier for a property list}
\usage{
H5Pget_class(h5plist)
}
\arguments{
\item{h5plist}{\linkS4class{H5IdComponent} object representing any type of HDF5
property list.}
}
\description{
Return the property list class identifier for a property list
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/H5P.R
\name{H5P_chunk_cache}
\alias{H5P_chunk_cache}
\alias{H5Pset_chunk_cache}
\title{Set parameters for the raw data chunk cache}
\usage{
H5Pset_chunk_cache(h5plist, rdcc_nslots, rdcc_nbytes, rdcc_w0)
}
\arguments{
\item{h5plist}{Object of class \linkS4class{H5IdComponent} representing a dataset
access property list.}

\item{rdcc_nslots}{Integer defining the number of chunk slots in the raw data
chunk cache for this dataset.}

\item{rdcc_nbytes}{Integer setting the total size of the raw data chunk cache
for this dataset in bytes. In most cases increasing this number will
improve performance, as long as you have enough free memory. The default
size is 1 MB}

\item{rdcc_w0}{Numeric value defining the chunk preemption policy.  Must be between
\code{0} and \code{1} inclusive.}
}
\description{
Set parameters for the raw data chunk cache
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/H5A.R
\name{H5Aget_space}
\alias{H5Aget_space}
\title{Get a copy of the attribute dataspace}
\usage{
H5Aget_space(h5attribute)
}
\arguments{
\item{h5attribute}{An object of class \linkS4class{H5IdComponent} representing an
attribute.  Normally created by \code{\link[=H5Aopen]{H5Aopen()}} or similar.}
}
\value{
Returns an object of class \linkS4class{H5IdComponent} representing a H5
dataspace identifier
}
\description{
Get a copy of the attribute dataspace
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/H5P.R
\name{H5Pset_sym_k}
\alias{H5Pset_sym_k}
\alias{H5Pget_sym_k}
\title{Get and set the size of the symbol table B-tree 1/2 rank and the leaf node 1/2 size}
\usage{
H5Pset_sym_k(h5plist, ik, lk)

H5Pget_sym_k(h5plist)
}
\arguments{
\item{h5plist}{\linkS4class{H5IdComponent} object representing the file creation property list}

\item{ik}{Symbol table B-tree 1/2 rank}

\item{lk}{Symbol table leaf node 1/2 size}
}
\description{
Get and set the size of the symbol table B-tree 1/2 rank and the leaf node 1/2 size
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/H5A.R
\name{H5Awrite}
\alias{H5Awrite}
\title{Write data to an HDF5 attribute}
\usage{
H5Awrite(h5attribute, buf)
}
\arguments{
\item{h5attribute}{An object of class \linkS4class{H5IdComponent} representing an
attribute.  Normally created by \code{\link[=H5Aopen]{H5Aopen()}} or similar.}

\item{buf}{The data to be written.}
}
\description{
Write data to an HDF5 attribute
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/H5P.R
\name{H5P_create_intermediate_group}
\alias{H5P_create_intermediate_group}
\alias{H5Pset_create_intermediate_group}
\alias{H5Pget_create_intermediate_group}
\title{Get and set whether to create missing intermediate groups}
\usage{
H5Pset_create_intermediate_group(h5plist, create_groups = TRUE)

H5Pget_create_intermediate_group(h5plist)
}
\arguments{
\item{h5plist}{An object of class \linkS4class{H5IdComponent} representing a link
creation property list.}

\item{create_groups}{A logical of length 1 specifying whether missing
groups should be created when a new object is created.  Default is \code{TRUE}.}
}
\description{
Get and set whether to create missing intermediate groups
}
\examples{
 
pid <- H5Pcreate("H5P_LINK_CREATE")

## by default intermediate groups are not created
H5Pget_create_intermediate_group( pid )

## Change the setting so groups will be created

H5Pget_create_intermediate_group( pid )

## tidy up
H5Pclose(pid)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/H5T.R
\name{H5T_strpad}
\alias{H5T_strpad}
\alias{H5Tset_strpad}
\alias{H5Tget_strpad}
\title{Retrieve or set the type of padding used by string datatype}
\usage{
H5Tset_strpad(dtype_id, strpad = "NULLPAD")

H5Tget_strpad(dtype_id)
}
\arguments{
\item{dtype_id}{ID of HDF5 datatype to query or modify.}

\item{strpad}{Character vector of length 1 specifying the type of padding
to use.  Valid options are \code{NULLTERM}, \code{NULLPAD} and \code{SPACEPAD}.}
}
\description{
Retrieve or set the type of padding used by string datatype
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/H5T.R
\name{H5T_cset}
\alias{H5T_cset}
\alias{H5Tset_cset}
\alias{H5Tget_cset}
\title{Retrieve or set the character set to be used in a string datatype.}
\usage{
H5Tset_cset(dtype_id, cset = "ASCII")

H5Tget_cset(dtype_id)
}
\arguments{
\item{dtype_id}{ID of HDF5 datatype to query or modify.}

\item{cset}{Encoding to use for string types. Valid options are 'ASCII' and
'UTF-8'.}
}
\description{
Retrieve or set the character set to be used in a string datatype.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/H5P.R
\name{H5Pset_userblock}
\alias{H5Pset_userblock}
\alias{H5Pget_userblock}
\title{Get and set the user block size}
\usage{
H5Pset_userblock(h5plist, size)

H5Pget_userblock(h5plist)
}
\arguments{
\item{h5plist}{\linkS4class{H5IdComponent} object representing the file creation property list}

\item{size}{of the user block in bytes}
}
\description{
Get and set the user block size
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/H5.R
\name{h5closeAll}
\alias{h5closeAll}
\title{Close open HDF5 handles}
\usage{
h5closeAll(...)
}
\arguments{
\item{...}{One or more objects of class \linkS4class{H5IdComponent} which should be
closed.  If nothing is provided to the function, all open handles will be
closed.}
}
\value{
Doesn't return anything. Called for the side-effect of closing open
HDF5 handles.
}
\description{
This functions can be used in two ways.  Firstly, it can be passed one or
more \linkS4class{H5IdComponent} objects and it'll will try to close all of them
regardless of the whether they represent a file, group, dataset etc.  This
can be easier than making multiple calls to \code{\link[=H5Fclose]{H5Fclose()}}, \code{\link[=H5Gclose]{H5Gclose()}}, etc.
}
\details{
Secondly, occasionally references to HDF5 files, groups, datasets etc can be
created and not closed correctly.  Maybe because a function stopped before
getting to the close statement, or the open handle was not assigned to an R
variable.  If no arguments are provide this function identifies all open
handles and closes them.
}
\examples{


## create an empty file and then re-open it
h5File <- tempfile(pattern = "ex_h5closeAll.h5")
h5createFile(h5File)
H5Fopen(h5File)

## list all open identifiers
h5listIdentifier()

## close all open identifiers and verify
h5closeAll()
h5listIdentifier()

}
\author{
Mike Smith
}
\keyword{IO}
\keyword{file}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/H5D.R
\name{H5Dclose}
\alias{H5Dclose}
\title{Close an open HDF5 dataset}
\usage{
H5Dclose(h5dataset)
}
\arguments{
\item{h5dataset}{Object of class \linkS4class{H5IdComponent} representing an open HDF5
dataset}
}
\description{
Close an open HDF5 dataset
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/h5save.R
\name{h5_save}
\alias{h5_save}
\alias{h5save}
\title{Saves a one or more objects to an HDF5 file.}
\usage{
h5save(..., file, name = NULL, createnewfile = TRUE, native = FALSE)
}
\arguments{
\item{\dots}{The objects to be saved.}

\item{file}{The filename (character) of the file in which the dataset will
be located. It is also possible to provide an object of
class \linkS4class{H5IdComponent} representing a H5 location identifier
(file or group). See \code{\link[=H5Fcreate]{H5Fcreate()}}, \code{\link[=H5Fopen]{H5Fopen()}},
\code{\link[=H5Gcreate]{H5Gcreate()}}, \code{\link[=H5Gopen]{H5Gopen()}} to create an object of this
kind.}

\item{name}{A character vector of names for the datasets. The length of the
name vector should match the number of objects.}

\item{createnewfile}{If \code{TRUE}, a new file will be created if necessary.}

\item{native}{An object of class \code{logical}. If TRUE, array-like objects
are treated as stored in HDF5 row-major rather than R column-major
orientation. Using \code{native = TRUE} increases HDF5 file portability
between programming languages. A file written with \code{native = TRUE}
should also be read with \code{native = TRUE}}
}
\value{
Nothing returned.
}
\description{
Saves a number of R objects to an HDF5 file.
}
\details{
The objects will be saved to the HDF5 file. If the file does not exists it
will be created. The data can be read again by either \code{\link[=h5dump]{h5dump()}}
or individually for each dataset by \code{\link[=h5read]{h5read()}}.
}
\examples{

A = 1:7;  B = 1:18; D = seq(0,1,by=0.1)
h5save(A, B, D, file="ex_save.h5")
h5dump("ex_save.h5")

}
\seealso{
\code{\link[=h5ls]{h5ls()}}, \code{\link[=h5write]{h5write()}}
}
\author{
Bernd Fischer
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/H5T.R
\name{H5T_precision}
\alias{H5T_precision}
\alias{H5Tset_precision}
\alias{H5Tget_precision}
\title{Retrieve or set the precision of an HDF5 datatype}
\usage{
H5Tset_precision(dtype_id, precision)

H5Tget_precision(dtype_id)
}
\arguments{
\item{dtype_id}{ID of HDF5 datatype to set precision of.}

\item{precision}{The number of bytes of precision for the datatype.}
}
\value{
\itemize{
\item \code{H5Tget_precision()} returns an integer giving the number of
significant bits used by the given datatype.
\item \code{H5Tset_precision()} is call for its side-effect of modifying the
precision of a datatype.  It will invisibly return \code{TRUE} if this is
successful and will stop with an error if the operation fails.
}
}
\description{
Retrieve or set the precision of an HDF5 datatype
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/H5P_extras.R
\name{H5Pset_blosc}
\alias{H5Pset_blosc}
\title{Add the BLOSC filter to the chunk processing pipeline.}
\usage{
H5Pset_blosc(h5plist, h5tid, method = 1L, level = 6L, shuffle = TRUE)
}
\arguments{
\item{h5plist}{Object of class \linkS4class{H5IdComponent} representing a dataset
creation property list.}

\item{h5tid}{HDF5 data type id}

\item{method}{Integer defining which of the compression algorithms provided
by BLOSC should be used. (See the details section for the mapping between
integers and algorithms).}

\item{level}{Compression level to be used by the selected algorithm.}

\item{shuffle}{Logical defining whether the bit-shuffle algorithm should
be used prior to compression.  This makes use of the shuffle implementation
provide by BLOSC, rather than the HDF5 version.}
}
\description{
Add the BLOSC filter to the chunk processing pipeline.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/H5O.R
\name{H5Oopen}
\alias{H5Oopen}
\title{Open an object in an HDF5 file}
\usage{
H5Oopen(h5loc, name)
}
\arguments{
\item{h5loc}{An object of class \linkS4class{H5IdComponent}}

\item{name}{Path to the object to be opened.  This should be relative to
\code{h5loc} rather than the file.}
}
\value{
An object of class \linkS4class{H5IdComponent} if the open operation was
successful. \code{FALSE} otherwise.
}
\description{
Open an object in an HDF5 file
}
\examples{

# create an hdf5 file and write something
h5createFile("ex_H5O.h5")
h5createGroup("ex_H5O.h5","foo")
B = array(seq(0.1,2.0,by=0.1),dim=c(5,2,2))
h5write(B, "ex_H5O.h5","foo/B")

# reopen file and dataset and get object info
fid <- H5Fopen("ex_H5O.h5")
oid = H5Oopen(fid, "foo")
H5Oget_num_attrs(oid)
H5Oclose(oid)
H5Fclose(fid)

}
\seealso{
\code{\link[=H5Oclose]{H5Oclose()}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/H5F.R
\name{H5Fget_intent}
\alias{H5Fget_intent}
\title{Determine the read only or read/write status of an open file handle.}
\usage{
H5Fget_intent(h5file)
}
\arguments{
\item{h5file}{An object of class \linkS4class{H5IdComponent} representing a H5
file identifier.  Typically produced by \code{\link[=H5Fopen]{H5Fopen()}} or \code{\link[=H5Fcreate]{H5Fcreate()}}.}
}
\value{
Returns a character vector of length 1.  This will either be \code{H5F_ACC_RDWR} (read / write)
or \code{H5F_ACC_READONLY} (read only).
}
\description{
Determine the read only or read/write status of an open file handle.
}
\details{
The native \code{H5Fget_intent()} function can in theory also return the values \code{H5F_ACC_SWMR_WRITE}
and \code{H5F_ACC_SWMR_READ}.  However these require the underlying HDF5 library to be complied with
support for single-writer/multiple-reader (SWMR), which Rhdf5lib currently is not.  Hence only the two
values detailed in the values section should be possible.
}
\examples{

## use an example file and show its location
h5file <- system.file("testfiles", "h5ex_t_array.h5", package = "rhdf5")
## open the file as read only and check this
fid <- H5Fopen(h5file, flags = "H5F_ACC_RDONLY")
H5Fget_intent(fid)
H5Fclose(fid)

## open file as read write and confirm
fid <- H5Fopen(h5file, flags = "H5F_ACC_RDWR")
H5Fget_intent(fid)
H5Fclose(fid)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/H5S.R
\name{H5Scombine_select}
\alias{H5Scombine_select}
\title{Combine two selections}
\usage{
H5Scombine_select(h5space1, op = h5default("H5S_SELECT"), h5space2)
}
\arguments{
\item{h5space1, h5space2}{\linkS4class{H5IdComponent} objects representing a dataspaces.}

\item{op}{Character string defined the operation used to join the two
dataspaces.  See \code{h5const("H5S_SELECT")} for the list of available options.}
}
\value{
Returns an \linkS4class{H5IdComponent} object representing a new dataspace.
The new dataspace will have the same extent as \code{h5space1} with the
hyperslab selection being the result of combining the selections of
\code{h5space1} and \code{h5space2}.
}
\description{
Combine two selections
}
\examples{

## create two 1 dimensional dataspaces
## of different sizes
sid_1 <- H5Screate_simple(dims = 20)
sid_2 <- H5Screate_simple(dims = 10)

## select a single block of 5 points in sid_1
## this is equivalent to [11:16] in R syntax
H5Sselect_hyperslab(sid_1, start = 11, stride = 1, 
                    block = 5, count = 1)

## select 2 blocks of 1 point from sid_2
## equivalent to [c(3,5)] in R syntax
H5Sselect_hyperslab(sid_2, start = 3, stride = 2, 
                    block = 1, count = 2)

## confirm we have select 5 and 2 points resepectively
H5Sget_select_npoints(sid_1)
H5Sget_select_npoints(sid_2)

## combine the two dataset selections keeping points that
## are in one or both of the selections
sid_3 <- H5Scombine_select(sid_1, "H5S_SELECT_OR", sid_2)

## extent of the new dataset is the same as sid_1
sid_3
## confirm the selection contains 7 points
H5Sget_select_npoints(sid_3)

## tidy up
H5Sclose(sid_1)
H5Sclose(sid_2)
H5Sclose(sid_3)

}
\seealso{
\code{\link[=H5Scombine_hyperslab]{H5Scombine_hyperslab()}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/Rhdf5.R
\docType{package}
\name{rhdf5}
\alias{rhdf5}
\title{rhdf5: An interface between HDF5 and R}
\description{
The rhdf5 package provides two categories of functions:
\itemize{
\item \code{h5} functions are high-level R functions that provide a convenient way of accessing HDF5 files
\item \code{H5} functions mirror much of the the HDF5 C API
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/H5T.R
\name{H5Tcopy}
\alias{H5Tcopy}
\title{Copy an existing datatype}
\usage{
H5Tcopy(dtype_id = h5default(type = "H5T"))
}
\arguments{
\item{dtype_id}{Datatype to copy.  Can either be a character
specifying a predefined HDF5 datatype (see \code{h5const("H5T")} for valid
options) or the ID of an already created datatype.}
}
\description{
Copy an existing datatype
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/h5errorHandling.R
\name{h5_errorHandling}
\alias{h5_errorHandling}
\alias{h5errorHandling}
\title{Set how HDF5 error messages are displayed}
\usage{
h5errorHandling(type = "normal")
}
\arguments{
\item{type}{'normal' (default) shows a one line error message in R.
'verbose' shows the whole HDF5 error message. 'suppress' suppresses the HDF5
error messages completely.}
}
\value{
Returns 0 if options are set successfully.
}
\description{
Sets the options for handling HDF5 error messages in the R sessions.
}
\examples{

h5errorHandling("normal")

}
\seealso{
\link{rhdf5}
}
\author{
Bernd Fischer
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/H5R.R
\name{H5Rget_region}
\alias{H5Rget_region}
\title{Return selection for a reference to dataset region}
\usage{
H5Rget_region(ref, h5loc)
}
\arguments{
\item{ref}{An object of class \code{H5Ref}.  This function is only valid
for reference of type \code{H5R_DATASET_REGION}, and not \code{H5R_OBJECT}.}

\item{h5loc}{An \code{H5IdComponent} object representing the file containing the
referenced object.}
}
\value{
An object of class \code{H5IdComponent} representing the dataspace of the
dataset that \code{ref} points to.  The dataspace will have the selection set
that matches the selection pointed to by \code{ref}. This should be closed using
\code{\link[=H5Sclose]{H5Sclose()}} when no longer required.
}
\description{
Given a dataset region reference, this function will return the dataspace
and selection required to read the data points indicated by the reference.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/H5L.R
\name{H5Lcreate_external}
\alias{H5Lcreate_external}
\title{Create a link to an object in a different HDF5 file}
\usage{
H5Lcreate_external(target_file_name, target_obj_name, link_loc, link_name)
}
\arguments{
\item{target_file_name}{Name of the external HDF5 to link to}

\item{target_obj_name}{Path to the object in the file specified by
\code{target_file_name} to link to.}

\item{link_loc}{\linkS4class{H5IdComponent} object giving the location where the
new link should be created. Can represent an HDF5 file or group.}

\item{link_name}{Name (path) of the new link, relative to the location of
\code{link_loc}.}
}
\description{
\code{H5Lcreate_external()} creates a new external link. An external
link is a soft link to an object in a different HDF5 file from the location
of the link.
}
\examples{
## The example below creates a new HDF5 file in a temporary director, and then
## links to the group "/foo" found in the file "multiple_dtypes.h5" 
## distributed with the package.

h5File1 <- system.file("testfiles", "multiple_dtypes.h5", package="rhdf5")
h5File2 <- tempfile(pattern = "H5L_2_", fileext = ".h5")
h5createFile(h5File2)

## open the new file & create a link to the group "/foo" in the original file
fid <- H5Fopen(h5File2)
H5Lcreate_external(target_file_name = h5File1, target_obj_name = "/foo", 
  link_loc = fid, link_name = "/external_link")
H5Fclose(fid)

## check the new file has a group called "/external_link"
h5ls(h5File2)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/H5P.R
\name{H5P_fill_value}
\alias{H5P_fill_value}
\alias{H5Pset_fill_value}
\title{Set the fill value for an HDF5 dataset}
\usage{
H5Pset_fill_value(h5plist, value)
}
\arguments{
\item{h5plist}{An object of class \linkS4class{H5IdComponent} representing a
dataset creation property list.}

\item{value}{The default fill value of the dataset. A vector of length 1.}
}
\description{
\code{H5Pset_fill_value} sets the fill value for a dataset in the dataset creation property list.
}
\seealso{
\link{H5P_fill_time},\link{H5Pfill_value_defined}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/h5read.R
\name{h5_read}
\alias{h5_read}
\alias{h5read}
\title{Reads and write object in HDF5 files}
\usage{
h5read(
  file,
  name,
  index = NULL,
  start = NULL,
  stride = NULL,
  block = NULL,
  count = NULL,
  compoundAsDataFrame = TRUE,
  callGeneric = TRUE,
  read.attributes = FALSE,
  drop = FALSE,
  ...,
  native = FALSE,
  s3 = FALSE,
  s3credentials = NULL
)
}
\arguments{
\item{file}{The filename (character) of the file in which the dataset is
be located. It is possible to provide an object of
class \linkS4class{H5IdComponent} representing a H5 location identifier
(file or group). See \code{\link{H5Fcreate}}, \code{\link{H5Fopen}},
\code{\link{H5Gcreate}}, \code{\link{H5Gopen}} to create an object of this
kind.}

\item{name}{The name of the dataset in the HDF5 file.}

\item{index}{List of indices for subsetting. The length of the list has to
agree with the dimensional extension of the HDF5 array. Each list element is
an integer vector of indices. A list element equal to NULL choses all
indices in this dimension. Counting is R-style 1-based.}

\item{start}{The start coordinate of a hyperslab (similar to subsetting in
R). Counting is R-style 1-based. This argument is ignored, if index is not
NULL.}

\item{stride}{The stride of the hypercube. Read the introduction
\url{http://ftp.hdfgroup.org/HDF5/Tutor/phypecont.html} before using this
argument. R behaves like Fortran in this example. This argument is ignored,
if index is not NULL.}

\item{block}{The block size of the hyperslab. Read the introduction
\url{http://ftp.hdfgroup.org/HDF5/Tutor/phypecont.html} before using this
argument. R behaves like Fortran in this example. This argument is ignored,
if index is not NULL.}

\item{count}{The number of blocks to be read. This argument is ignored,
if index is not NULL.}

\item{compoundAsDataFrame}{If true, a compound datatype will be coerced to a
data.frame. This is not possible, if the dataset is multi-dimensional.
Otherwise the compound datatype will be returned as a list. Nested compound
data types will be returned as a nested list.}

\item{callGeneric}{If TRUE a generic function h5read.classname will be
called if it exists depending on the dataset's class attribute within the
HDF5 file. This function can be used to convert the standard output of
h5read depending on the class attribute. Note that h5read is not a S3
generic function. Dispatching is done based on the HDF5 attribute after the
standard h5read function.}

\item{read.attributes}{(logical) If \code{TRUE}, the HDF5 attributes are read and
attached to the respective R object.}

\item{drop}{(logical) If TRUE, the HDF5 object is read as a vector with \code{NULL}
dim attributes.}

\item{\dots}{Further arguments passed to \code{\link{H5Dread}}.}

\item{native}{An object of class \code{logical}. If TRUE, array-like objects
are treated as stored in HDF5 row-major rather than R column-major
orientation. Using \code{native = TRUE} increases HDF5 file portability
between programming languages. A file written with \code{native = TRUE}
should also be read with \code{native = TRUE}}

\item{s3}{Logical value indicating whether the file argument should be
treated as a URL to an Amazon S3 bucket, rather than a local file path.}

\item{s3credentials}{A list of length three, providing the credentials for
accessing files in a private Amazon S3 bucket.}
}
\value{
\code{h5read} returns an array with the data read.
}
\description{
Reads objects in HDF5 files. This function can be used to read
either full arrays/vectors or subarrays (hyperslabs) from an
existing dataset.
}
\details{
Read an R object from an HDF5 file. If none of the arguments
\code{start, stride, block, count} are specified, the dataset has the same
dimension in the HDF5 file and in memory. If the dataset already exists in
the HDF5 file, one can read subarrays, so called hyperslabs from
the HDF5 file. The arguments \code{start, stride, block, count} define the
subset of the dataset in the HDF5 file that is to be read/written. See these
introductions to hyperslabs:
\url{https://support.hdfgroup.org/HDF5/Tutor/selectsimple.html},
\url{https://support.hdfgroup.org/HDF5/Tutor/select.html} and
\url{http://ftp.hdfgroup.org/HDF5/Tutor/phypecont.html}. Please note that in
R the first dimension is the fastest changing dimension.

When viewing the HDF5 datasets with any C-program (e.g. HDFView), the order
of dimensions is inverted. In the R interface counting starts with 1,
whereas in the C-programs (e.g. HDFView) counting starts with 0.
}
\examples{

h5createFile("ex_hdf5file.h5")

# write a matrix
B = array(seq(0.1,2.0,by=0.1),dim=c(5,2,2))
h5write(B, "ex_hdf5file.h5","B")

# read a matrix
E = h5read("ex_hdf5file.h5","B")

# write and read submatrix
h5createDataset("ex_hdf5file.h5", "S", c(5,8), storage.mode = "integer", chunk=c(5,1), level=7)
h5write(matrix(1:5,nr=5,nc=1), file="ex_hdf5file.h5", name="S", index=list(NULL,1))
h5read("ex_hdf5file.h5", "S")
h5read("ex_hdf5file.h5", "S", index=list(NULL,2:3))

# Read a subset of an hdf5 file in a public S3 bucket
\donttest{
h5read('https://rhdf5-public.s3.eu-central-1.amazonaws.com/rhdf5ex_t_float_3d.h5', 
      s3 = TRUE, name = "a1", index = list(NULL, 3, NULL))
}

}
\seealso{
\code{\link{h5ls}}
}
\author{
Bernd Fischer, Mike Smith
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/h5write.R
\name{h5_write}
\alias{h5_write}
\alias{h5write}
\alias{h5write.default}
\alias{h5writeDataset}
\alias{h5writeDataset.data.frame}
\alias{h5writeDataset.array}
\title{Write object to an HDF5 file.}
\usage{
h5write(obj, file, name, ...)

\method{h5write}{default}(
  obj,
  file,
  name,
  createnewfile = TRUE,
  write.attributes = FALSE,
  ...,
  native = FALSE
)

h5writeDataset(obj, h5loc, name, ...)

\method{h5writeDataset}{data.frame}(obj, h5loc, name, level = 6, chunk, DataFrameAsCompound = TRUE)

\method{h5writeDataset}{array}(
  obj,
  h5loc,
  name,
  index = NULL,
  start = NULL,
  stride = NULL,
  block = NULL,
  count = NULL,
  size = NULL,
  variableLengthString = FALSE,
  encoding = NULL,
  level = 6
)
}
\arguments{
\item{obj}{The R object to be written.}

\item{file}{The filename (character) of the file in which the dataset will be
located. For advanced programmers it is possible to provide an object of
class \linkS4class{H5IdComponent} representing a H5 location identifier (file or
group). See \code{\link{H5Fcreate}}, \code{\link{H5Fopen}},
\code{\link{H5Gcreate}}, \code{\link{H5Gopen}} to create an object of this
kind.}

\item{name}{The name of the dataset in the HDF5 file.}

\item{\dots}{Further arguments passed to \code{\link{H5Dwrite}}.}

\item{createnewfile}{If \code{TRUE}, a new file will be created if necessary.}

\item{write.attributes}{(logical) If TRUE, all R-attributes attached to the
object \code{obj} are written to the HDF5 file.}

\item{native}{An object of class \code{logical}. If TRUE, array-like objects
are treated as stored in HDF5 row-major rather than R column-major
orientation. Using \code{native = TRUE} increases HDF5 file portability
between programming languages. A file written with \code{native = TRUE}
should also be read with \code{native = TRUE}}

\item{h5loc}{An object of class \linkS4class{H5IdComponent} representing a H5
location identifier (file or group). See \code{\link{H5Fcreate}},
\code{\link{H5Fopen}}, \code{\link{H5Gcreate}}, \code{\link{H5Gopen}} to
create an object of this kind.}

\item{level}{The compression level. An integer value between 0 (no
compression) and 9 (highest and slowest compression). Only used, if the
dataset does not yet exist. See \code{\link[=h5createDataset]{h5createDataset()}} to create an dataset.}

\item{chunk}{Specifies the number of items to be include in an HDF5 chunk. If
left unspecified the defaults is the smaller of: the total number of
elements or the number of elements that fit within 4GB of memory. If
\code{DataFrameAsCompound=FALSE} each row of the \code{data.frame} can be consider an
"element".}

\item{DataFrameAsCompound}{If true, a \code{data.frame} will be saved as a
compound data type. Otherwise it is saved like a list. The advantage of
saving a data.frame as a compound data type is that it can be read as a
table from python or with a struct-type from C. The disadvantage is that
the data has to be rearranged on disk and thus can slow down I/O. If fast
reading is required, \code{DataFrameAsCompound=FALSE} is recommended.}

\item{index}{List of indices for subsetting. The length of the list has to
agree with the dimensional extension of the HDF5 array. Each list element
is an integer vector of indices. A list element equal to \code{NULL} chooses all
indices in this dimension. Counting is R-style 1-based.}

\item{start}{The start coordinate of a hyperslab (similar to subsetting in
R). Counting is R-style 1-based. This argument is ignored, if index is not
NULL.}

\item{stride}{The stride of the hypercube. Read the introduction
\url{http://ftp.hdfgroup.org/HDF5/Tutor/phypecont.html} before using this
argument. R behaves like Fortran in this example. This argument is ignored,
if index is not NULL.}

\item{block}{The block size of the hyperslab. Read the introduction
\url{http://ftp.hdfgroup.org/HDF5/Tutor/phypecont.html} before using this
argument. R behaves like Fortran in this example. This argument is ignored,
if index is not NULL.}

\item{count}{The number of blocks to be written. This argument is ignored, if
index is not NULL.}

\item{size}{The length of the fixed-width string data type, when \code{obj} is a
character vector. If \code{NULL}, this is set to the length of the largest
string.}

\item{variableLengthString}{Whether character vectors should be written as
variable-length strings into the attributes. If \code{TRUE}, \code{size} is ignored.}

\item{encoding}{The encoding of the string data type.  Valid options are
"ASCII" or "UTF-8".}
}
\value{
\code{h5write} returns 0 if successful.
}
\description{
Writes an R object to an HDF5 file. This function can be used to write either
full arrays/vectors or subarrays (hyperslabs) within an existing dataset.
}
\details{
Writes an R object to an HDF5 file. If none of the arguments \code{start,
stride, block, count} is specified, the dataset has the same dimension in the
HDF5 file and in memory. If the dataset already exists in the HDF5 file, one
can write subarrays, (so called hyperslabs) to the HDF5 file. The arguments
\code{start, stride, block, count} define the subset of the dataset in the
HDF5 file that is to be written to. See these introductions to hyperslabs:
\url{https://support.hdfgroup.org/HDF5/Tutor/selectsimple.html},
\url{https://support.hdfgroup.org/HDF5/Tutor/select.html} and
\url{http://ftp.hdfgroup.org/HDF5/Tutor/phypecont.html}. Please note that in
R the first dimension is the fastest changing dimension.

When viewing the HDF5 datasets with any C-program (e.g. HDFView), the order
of dimensions is inverted. In the R interface counting starts with 1, whereas
in the C-programs (e.g. HDFView) counting starts with 0.
}
\examples{

h5File <- tempfile(fileext = ".h5")
h5createFile( h5File )

# write a matrix
B = array(seq(0.1,2.0,by=0.1),dim=c(5,2,2))
attr(B, "scale") <- "liter"
h5write(B, h5File,"B")

# write a submatrix
h5createDataset(h5File, "S", c(5,8), storage.mode = "integer", chunk=c(5,1), level=7)
h5write(matrix(1:5,nr=5,nc=1), file=h5File, name="S", index=list(NULL,1))

}
\references{
\url{https://portal.hdfgroup.org/display/HDF5}
}
\seealso{
\code{\link{h5ls}}, \code{\link{h5createFile}},
\code{\link{h5createDataset}}, \link{rhdf5}
}
\author{
Bernd Fischer, Mike Smith
}
\keyword{IO}
\keyword{file}
\keyword{interface}
\keyword{programming}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/H5D.R
\name{H5Dset_extent}
\alias{H5Dset_extent}
\title{Change the dimensions of an HDF5 dataset}
\usage{
H5Dset_extent(h5dataset, size)
}
\arguments{
\item{h5dataset}{Object of class \linkS4class{H5IdComponent} representing an open HDF5
dataset.}

\item{size}{An integer vector with the new dimension of the dataset.}
}
\description{
Change the dimensions of an HDF5 dataset
}
\details{
This function can only be applied to datasets that meet the
following criteria:
\itemize{
\item A chunked dataset with unlimited dimensions
\item A chunked dataset with fixed dimensions if the new dimension sizes are
less than the maximum sizes set with maxdims
#'
}
}
\author{
Bernd Fischer, Mike Smith
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/H5S.R
\name{H5Screate_simple}
\alias{H5Screate_simple}
\title{Create a simple dataspace}
\usage{
H5Screate_simple(dims, maxdims, native = FALSE)
}
\arguments{
\item{dims}{An integer vector defining the initial dimensions of the dataspace.
The length of \code{dims} determines the rank of the dataspace.}

\item{maxdims}{An integer vector with the same length length as \code{dims}.  Specifies the
upper limit on the size of the dataspace dimensions.  Only needs to be specified
if this is different from the values given to \code{dims}.}

\item{native}{An object of class \code{logical}. If \code{TRUE}, array-like
objects are treated as stored in HDF5 row-major rather than R column-major
orientation. Using \code{native = TRUE} increases HDF5 file portability between
programming languages. A file written with \code{native = TRUE} should also be
read with \code{native = TRUE}.}
}
\value{
Returns an object of class \linkS4class{H5IdComponent} representing a
dataspace.
}
\description{
Create a simple dataspace
}
\seealso{
\link{H5Screate}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/H5O.R
\name{H5Ocopy}
\alias{H5Ocopy}
\title{Copies an HDF5 object}
\usage{
H5Ocopy(h5loc, name, h5loc_dest, name_dest, obj_cpy_pl = NULL, lcpl = NULL)
}
\arguments{
\item{h5loc}{An object of class \linkS4class{H5IdComponent} representing an open
HDF5 object where the source obiect should be copied from.}

\item{name}{Character vector of length 1, giving the name of the source object
to be copied.}

\item{h5loc_dest}{An object of class \linkS4class{H5IdComponent} representing an open
HDF5 object where the new copy should be created.}

\item{name_dest}{Character vector of length 1, giving the name of the new object
to be created.}

\item{obj_cpy_pl, lcpl}{\linkS4class{H5IdComponent} objects representing object copy and link creation property lists
respectively.  If left as \code{NULL} the default values for these will be used.}
}
\description{
Copies an HDF5 object
}
\examples{

## Create a temporary copy of an example file check the contents
example_file <- system.file("testfiles", "h5ex_t_array.h5", package="rhdf5")
file.copy(example_file, tempdir())
h5_file <- file.path(tempdir(), "h5ex_t_array.h5")
h5ls(h5_file)

## open the example file and create a new, empty, file
fid1 <- H5Fopen( h5_file )
h5_file2 <- tempfile(fileext = ".h5")
fid2 <- H5Fcreate( h5_file2 )

## We can copy a dataset inside the same file
H5Ocopy(h5loc = fid1, name = "DS1", h5loc_dest = fid1, name_dest = "DS2")
## Or to a different file
H5Ocopy(h5loc = fid1, name = "DS1", h5loc_dest = fid2, name_dest = "DS1_copy")

## if we want to create a new group hierarchy we can use a link creation property list
lcpl <- H5Pcreate("H5P_LINK_CREATE")
H5Pset_create_intermediate_group( lcpl, create_groups = TRUE )
H5Ocopy(h5loc = fid1, name = "DS1", h5loc_dest = fid2, name_dest = "/foo/baa/DS1_nested", lcpl = lcpl)

## tidy up
H5Pclose(lcpl)
H5Fclose(fid1)
H5Fclose(fid2)

## Check we now have groups DS1 and DS2 in the original file
h5ls( h5_file )
## Check we have a copy of DS1 at the root and nests in the new file
h5ls( h5_file2 )

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/H5S.R
\name{H5Scopy}
\alias{H5Scopy}
\title{Create a copy of a dataspace}
\usage{
H5Scopy(h5space)
}
\arguments{
\item{h5space}{Object of class \linkS4class{H5IdComponent} representing the
dataspace to be copied.}
}
\value{
If the copying is successful returns an object of class
\linkS4class{H5IdComponent} representing the new dataspace.  Otherwise returns
\code{FALSE}.
}
\description{
\code{H5S_copy()} creates an exact copy of a given dataspace.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/H5Z.R
\name{H5Zfilter_avail}
\alias{H5Zfilter_avail}
\title{Determine whether a filter is available on this system}
\usage{
H5Zfilter_avail(filter_id)
}
\arguments{
\item{filter_id}{Integer representing the ID of the filter to be checked.}
}
\description{
Determine whether a filter is available on this system
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/H5.R
\name{H5functions}
\alias{H5functions}
\alias{H5open}
\alias{H5close}
\alias{H5garbage_collect}
\alias{H5get_libversion}
\title{HDF5 General Library Functions}
\usage{
H5open()

H5close()

H5garbage_collect()

H5get_libversion()
}
\value{
\itemize{
\item \code{H5open} initializes the HDF5 library.
\item \code{H5close} flushes all data to disk, closes all open identifiers, and cleans up memory.
\item \code{H5garbage_collect} cleans up memory.
\item \code{H5get_libversion} returns the version number of the HDF5 C-library.
}
}
\description{
These low level functions provide general library functions for HDF5.
}
\examples{
\dontrun{
  H5open()
  H5close()
  H5garbage_collect()
  H5get_libversion()
}
}
\author{
Bernd Fischer, Mike Smith
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/H5P.R
\name{H5Pfill_value_defined}
\alias{H5Pfill_value_defined}
\title{Determine whether a property list has a fill value defined}
\usage{
H5Pfill_value_defined(h5plist)
}
\arguments{
\item{h5plist}{Object of class \linkS4class{H5IdComponent} representing a dataset
creation property list.}
}
\value{
\code{TRUE} if the fill value is defined, \code{FALSE} if not.  Will return
\code{NULL} if there is a problem determining the status of the fill value.
}
\description{
Determine whether a property list has a fill value defined
}
\details{
Note that the return value for this function is slightly different
from the C version.  The C API provides three return types and can, in the
case that a fill value is defined, differentiate whether the value is the
HDF5 library default or has been set by the application.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/H5S.R
\name{H5Sget_select_npoints}
\alias{H5Sget_select_npoints}
\title{Find the number of elements in a dataspace selection}
\usage{
H5Sget_select_npoints(h5space)
}
\arguments{
\item{h5space}{\linkS4class{H5IdComponent} object representing a dataspace.}
}
\description{
Find the number of elements in a dataspace selection
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/H5D.R
\name{H5Dget_num_chunks}
\alias{H5Dget_num_chunks}
\title{Get the number of chunks in a dataset}
\usage{
H5Dget_num_chunks(h5dataset)
}
\arguments{
\item{h5dataset}{An object of class \linkS4class{H5IdComponent} representing the dataset from which chunks will be counted.}
}
\value{
An integer value indicating the number of chunks present in the dataset or selected region.
}
\description{
Retrieves the number of chunks used by an HDF5 dataset.
}
\details{
Note, this function only returns the number of chunks that actually have data written to them.
It does not return the theoretical number of chunks in a dataset or intersection with a
dataspace.  For example, if an empty dataset is created and but no values have been written
to it \code{H5Dget_num_chunks()} will return 0.  This can be seen in the examples below.

The C API also provides an optional parameter to constrain the query by providing a dataspace
selection.  However this argument is not currently used at the C level and so is ommitted here.
}
\examples{
file <- tempfile(fileext = ".h5")
fid <- H5Fcreate(file)

## Create a dataset that will be represented by 4 chunks if complete
h5createDataset(file, "data", dims = c(10, 10), chunk = c(5, 5), storage.mode = "integer")
did <- H5Dopen(fid, "data")
## Here we return 0 chunks as no values have been written
H5Dget_num_chunks(did)

## Now write data to half the dataset
h5writeDataset(obj = matrix(1:50, nrow = 10), h5loc = fid, name = "/data", index = list(1:10, 1:5))
## We now see it contains 2 chunks
H5Dget_num_chunks(did)

## Now write the complete dataset, overwriting the existing values
h5writeDataset(obj = matrix(201:300, nrow = 10), h5loc = fid, name = "/data", index = NULL)
## We now see it contains 4 chunks
H5Dget_num_chunks(did)

## Tidy up op handles
h5closeAll(did, fid)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/H5G.R
\name{H5Gget_info}
\alias{H5Gget_info}
\alias{H5Gget_info_by_name}
\alias{H5Gget_info_by_idx}
\title{Retrieve information about a group}
\usage{
H5Gget_info(h5loc)

H5Gget_info_by_name(h5loc, group_name)

H5Gget_info_by_idx(
  h5loc,
  n,
  group_name = ".",
  index_type = h5default("H5_INDEX"),
  order = h5default("H5_ITER")
)
}
\arguments{
\item{h5loc}{An object of class \linkS4class{H5IdComponent} representing a H5
group.}

\item{group_name}{An additional group name specifying the group for which
information is sought. It is interpreted relative to \code{h5loc}.}

\item{n}{Position in the index of the group for which information is
retrieved.}

\item{index_type}{See \code{h5const("H5_INDEX")} for possible arguments.}

\item{order}{See \code{h5const("H5_ITER")} for possible arguments.}
}
\value{
A list with group information
}
\description{
Retrieve information about a group
}
\examples{
h5file <- system.file("testfiles", "multiple_dtypes.h5", package="rhdf5")
fid <- H5Fopen(h5file)
gid <- H5Gopen(fid, "/foo")
gid
H5Gget_info(gid)
H5Gclose(gid)

## the "get_info_by" functions take the H5 object that contains the
## group(s) of interest.  We can retrieve information by index or by name
H5Gget_info_by_idx(fid, 3)
H5Gget_info_by_name(fid,"/foo")

H5Fclose(fid)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/H5T.R
\name{H5T_enum}
\alias{H5T_enum}
\alias{H5Tenum_create}
\alias{H5Tenum_insert}
\title{Create or modify an HDF5 enum datatype}
\usage{
H5Tenum_create(dtype_id = "H5T_NATIVE_INT")

H5Tenum_insert(dtype_id, name, value)
}
\arguments{
\item{dtype_id}{ID of HDF5 datatype to work with.  For \code{H5Tenum_create}, this
is the identifier of the base data type, and must be an integer e.g.
\code{H5T_NATIVE_INT}. For \code{H5Tenum_insert} this will be a datatype identifier
created by \code{H5Tenum_create}.}

\item{name}{The name of a the new enum member.  This is analogous to a
"level" in an R factor.}

\item{value}{The value of the new member.  Must be compatible with the base
datatype defined by \code{dtype_id}.}
}
\value{
\itemize{
\item \code{H5Tinsert_enum()} returns an character representing the H5 identifier
of the new datatype.
\item \code{H5Tset_precision()} is called for its side-effect of modifying the
existing datatype.  It will invisibly
return \code{TRUE} if this is successful \code{FALSE} if not.
}
}
\description{
Create or modify an HDF5 enum datatype
}
\examples{
tid <- H5Tenum_create(dtype_id = "H5T_NATIVE_UCHAR")
H5Tenum_insert(tid, name = "TRUE", value = 1L)
H5Tenum_insert(tid, name = "FALSE", value = 0L)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/H5A.R
\name{H5Aopen}
\alias{H5Aopen}
\alias{H5Aopen_by_name}
\alias{H5Aopen_by_idx}
\title{Open an attribute for an HDF5 object}
\usage{
H5Aopen(h5obj, name)

H5Aopen_by_name(h5obj, objname = ".", name)

H5Aopen_by_idx(
  h5obj,
  n,
  objname = ".",
  index_type = h5default("H5_INDEX"),
  order = h5default("H5_ITER")
)
}
\arguments{
\item{h5obj}{An object of class \linkS4class{H5IdComponent} representing a H5 object
identifier (file, group, or dataset). See \code{\link[=H5Fcreate]{H5Fcreate()}}, \code{\link[=H5Fopen]{H5Fopen()}},
\code{\link[=H5Gcreate]{H5Gcreate()}}, \code{\link[=H5Gopen]{H5Gopen()}}, \code{\link[=H5Dcreate]{H5Dcreate()}}, or \code{\link[=H5Dopen]{H5Dopen()}} to create an object of this kind.}

\item{name}{The name of the attribute (character).}

\item{objname}{The name of the object the attribute belongs to.}

\item{n}{Opens attribute number \code{n} in the given order and index. Indexing is C-style, base-0,
so the first attribute is opened with \code{n=0}.}

\item{index_type}{See \code{h5const("H5_INDEX")} for possible arguments.}

\item{order}{See \code{h5const("H5_ITER")} for possible arguments.}
}
\value{
An object of class \linkS4class{H5IdComponent} representing a H5 attribute identifier.
}
\description{
Open an attribute for an HDF5 object
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/H5S.R
\name{H5Sis_simple}
\alias{H5Sis_simple}
\title{Determine whether a dataspace is a simple dataspace}
\usage{
H5Sis_simple(h5space)
}
\arguments{
\item{h5space}{\linkS4class{H5IdComponent} object representing a dataspace.}
}
\description{
In HDF5 a dataspace is considered "simple" if it represents a regular
N-dimensional array of points.
Currently (HDF 1.10.7) all dataspaces are simple.  Support for complex
dataspaces is planned for future HDF versions.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/h5dump.R
\name{h5_dump}
\alias{h5_dump}
\alias{h5dump}
\title{Dump the content of an HDF5 file.}
\usage{
h5dump(
  file,
  recursive = TRUE,
  load = TRUE,
  all = FALSE,
  index_type = h5default("H5_INDEX"),
  order = h5default("H5_ITER"),
  s3 = FALSE,
  s3credentials = NULL,
  ...,
  native = FALSE
)
}
\arguments{
\item{file}{The filename (character) of the file in which the dataset will
be located. You can also provide an object of class \linkS4class{H5IdComponent}
representing a H5 location identifier (file or group). See \code{\link[=H5Fcreate]{H5Fcreate()}},
\code{\link[=H5Fopen]{H5Fopen()}}, \code{\link[=H5Gcreate]{H5Gcreate()}}, \code{\link[=H5Gopen]{H5Gopen()}} to create an object of this kind.}

\item{recursive}{If \code{TRUE}, the content of the whole group hierarchy is
listed. If \code{FALSE}, Only the content of the main group is shown. If a positive
integer is provided this indicates the maximum level of the hierarchy that
is shown.}

\item{load}{If \code{TRUE} the datasets are read in, not only the header
information. Note, that this can cause memory problems for very large files.
In this case choose \code{load=FALSE} and load the datasets successively.}

\item{all}{If \code{TRUE}, a longer list of information on each entry is provided.}

\item{index_type}{See \code{h5const("H5_INDEX")} for possible arguments.}

\item{order}{See \code{h5const("H5_ITER")} for possible arguments.}

\item{s3}{Logical value indicating whether the file argument should be
treated as a URL to an Amazon S3 bucket, rather than a local file path.}

\item{s3credentials}{A list of length three, providing the credentials for
accessing files in a private Amazon S3 bucket.}

\item{\dots}{Arguments passed to \code{\link[=h5read]{h5read()}}}

\item{native}{An object of class \code{logical}. If TRUE, array-like objects
are treated as stored in HDF5 row-major rather than R column-major
orientation. Using \code{native = TRUE} increases HDF5 file portability
between programming languages. A file written with \code{native = TRUE}
should also be read with \code{native = TRUE}}
}
\value{
Returns a hierarchical list structure representing the HDF5
group hierarchy. It either returns the datasets within the list structure
(\code{load=TRUE}) or it returns a \code{data.frame} for each dataset with the
dataset header information (\code{load=FALSE}).
}
\description{
Dump the content of an HDF5 file.
}
\examples{

h5createFile("ex_ls_dump.h5")

# create groups
h5createGroup("ex_ls_dump.h5","foo")
h5createGroup("ex_ls_dump.h5","foo/foobaa")

# write a matrix
B = array(seq(0.1,2.0,by=0.1),dim=c(5,2,2))
attr(B, "scale") <- "liter"
h5write(B, "ex_ls_dump.h5","foo/B")

# list content of hdf5 file
h5dump("ex_ls_dump.h5")

# list content of an hdf5 file in a public S3 bucket
\donttest{
h5dump(file = "https://rhdf5-public.s3.eu-central-1.amazonaws.com/h5ex_t_array.h5", s3 = TRUE)
}

}
\seealso{
\code{\link[=h5ls]{h5ls()}}
}
\author{
Bernd Fischer, Mike L. Smith
}
\keyword{IO}
\keyword{file}
\keyword{interface}
\keyword{programming}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/H5S.R
\name{H5Screate}
\alias{H5Screate}
\title{Create a new dataspace of a specified type}
\usage{
H5Screate(type = h5default("H5S"), native = FALSE)
}
\arguments{
\item{type}{The type of dataspace to create. See \code{h5const("H5S")} for
possible types.}

\item{native}{An object of class \code{logical}. If \code{TRUE}, array-like
objects are treated as stored in HDF5 row-major rather than R column-major
orientation. Using \code{native = TRUE} increases HDF5 file portability between
programming languages. A file written with \code{native = TRUE} should also be
read with \code{native = TRUE}.}
}
\value{
Returns an object of class \linkS4class{H5IdComponent} representing a
dataspace.
}
\description{
Create a new dataspace of a specified type
}
\seealso{
\link{H5Screate_simple}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/H5S.R
\name{H5Sselect_none}
\alias{H5Sselect_none}
\title{Set the selection region of a dataspace to include no elements}
\usage{
H5Sselect_none(h5space)
}
\arguments{
\item{h5space}{\linkS4class{H5IdComponent} object representing a dataspace.}
}
\description{
Set the selection region of a dataspace to include no elements
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/H5O.R
\name{H5Olink}
\alias{H5Olink}
\title{Create a hard link to an object in an HDF5 file}
\usage{
H5Olink(h5obj, h5loc, newLinkName, lcpl = NULL, lapl = NULL)
}
\arguments{
\item{h5obj}{An object of class \linkS4class{H5IdComponent} representing the object to be linked to.}

\item{h5loc}{An object of class \linkS4class{H5IdComponent} representing the location at which the
object is to be linked.  Can represent a file, group, dataset, datatype or attribute.}

\item{newLinkName}{Character string giving the name of the new link.  This should be relative to
\code{h5loc}.}

\item{lcpl, lapl}{\linkS4class{H5IdComponent} objects representing link creation and link access property lists
respectively.  If left as \code{NULL} the default values for these will be used.}
}
\description{
Create a hard link to an object in an HDF5 file
}
\examples{
## Create a temporary copy of an example file, and open it
example_file <- system.file("testfiles", "h5ex_t_array.h5", package="rhdf5")
file.copy(example_file, tempdir())
h5_file <- file.path(tempdir(), "h5ex_t_array.h5")
fid <- H5Fopen( h5_file )

## create a new group without a location in the file
gid <- H5Gcreate_anon(fid)

## create link to newly create group
## relative to the file identifier
H5Olink(h5obj = gid, h5loc = fid, newLinkName = "foo")

## tidy up
H5Gclose(gid)
H5Fclose(fid)

## Check we now have a "/foo" group
h5ls( h5_file )

}
\seealso{
\link{H5Gcreate_anon}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/H5D_extras.R
\name{H5D_extras}
\alias{H5D_extras}
\alias{H5Dchunk_dims}
\alias{H5Dis_chunked}
\title{Additional functions for finding details of dataset chunking.}
\usage{
H5Dchunk_dims(h5dataset)

H5Dis_chunked(h5dataset)
}
\arguments{
\item{h5dataset}{Object of class \linkS4class{H5IdComponent} representing an open HDF5
dataset.}
}
\value{
\itemize{
\item \code{H5Dchunk_dims}: If the supplied dataset is chunked returns a vector, with length
equal to the rank of the dataset, containing the size of the dataset
dimensions.  Returns \code{NULL} if the given dataset is not chunked.
\item \code{H5Dis_chunked}: returns \code{TRUE} if a dataset is chunked and \code{FALSE} otherwise.
}
}
\description{
Additional functions for finding details of dataset chunking.
}
\details{
These functions do not map directly to the HDF5 C API but follow the same style and are
included as potentially useful additions.
\itemize{
\item \code{H5Dis_chunked} tests whether a dataset is chunked.
\item \code{H5Dchunk_dims} will return the dimensions of the dataset chunks.
}
}
\author{
Mike Smith
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/H5P.R
\name{H5P_libver_bounds}
\alias{H5P_libver_bounds}
\alias{H5Pset_libver_bounds}
\alias{H5Pget_libver_bounds}
\title{Control the range of HDF5 library versions that will be compatible with
a file.}
\usage{
H5Pset_libver_bounds(
  h5plist,
  libver_low = "H5F_LIBVER_EARLIEST",
  libver_high = "H5F_LIBVER_LATEST"
)

H5Pget_libver_bounds(h5plist)
}
\arguments{
\item{h5plist}{\linkS4class{H5IdComponent} object representing a file access
property list.}

\item{libver_low, libver_high}{Define the earliest and latest versions of
the HDF5 library that will be used when writing object in the file.}
}
\description{
Control the range of HDF5 library versions that will be compatible with
a file.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/H5R.R
\name{H5Rcreate}
\alias{H5Rcreate}
\title{Create a reference}
\usage{
H5Rcreate(h5loc, name, ref_type = "H5R_OBJECT", h5space = NULL)
}
\arguments{
\item{h5loc}{An \code{H5IdComponent} object representing the location to be pointed to
by the created reference.}

\item{name}{Character string giving the name of the object to be referenced,
relative to the location given by \code{h5loc}.}

\item{ref_type}{The type of reference to create.  Accepts either \code{H5R_OBJECT}
or \code{H5R_DATASET_REGION}.}

\item{h5space}{An object of class \code{H5IdComponent} representing a dataspace
with a selection set.  This argument is only used if creating a
reference to a dataset region, and will be ignored otherwise.}
}
\value{
An \linkS4class{H5Ref} object storing the reference.
}
\description{
Creates a reference to an object or dataset selection inside an HDF5 file.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/H5O.R
\name{H5Oget_info}
\alias{H5Oget_info}
\title{Retrieves the metadata for an HDF5 object specified by an identifier.}
\usage{
H5Oget_info(h5loc)
}
\arguments{
\item{h5loc}{An object of class \linkS4class{H5IdComponent} representing an open
HDF5 dataset or group.}
}
\description{
Retrieves the metadata for an HDF5 object specified by an identifier.
}
\examples{

## Create a temporary copy of an example file check the contents
example_file <- system.file("testfiles", "h5ex_t_array.h5", package = "rhdf5")

## open the example file, root group, and DS1 dataset
fid <- H5Fopen(example_file)
gid <- H5Gopen(fid, "/")
did <- H5Dopen(fid, "/DS1")

## List the available object information for both groups and datasets
H5Oget_info(h5loc = gid)

H5Oget_info(h5loc = did)

## close open handles
h5closeAll(did, gid, fid)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/H5D.R
\name{H5Dopen}
\alias{H5Dopen}
\title{Open an existing HDF5 dataset}
\usage{
H5Dopen(h5loc, name, dapl = NULL)
}
\arguments{
\item{h5loc}{An object of class \linkS4class{H5IdComponent} representing a H5
location identifier (file or group).}

\item{name}{Name of the dataset to open.}

\item{dapl}{An object of class \linkS4class{H5IdComponent} representing a H5 dataset access property list.}
}
\value{
An object of class \code{H5IdComponent} representing the opened dataset.
To prevent memory leaks this must be closed with a call to \code{\link[=H5Dclose]{H5Dclose()}}
when no longer needed.
}
\description{
Open an existing HDF5 dataset
}
\examples{
h5file <- tempfile(fileext = ".h5")
h5createFile( h5file )
h5createDataset( h5file, dataset = "A", dims = 10)

fid <- H5Fopen( h5file )
did <- H5Dopen( h5loc = fid, name = "A")
did

## rember to close open handles
H5Dclose( did )
H5Fclose( fid )

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/h5delete.R
\name{h5_deleteAttribute}
\alias{h5_deleteAttribute}
\alias{h5deleteAttribute}
\title{Delete attribute}
\usage{
h5deleteAttribute(file, name, attribute)
}
\arguments{
\item{file}{The filename (character) of the file in which the object is
located.}

\item{name}{The name of the object to which the attribute belongs.}

\item{attribute}{Name of the attribute to be deleted.}
}
\description{
Deletes an attribute associated with a group or dataset within an HDF5 file.
}
\author{
Mike Smith
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/H5T.R
\name{H5T_ops}
\alias{H5T_ops}
\alias{H5Tget_class}
\alias{H5Tget_nmembers}
\title{Get details of HDF5 data types}
\usage{
H5Tget_class(dtype_id)

H5Tget_nmembers(dtype_id)
}
\arguments{
\item{dtype_id}{ID of HDF5 datatype to work with.  Normally created with
a function like \code{H5Tcopy} or \code{H5Tenum_create}.}
}
\value{
\itemize{
\item \code{H5Tget_class()} returns an character vector of length 1 giving the
class of the data type.
\item \code{H5Tget_nmembers()} returns the number of members in the given
datatype.  Will fail with an error if the supplied datatype is not of type
\code{H5T_COMPUND} or \code{H5T_ENUM}.
}
}
\description{
Get details of HDF5 data types
}
\examples{
## create an enum datatype with two entries
tid <- H5Tenum_create(dtype_id = "H5T_NATIVE_UCHAR")
H5Tenum_insert(tid, name = "TRUE", value = 1L)
H5Tenum_insert(tid, name = "FALSE", value = 0L)

H5Tget_class(tid)
H5Tget_nmembers(tid)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/h5filters.R
\name{h5checkFilters}
\alias{h5checkFilters}
\title{Identifies the filters required to read a dataset
If filters aren't available it will try to identify them
and print the names to the user.}
\usage{
h5checkFilters(h5id)
}
\description{
Identifies the filters required to read a dataset
If filters aren't available it will try to identify them
and print the names to the user.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/H5P.R
\name{H5Pset_shared_mesg_phase_change}
\alias{H5Pset_shared_mesg_phase_change}
\alias{H5Pget_shared_mesg_phase_change}
\title{Get and set threshold values for storage of shared object header message indexes}
\usage{
H5Pset_shared_mesg_phase_change(h5plist, max_list, min_btree)

H5Pget_shared_mesg_phase_change(h5plist)
}
\arguments{
\item{h5plist}{\linkS4class{H5IdComponent} object representing the file creation property list}

\item{max_list}{Threshold above which storage shifts from list to B-tree}

\item{min_btree}{Threshold below which storage reverts to list format}
}
\description{
Get and set threshold values for storage of shared object header message indexes
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/H5P.R
\name{H5Pset_istore_k}
\alias{H5Pset_istore_k}
\alias{H5Pget_istore_k}
\title{Get and set the 1/2 rank of an indexed storage B-tree}
\usage{
H5Pset_istore_k(h5plist, ik)

H5Pget_istore_k(h5plist)
}
\arguments{
\item{h5plist}{\linkS4class{H5IdComponent} object representing the file creation property list}

\item{ik}{chunked Storage B-tree 1/2 rank}
}
\description{
Get and set the 1/2 rank of an indexed storage B-tree
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/H5L.R
\name{H5Lexists}
\alias{H5Lexists}
\title{Confirm existence of a link}
\usage{
H5Lexists(h5loc, name)
}
\arguments{
\item{h5loc}{An object of class \linkS4class{H5IdComponent} representing a H5
location identifier (file or group).}

\item{name}{The name of the link to be checked}
}
\description{
Confirm existence of a link
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/H5P.R
\name{H5Pset_fapl_ros3}
\alias{H5Pset_fapl_ros3}
\title{Set the read-only S3 virtual file driver}
\usage{
H5Pset_fapl_ros3(h5plist, s3credentials = NULL)
}
\arguments{
\item{h5plist}{\linkS4class{H5IdComponent} object representing a file access
property list.}

\item{s3credentials}{Either \code{NULL} or a list of length 3 specifying the AWS access credentials (see details).}
}
\description{
The read-only S3 virtual file driver can be used to read files hosted
remotely on Amazon's S3 storage.
}
\details{
To access files in a private Amazon S3 bucket you will need to
provide three additional details: The AWS region where the files are
hosted, your AWS access key ID, and your AWS secret access key.  More
information on how to obtain AWS access keys can be found at
\url{https://docs.aws.amazon.com/general/latest/gr/aws-sec-cred-types.html#access-keys-and-secret-access-keys}.
These are provided as a list to the \code{s3credentials} argument.  If you
are accessing public data this argument should be \code{NULL}.
}
\examples{

## this doesn't work on the Bioconductor Mac build machine
\dontrun{
pid <- H5Pcreate("H5P_FILE_ACCESS")
H5Pset_fapl_ros3( pid )
H5Pclose(pid)
}

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/h5create.R
\name{h5_createDataset}
\alias{h5_createDataset}
\alias{h5createDataset}
\title{Create HDF5 dataset}
\usage{
h5createDataset(
  file,
  dataset,
  dims,
  maxdims = dims,
  storage.mode = "double",
  H5type = NULL,
  size = NULL,
  encoding = NULL,
  chunk = dims,
  fillValue,
  level = 6,
  filter = "gzip",
  shuffle = TRUE,
  native = FALSE
)
}
\arguments{
\item{file}{The filename (character) of the file in which the dataset will be
located. For advanced programmers it is possible to provide an object of
class \linkS4class{H5IdComponent} representing a H5 location identifier (file or
group). See \code{\link[=H5Fcreate]{H5Fcreate()}}, \code{\link[=H5Fopen]{H5Fopen()}}, \code{\link[=H5Gcreate]{H5Gcreate()}}, \code{\link[=H5Gopen]{H5Gopen()}} to
create an object of this kind.}

\item{dataset}{Name of the dataset to be created. The name can contain group
names, e.g. 'group/dataset', but the function will fail, if the group does
not yet exist.}

\item{dims}{The dimensions of the array as they will appear in the file.
Note, the dimensions will appear in inverted order when viewing the file
with a C-programm (e.g. HDFView), because the fastest changing dimension in
R is the first one, whereas the fastest changing dimension in C is the last
one.}

\item{maxdims}{The maximum extension of the array. Use \code{H5Sunlimited()}
to indicate an extensible dimension.}

\item{storage.mode}{The storage mode of the data to be written. Can be
obtained by \code{storage.mode(mydata)}.}

\item{H5type}{Advanced programmers can specify the datatype of the dataset
within the file. See \code{h5const("H5T")} for a list of available
datatypes. If \code{H5type} is specified the argument \code{storage.mode}
is ignored. It is recommended to use \code{storage.mode}}

\item{size}{For \code{storage.mode='character'} the maximum string length to use.
The default value of \code{NULL} will result in using variable length strings.
See the details for more information on this option.}

\item{encoding}{The encoding of the string data type. Valid options are
"ASCII" or "UTF-8".}

\item{chunk}{The chunk size used to store the dataset. It is an integer
vector of the same length as \code{dims}. This argument is usually set
together with a compression property (argument \code{level}).}

\item{fillValue}{Standard value for filling the dataset. The storage.mode of
value has to be convertible to the dataset type by HDF5.}

\item{level}{The compression level used. An integer value between 0 (no
compression) and 9 (highest and slowest compression).}

\item{filter}{Character defining which compression filter should be applied
to the chunks of the dataset.  See the Details section for more information
on the options that can be provided here.}

\item{shuffle}{Logical defining whether the byte-shuffle algorithm should be
applied to data prior to compression.}

\item{native}{An object of class \code{logical}. If TRUE, array-like objects
are treated as stored in HDF5 row-major rather than R column-major
orientation. Using \code{native = TRUE} increases HDF5 file portability
between programming languages. A file written with \code{native = TRUE}
should also be read with \code{native = TRUE}}
}
\value{
Returns (invisibly) \code{TRUE} if dataset was created successfully and \code{FALSE} otherwise.
}
\description{
R function to create an HDF5 dataset and defining its dimensionality and
compression behaviour.
}
\details{
Creates a new dataset in an existing HDF5 file. The function will fail if the
file doesn't exist or if there exists already another dataset with the same
name within the specified file.

The \code{size} argument is only used when \code{storage.mode = 'character'}.  When
storing strings HDF5 can use either a fixed or variable length datatype.
Setting \code{size} to a positive integer will use fixed length strings where
\code{size} defines the length.  \pkg{rhdf5} writes null padded strings by default
and so to avoid data loss the value provided here should be the length of the
longest string.  Setting \code{size = NULL} will use variable length strings. The
choice is probably dependent on the nature of the strings you're writing. The
principle difference is that a dataset of variable length strings will not be
compressed by HDF5 but each individual string only uses the space it
requires, whereas in a fixed length dataset each string is of length uses
\code{size}, but the whole dataset can be compressed. This explored more in the
examples below.

The \code{filter} argument can take several options matching to compression
filters distributed in either with the HDF5 library in \pkg{Rhdf5lib} or via
the \pkg{rhdf5filters} package.  The plugins available and the corresponding
values for selecting them are shown below:

\describe{ \item{zlib: Ubiquitous deflate compression algorithm used in GZIP
or ZIP files.  All three options below achieve the same result.}{ \itemize{
\item\code{"GZIP"}, \item\code{"ZLIB"}, \item\code{"DEFLATE"} } } \item{szip:
Compression algorithm maintained by the HDF5 group.}{ \itemize{
\item\code{"SZIP"} } } \item{bzip2}{ \itemize{ \item\code{"BZIP2"} } }
\item{BLOSC meta compressor: As a meta-compressor BLOSC wraps several
different compression algorithms.  Each of the options below will active a
different compression filter. }{ \itemize{ \item\code{"BLOSC_BLOSCLZ"}
\item\code{"BLOSC_LZ4"} \item\code{"BLOSC_LZ4HC"} \item\code{"BLOSC_SNAPPY"}
\item\code{"BLOSC_ZLIB"} \item\code{"BLOSC_ZSTD"} } } \item{lzf}{ \itemize{
\item\code{"LZF"} } } \item{Disable: It is possible to write chunks without
any compression applied.}{ \itemize{ \item\code{"NONE"} } } }
}
\examples{

h5createFile("ex_createDataset.h5")

# create dataset with compression
h5createDataset("ex_createDataset.h5", "A", c(5,8), storage.mode = "integer", chunk=c(5,1), level=6)

# create dataset without compression
h5createDataset("ex_createDataset.h5", "B", c(5,8), storage.mode = "integer")
h5createDataset("ex_createDataset.h5", "C", c(5,8), storage.mode = "double")

# create dataset with bzip2 compression
h5createDataset("ex_createDataset.h5", "D", c(5,8), storage.mode = "integer",
    chunk=c(5,1), filter = "BZIP2", level=6)

# create a dataset of strings & define size based on longest string
ex_strings <- c('long', 'longer', 'longest')
h5createDataset("ex_createDataset.h5", "E",
    storage.mode = "character", chunk = 3, level = 6,
    dims = length(ex_strings), size = max(nchar(ex_strings)))


# write data to dataset
h5write(matrix(1:40,nr=5,nc=8), file="ex_createDataset.h5", name="A")
# write second column
h5write(matrix(1:5,nr=5,nc=1), file="ex_createDataset.h5", name="B", index=list(NULL,2))
# write character vector
h5write(ex_strings, file = "ex_createDataset.h5", name = "E")

h5dump("ex_createDataset.h5")

## Investigating fixed vs variable length string datasets

## create 1000 random strings with length between 50 and 100 characters
words <- ceiling(runif(n = 1000, min = 50, max = 100)) |>
vapply(FUN = \(x) {
 paste(sample(letters, size = x, replace = TRUE), collapse = "")
},
FUN.VALUE = character(1))

## create two HDF5 files
f1 <- tempfile()
f2 <- tempfile()
h5createFile(f1)
h5createFile(f2)

## create two string datasets
## the first is variable length strings, the second fixed at the length of our longest word
h5createDataset(f1, "strings", dims = length(words), storage.mode = "character", size = NULL, chunk = 25)
h5createDataset(f2, "strings", dims = length(words), storage.mode = "character", size = max(nchar(words)), chunk = 25)

## Write the data
h5write(words, f1, "strings")
h5write(words, f2, "strings")

## Check file sizes.
## In this example the fixed length string dataset is normally much smaller
file.size(f1)
file.size(f2)

}
\seealso{
\code{\link[=h5createFile]{h5createFile()}}, \code{\link[=h5createGroup]{h5createGroup()}}, \code{\link[=h5read]{h5read()}}, \code{\link[=h5write]{h5write()}}
}
\author{
Bernd Fischer, Mike L. Smith
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/h5create.R
\name{h5_createGroup}
\alias{h5_createGroup}
\alias{h5createGroup}
\title{Create HDF5 group}
\usage{
h5createGroup(file, group)
}
\arguments{
\item{file}{The filename (character) of the file in which the dataset will
be located. For advanced programmers it is possible to provide an object of
class \linkS4class{H5IdComponent} representing a H5 location identifier
(file or group). See \code{\link[=H5Fcreate]{H5Fcreate()}}, \code{\link[=H5Fopen]{H5Fopen()}},
\code{\link[=H5Gcreate]{H5Gcreate()}}, \code{\link[=H5Gopen]{H5Gopen()}} to create an object of this
kind.}

\item{group}{The name of the new group. The name can contain a hierarchy of
groupnames, e.g. \code{"/group1/group2/newgroup"}, but the function will fail if the
top level groups do not exists.}
}
\value{
Returns TRUE is group was created successfully and FALSE otherwise.
}
\description{
Creates a group within an HDF5 file.
}
\details{
Creates a new group within an HDF5 file.
}
\examples{

h5createFile("ex_createGroup.h5")

# create groups
h5createGroup("ex_createGroup.h5","foo")
h5createGroup("ex_createGroup.h5","foo/foobaa")

h5ls("ex_createGroup.h5")

}
\seealso{
\code{\link[=h5createFile]{h5createFile()}}, \code{\link[=h5createDataset]{h5createDataset()}},
\code{\link[=h5read]{h5read()}}, \code{\link[=h5write]{h5write()}}
}
\author{
Bernd Fischer
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/H5F.R
\name{H5Fopen}
\alias{H5Fopen}
\title{Open an existing HDF5 file}
\usage{
H5Fopen(name, flags = h5default("H5F_ACC_RD"), fapl = NULL, native = FALSE)
}
\arguments{
\item{name}{The name (or path) of the HDF5 file to be opened.}

\item{flags}{Character string defining the access mode for opening the file.}

\item{fapl}{\linkS4class{H5IdComponent} object representing a file access property list.
Leaving this argument as \code{NULL} will use the default HDF5 properties.}

\item{native}{An object of class \code{logical}. If \code{TRUE}, array-like
objects are treated as stored in HDF5 row-major rather than R column-major
orientation. Using \code{native = TRUE} increases HDF5 file portability
between programming languages. A file written with \code{native = TRUE}
should also be opened for reading with \code{native = TRUE}.}
}
\description{
Open an existing HDF5 file
}
\details{
Possible values for the \code{flags} argument are \code{H5F_ACC_RDWR} and \code{H5F_ACC_RDONLY}.
Note that HDF5's "Single Write Multiple Reader (SWMR) mode is not currently supported via
\strong{rhdf5}.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/h5fileLocking.R
\name{h5_FileLocking}
\alias{h5_FileLocking}
\alias{h5testFileLocking}
\alias{h5enableFileLocking}
\alias{h5disableFileLocking}
\title{Test and set file locking for HDF5}
\usage{
h5testFileLocking(location)

h5disableFileLocking()

h5enableFileLocking()
}
\arguments{
\item{location}{The name of a directory or file to test.  If an existing
directory is provided a temporary file will be created in this folder.  If
non-existant location is provided a file with the name will be created,
tested for file locking, and then removed.  Providing an existing file will
result in an error.}
}
\value{
\code{h5testFileLocking} returns \code{TRUE} if a file can be
successfully locked at the specified location, or \code{FALSE} otherwise.

\code{h5disableFileLocking} and \code{h5enableFileLocking} set are called
for the side effect of setting or unsetting the environment variable
\code{HDF5_USE_FILE_LOCKING} and do not return anything.
}
\description{
HDF5 1.10 uses file locking by default.  On some file systems this is not
available, and the HDF5 library will throw an error if the user attempts to
create or access a file located on such a file system.  These functions help
identify if file locking is available without throwing an error, and allow
the locking to be disabled for the duration of the R session if needed.
}
\details{
\code{h5testFileLocking} will create a temporary file and then attempt to
apply a file lock using the appropriate function within the HDF5 library.
The success or failure of the locking is then recorded and the temporary
file removed.  Even relatively low level functions such as
\code{\link{H5Fcreate}} will fail inelegantly if file locking fails.

\code{h5disableFileLocking} will set the environment variable
\code{RHDF5_USE_FILE_LOCKING=FALSE}, which is the recommended was to disable
this behaviour if file locking is not supported.  This will only persist
within the current R session.  You can set the environment variable outside
of R if this is a more general issue on your system.

\code{h5enableFileLocking} will unset the \code{RHDF5_USE_FILE_LOCKING}
environment variable.

More discussion of HDF5's use of file locking can be found online e.g.
https://forum.hdfgroup.org/t/hdf5-1-10-0-and-flock/3761/4 or
https://forum.hdfgroup.org/t/hdf5-files-on-nfs/3985/5
}
\examples{

## either a file name or directory can be tested
file <- tempfile()
dir <- tempdir()

h5testFileLocking(dir)
h5testFileLocking(file)

## we can check for file locking, and disable if needed
if( !h5testFileLocking(dir) ) {
  h5disableFileLocking()
}

}
\author{
Mike Smith
}
\keyword{IO}
\keyword{file}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AllClass.R, R/AllMethods.R
\docType{class}
\name{H5IdComponent-class}
\alias{H5IdComponent-class}
\alias{show,H5IdComponent-method}
\alias{&,H5IdComponent,character-method}
\alias{$,H5IdComponent-method}
\alias{$<-,H5IdComponent-method}
\alias{[,H5IdComponent-method}
\alias{[<-,H5IdComponent-method}
\title{An S4 class representing an H5 object}
\usage{
\S4method{show}{H5IdComponent}(object)

\S4method{&}{H5IdComponent,character}(e1, e2)

\S4method{$}{H5IdComponent}(x, name)

\S4method{$}{H5IdComponent}(x, name) <- value

\S4method{[}{H5IdComponent}(x, i, j, ..., drop = TRUE)

\S4method{[}{H5IdComponent}(x, i, j, ...) <- value
}
\arguments{
\item{object}{Object of class \code{H5IdComponent}}

\item{e1}{An \code{H5IdComponent} object representing an H5 file or group.}

\item{e2}{Character giving the path to an HDF5 group or dataset relative to \code{e1}.}

\item{x}{Object of class \code{H5IdComponent} representing the HDF5 dataset from
which to extract element(s) or in which to replace element(s).}

\item{name}{Character giving the path to an HDF5 group or dataset relative to \code{x}.}

\item{value}{Array-like \R object containing value to be inserted into
the HDF5 dataset.}

\item{i, j, \dots}{Indices specifying elements to extract or replace. Indices
are \code{numeric} vectors or empty (missing) or \code{NULL}.  Numeric
values are coerced to integer as by \code{\link[base]{as.integer}} (and
hence truncated towards zero).}

\item{drop}{If \code{TRUE} the result is coerced to the lowest possible dimension
(see the examples).  This only works for extracting elements, not for the
replacement.  See \code{\link[base]{drop}} for further details.}
}
\description{
A class representing a HDF5 identifier handle. HDF5 identifiers represent
open files, groups, datasets, dataspaces, attributes, and datatypes.
}
\section{Methods (by generic)}{
\itemize{
\item \code{show(H5IdComponent)}: Print details of the object to screen.

\item \code{e1 & e2}: Returns a group handle or dataset handle for the
group or dataset \code{name} in the HDF5 location \code{h5loc}. \code{h5loc} can either be a file handle
as returned by \link{H5Fopen} or a group handle as e.g. returned by \code{h5f$g1} or
\code{h5f$'/g1/g2'}.

\item \code{$}: Reads the HDF5 object \code{name} in the HDF5 location \code{x}. \code{x} can either be
a file handle as returned by \link{H5Fopen} or a group handle as e.g. returned by
\code{h5f$g1} or \code{h5f$'/g1/g2'}.

\item \code{`$`(H5IdComponent) <- value}: Writes the assigned object to to the HDF5 file at
location e1. e1 can either be a file handle as returned by \link{H5Fopen} or a
group handle as e.g. returned by h5f$g1 or h5f$'/g1/g2's. The storage.mode
of the assigned object has to be compatible to the datatype of the HDF5
dataset. The dimension of the assigned object have to be identical the
dimensions of the HDF5 dataset. To create a new HDF5 dataset with specific
properties (e.g. compression level or chunk size), please use the function
\link{h5createDataset} first.

\item \code{[}: Subsetting of an HDF5 dataset. The function reads a
subset of an HDF5 dataset. The given dimensions have to fit the dimensions
of the HDF5 dataset.

\item \code{`[`(H5IdComponent) <- value}: Subsetting of an HDF5 dataset. The function writes
an R data object to a subset of an HDF5 dataset. The given dimensions have
to fit the dimensions of the HDF5 dataset. The HDF5 dataset has to be
created beforehand, e.g. by \link{h5createDataset}.

}}
\section{Slots}{

\describe{
\item{\code{ID}}{\code{integer} of length 1. Contains the handle of C-type \code{hid_t}.}

\item{\code{native}}{An object of class \code{logical}. If TRUE, array-like objects
are treated as stored in HDF5 row-major rather than R column-major
orientation. Using \code{native = TRUE} increases HDF5 file portability
between programming languages. A file written with \code{native = TRUE}
should also be read with \code{native = TRUE}}
}}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/H5F.R
\name{H5Fis_hdf5}
\alias{H5Fis_hdf5}
\title{Determine whether a file is in the HDF5 format}
\usage{
H5Fis_hdf5(name, showWarnings = TRUE)
}
\arguments{
\item{name}{Character vector of length 1, giving the path to the file to
be checked.}

\item{showWarnings}{If the file doesn't exist an warning is generated.
Setting this argument to \code{FALSE} will suppress the warning.}
}
\value{
Returns \code{TRUE}, if the file is an HDF5 file, or \code{FALSE} otherwise.
In the case the file doesn't exist, \code{NA} is returned
}
\description{
\code{H5Fis_hdf5()} determines whether a file is in the HDF5 format.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/H5P.R
\name{H5Pall_filters_avail}
\alias{H5Pall_filters_avail}
\alias{H5Pget_nfilters}
\alias{H5Pget_filter}
\title{Query dataset filter properties.}
\usage{
H5Pall_filters_avail(h5plist)

H5Pget_nfilters(h5plist)

H5Pget_filter(h5plist, idx)
}
\arguments{
\item{h5plist}{Object of class \linkS4class{H5IdComponent} representing a dataset
creation property list.}

\item{idx}{Integer of length 1.  This argument selects which filter to return
information about.  Indexing is R-style 1-based.}
}
\description{
Return information about the filter pipeline applied to a dataset creation
property list.
}
\details{
\itemize{
\item \code{H5Pall_filters_avail()} checks whether all filters required to process a
dataset are available to \strong{rhdf5}.  This can be required if reading files
created with other HDF5 software.
\item \code{H5Pget_nfilters()} returns the number of
filters in the dataset chunk processing pipeline.
\item \code{H5Pget_filter()}
provides details of a specific filter in the pipeline. This includes the
filter name and the parameters provided to it e.g. compression level.
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/Rhdf5.R
\name{h5listObjects}
\alias{h5listObjects}
\alias{h5listIdentifier}
\alias{h5validObjects}
\title{List all open HDF5 objects.}
\usage{
h5listIdentifier()

h5validObjects(native = FALSE)
}
\arguments{
\item{native}{An object of class \code{logical}. If TRUE, array-like objects
are treated as stored in HDF5 row-major rather than R column-major
orientation. Using \code{native = TRUE} increases HDF5 file portability
between programming languages. A file written with \code{native = TRUE}
should also be read with \code{native = TRUE}}
}
\value{
\code{h5validObjects} returns a list of \linkS4class{H5IdComponent}
objects. \code{h5listIdentifier} prints the valid identifiers on screen and
returns NULL.
}
\description{
A list of all valid HDF5 identifiers. H5 objects should be closed after usage
to release resources.
}
\examples{

h5createFile("ex_list_identifier.h5")

# create groups
h5createGroup("ex_list_identifier.h5","foo")

h5listIdentifier()
h5validObjects()

}
\author{
Bernd Fischer, Mike Smith
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/H5R.R
\name{H5Rget_obj_type}
\alias{H5Rget_obj_type}
\title{Identify the type of object that a reference points to}
\usage{
H5Rget_obj_type(ref, h5loc)
}
\arguments{
\item{ref}{\code{H5ref} object containing the reference to be queried.}

\item{h5loc}{An \code{H5IdComponent} object representing the file containing the
referenced object.}
}
\value{
Character string of length 1 identifying the object type.  Valid return
values are: \code{"GROUP"}, \code{"DATASET"}, and \code{"NAMED_DATATYPE"}.
}
\description{
Identify the type of object that a reference points to
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/H5L.R
\name{H5Lmove}
\alias{H5Lmove}
\title{Move a link within an HDF5 file}
\usage{
H5Lmove(h5loc, name, h5loc_dest, name_dest, lcpl = NULL, lapl = NULL)
}
\arguments{
\item{h5loc}{An object of class \linkS4class{H5IdComponent} representing a H5
location identifier (file or group) where the new link is placed.}

\item{name}{The name of the link to be moved.}

\item{h5loc_dest}{\linkS4class{H5IdComponent} object representing the H5 location
where the new link should be created.}

\item{name_dest}{Name of the new link to be created}

\item{lcpl, lapl}{Link creation and link access property lists to be
associated with the new link.  Leaving these arguments as \code{NULL} will use
the HDF5 default property lists.}
}
\description{
Move a link within an HDF5 file
}
\examples{
## create an HDF5 file with a single group
## that contains a dataset of 10 numbers
h5file <- tempfile(fileext = ".h5")
h5createFile(h5file)
h5createGroup(h5file, "/foo")
h5write(1:10, h5file, name = "/foo/vector1")
## check the structure is what we expect
h5ls(h5file)

## open the file, the group where the dataset currently is
## and the root group
fid <- H5Fopen(name = h5file)
gid1 <- H5Gopen(fid, "/foo")
gid2 <- H5Gopen(fid, "/")
## move the dataset to the root of the file and rename it
H5Lmove(gid1, "vector1", gid2, "vector_new")
h5closeAll()
## check the dataset has moved out of the foo group
h5ls(h5file)

## we can also provide the ID of the HDF5 file
## and use the "name" arguments to move between groups
fid <- H5Fopen(name = h5file)
H5Lmove(fid, "/vector_new", fid, "/foo/vector_newer")
H5Fclose(fid)
h5ls(h5file)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/h5readTimestamps.R
\name{h5readTimestamps}
\alias{h5readTimestamps}
\title{Read the time stamps associated with an HDF5 group or dataset.}
\usage{
h5readTimestamps(file, name)
}
\arguments{
\item{file}{Character vector of length 1, giving the path to the HDF5 file}

\item{name}{Path within the HDF5 file to the object whose attributes should
be read. The datasets present in \code{file} can be listed with the
function \code{\link{h5ls}}.}
}
\value{
A named list of length 4 containing the timestamps on the object.
The timestamps themselves are \code{POSIXct} objects (see
\code{\link[base:DateTimeClasses]{base::DateTimeClasses()}}).
}
\description{
Read the time stamps associated with an HDF5 group or dataset.
}
\details{
All timestamps are returned in the UTC timezone.  HDF5 objects
can have between 0 and 4 timestamps set, depending on the property lists
provided when they are created or accessed.  Timestamps that are not tracked
will be returned as the UNIX epoch \verb{1970-01-01 UTC}.
}
\examples{
# example file
example_file <- system.file("testfiles", "h5ex_t_array.h5", package = "rhdf5")

## read timestamps on a group
h5readTimestamps(example_file, name = "/")

## read timestamps on a datasets
h5readTimestamps(example_file, name = "/DS1")

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AllClass.R, R/AllMethods.R
\docType{class}
\name{H5Ref-class}
\alias{H5Ref-class}
\alias{show,H5Ref-method}
\alias{length,H5Ref-method}
\alias{c,H5Ref-method}
\alias{[,H5Ref-method}
\title{An S4 class representing H5 references.}
\usage{
\S4method{show}{H5Ref}(object)

\S4method{length}{H5Ref}(x)

\S4method{c}{H5Ref}(x, ...)

\S4method{[}{H5Ref}(x, i)
}
\arguments{
\item{object}{Object of class \code{H5Ref}}

\item{x}{An \code{H5Ref} object.}

\item{...}{Additional \code{H5Ref} objects to be combined with \code{x}.}

\item{i}{Integer vector giving the indices of references to select.}
}
\description{
A class representing one or more HDF5 references.
}
\details{
The length of the \code{val} slot is dependent on both the number and type of
references stored in the object. \code{H5R_OBJECT} references are stored in 8
bytes, while \code{H5R_DATASET_REGION} references require 12 bytes.  The length
of \code{val} will then be a multiple of 8 or 12 respectively.  This also means
that references of different types cannot be combined in a single object.
}
\section{Methods (by generic)}{
\itemize{
\item \code{show(H5Ref)}: Print details of the object to screen.

\item \code{length(H5Ref)}: Return the number of references stored in an \code{H5Ref}
object.

\item \code{c(H5Ref)}: Combine two or more \code{H5Ref} objects.  Objects must all
contain the same type of reference, either \code{H5R_OBJECT} or
\code{H5R_DATASET_REFERENCE}.

\item \code{[}: Subset an \code{H5Ref} object.

}}
\section{Slots}{

\describe{
\item{\code{val}}{\code{raw} vector containing the byte-level representation of each
reference.}

\item{\code{type}}{\code{integer} of length 1, which maps to either \code{H5R_OBJECT} or
\code{H5R_DATASET_REGION}.}
}}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/H5A.R
\name{H5Aclose}
\alias{H5Aclose}
\title{Close an HDF5 attribute}
\usage{
H5Aclose(h5attribute)
}
\arguments{
\item{h5attribute}{An object of class \linkS4class{H5IdComponent} representing a
the attribute to be closed.  Normally created by \code{\link[=H5Aopen]{H5Aopen()}} or similar.}
}
\description{
Close an HDF5 attribute
}
\seealso{
\code{\link[=H5Aopen]{H5Aopen()}}
}
